package cmdbuild.action_forms;

import java.sql.*;
import java.util.*;

import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBclass;
import cmdbuild.elements.CMDBlookup;
import cmdbuild.utils.Settings;
import cmdbuild.collection.AttributeBean;
import cmdbuild.collection.ClassBean;
import cmdbuild.collection.ErrorBean;
import cmdbuild.collection.InheritsBean;
import cmdbuild.collection.LookupBean;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionMapping;

public class AttributeForm extends ActionFormTemplate {

	static final long serialVersionUID = 1L;
	private String className;
	private String method;
	private String target;
	private String comment; // comment of this class
	private String mode;  // mode of this class
	private String superClassAttribute; // session object
	private String superClassFilter; // form object
	private int index;
	private int DBindex;
	private Vector namePosition;
	private Vector attributeBeanVector;
	private Vector lookupVector;
	private CMDBclass CMDB;
	private boolean inheritsFromClass;


	public AttributeForm() {
		super();
	}
	
	public void reset(ActionMapping mapping, HttpServletRequest request) {
		DEBUG.println("**ATTRIBUTEFORM RESET**");
		ErrorBean err = null;
		if (request.getParameter("class") != null){
			className = request.getParameter("class");
		} else if (request.getSession().getAttribute("class") != null){
 			className = (String)request.getSession().getAttribute("class");
		} else {
			Settings sett = (Settings)request.getSession().getAttribute("settings");
			className = sett.getStartingClass();
		}
        DBService db = (DBService)servlet.getServletContext().getAttribute("db");
        CMDB = new CMDBclass(db);
        superClassAttribute = (String)request.getSession().getAttribute("superClassAttribute");
        Enumeration en = null;
		AttributeBean ab = null;
		InheritsBean inh = null;
		try {
			inh = CMDB.selectSuperClass(className);
		} catch (SQLException e) {
			err = new ErrorBean("attribute.jsp",e);
			e.printStackTrace();
		}
		if (inh.getParent().equals("Class")){
			inheritsFromClass=true;
		} else {
			inheritsFromClass=false;
		}
		HashSet hash = new HashSet();
		if (superClassAttribute==null || superClassAttribute.equals("")){
			Vector supAttVector = new Vector();
			try {
				supAttVector = CMDB.selectAllAttribute(inh.getParent(),"rw");
				attributeBeanVector = CMDB.selectAllAttribute(className,"rw") ;		       
			} catch (SQLException e) {
				err = new ErrorBean("attribute.jsp",e);
				e.printStackTrace();
			}
			Hashtable ht = new Hashtable(); // superclass attributes
			ClassBean cb = null;
			en = supAttVector.elements();
			while (en.hasMoreElements()){
				ab = (AttributeBean)en.nextElement();
				ht.put(ab.getName(),ab);
				cb = ab.getClassBean();
			}
			en = attributeBeanVector.elements();
			while (en.hasMoreElements()){
				ab = (AttributeBean)en.nextElement();
				if (ab.getType()==AttributeBean.LOOKUP && ab.getDefaultValue()!=null && ab.getDefaultValue().length()>0){
					hash.add(ab.getLookup());
				}
				// replace class info from superclass
				if (ht.containsKey(ab.getName())){
					ab.setClassBean(cb);
				}
			}
		} else { // no inherited attributes
			Vector supAttVector = new Vector();
			try {
				supAttVector = CMDB.selectAllAttribute(inh.getParent(),"rw");
				attributeBeanVector = CMDB.selectAllAttribute(className,"rw") ;		       
			} catch (SQLException e) {
				err = new ErrorBean("attribute.jsp",e);
				e.printStackTrace();
			}
			Hashtable ht = new Hashtable(); // superclass attributes
			en = supAttVector.elements();
			while (en.hasMoreElements()){
				ab = (AttributeBean)en.nextElement();
				ht.put(ab.getName(),ab);
			}
			en = attributeBeanVector.elements();
			Vector rv = new Vector();
			while (en.hasMoreElements()){
				ab = (AttributeBean)en.nextElement();
				if (!ht.containsKey(ab.getName())){
					rv.add(ab);
					if (ab.getType()==AttributeBean.LOOKUP && ab.getDefaultValue()!=null && ab.getDefaultValue().length()>0){
						hash.add(ab.getLookup());
					}
				}
			}
		}
		if (hash.size()>0){
			// getting lookups
			CMDBlookup LOOKUP = new CMDBlookup(db);
			try {
				Vector options = new Vector();
				options.addAll(hash);
				lookupVector = LOOKUP.selectLookupByTypes(options);
			} catch (SQLException e) {
				err = new ErrorBean("attribute.jsp",e);
				e.printStackTrace();
			}
			System.out.println("lookup.size="+lookupVector.size());
		} else {
			lookupVector = new Vector();
		}
		
		// replace lookup default number with description
		Enumeration en2 = null;
		LookupBean lb = null;
		int id = 0;
		if (hash.size()>0){
			en = attributeBeanVector.elements();
			while (en.hasMoreElements()){
				ab = (AttributeBean) en.nextElement();
				if (ab.getType()==AttributeBean.LOOKUP && ab.getDefaultValue()!=null && ab.getDefaultValue().length()>0){
					en2 = lookupVector.elements();
					while (en2.hasMoreElements()){
						lb = (LookupBean) en2.nextElement();
						try {
							id = Integer.parseInt(ab.getDefaultValue());
						} catch (NumberFormatException e) {
							id = 0;
						}
						if (lb.getId()==id){
							ab.setDefaultValue(lb.getDescription());
							break;
						}
					}
				}
			}
		}
		// don't show Notes
		/*
		Vector vett = attributeBeanVector;
		if (vett!=null){
			en = vett.elements();
			attributeBeanVector = new Vector();
			while (en.hasMoreElements()){
				ab = (AttributeBean)en.nextElement();
				if (!ab.getName().endsWith("Notes")){
					attributeBeanVector.add(ab);
				}
			}
		}
		*/
		
		/*
		ClassBean cb = CMDB.getBean();
		if (cb != null) {
			comment = cb.getComment();
			if (comment!=null && comment.length()>0){
				mode = comment.substring(6,comment.indexOf("|"));
			} else {
				mode = "read";
			}
		}
		*/
		mode = CMDB.getBean().getMode();
		if (err!=null){
			request.getSession().setAttribute("error",err);
		}
	}

	public Vector getAttributeBeanVector() {
		return attributeBeanVector;
	}
	public void setAttributeBeanVector(Vector attributeBeanVector) {
		this.attributeBeanVector = attributeBeanVector;
	}
	public String getClassName() {
		return className;
	}
	public void setClassName(String className) {
		this.className = className;
	}
	public CMDBclass getCMDB() {
		return CMDB;
	}
	public void setCMDB(CMDBclass cmdb) {
		CMDB = cmdb;
	}
	public String getComment() {
		return comment;
	}
	public void setComment(String comment) {
		this.comment = comment;
	}
	public int getDBindex() {
		return DBindex;
	}
	public void setDBindex(int bindex) {
		DBindex = bindex;
	}
	public int getIndex() {
		return index;
	}
	public void setIndex(int index) {
		this.index = index;
	}
	public String getMethod() {
		return method;
	}
	public void setMethod(String method) {
		this.method = method;
	}
	public String getMode() {
		return mode;
	}
	public void setMode(String mode) {
		this.mode = mode;
	}
	public Vector getNamePosition() {
		return namePosition;
	}
	public void setNamePosition(Vector namePosition) {
		this.namePosition = namePosition;
	}
	public String getSuperClassAttribute() {
		return superClassAttribute;
	}
	public void setSuperClassAttribute(String superClassAttribute) {
		this.superClassAttribute = superClassAttribute;
	}
	public String getSuperClassFilter() {
		return superClassFilter;
	}
	public void setSuperClassFilter(String superClassFilter) {
		this.superClassFilter = superClassFilter;
	}
	public String getTarget() {
		return target;
	}
	public void setTarget(String target) {
		this.target = target;
	}
	public boolean isInheritsFromClass() {
		return inheritsFromClass;
	}
	public void setInheritsFromClass(boolean inheritsFromClass) {
		this.inheritsFromClass = inheritsFromClass;
	}
	
	
} // end of class
