package cmdbuild.action_forms;
import java.sql.*;
import java.util.*;

import cmdbuild.presentation.HTMLclass;
import cmdbuild.presentation.Label;
import cmdbuild.collection.*;
import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBclass;
import cmdbuild.elements.CMDBlookup;
import cmdbuild.utils.MultiLanguage;
import cmdbuild.utils.SecurityDescriptor;
import cmdbuild.utils.Settings;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;

public class CardForm extends ActionFormTemplate {

	static final long serialVersionUID = 1L;
	private String className;
	private int classId;
	private int objId; // contains the real id of the row
	private String masterDetail;
	private Vector masterDetailMenu; 
	private String classDescription="";
	private String targetClass; // used to implement detail delete and gotopage
	private String targetObjId;	// used to implement detail delete and gotopage
	private String method;
	private String mode;
	private String search; 
	private Vector columnVector;  // contains a list of parameters (attributes) to display
	private Vector rowIdVector; // contains all the row from the query
	private Vector selectVector; // items to show in toCardFormDetail
	private Vector reportVector; // matrix that contains reports to display 
	private Vector attributeBeanVector;
	private Vector lookupVector; // contains objects lookup where name=type & description=<option></option>...
	private Hashtable referenceHash; // contains references (LookupBean)
	private int currentPage=1;  // the first page corrisponds to vector[0]
	private int totalPages=0;
	private int subpage=1;       // used only in CardForm / scope request
	private Collection classCollection; // only used in mode create
	private Vector treeVector;
	private CMDBclass CMDB;
	private HTMLclass presentation;

	public CardForm() {
		super();
	}
	
	public void reset(ActionMapping mapping, HttpServletRequest request) {
		DEBUG.println("**CARDFORM RESET**");
        DBService db = (DBService)servlet.getServletContext().getAttribute("db");
        ErrorBean err = null;
		SecurityDescriptor user = null;
		if (request.getSession().getAttribute("user")!=null){
			user = (SecurityDescriptor)request.getSession().getAttribute("user");
		}
        CMDB = new CMDBclass(db);
        CMDBlookup LOOKUP = new CMDBlookup(db);
		if (request.getParameter("class") != null){
			className = request.getParameter("class");
			request.getSession().setAttribute("class",className);
			// if class from request then delete masterdetail
			request.getSession().removeAttribute("masterdetail");
		} else if (request.getSession().getAttribute("class") != null){
			className = (String)request.getSession().getAttribute("class");
		} else {
			Settings sett = (Settings)request.getSession().getAttribute("settings");
			className = sett.getStartingClass();
		}
		ClassBean cb = null;
		// classid is passed from search.jsp 
		if (request.getParameter("classid") != null){
			classId = Integer.parseInt(request.getParameter("classid"));
			if (classId!=0){
				try {
					cb = CMDB.selectClassById(classId);
					CMDB.setBean(cb);
				} catch (SQLException e) {
					err = new ErrorBean("cardform.jsp",e);
					e.printStackTrace();
				}
				className= cb.getName();
				request.getSession().setAttribute("class",className);
			}
		}
		if (request.getParameter("page") != null){
			currentPage = Integer.parseInt(request.getParameter("page"));
			request.getSession().setAttribute("page",""+currentPage);
		} else if (request.getSession().getAttribute("page") != null){
 			currentPage = Integer.parseInt((String) request.getSession().getAttribute("page"));
		}
		if (request.getParameter("mode") != null){
			mode = request.getParameter("mode");
			request.getSession().setAttribute("mode",mode);
		} else if (request.getSession().getAttribute("mode") != null){
			mode = (String) request.getSession().getAttribute("mode");
		} else {
			mode="";
		}
		masterDetail = "";
		if (request.getParameter("masterdetail") != null){
			masterDetail = request.getParameter("masterdetail");
			//request.getSession().setAttribute("masterdetail",name);
		} else if (request.getSession().getAttribute("masterdetail")!=null){
			masterDetail = (String) request.getSession().getAttribute("masterdetail");
		}
		try {
			treeVector = CMDB.selectClassTree();
			masterDetailMenu = CMDB.selectMasterDetailMenu(className,treeVector);
		} catch (SQLException e) {
			err = new ErrorBean("card.jsp",e);
			e.printStackTrace();
		}
		AttributeBean ab = null;
		AssetBean ass = null;
		Enumeration en = null;
		Vector options= new Vector();
		referenceHash = new Hashtable();
		lookupVector = new Vector();
		DEBUG.println("mode="+mode+" classe="+className+" currentPage="+currentPage+" masterDetail="+masterDetail);
		// ** getting info for detail page, mode=show masterDetail<>'' **
		if (mode.equals("show") && masterDetail.length()>0){
			try {
				attributeBeanVector = CMDB.selectAllAttribute(masterDetail,"rw") ;		       
			} catch (SQLException e) {
				err = new ErrorBean("cardform.jsp",e);
				e.printStackTrace();
			}
			ClassBean cbd = new ClassBean();
			if (attributeBeanVector!=null && attributeBeanVector.size()>0){
				classDescription = ((AttributeBean)attributeBeanVector.elementAt(0)).getClassBean().getDescription();
				cbd = ((AttributeBean)attributeBeanVector.elementAt(0)).getClassBean();
			}
			Vector thVector = new Vector();
			if (attributeBeanVector.size()>0){
				if (request.getParameter("objid") != null){
					try {
						objId = Integer.parseInt(request.getParameter("objid"));
					} catch (NumberFormatException e) {
						e.printStackTrace();
						objId = 0;
					}
				} else if (request.getSession().getAttribute("objid")!=null){
					try {
						objId = Integer.parseInt((String)request.getSession().getAttribute("objid"));
					} catch (NumberFormatException e) {
						objId = 0;
					}
				}
				// getting info about this reference
				en = masterDetailMenu.elements();
				AssetBean as = null;
				while (en.hasMoreElements()){
					ab = (AttributeBean) en.nextElement();
					if (ab.getClassBean().getName().equals(masterDetail)){
						as = new AssetBean(ab);
						as.setValue(objId+"");
						break;
					}
				}
				DEBUG.println("DETAIL objId="+objId);
				// creating a select vector, contains elements to retrieve for the query select...
				selectVector = new Vector();
				ab = new AttributeBean();
				ab.setName("Id");
				ab.setSQLType("int4");
				ab.setType("int4");
				selectVector.add(ab);
				ab = new AttributeBean();
				ab.setName("IdClass");
				ab.setSQLType("int4");
				ab.setType("int4");
				selectVector.add(ab);
				en = attributeBeanVector.elements();
				// th = table heads
				// creating lookupVector if there are lookups
				HashSet hash = new HashSet();
				while (en.hasMoreElements()){
					ab = (AttributeBean)en.nextElement();
					if (!ab.getName().equals("Id") && !ab.getName().equals("IdClass")){
						if ( (ab.getBaseDSP().equals("true") && ab.getType()!=AttributeBean.REFERENCE) || (ab.getBaseDSP().equals("true") && ab.getType()==AttributeBean.REFERENCE && !ab.getReference().equals(className)) ){
		 					selectVector.add(ab);
		 					thVector.add(ab);
						}
					}
				}
				presentation = (HTMLclass)CMDB.getPresentation();
				int offset;
				if (subpage==0 || subpage==1){
					//subpage=1;
					offset=0;
				} else {
					offset=(subpage-1)*presentation.getResultsForPage();
				}
				DEBUG.println("masterdetail="+masterDetail+" selectvector="+selectVector+" as="+as);
				try {
					reportVector = CMDB.selectDetailCards(masterDetail,selectVector,as,presentation.getResultsForPage(),offset);
				} catch (SQLException e) {
					err = new ErrorBean("card.jsp",e);
					e.printStackTrace();
				}
				if (reportVector.size()>0){
					en = reportVector.elements();
					options = (Vector) en.nextElement();
					Enumeration eni = options.elements();
					while (eni.hasMoreElements()){
						ass = (AssetBean) eni.nextElement(); 
						if (ass.getType()==AttributeBean.LOOKUP){
							hash.add(ass.getLookup());
						}
						if (ass.getType()==AttributeBean.REFERENCE){
							try {
								if (!referenceHash.containsKey(ass.getReference()) && ass.getReference().length()>0){ // don't get duplicates
									DEBUG.println("Getting refrence for "+ass.getReference());
									options = LOOKUP.selectAllReference(ass.getReference());
									referenceHash.put(ass.getReference(),options);
								}
							} catch (SQLException e) {
								err = new ErrorBean("card.jsp",e);
								e.printStackTrace();
							}
						}
					}
					// getting lookups
					try {
						options = new Vector();
						options.addAll(hash);
						lookupVector = LOOKUP.selectLookupByTypes(options);
					} catch (SQLException e) {
						err = new ErrorBean("findrelationform.jsp",e);
						e.printStackTrace();
					}
				}
			}
			CMDB = CMDB.load(CMDB,CMDB.getBean().getManager());
			presentation = (HTMLclass)CMDB.getPresentation();
			MultiLanguage multilanguage = (MultiLanguage)request.getSession().getAttribute("multilanguage");
			presentation.setMultilanguage(multilanguage);
			presentation.setClassName(className);
			presentation.setObjId(objId);
			presentation.setMasterDetail(masterDetail);
			presentation.setMasterDetailMenu(masterDetailMenu);
			presentation.setCurrentPage(currentPage);
			presentation.setThVector(thVector);
			presentation.setReportVector(reportVector);
			presentation.setLookupVector(lookupVector);
			presentation.setReferenceHash(referenceHash);
			presentation.setUser(user);
			// setting create button
			
			presentation.getHeader().hideAll();
			presentation.getHeader().getCreate().setVisible(true);
			presentation.getHeader().getCreate().setUrl("cardpopup.jsp?mode=create&masterclass="+className+"&detailclass="+masterDetail+"&masterobjid="+objId+"&detailobjid=0&superclass="+cbd.isSuperClass());
			presentation.getHeader().getCreate().setWhere("popup");
			if (request.getSession().getAttribute("label")!=null){
				//DEBUG.println("getting label");
				Label label = (Label) request.getSession().getAttribute("label");
				presentation.getHeader().getLabel().setVisible(true);
				presentation.getHeader().getLabel().setLabel(label.toForm());
			}
			/*
			// disable others
			presentation.getHeader().getFirst().setVisible(false);
			presentation.getHeader().getPrev().setVisible(false);
			presentation.getHeader().getPage().setVisible(false);
			presentation.getHeader().getNext().setVisible(false);
			presentation.getHeader().getLast().setVisible(false);
			presentation.getHeader().getLabel().setVisible(false);
			presentation.getHeader().getCheckFilter().setVisible(false);
			presentation.getHeader().getCopy().setVisible(false);
			presentation.getHeader().getPaste().setVisible(false);
			presentation.getHeader().getModify().setVisible(false);
			presentation.getHeader().getDelete().setVisible(false);
			presentation.getHeader().getFilter().setVisible(false);
			presentation.getHeader().getNofilter().setVisible(false);
			*/
		//** mode show(no detail), create, modify **	
		} else { 
			try {
				attributeBeanVector = CMDB.selectAllAttribute(className,"rw") ;		       
			} catch (SQLException e) {
				err = new ErrorBean("cardform.jsp",e);
				e.printStackTrace();
			}
		    if ( classCollection == null && mode.equals("create")) {
				classCollection = CMDB.selectNormalChilds(className,treeVector);		       
				if (classCollection.size()==0 && attributeBeanVector.size()>0){
					ClassBean cbd = ((AttributeBean)attributeBeanVector.elementAt(0)).getClassBean();
					classCollection.add(cbd);
				}
		    }
			if (attributeBeanVector!=null && attributeBeanVector.size()>0){
				classDescription = ((AttributeBean)attributeBeanVector.elementAt(0)).getClassBean().getDescription(); 
			}
			// managing filter 
			String baseQuery = "";
			// replacing select parameters with "Id"
			baseQuery = "SELECT \"Id\" FROM \""+className+"\" WHERE \"Status\"='A'";
	        Hashtable filter = null;
	        FilterBean fb = null;
	        if (request.getSession().getAttribute("filter")!=null){
	        	filter = (Hashtable)request.getSession().getAttribute("filter");
	        	if (filter.containsKey(className)){
	        		fb = (FilterBean)filter.get(className);
	        		try {
	            		rowIdVector = CMDB.selectCardsId(fb.getQuery());
	        		} catch (SQLException e) {
	    				err = new ErrorBean("cardform.jsp",e);
	    				e.printStackTrace();
	        		}
	        	} else {
	        		try {
	            		rowIdVector = CMDB.selectCardsId(baseQuery);
	        		} catch (SQLException e) {
	    				err = new ErrorBean("cardform.jsp",e);
	    				e.printStackTrace();
	        		}
	        	}
	        } else {
	    		try {
	        		rowIdVector = CMDB.selectCardsId(baseQuery);
	    		} catch (SQLException e) {
					err = new ErrorBean("cardform.jsp",e);
					e.printStackTrace();
	    		}
	        }
			// objid is passed from search.jsp if classname is Asset
			IdBean id = null;
			if (request.getParameter("objid") != null){
				try {
					objId = Integer.parseInt(request.getParameter("objid"));
				} catch (NumberFormatException e) {
					objId = 0;
				}
				if (objId!=0){
					Enumeration eni = rowIdVector.elements();
					int pagina = 0;
					while (eni.hasMoreElements()){
						pagina++;
						id = (IdBean)eni.nextElement();
						if (id.getId()==objId){
							currentPage = pagina;
							break;
						}
					}
				}
				request.getSession().setAttribute("page",""+currentPage);
			} else if (request.getSession().getAttribute("objid")!=null){
				try {
					objId = Integer.parseInt((String)request.getSession().getAttribute("objid"));
				} catch (NumberFormatException e) {
					objId = 0;
				}
			}
			totalPages = rowIdVector.size();
			if (rowIdVector==null){DEBUG.println("rowIdVector  nullo!");}
			if (rowIdVector.size()>0){
				if(currentPage < 1){
					currentPage = 1;
				} else if (currentPage>totalPages){
					currentPage = 1;
					request.getSession().setAttribute("page",""+currentPage);
				}
				objId = ((IdBean)rowIdVector.elementAt(currentPage-1)).getId(); // -1 beacause it's a vector
			} else { // There aren't cards
				currentPage = 0;
			}
			if (objId==0){DEBUG.println("rowId  nullo!");}
			Hashtable copypaste = (Hashtable)request.getSession().getAttribute("copypaste");
			Boolean usecopypaste = new Boolean(false);
			if (request.getSession().getAttribute("usecopypaste")!=null){
				usecopypaste = (Boolean)request.getSession().getAttribute("usecopypaste");
			}
			if (copypaste!=null && usecopypaste.booleanValue() && copypaste.containsKey(className)){
				columnVector = (Vector)copypaste.get(className);
				DEBUG.println("columnVector.size="+columnVector.size());
			} else {
				try {
					columnVector = CMDB.selectCard(className,objId,attributeBeanVector);		       
				} catch (SQLException e) {
					err = new ErrorBean("cardform.jsp",e);
					e.printStackTrace();
				}
			}
			if (columnVector==null){DEBUG.println("columnVector  nullo!");}
			String code = "";
			String description ="";
			HashSet hash = new HashSet();
			if (columnVector.size()>0){
				en = columnVector.elements();
				while (en.hasMoreElements()){
					ass = (AssetBean)en.nextElement();
					if (ass.getName().equals("Code")){
						code = ass.getValue();
					}
					if (ass.getName().equals("Description")){
						description = ass.getValue();
					}
					if (!ass.getName().equals("Id") && !ass.getName().equals("IdClass")){
						if (ass.getType()==AttributeBean.LOOKUP){
							hash.add(ass.getLookup());
						}
						if (ass.getType()==AttributeBean.REFERENCE){
							try {
								if (!referenceHash.containsKey(ass.getReference()) && ass.getReference().length()>0){ // don't get duplicates
									DEBUG.println("Getting refrence for "+ass.getReference());
									options = LOOKUP.selectAllReference(ass.getReference());
									referenceHash.put(ass.getReference(),options);
								}
							} catch (SQLException e) {
								err = new ErrorBean("card.jsp",e);
								e.printStackTrace();
							}
						}
					}
				}
				// getting lookups
				try {
					options = new Vector();
					options.addAll(hash);
					lookupVector = LOOKUP.selectLookupByTypes(options);
				} catch (SQLException e) {
					err = new ErrorBean("card.jsp",e);
					e.printStackTrace();
				}
			}
			// cleaning page when page=0
			if (currentPage==0){
				Enumeration eni = columnVector.elements();
				AssetBean asb = null;
				while (eni.hasMoreElements()){
					asb = (AssetBean)eni.nextElement();
					asb.setValue(null);
				}
			}
			// getting general class info
	        ClassBean bean = CMDB.getBean();
			// getting user from session
			CMDB = CMDB.load(CMDB,CMDB.getBean().getManager());
			presentation = (HTMLclass)CMDB.getPresentation();
			MultiLanguage multilanguage = (MultiLanguage)request.getSession().getAttribute("multilanguage");
			presentation.setMultilanguage(multilanguage);
			presentation.setClassName(className);
			presentation.setObjId(objId);
			presentation.setMasterDetail(masterDetail);
			presentation.setMasterDetailMenu(masterDetailMenu);
			presentation.setCurrentPage(currentPage);
			presentation.setCategory(bean.getCategory());
			presentation.setAssetVector(columnVector);
			presentation.setReportVector(reportVector);
			if (usecopypaste.booleanValue()){ presentation.setToPaste(true); }
			presentation.setClassCollection(classCollection);
			presentation.setLookupVector(lookupVector);
			presentation.setReferenceHash(referenceHash);
			presentation.setClassDescription(classDescription);
			presentation.setUser(user);
			if (user.isAllowed(className,2)){
				presentation.getHeader().getCreate().setUrl("card.jsp?class="+className+"&mode=create");
				if (totalPages!=0){
					presentation.getHeader().getModify().setUrl("card.jsp?class="+className+"&mode=modify&page="+currentPage);
				} else { // disable if there arem't cards to modify
					presentation.getHeader().getModify().setVisible(false);
				}
				presentation.getHeader().getDelete().setUrl("javascript:if (confirm('"+multilanguage.getMessage("CardForm.delete")+"')){cardForm.method.value='delete';cardForm.submit();}");
				if (mode.equals("show") && !CMDB.getBean().isSuperClass()){ // don't permit copy/paste if you are in a superclass
					presentation.getHeader().getCopy().setUrl("javascript:cardForm.method.value='copy';cardForm.submit();");
					presentation.getHeader().getCopy().setVisible(true);
					if (copypaste!=null && copypaste.containsKey(className)){ // if there are copies saved in the session
						presentation.getHeader().getPaste().setUrl("javascript:cardForm.method.value='paste';cardForm.submit();");
						presentation.getHeader().getPaste().setVisible(true);
					}
				}
			} else {
				presentation.getHeader().getCreate().setUrl("javascript:alert('"+multilanguage.getMessage("com.youhavenopermission")+"');");
				presentation.getHeader().getModify().setUrl("javascript:alert('"+multilanguage.getMessage("com.youhavenopermission")+"');");
				presentation.getHeader().getDelete().setUrl("javascript:alert('"+multilanguage.getMessage("com.youhavenopermission")+"');");
			}
			presentation.getHeader().getFilter().setVisible(false);
			presentation.getHeader().getNofilter().setVisible(false);
			// settings arrows
			if (currentPage==0){
				presentation.getHeader().getFirst().setUrl("card.jsp?class="+className+"&page=0");
				presentation.getHeader().getPrev().setUrl("card.jsp?class="+className+"&page=0");
				presentation.getHeader().getNext().setUrl("card.jsp?class="+className+"&page=0");
			} else if (currentPage==1){
				presentation.getHeader().getFirst().setUrl("card.jsp?class="+className+"&page=1");
				presentation.getHeader().getPrev().setUrl("card.jsp?class="+className+"&page=1");
				presentation.getHeader().getNext().setUrl("card.jsp?class="+className+"&page=2");
			} else if(currentPage==totalPages) {
				presentation.getHeader().getFirst().setUrl("card.jsp?class="+className+"&page=1");
				presentation.getHeader().getPrev().setUrl("card.jsp?class="+className+"&page="+(totalPages-1));
				presentation.getHeader().getNext().setUrl("card.jsp?class="+className+"&page="+totalPages);
			} else {
				presentation.getHeader().getFirst().setUrl("card.jsp?class="+className+"&page=1");
				presentation.getHeader().getPrev().setUrl("card.jsp?class="+className+"&page="+(currentPage-1));
				presentation.getHeader().getNext().setUrl("card.jsp?class="+className+"&page="+(currentPage+1));
			}
			presentation.getHeader().getLast().setUrl("card.jsp?class="+className+"&page="+totalPages);
			// setting current page
			presentation.getHeader().getPage().setCurrent(currentPage);
			presentation.getHeader().getPage().setTotal(totalPages);
			presentation.getHeader().getLabel().setLabel("&nbsp;");
			// setting calendar reference
			presentation.setFormName("cardForm");
			presentation.getHeader().getCheckFilter().setVisible(false);
			String stat="";
			if (stat.equals("") || stat.equals("A")){
				presentation.setDeleted(false);
			} else {
				presentation.setDeleted(true);
			}
			// disable operations if className=Asset
			if (CMDB.getBean().isSuperClass()){
				Vector childs = CMDB.selectNormalChilds(className,treeVector);
				if (childs.size()==0){
					presentation.getHeader().getCreate().setUrl("javascript:alert('"+multilanguage.getMessage("com.classreadonly")+"');");	
				}
				presentation.getHeader().getModify().setUrl("javascript:alert('"+multilanguage.getMessage("com.classreadonly")+"');");
				presentation.getHeader().getDelete().setUrl("javascript:alert('"+multilanguage.getMessage("com.classreadonly")+"');");
			}
			Label label = new Label(classDescription,code,description);
			request.getSession().setAttribute("label",label);
			DEBUG.println("saving label");
		}
		if (err!=null){
			request.getSession().setAttribute("error",err);
		}
		request.setAttribute("masterdetail",masterDetail);
		request.setAttribute("objid",objId+"");
	}

	public ActionErrors validate(ActionMapping arg0, HttpServletRequest arg1) {
		DEBUG.println("**VALIDATE**");
		mode = (String)arg1.getSession().getAttribute("mode");
		//DEBUG.println("Mode is "+mode);
		ActionErrors errors = new ActionErrors();
		AssetBean ab = null;
		String tname = "";
		String tdescription = "";
		String target="";
		String actionMethod = arg1.getParameter("method");
		DEBUG.println("columnVector.size"+columnVector.size());
		if (!mode.equals("show") && !actionMethod.equals("search")){
			Enumeration en = columnVector.elements();
			while (en.hasMoreElements()){
				ab = (AssetBean)en.nextElement();
				if (ab.getMandatory().equals("Y")){
					tname = ab.getName();
					tdescription = ab.getDescription();
					target= arg1.getParameter(tname);
					//DEBUG.println("target is "+tname+"target value="+target);
					if (target == null || target.trim().equals("")){ // ,tname
						errors.add(tname, new ActionMessage("par.required",tdescription));
					} else { // if there is something
						if (ab.getType()==AttributeBean.INTEGER){
							try {
								Integer.parseInt(target);
							} catch (NumberFormatException e){
								errors.add(tname, new ActionMessage("par.precision.to.integer",tdescription));
							}
						} // end int4
						if (ab.getType()==AttributeBean.DOUBLE){
							try {
								Double.parseDouble(target);
							} catch (NumberFormatException e){
								errors.add(tname, new ActionMessage("par.precision.to.double",tdescription));
							}
						} // end float8
						if (ab.getType()==AttributeBean.DECIMAL){
							try {
								Double.parseDouble(target);
							} catch (NumberFormatException e){
								errors.add(tname, new ActionMessage("par.precision.to.double",tdescription));
							}
						} // end numeric
						if (ab.getType()==AttributeBean.STRING){
							if (target.length()>ab.getLength()){
								errors.add(tname, new ActionMessage("par.length.invalid",tdescription+"="+ab.getLength()));
							}
						} // end varchar
					} // end else	
				} else {  // not mandatory
					tname = ab.getName();
					tdescription = ab.getDescription();
					target= arg1.getParameter(tname);
					DEBUG.println("target value="+target);
					if (target != null && !target.trim().equals("")){ // if there is something
						if (ab.getType()==AttributeBean.INTEGER){
							try {
								Integer.parseInt(target);
							} catch (NumberFormatException e){
								errors.add(tname, new ActionMessage("par.precision.to.integer",tdescription));
							}
						} // end numeric
						if (ab.getType()==AttributeBean.DOUBLE){
							try {
								Double.parseDouble(target);
							} catch (NumberFormatException e){
								errors.add(tname, new ActionMessage("par.precision.to.double",tdescription));
							}
						} // end numeric
						if (ab.getType()==AttributeBean.DECIMAL){
							try {
								Double.parseDouble(target);
							} catch (NumberFormatException e){
								errors.add(tname, new ActionMessage("par.precision.to.double",tdescription));
							}
						} // end numeric
						if (ab.getType()==AttributeBean.STRING){
							if (target.length()>ab.getLength()){
								errors.add(tname, new ActionMessage("par.length.invalid",tdescription+"="+ab.getLength()));
							}
						} // end varchar
					} // end target	
				} // end mandatory
			} // end while
		}
		return errors;
	}
	
	public HTMLclass getPresentation() {
		return presentation;
	}
	public void setPresentation(HTMLclass presentation) {
		this.presentation = presentation;
	}
	public Vector getAttributeBeanVector() {
		return attributeBeanVector;
	}
	public void setAttributeBeanVector(Vector attributeBeanVector) {
		this.attributeBeanVector = attributeBeanVector;
	}
	public Collection getClassCollection() {
		return classCollection;
	}
	public void setClassCollection(Collection classCollection) {
		this.classCollection = classCollection;
	}
	public Vector getColumnVector() {
		return columnVector;
	}
	public void setColumnVector(Vector columnVector) {
		this.columnVector = columnVector;
	}
	public int getCurrentPage() {
		return currentPage;
	}
	public void setCurrentPage(int currentPage) {
		this.currentPage = currentPage;
	}
	public Vector getLookupVector() {
		return lookupVector;
	}
	public void setLookupVector(Vector lookupVector) {
		this.lookupVector = lookupVector;
	}
	public String getMethod() {
		return method;
	}
	public void setMethod(String method) {
		this.method = method;
	}
	public Vector getRowIdVector() {
		return rowIdVector;
	}
	public void setRowIdVector(Vector rowIdVector) {
		this.rowIdVector = rowIdVector;
	}
	public String getSearch() {
		return search;
	}
	public void setSearch(String search) {
		this.search = search;
	}
	public int getTotalPages() {
		return totalPages;
	}
	public void setTotalPages(int totalPages) {
		this.totalPages = totalPages;
	}
	public String getMode() {
		return mode;
	}
	public void setMode(String mode) {
		this.mode = mode;
	}
	public String getClassDescription() {
		return classDescription;
	}
	public void setClassDescription(String classDescription) {
		this.classDescription = classDescription;
	}
	public String getMasterDetail() {
		return masterDetail;
	}
	public void setMasterDetail(String masterDetail) {
		this.masterDetail = masterDetail;
	}
	public int getClassId() {
		return classId;
	}
	public void setClassId(int classId) {
		this.classId = classId;
	}
	public String getClassName() {
		return className;
	}
	public void setClassName(String className) {
		this.className = className;
	}
	public int getObjId() {
		return objId;
	}
	public void setObjId(int objId) {
		this.objId = objId;
	}
	public String getTargetClass() {
		return targetClass;
	}
	public void setTargetClass(String targetClass) {
		this.targetClass = targetClass;
	}
	public String getTargetObjId() {
		return targetObjId;
	}
	public void setTargetObjId(String targetObjId) {
		this.targetObjId = targetObjId;
	}

} // end class
