package cmdbuild.action_forms;
import java.sql.*;
import java.util.*;

import cmdbuild.presentation.HTMLclass;
import cmdbuild.collection.*;
import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBclass;
import cmdbuild.elements.CMDBlookup;
import cmdbuild.utils.MultiLanguage;
import cmdbuild.utils.SecurityDescriptor;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;

public class CardPopupForm extends ActionFormTemplate {

	static final long serialVersionUID = 1L;
	private String masterClass;
	private int masterObjId;
	private String detailClass;
	private int detailObjId;
	private String classDescription="";
	private String method;
	private String mode;
	private String search; 
	private String className;
	private Vector columnVector;  // contains a list of parameters (attributes) to display
	private Vector rowIdVector; // contains all the row from the query
	private Vector reportVector; // matrix that contains reports to display 
	private Vector attributeBeanVector;
	private Collection classCollection;
	private Vector treeVector;
	private Vector lookupVector; // contains objects lookup where name=type & description=<option></option>...
	private Hashtable referenceHash; // contains references (LookupBean)
	private CMDBclass CMDB;
	private HTMLclass presentation;
	private boolean superClass;

	public CardPopupForm() {
		super();
	}
	
	public void reset(ActionMapping mapping, HttpServletRequest request) {
		DEBUG.println("**CARDPOPUPFORM RESET**");
        DBService db = (DBService)servlet.getServletContext().getAttribute("db");
        ErrorBean err = null;
		SecurityDescriptor user = null;
		if (request.getSession().getAttribute("user")!=null){
			user = (SecurityDescriptor)request.getSession().getAttribute("user");
		}
        CMDB = new CMDBclass(db);
        CMDBlookup LOOKUP = new CMDBlookup(db);
		if (request.getParameter("mode") != null){
			mode = request.getParameter("mode");
		} else {
			mode="create";
		}
		if (request.getParameter("masterclass") != null){
			masterClass = request.getParameter("masterclass");
		} else {
			masterClass = "";
		}
		if (request.getParameter("masterobjid") != null){
			try {
				masterObjId = Integer.parseInt(request.getParameter("masterobjid"));
			} catch (NumberFormatException e) {
				masterObjId = 0;
			}
		}
		if (request.getParameter("detailclass") != null){
			detailClass = request.getParameter("detailclass");
		} else {
			detailClass = "";
		}
        // used only in mode modify
		if (request.getParameter("classid") != null){
			int classid = 0;
			try {
				classid = Integer.parseInt(request.getParameter("classid"));
			} catch (NumberFormatException e) {
			}
			ClassBean cb = new ClassBean();
			if (classid!=0){
				try {
					cb = CMDB.selectClassById(classid);
					detailClass = cb.getName();
				} catch (SQLException e) {
					err = new ErrorBean("cardpopup.jsp",e);
					e.printStackTrace();
				}
			}
		}
		if (request.getParameter("detailobjid") != null){
			try {
				detailObjId = Integer.parseInt(request.getParameter("detailobjid"));
			} catch (NumberFormatException e) {
				detailObjId = 0;
			}
		}
		String str = "";
		superClass = false;
		if (request.getParameter("superclass") != null){
			str = request.getParameter("superclass");
			if (str.equals("true")){
				superClass = true;
			}
		} 
		DEBUG.println("mode="+mode+" mclass="+masterClass+" dclass="+detailClass+" mobjId="+masterObjId+" dobjid="+detailObjId+" superClass="+superClass);
		InheritsBean inh = null; 
		if (masterClass==null || masterClass.length()==0){
			inh = (InheritsBean) request.getSession().getAttribute("cardpopup");
			masterClass = inh.getParent();
			masterObjId = inh.getParentId();
			detailClass = inh.getChild();
			detailObjId = inh.getChildId();
			mode = inh.getParentDescription();
			if (inh.getChildDescription().equals("true")){
				superClass = true;
			} else {
				superClass = false;
			} 
		}
		DEBUG.println("mode="+mode+" mclass="+masterClass+" dclass="+detailClass+" mobjId="+masterObjId+" dobjid="+detailObjId);
		DEBUG.println("mode="+mode);
	    if (mode.equals("create")) {
	    	classCollection = new ArrayList();
	    	if (superClass){
	    		DEBUG.println("in query selectNormalChilds");
				try {
					if (treeVector==null){
						treeVector = CMDB.selectClassTree();
					}
					classCollection = CMDB.selectNormalChilds(detailClass,treeVector);		       
				} catch (SQLException e) {
					err = new ErrorBean("cardpopupform.jsp",e);
					e.printStackTrace();
				}
				if (search!=null){
					className = search;
				} else {
					// get first element
					Iterator it = classCollection.iterator();
					ClassBean cbd = new ClassBean();
					if (it.hasNext()){
						cbd = (ClassBean) it.next();
						className = cbd.getName();
					}
				}
				try {
					attributeBeanVector = CMDB.selectAllAttribute(className,"rw") ;		       
				} catch (SQLException e) {
					err = new ErrorBean("cardform.jsp",e);
					e.printStackTrace();
				}
	    	} else {
		    	className = detailClass;
				try {
					attributeBeanVector = CMDB.selectAllAttribute(className,"rw") ;		       
				} catch (SQLException e) {
					err = new ErrorBean("cardform.jsp",e);
					e.printStackTrace();
				}
				if (classCollection.size()==0){
					ClassBean cbd = new ClassBean();
					if (attributeBeanVector!=null && attributeBeanVector.size()>0){
						cbd = ((AttributeBean)attributeBeanVector.elementAt(0)).getClassBean();
						classCollection.add(cbd);
					}
				}
	    	}
	    } else {
	    	className = detailClass;
			try {
				attributeBeanVector = CMDB.selectAllAttribute(className,"rw") ;		       
			} catch (SQLException e) {
				err = new ErrorBean("cardform.jsp",e);
				e.printStackTrace();
			}
	    }
		if (attributeBeanVector!=null && attributeBeanVector.size()>0){
			classDescription = ((AttributeBean)attributeBeanVector.elementAt(0)).getClassBean().getDescription();
		}
		AttributeBean ab = null;
		Enumeration en = null;
		Vector options= new Vector();
		referenceHash = new Hashtable();
		lookupVector = new Vector();
		referenceHash = new Hashtable();
		DEBUG.println("className="+className+" objid="+detailObjId+" attributeVector="+attributeBeanVector);
		try {
			columnVector = CMDB.selectCard(className,detailObjId,attributeBeanVector);		       
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		//if (objId==0){DEBUG.println("rowId  nullo!");}
		if (columnVector==null){DEBUG.println("columnVector  nullo!");}
		HashSet hash = new HashSet();
		if (columnVector!=null && columnVector.size()>0){
			en = columnVector.elements();
			while (en.hasMoreElements()){
				ab = (AttributeBean)en.nextElement();
				if (!ab.getName().equals("Id") && !ab.getName().equals("IdClass")){
					if (ab.getType()==AttributeBean.LOOKUP){
						hash.add(ab.getLookup());
					}
					if (ab.getType()==AttributeBean.REFERENCE){
						try {
							if (!referenceHash.containsKey(ab.getReference()) && ab.getReference().length()>0){ // don't get duplicates
								DEBUG.println("Getting reference for "+ab.getReference());
								options = LOOKUP.selectAllReference(ab.getReference());
								referenceHash.put(ab.getReference(),options);
							}
						} catch (SQLException e) {
							err = new ErrorBean("cardpopup.jsp",e);
							e.printStackTrace();
						}
					}
				}
			}
			// getting lookups
			try {
				options = new Vector();
				options.addAll(hash);
				lookupVector = LOOKUP.selectLookupByTypes(options);
			} catch (SQLException e) {
				err = new ErrorBean("cardpopup.jsp",e);
				e.printStackTrace();
			}
		}
		// getting general class info
	    ClassBean bean = CMDB.getBean();
		// getting user from session
		CMDB = CMDB.load(CMDB,CMDB.getBean().getManager());
		presentation = (HTMLclass)CMDB.getPresentation();
		MultiLanguage multilanguage = (MultiLanguage)request.getSession().getAttribute("multilanguage");
		presentation.setMultilanguage(multilanguage);
		presentation.setClassName(className);
		presentation.setClassCollection(classCollection);
		presentation.setCategory(bean.getCategory());
		presentation.setAssetVector(columnVector);
		presentation.setReportVector(reportVector);
		presentation.setLookupVector(lookupVector);
		presentation.setReferenceHash(referenceHash);
		presentation.setReferenceId(masterObjId);
		presentation.setClassDescription(classDescription);
		presentation.setUser(user);
		presentation.getHeader().setVisible(false);
		// setting calendar reference
		presentation.setFormName("cardPopupForm");
			
		if (err!=null){
			request.getSession().setAttribute("error",err);
		}
		
		// saving request info
		inh = new InheritsBean();
		inh.setParent(masterClass);
		inh.setParentId(masterObjId);
		inh.setChild(detailClass);
		inh.setChildId(detailObjId);
		inh.setParentDescription(mode);
		inh.setChildDescription(superClass+"");
		request.getSession().setAttribute("cardpopup",inh);
	}

	public ActionErrors validate(ActionMapping arg0, HttpServletRequest arg1) {
		DEBUG.println("**VALIDATE**");
		mode = (String)arg1.getSession().getAttribute("mode");
		//DEBUG.println("Mode is "+mode);
		ActionErrors errors = new ActionErrors();
		AssetBean ab = null;
		String tname = "";
		String tdescription = "";
		String target="";
		String actionMethod = arg1.getParameter("method");
		DEBUG.println("columnVector.size"+columnVector.size());
		if (!mode.equals("show") && !actionMethod.equals("search")){
			Enumeration en = columnVector.elements();
			while (en.hasMoreElements()){
				ab = (AssetBean)en.nextElement();
				if (ab.getMandatory().equals("Y")){
					tname = ab.getName();
					tdescription = ab.getDescription();
					target= arg1.getParameter(tname);
					//DEBUG.println("target is "+tname+"target value="+target);
					if (target == null || target.trim().equals("")){ // ,tname
						errors.add(tname, new ActionMessage("par.required",tdescription));
					} else { // if there is something
						if (ab.getType()==AttributeBean.INTEGER){
							try {
								Integer.parseInt(target);
							} catch (NumberFormatException e){
								errors.add(tname, new ActionMessage("par.precision.to.integer",tdescription));
							}
						} // end int4
						if (ab.getType()==AttributeBean.DOUBLE){
							try {
								Double.parseDouble(target);
							} catch (NumberFormatException e){
								errors.add(tname, new ActionMessage("par.precision.to.double",tdescription));
							}
						} // end float8
						if (ab.getType()==AttributeBean.DECIMAL){
							try {
								Double.parseDouble(target);
							} catch (NumberFormatException e){
								errors.add(tname, new ActionMessage("par.precision.to.double",tdescription));
							}
						} // end numeric
						if (ab.getType()==AttributeBean.STRING){
							if (target.length()>ab.getLength()){
								errors.add(tname, new ActionMessage("par.length.invalid",tdescription+"="+ab.getLength()));
							}
						} // end varchar
					} // end else	
				} else {  // not mandatory
					tname = ab.getName();
					tdescription = ab.getDescription();
					target= arg1.getParameter(tname);
					DEBUG.println("target value="+target);
					if (target != null && !target.trim().equals("")){ // if there is something
						if (ab.getType()==AttributeBean.INTEGER){
							try {
								Integer.parseInt(target);
							} catch (NumberFormatException e){
								errors.add(tname, new ActionMessage("par.precision.to.integer",tdescription));
							}
						} // end numeric
						if (ab.getType()==AttributeBean.DOUBLE){
							try {
								Double.parseDouble(target);
							} catch (NumberFormatException e){
								errors.add(tname, new ActionMessage("par.precision.to.double",tdescription));
							}
						} // end numeric
						if (ab.getType()==AttributeBean.DECIMAL){
							try {
								Double.parseDouble(target);
							} catch (NumberFormatException e){
								errors.add(tname, new ActionMessage("par.precision.to.double",tdescription));
							}
						} // end numeric
						if (ab.getType()==AttributeBean.STRING){
							if (target.length()>ab.getLength()){
								errors.add(tname, new ActionMessage("par.length.invalid",tdescription+"="+ab.getLength()));
							}
						} // end varchar
					} // end target	
				} // end mandatory
			} // end while
		}
		return errors;
	}
	
	/*
	public ActionErrors validate(ActionMapping arg0, HttpServletRequest arg1) {
		DEBUG.println("**VALIDATE**");
		mode = (String)arg1.getSession().getAttribute("mode");
		DEBUG.println("Mode is "+mode);
		ActionErrors errors = new ActionErrors();
		AssetBean ab = null;
		String tname = "";
		String tdescription = "";
		String target="";
		Enumeration en = columnVector.elements();
		while (!mode.equals("show") && en.hasMoreElements()){
			ab = (AssetBean)en.nextElement();
			if (ab.getMandatory().equals("Y")){
				tname = ab.getName();
				tdescription = ab.getDescription();
				target= arg1.getParameter(tname);
				//DEBUG.println("target is "+tname+"target value="+target);
				if (target == null || target.trim().equals("")){ // ,tname
					errors.add(tname, new ActionMessage("par.required",tdescription));
				} else { // if there is something
					if (ab.getType()==AttributeBean.INTEGER){
						try {
							Integer.parseInt(target);
						} catch (NumberFormatException e){
							errors.add(tname, new ActionMessage("par.precision.to.integer",tdescription));
						}
					} // end int4
					if (ab.getType()==AttributeBean.DOUBLE){
						try {
							Double.parseDouble(target);
						} catch (NumberFormatException e){
							errors.add(tname, new ActionMessage("par.precision.to.double",tdescription));
						}
					} // end float8
					if (ab.getType()==AttributeBean.DECIMAL){
						try {
							Double.parseDouble(target);
						} catch (NumberFormatException e){
							errors.add(tname, new ActionMessage("par.precision.to.double",tdescription));
						}
					} // end numeric
					if (ab.getType()==AttributeBean.STRING){
						if (target.length()>ab.getLength()){
							errors.add(tname, new ActionMessage("par.length.invalid",tdescription+"="+ab.getLength()));
						}
					} // end varchar
				} // end else	
			} else {  // not mandatory
				tname = ab.getName();
				tdescription = ab.getDescription();
				target= arg1.getParameter(tname);
				DEBUG.println("target value="+target);
				if (target != null && !target.trim().equals("")){ // if there is something
					if (ab.getType()==AttributeBean.INTEGER){
						try {
							Integer.parseInt(target);
						} catch (NumberFormatException e){
							errors.add(tname, new ActionMessage("par.precision.to.integer",tdescription));
						}
					} // end numeric
					if (ab.getType()==AttributeBean.DOUBLE){
						try {
							Double.parseDouble(target);
						} catch (NumberFormatException e){
							errors.add(tname, new ActionMessage("par.precision.to.double",tdescription));
						}
					} // end numeric
					if (ab.getType()==AttributeBean.DECIMAL){
						try {
							Double.parseDouble(target);
						} catch (NumberFormatException e){
							errors.add(tname, new ActionMessage("par.precision.to.double",tdescription));
						}
					} // end numeric
					if (ab.getType()==AttributeBean.STRING){
						if (target.length()>ab.getLength()){
							errors.add(tname, new ActionMessage("par.length.invalid",tdescription+"="+ab.getLength()));
						}
					} // end varchar
				} // end else	
			}
		}
		return errors;
	}
	*/
	
	public HTMLclass getPresentation() {
		return presentation;
	}
	public void setPresentation(HTMLclass presentation) {
		this.presentation = presentation;
	}
	public Vector getAttributeBeanVector() {
		return attributeBeanVector;
	}
	public void setAttributeBeanVector(Vector attributeBeanVector) {
		this.attributeBeanVector = attributeBeanVector;
	}
	public Vector getColumnVector() {
		return columnVector;
	}
	public void setColumnVector(Vector columnVector) {
		this.columnVector = columnVector;
	}
	public Vector getLookupVector() {
		return lookupVector;
	}
	public void setLookupVector(Vector lookupVector) {
		this.lookupVector = lookupVector;
	}
	public String getMethod() {
		return method;
	}
	public void setMethod(String method) {
		this.method = method;
	}
	public Vector getRowIdVector() {
		return rowIdVector;
	}
	public void setRowIdVector(Vector rowIdVector) {
		this.rowIdVector = rowIdVector;
	}
	public String getSearch() {
		return search;
	}
	public void setSearch(String search) {
		this.search = search;
	}
	public String getMode() {
		return mode;
	}
	public void setMode(String mode) {
		this.mode = mode;
	}
	public String getClassDescription() {
		return classDescription;
	}
	public void setClassDescription(String classDescription) {
		this.classDescription = classDescription;
	}
	public String getDetailClass() {
		return detailClass;
	}
	public void setDetailClass(String detailClass) {
		this.detailClass = detailClass;
	}
	public int getDetailObjId() {
		return detailObjId;
	}
	public void setDetailObjId(int detailObjId) {
		this.detailObjId = detailObjId;
	}
	public String getMasterClass() {
		return masterClass;
	}
	public void setMasterClass(String masterClass) {
		this.masterClass = masterClass;
	}
	public int getMasterObjId() {
		return masterObjId;
	}
	public void setMasterObjId(int masterObjId) {
		this.masterObjId = masterObjId;
	}
	public boolean isSuperClass() {
		return superClass;
	}
	public void setSuperClass(boolean superClass) {
		this.superClass = superClass;
	}

} // end class
