package cmdbuild.action_forms;
import java.sql.*;
import java.util.*;
import java.util.regex.Pattern;

import cmdbuild.collection.*;
import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBcategory;
import cmdbuild.elements.CMDBclass;
import cmdbuild.utils.Settings;
import cmdbuild.utils.MultiLanguage;
import cmdbuild.presentation.HTMLclass;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;

public class ClassForm extends ActionFormTemplate {
	
	static final long serialVersionUID = 1L;
	private String method;
	private String className; // memorizza il vecchio nome
	private String mode;
	private String name;         // form element
	private String description;  // form element
	private String manager;      // form element
	private String inherits;	 // form element
	private boolean superClass;	 // form element
	private String status;		 // form element
	private String search;
	private Collection classCollection;
	private Collection superCollection;
	private Collection categoryCollection;
	private CMDBclass CMDB;
	private HTMLclass presentation;
	private ClassBean classBean;
	private boolean validate;

	public ClassForm() {
		super();
	}
	
	public void reset(ActionMapping mapping, HttpServletRequest request) {
		validate = false; // setted only by javascript, and used in validate()
		System.out.println("**CLASSFORM RESET**");
        DBService db = (DBService)servlet.getServletContext().getAttribute("db");
		CMDB = new CMDBclass(db);
		//if ( classCollection == null ) {
	    	classCollection = new ArrayList();
			try {
				//classCollection = db.selectAllClass();
				classCollection = CMDB.selectAllClass();
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
	    //}
		if ( superCollection == null ) {
	    	superCollection = new ArrayList();
			try {
				//classCollection = db.selectAllClass();
				superCollection = CMDB.selectSuperClasses();
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
	    }
		if (request.getParameter("class") != null){
			className = request.getParameter("class");
			request.getSession().setAttribute("class",className);
		} else if (request.getSession().getAttribute("class") != null) {
				className = (String)request.getSession().getAttribute("class");
		} else {
			Settings sett = (Settings)request.getSession().getAttribute("settings");
			className = sett.getStartingClass();
		}
		if (request.getParameter("mode")!=null){
			mode = request.getParameter("mode");
			System.out.println("mode from request");
			//request.getSession().setAttribute("mode",mode);
		} else if (request.getSession().getAttribute("mode")!=null){
			mode = (String)request.getSession().getAttribute("mode");
		} else {
			mode = "show";
		}
		System.out.println("mode="+mode);
		boolean dis;
		if (request.getParameter("disabled") == null){
			dis = true;
		} else {
			dis = Boolean.parseBoolean(request.getParameter("disabled"));
		}
	    CMDBcategory CATEGORY = new CMDBcategory(db);
	    if ( categoryCollection == null ) {
	    	categoryCollection = new ArrayList();
			try {
				categoryCollection = CATEGORY.selectAllCategory();
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		    // removing disabled categories
		    Iterator it = categoryCollection.iterator();
		    CategoryBean catb = null;
		    Vector catVector = new Vector();
		    while(it.hasNext()){
		    	catb = (CategoryBean)it.next();
		    	catVector.add(catb);
		    }
		   int i = 0;
		   Enumeration en = catVector.elements();
		   while(en.hasMoreElements()){
			   catb = (CategoryBean)en.nextElement();
			   if (!catb.getStatus().equals("A")){
				   System.out.println("ModifyClassForm, removing "+catb.getDescription());
				   catVector.remove(i);
			   }
			   i++;
		   }
		   LinkedList lis = new LinkedList(); 
		   en = catVector.elements();
		   while(en.hasMoreElements()){
			   catb = (CategoryBean)en.nextElement();
			   lis.add(catb);
		   }
		   categoryCollection = lis;
	    }
       InheritsBean ib = null;
       if (!mode.equals("create")){
    	   try {
		   	   classBean = CMDB.selectClassByName(className);	
		       } catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
		       }
		       try {
		    	   ib = CMDB.selectSuperClass(className);	
		       } catch (SQLException e) {
					// TODO Auto-generated catch block
		    	   e.printStackTrace();
		       }
		       //System.out.println("ManagersList="+manager+" classBean.getManager()="+classBean.getManager()+" request manage="+request.getSession().getAttribute(""));
	    }
       // getting managersList
	   Settings sett = (Settings)request.getSession().getAttribute("settings");;
       if (manager==null || manager.equals("")){
    	   if (!mode.equals("create") && classBean!=null && classBean.getManager()!=null){
    		   manager = classBean.getManager();
    	   } else { // create mode
    		   //String realPath = request.getContextPath();
        	   manager = (String)sett.getManagersList().toArray()[0];
    	   }
       }
       if (inherits==null){
    	   inherits = "";
       }
       // class loader
       System.out.println("ManagersList="+manager+" request manage="+request.getSession().getAttribute(""));
       //CMDB = (CMDBclass)CMDB.load(CMDB,manager);
       CMDB = CMDB.load(CMDB,manager);
       System.out.println("class="+CMDB.getClass().getName());
       CMDB.setClassManager(manager);
       presentation = (HTMLclass)CMDB.getPresentation();
       MultiLanguage multilanguage = (MultiLanguage)request.getSession().getAttribute("multilanguage");
       presentation.setMultilanguage(multilanguage);
       // patch after delete when className=''
       if (classBean==null){
    	   classBean = new ClassBean();
       }
       if (!mode.equals("create")){
           presentation.setClassName(classBean.getName());
           presentation.setClassDescription(classBean.getDescription());
           presentation.setStatus(classBean.getStatus());
           presentation.setCategory(classBean.getCategory());
           presentation.setManager(classBean.getManager());
           presentation.setCategoryId(classBean.getIdCategory());
       } else {  // create
    	   if (name==null){
    		   name = "";
    	   }
    	   if (description==null){
    		   description = "";
    	   }
    	   presentation.setClassName(name);
    	   presentation.setClassDescription(description);
    	   if (request.getParameter("superClass")!=null && request.getParameter("superClass").equals("on")){
    		   presentation.setSuperClassOn(true);   
    	   } else {
    		   presentation.setSuperClassOn(false);
    	   }
    	   presentation.setInherits(inherits);
    	   presentation.setManager(manager);
       }
       presentation.setManagersList(sett.getManagersList());
       presentation.setClassCollection(classCollection);
       presentation.setSuperClass(ib);
       presentation.setSuperCollection(superCollection);
       presentation.setCategoryCollection(categoryCollection);
       presentation.setDisabled(dis);
       presentation.getHeader().getCreate().setUrl("class.jsp?class="+className+"&mode=create");
       if (!mode.equals("create")){
           presentation.getHeader().getModify().setUrl("class.jsp?class="+className+"&mode=modify");
    	   presentation.getHeader().getDelete().setUrl("javascript:if (confirm('"+multilanguage.getMessage("ClassForm.delete")+"')){classForm.method.value='delete';classForm.submit();}");   
       } else {
           presentation.getHeader().getModify().setUrl("javascript:alert('"+multilanguage.getMessage("ClassForm.selectclass")+"');");
    	   presentation.getHeader().getDelete().setUrl("javascript:alert('"+multilanguage.getMessage("ClassForm.delete")+"');");
       }
       presentation.getHeader().getFilter().setVisible(false);
       presentation.getHeader().getNofilter().setVisible(false);
       presentation.getHeader().getFirst().setVisible(false);
       presentation.getHeader().getPrev().setVisible(false);
       presentation.getHeader().getNext().setVisible(false);
       presentation.getHeader().getLast().setVisible(false);
       presentation.getHeader().getLabel().setVisible(false);
       presentation.getHeader().getPage().setVisible(false);
       presentation.getHeader().getCheckFilter().setVisible(false);
	}
	
	public ActionErrors validate(ActionMapping arg0, HttpServletRequest arg1) {
		ActionErrors errors = new ActionErrors();
		System.out.println("**VALIDATE**");
		String mmode="";  // mode types are: filter,create,modify,show || null
		if (arg1.getParameter("mode")!=null){
			mmode = arg1.getParameter("mode");
			//request.getSession().setAttribute("mode",mmode);
			//System.out.println("mode from request="+mmode);
		} else if (arg1.getSession().getAttribute("mode")!=null){
			mmode = (String)arg1.getSession().getAttribute("mode");
			//System.out.println("mode from session="+mmode);
		} else {
			mmode = "show";
		}
		System.out.println("mode="+mmode+" valisate="+validate);
		if (mmode!=null && !mmode.equals("") && !mmode.equals("show") && validate){ // validate only in create/modify mode
		    Collection cCollection = new ArrayList();
	        DBService db = (DBService)servlet.getServletContext().getAttribute("db");
	        CMDBclass CMDB = new CMDBclass(db);
			try {
				cCollection = CMDB.selectAllClass();		       
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			System.out.println("name="+name);
			name = arg1.getParameter("name");
			System.out.println("arg1 name="+name);
			description = arg1.getParameter("description");
			if (name == null || name.trim().equals("")){
				errors.add("name", new ActionMessage("name.required"));
			} else if (name.indexOf(" ")!=-1){
				errors.add("name", new ActionMessage("name.nospace"));
			} else if (!Pattern.matches("[a-zA-Z0-9]+",name)){
				errors.add("name", new ActionMessage("name.alfanumeric"));
			}
			if (name != null && !name.trim().equals("") && !className.equals(name)){
				Iterator it = cCollection.iterator();
				ClassBean cb = null;
				while(it.hasNext()){
					cb = (ClassBean)it.next();
					if (cb.getName().equals(name)){
						errors.add("Nome esiste", new ActionMessage("name.exists"));
						break;
					}
				}
			}
			if (description == null || description.trim().equals("")){
				//errors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("form.field.required", "Descrizione tabella"));
				errors.add("description", new ActionMessage("description.required"));
			}
			//  add if statement for category and status
		}
		return errors;
	}
	
	public String getMethod() {
		return method;
	}
	public void setMethod(String method) {
		this.method = method;
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public String getDescription() {
		return description;
	}
	public void setDescription(String description) {
		this.description = description;
	}
	public String getSearch() {
		return search;
	}		
	public void setSearch(String search) {
		this.search = search;
	}
	public Collection getClassCollection() {
		return classCollection;
	}
	public void setClassCollection(Collection classCollection) {
		this.classCollection = classCollection;
	}
	public Collection getCategoryCollection() {
		return categoryCollection;
	}
	public void setCategoryCollection(Collection categoryCollection) {
		this.categoryCollection = categoryCollection;
	}
	public String getMode() {
		return mode;
	}
	public void setMode(String mode) {
		this.mode = mode;
	}
	public HTMLclass getPresentation() {
		return presentation;
	}
	public void setPresentation(HTMLclass presentation) {
		this.presentation = presentation;
	}
	public ClassBean getClassBean() {
		return classBean;
	}
	public void setClassBean(ClassBean classBean) {
		this.classBean = classBean;
	}
	public String getClassName() {
		return className;
	}
	public void setClassName(String className) {
		this.className = className;
	}
	public Collection getSuperCollection() {
		return superCollection;
	}
	public void setSuperCollection(Collection superCollection) {
		this.superCollection = superCollection;
	}
	public CMDBclass getCMDB() {
		return CMDB;
	}
	public void setCMDB(CMDBclass cmdb) {
		CMDB = cmdb;
	}
	public String getInherits() {
		return inherits;
	}
	public void setInherits(String inherits) {
		this.inherits = inherits;
	}
	public String getManager() {
		return manager;
	}
	public void setManager(String manager) {
		this.manager = manager;
	}
	public String getStatus() {
		return status;
	}
	public void setStatus(String status) {
		this.status = status;
	}
	public boolean isValidate() {
		return validate;
	}
	public void setValidate(boolean validate) {
		this.validate = validate;
	}
	public boolean isSuperClass() {
		return superClass;
	}
	public void setSuperClass(boolean superClass) {
		this.superClass = superClass;
	}
	
} // end of class
