package cmdbuild.action_forms;

import java.sql.*;
import java.util.*;
import java.util.regex.Pattern;

import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBclass;
import cmdbuild.elements.CMDBlookup;
import cmdbuild.elements.CMDBmap;
import cmdbuild.collection.AttributeBean;
import cmdbuild.collection.ClassBean;
import cmdbuild.collection.DomainBean;
import cmdbuild.collection.ErrorBean;
import cmdbuild.collection.InheritsBean;
import cmdbuild.collection.LookupBean;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;

public class CreateAttributeForm extends ActionFormTemplate {
	
	static final long serialVersionUID = 1L;
	private String method;
	private String className;
	private boolean superClass;
	private String aName;
	private int aIndex;
	private String aDescription;
	private int aType;
	private String extraInput;
	private String aLookup;
	private String aReference;
	private String aReferenceDomain;
	private String aReferenceType;
	private String aDateExpire;
	private String aMandatory;
	private String aDefault;
	private int aDefaultLookup; // value of default if the type is lookup, normally the value that as default=true in Lookup table / hidden tag
	private String aStatus;
	private Collection lookupTypes;
	private Hashtable lookupHash;
	private Vector treeVector;
	private String baseDSP;
	private Collection domainCollection; // used for reference
	private HashSet family;

	public CreateAttributeForm() {
		super();
		// TODO Auto-generated constructor stub
	}
	
	/* (non-Javadoc)
	 * @see org.apache.struts.action.ActionForm#reset(org.apache.struts.action.ActionMapping, javax.servlet.http.HttpServletRequest)
	 */
	public void reset(ActionMapping mapping, HttpServletRequest request) {
		DEBUG.println("**CREATEATTRIBUTEFORM RESET**");
		method = "";
		aType = 0;
		aName = "";
		aDescription = "";
		aDefault = "";
		aMandatory = "N";
		aReferenceType = "";
		if (request.getParameter("class") != null){
			className = request.getParameter("class");
			// initialize all variables
			request.getSession().setAttribute("class",className);
			request.getSession().setAttribute("domainCollection",null);
			request.getSession().setAttribute("family",null);
			request.getSession().setAttribute("lookupHash",null);
			request.getSession().setAttribute("lookupTypes",null);
		} else if (request.getSession().getAttribute("class") != null ){
			className = (String)request.getSession().getAttribute("class");
		} else {
			className="";
		}
        DBService db = (DBService)servlet.getServletContext().getAttribute("db");
        CMDBclass CMDB = new CMDBclass(db);
        ClassBean cb = null;
        ErrorBean err = null;
		try {
			cb = CMDB.selectClassByName(className);
		} catch (SQLException e) {
			err = new ErrorBean("createattribute.jsp",e);
			e.printStackTrace();
		}
		if (cb!=null){
			superClass = cb.isSuperClass();
		}
		CMDBlookup LOOKUP = new CMDBlookup(db);
		LookupBean lb = null;
		if (request.getSession().getAttribute("lookupTypes")!=null){
			lookupTypes = (Collection) request.getSession().getAttribute("lookupTypes");
			DEBUG.println("get lookupTypes from session");
		}
		if (request.getSession().getAttribute("lookupHash")!=null){
			lookupHash = (Hashtable) request.getSession().getAttribute("lookupHash");
			DEBUG.println("get lookupHash from session");
		} else {
			DEBUG.println("get lookupHash from db");
			Vector vett = new Vector();
			try {
				vett = LOOKUP.selectAllLookup();		       
			} catch (SQLException e) {
				err = new ErrorBean("createattribute.jsp",e);
				e.printStackTrace();
			}
			String lasttype="";
			lookupTypes = new LinkedList();
			lookupHash = new Hashtable();
			if (vett.size()>0){
				// mapping lookup type with it's default value
				Enumeration en = vett.elements();
				while (en.hasMoreElements()){
					lb = (LookupBean) en.nextElement();
					if (!lb.getType().equals(lasttype)){ // change of type
						lookupHash.put(lb.getType(),lb); // save the first
						lasttype = lb.getType();
						DEBUG.println("save first "+lb.getType()+" "+lb.getDescription());
					} else { // same type
						if (lb.isDefaultValue()){
							lookupHash.put(lb.getType(),lb); // save default
							DEBUG.println("save default "+lb.getType()+" "+lb.getDescription());
						}
					}
				}
				en = lookupHash.elements();
				while (en.hasMoreElements()){
					lookupTypes.add(en.nextElement());
				}
			}
			request.getSession().setAttribute("lookupHash",lookupHash);
			request.getSession().setAttribute("lookupTypes",lookupTypes);
		}
		// setting default
		if (aType==AttributeBean.LOOKUP){
			DEBUG.println("ab is lookup aLookup="+aLookup);
			if (aLookup!=null && aLookup.length()>0){
				lb = (LookupBean) lookupHash.get(aLookup);
				if (lb!=null){
					aDefault = lb.getDescription();
					aDefaultLookup = lb.getId();
				}
			}
		}	
		// getting domainCollection for reference (only master/detail domains)
		if (request.getSession().getAttribute("domainCollection") != null ){
			 domainCollection = (Collection) request.getSession().getAttribute("domainCollection");
		} else {
			DEBUG.println("domainCollection == null");
	        CMDBmap MAP = new CMDBmap(db);
	        // creating a tree of this class       
	        Hashtable pt = new Hashtable();  // key = child   value = parent
	        DEBUG.println("pt="+pt);
	        treeVector = null;
	        try {
	        	treeVector = CMDB.selectClassTree();
			} catch (SQLException e) {
				err = new ErrorBean("createattribute.jsp",e);
				e.printStackTrace();
			}
			DEBUG.println("treeVector="+treeVector);
	        Enumeration en = treeVector.elements();
	        InheritsBean inh = null;
			while (en.hasMoreElements()){
				inh = (InheritsBean)en.nextElement();
				pt.put(inh.getChild(),inh.getParent());
			}
			String targ = className;
			DEBUG.println("targ="+targ);
			family = new HashSet();
			DEBUG.println("family="+family);
			while (pt.containsKey(targ)){
				family.add(targ);
				targ = (String)pt.get(targ);
			}
			Vector dvett = null;
			Vector domainBeanVector = new Vector();
			try {
				dvett = MAP.selectAllDomain();
			} catch (SQLException e) {
				err = new ErrorBean("createattribute.jsp",e);
				e.printStackTrace();
			}
			en = dvett.elements();
			DomainBean dm = null;
			String str = null;
			while(en.hasMoreElements()){
				dm = (DomainBean)en.nextElement();
				if (family.contains(dm.getStartClass())){
					// domainMode is used as displayed text
					if (dm.getName().startsWith("Map_")){
						str = dm.getName();
						str = str.substring(4,str.length());
						dm.setDomainMode(str);
					} else {
						dm.setDomainMode(dm.getName());
					}
					if (dm.isMasterDetail() && dm.getCardinality().startsWith("N")){
						domainBeanVector.add(dm);
					}
					//dm.setDomainMode(dm.getDirectDescription()+" - "+dm.getInverseDescription());
					//domainBeanVector.add(dm);
				}
				if (family.contains(dm.getEndClass())){
					// domainMode is used as displayed text
					if (dm.getName().startsWith("Map_")){
						str = dm.getName();
						str = str.substring(4,str.length());
						dm.setDomainMode(str);
					} else {
						dm.setDomainMode(dm.getName());
					}
					if (dm.isMasterDetail() && dm.getCardinality().endsWith("N")){
							domainBeanVector.add(dm);	
					}
					//dm.setDomainMode(dm.getDirectDescription()+" - "+dm.getInverseDescription());
					//domainBeanVector.add(dm);
				}
			}	
			DEBUG.println("domaincollection="+domainCollection);
	    	domainCollection = domainBeanVector;
	    	request.getSession().setAttribute("domainCollection",domainCollection);
	    	request.getSession().setAttribute("family",family);
	    }

		if (request.getSession().getAttribute("max")!=null){
			String n = (String) request.getSession().getAttribute("max");
			aIndex = Integer.parseInt(n);
			aIndex = aIndex+1;
		} else {
			aIndex = 1;
		}
		if (err!=null){
			request.getSession().setAttribute("error",err);
		}
	}

	public ActionErrors validate(ActionMapping arg0, HttpServletRequest arg1) {
		DEBUG.println("**VALIDATE**");
        DBService db = (DBService)servlet.getServletContext().getAttribute("db");
		Vector attributeBeanVector = null;
		CMDBclass CMDB = new CMDBclass(db);
		try {
			attributeBeanVector = CMDB.selectAllAttribute(className,"all") ;		       
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		ActionErrors errors = new ActionErrors();
		if (aName == null || aName.trim().equals("")){
			errors.add("aName", new ActionMessage("name.required"));
		} else if (!Pattern.matches("[a-zA-Z0-9]+",aName)){
			errors.add("aName", new ActionMessage("name.alfanumeric"));
		}
		if (aName != null || !aName.trim().equals("")){
			Enumeration en = attributeBeanVector.elements();
			AttributeBean atb = new AttributeBean();
			while(en.hasMoreElements()){
				atb = (AttributeBean)en.nextElement();
				if (atb.getName().equals(aName)){
					errors.add("Nome esiste", new ActionMessage("name.exists"));
					break;
				}
			}
		}
		if (aDescription == null || aDescription.trim().equals("")){
			errors.add("aDescription", new ActionMessage("description.required"));
		}
		if (aType==AttributeBean.STRING){
			if (extraInput==null ||  extraInput.length()==0) {
				errors.add("aType", new ActionMessage("length.required"));
			} else {
				int temp = 0;
				try {
					temp = Integer.parseInt(extraInput);
					if (temp<1){
						errors.add("extraInput", new ActionMessage("length.to.integer"));
					}
				} catch (NumberFormatException e){
					errors.add("extraInput", new ActionMessage("length.to.integer"));
				}
			}
 		} else if (aType==AttributeBean.DECIMAL){
 			if (extraInput==null ||  extraInput.trim().equals("")) {
				errors.add("aType", new ActionMessage("precision.required"));
			}
			double d;
			try {
				d = Double.parseDouble(extraInput);
				if (d<1 || d>1000){
					errors.add("aType", new ActionMessage("precision.range"));
				}
				String dstring = Double.toString(d);
				int a=(int)dstring.charAt(0);
				int b=(int)dstring.charAt(2);
				if (a<b){
					errors.add("aType", new ActionMessage("precision.invalid"));
				}
			} catch (NumberFormatException e){
				errors.add("aType", new ActionMessage("precision.to.double"));
			}
		} else if (aType==AttributeBean.REFERENCE){
			DEBUG.println("ref from request"+arg1.getParameter("AReferenceDomain"));
			DEBUG.println("ref from Str"+aReferenceDomain);
 			if (arg1.getParameter("AReferenceDomain")==null || arg1.getParameter("AReferenceDomain").trim().equals("")) {
				errors.add("aType", new ActionMessage("reference.required"));
			}
 		} else if (aType==AttributeBean.LOOKUP){
 			//int type = f.getAType();
 			LookupBean lb = null;
 			//Hashtable lookupHash = (Hashtable) request.getSession().getAttribute("lookupHash");
			if (aLookup!=null && aLookup.length()>0){
				lb = (LookupBean) lookupHash.get(aLookup);
				if (lb!=null){
					aDefault =lb.getDescription();
					aDefaultLookup = lb.getId();
				}
			}
 		}
		// validate default
		if (aDefault!=null && !aDefault.trim().equals("")) {
			if (aType==AttributeBean.BOOLEAN){
				Boolean.parseBoolean(aDefault);
	 		}
			if (aType==AttributeBean.INTEGER){
				//int i;
				try {
					Integer.parseInt(aDefault);
				} catch (NumberFormatException e){
					errors.add("aDefault", new ActionMessage("precision.to.integer"));
				}
	 		} 
			if (aType==AttributeBean.DECIMAL){
				// double d;
				try {
					Double.parseDouble(aDefault);
				} catch (NumberFormatException e){
					errors.add("aDefault", new ActionMessage("precision.to.double"));
				}
	 		}
			if (aType==AttributeBean.DOUBLE){
				//double d;
				try {
					Double.parseDouble(aDefault);
				} catch (NumberFormatException e){
					errors.add("aDefault", new ActionMessage("precision.to.double"));
				}
	 		} 
			if (aType==AttributeBean.DATE){
				//date d;
	 		} 
			if (aType==AttributeBean.TIMESTAMP){
				//timestamp d;
	 		} 
		} // end mandatory
		//  add if statement for category and status
		return errors;
	}

	public String getADefault() {
		return aDefault;
	}
	public void setADefault(String default1) {
		aDefault = default1;
	}
	public String getADescription() {
		return aDescription;
	}
	public void setADescription(String description) {
		aDescription = description;
	}
	public String getAStatus() {
		return aStatus;
	}
	public void setAStatus(String status) {
		aStatus = status;
	}
	public int getAType() {
		return aType;
	}
	public void setAType(int type) {
		aType = type;
	}
	public String getMethod() {
		return method;
	}
	public void setMethod(String method) {
		this.method = method;
	}
	public String getAName() {
		return aName;
	}
	public void setAName(String name) {
		aName = name;
	}
	public Collection getLookupTypes() {
		return lookupTypes;
	}
	public void setLookupTypes(Collection lookupTypes) {
		this.lookupTypes = lookupTypes;
	}
	public String getClassName() {
		return className;
	}
	public void setClassName(String className) {
		this.className = className;
	}
	public String getAMandatory() {
		return aMandatory;
	}
	public void setAMandatory(String mandatory) {
		aMandatory = mandatory;
	}
	public int getAIndex() {
		return aIndex;
	}
	public void setAIndex(int index) {
		aIndex = index;
	}
	public String getALookup() {
		return aLookup;
	}
	public void setALookup(String lookup) {
		aLookup = lookup;
	}
	public String getExtraInput() {
		return extraInput;
	}
	public void setExtraInput(String extraInput) {
		this.extraInput = extraInput;
	}
	public String getBaseDSP() {
		return baseDSP;
	}
	public void setBaseDSP(String baseDSP) {
		this.baseDSP = baseDSP;
	}
	public int getADefaultLookup() {
		return aDefaultLookup;
	}
	public void setADefaultLookup(int defaultLookup) {
		aDefaultLookup = defaultLookup;
	}
	public boolean isSuperClass() {
		return superClass;
	}
	public void setSuperClass(boolean superClass) {
		this.superClass = superClass;
	}
	public String getAReference() {
		return aReference;
	}
	public void setAReference(String reference) {
		aReference = reference;
	}
	public String getAReferenceDomain() {
		return aReferenceDomain;
	}
	public void setAReferenceDomain(String referenceDomain) {
		aReferenceDomain = referenceDomain;
	}
	public String getAReferenceType() {
		return aReferenceType;
	}
	public void setAReferenceType(String referenceType) {
		aReferenceType = referenceType;
	}
	public String getADateExpire() {
		return aDateExpire;
	}
	public void setADateExpire(String dateExpire) {
		aDateExpire = dateExpire;
	}
	public Vector getTreeVector() {
		return treeVector;
	}
	public void setTreeVector(Vector treeVector) {
		this.treeVector = treeVector;
	}
	public Collection getDomainCollection() {
		return domainCollection;
	}
	public void setDomainCollection(Collection domainCollection) {
		this.domainCollection = domainCollection;
	}
	public HashSet getFamily() {
		return family;
	}
	public void setFamily(HashSet family) {
		this.family = family;
	}
	public Hashtable getLookupHash() {
		return lookupHash;
	}
	public void setLookupHash(Hashtable lookupHash) {
		this.lookupHash = lookupHash;
	}
	
	
} // end of class
