package cmdbuild.action_forms;
import java.sql.*;
import java.util.*;
import java.util.regex.Pattern;

import cmdbuild.collection.*;
import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBclass;
import cmdbuild.elements.CMDBmap;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;

public class CreateDomainForm extends ActionFormTemplate {

	static final long serialVersionUID = 1L;
	private String method;
	private String name;
	private String className; // from request, used in validate method
	private String directDescription;
	private String inverseDescription;
	private String startClass;
	private String endClass;
	// for manage cardinality
	private String card1;
	private String card2;
	private boolean masterDetail;
	private String status;
	private Collection class1;
	private Collection class2;
	private String class1HTMLOption;
	private String class2HTMLOption;

	public CreateDomainForm() {
		super();
	}
	
	public void reset(ActionMapping mapping, HttpServletRequest request) {
		DEBUG.println("**CREATEDOMAIN RESET**");
		method = "";
		if (request.getParameter("class")!=null){
			className = request.getParameter("class");
		}
		/*
		ClassBean obj = new ClassBean();
		obj.setName("Asset"); // add Asset to combo list
		obj.setDescription("Asset");
		obj.setStatus("active");
		*/
        DBService db = (DBService)servlet.getServletContext().getAttribute("db");
		CMDBclass CMDB = new CMDBclass(db);
	    if ( class1 == null ) {
	    	class1 = new ArrayList();
			try {
				class1 = CMDB.selectAllClass();
				class2 = class1;
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
	    }
	}

	public ActionErrors validate(ActionMapping arg0, HttpServletRequest arg1) {
		DEBUG.println("**VALIDATE**");
        DBService db = (DBService)servlet.getServletContext().getAttribute("db");
        Vector allDomainVector = null;
        CMDBmap MAP = new CMDBmap(db);
		try {
			allDomainVector = MAP.selectAllDomain();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		ActionErrors errors = new ActionErrors();
		if (name == null || name.trim().equals("")){
			//errors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("form.field.required", "Nome tabella"));
			errors.add("name", new ActionMessage("name.required"));
		} else if (name.indexOf(" ")!=-1){
			errors.add("name", new ActionMessage("name.nospace"));
		} else if (!Pattern.matches("[a-zA-Z0-9]+",name)){
			errors.add("name", new ActionMessage("name.alfanumeric"));
		}
		if (directDescription == null || directDescription.trim().equals("")){
			//errors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("form.field.required", "Descrizione tabella"));
			errors.add("directDescription", new ActionMessage("description.required"));
		}
		if (inverseDescription == null || inverseDescription.trim().equals("")){
			//errors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("form.field.required", "Descrizione tabella"));
			errors.add("inverseDescription", new ActionMessage("description.required"));
		}
        // creating a tree of this class 
		CMDBclass CMDB = new CMDBclass(db);
        Hashtable pt = new Hashtable();  // key = child   value = parent
        Vector ptv = null;
        try {
			ptv = CMDB.selectClassTree();
		} catch (SQLException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
        Enumeration en = ptv.elements();
        InheritsBean inh = null;
		while (en.hasMoreElements()){
			inh = (InheritsBean)en.nextElement();
			pt.put(inh.getChild(),inh.getParent());
		}
		String targ = className;
		HashSet ptset = new HashSet();
		while (pt.containsKey(targ)){
			ptset.add(targ);
			targ = (String)pt.get(targ);
		}
		if (!ptset.contains(startClass) && !ptset.contains(endClass)){
			errors.add("not linked", new ActionMessage("linked.required"));
		}
		if (name != null || !name.trim().equals("")){
			en = allDomainVector.elements();
			DomainBean dm = new DomainBean();
			while(en.hasMoreElements()){
				dm = (DomainBean)en.nextElement();
				if (dm.getName().equals(name)){
					errors.add("Name exists", new ActionMessage("name.exists"));
					break;
				}
			}
		}
		boolean md = false;
		if (arg1.getParameter("masterDetail")!=null && arg1.getParameter("masterDetail").equals("on")){
			md = true;
		}
		if (md){
			targ = arg1.getParameter("card1")+":"+arg1.getParameter("card2");
			if (targ.equals("N:N") || targ.equals("1:1")){
				errors.add("invalid cardinality", new ActionMessage("domain.invalidcardinality"));
			}
		}
		return errors;
	}

	public Collection getClass1() {
		return class1;
	}
	public void setClass1(Collection class1) {
		this.class1 = class1;
	}
	public Collection getClass2() {
		return class2;
	}
	public void setClass2(Collection class2) {
		this.class2 = class2;
	}
	public String getClass1HTMLOption() {
		return class1HTMLOption;
	}
	public void setClass1HTMLOption(String class1HTMLOption) {
		this.class1HTMLOption = class1HTMLOption;
	}
	public String getClass2HTMLOption() {
		return class2HTMLOption;
	}
	public void setClass2HTMLOption(String class2HTMLOption) {
		this.class2HTMLOption = class2HTMLOption;
	}
	public String getDirectDescription() {
		return directDescription;
	}
	public void setDirectDescription(String directDescription) {
		this.directDescription = directDescription;
	}
	public String getEndClass() {
		return endClass;
	}
	public void setEndClass(String endClass) {
		this.endClass = endClass;
	}
	public String getInverseDescription() {
		return inverseDescription;
	}
	public void setInverseDescription(String inverseDescription) {
		this.inverseDescription = inverseDescription;
	}
	public String getMethod() {
		return method;
	}
	public void setMethod(String method) {
		this.method = method;
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public String getStartClass() {
		return startClass;
	}
	public void setStartClass(String startClass) {
		this.startClass = startClass;
	}
	public String getStatus() {
		return status;
	}
	public void setStatus(String status) {
		this.status = status;
	}
	public String getClassName() {
		return className;
	}
	public void setClassName(String className) {
		this.className = className;
	}
	public String getCard1() {
		return card1;
	}
	public void setCard1(String card1) {
		this.card1 = card1;
	}
	public String getCard2() {
		return card2;
	}
	public void setCard2(String card2) {
		this.card2 = card2;
	}
	public boolean isMasterDetail() {
		return masterDetail;
	}
	public void setMasterDetail(boolean masterDetail) {
		this.masterDetail = masterDetail;
	}

} // end of class
