package cmdbuild.action_forms;

import java.sql.SQLException;
import java.util.Collection;
import java.util.Iterator;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;

import cmdbuild.collection.ErrorBean;
import cmdbuild.collection.MacroCategoryBean;
import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBmacrocategory;

public class CreateMacroCategoryForm extends ActionFormTemplate {
	
	static final long serialVersionUID = 1L;
	private String method;
	private String description;
	private String status;
	private Collection macroCategories;

	public CreateMacroCategoryForm() {
		super();
	}
	
	public void reset(ActionMapping mapping, HttpServletRequest request) {
		DEBUG.println("**CREATEMACROCATEGORY**");
		method = "";
	} // end reset method

	public ActionErrors validate(ActionMapping arg0, HttpServletRequest arg1) {
		ErrorBean err = null;
		DBService db = (DBService)servlet.getServletContext().getAttribute("db");
		CMDBmacrocategory MACROCATEGORY = new CMDBmacrocategory(db);
		try {
			macroCategories = MACROCATEGORY.selectAllMacroCategory();
		} catch (SQLException e) {
			err = new ErrorBean("createmacrocategory.jsp",e);
			e.printStackTrace();
		}
		ActionErrors errors = new ActionErrors();
		if (description == null || description.trim().equals("")){
			errors.add("description", new ActionMessage("description.required"));
		}
		if (description!=null){
			description = description.trim();
			Iterator it = macroCategories.iterator();
			MacroCategoryBean mc = null;
			while (it.hasNext()){
				mc = (MacroCategoryBean) it.next();
				if (mc.getDescription().equals(description)){
					errors.add("description", new ActionMessage("name.exists"));
					break;
				}
			}
		}
		if (err!=null){
			arg1.getSession().setAttribute("error",err);
		}
		return errors;
	}
	
	public String getDescription() {
		return description;
	}
	public void setDescription(String description) {
		this.description = description;
	}
	public String getMethod() {
		return method;
	}
	public void setMethod(String method) {
		this.method = method;
	}
	public String getStatus() {
		return status;
	}
	public void setStatus(String status) {
		this.status = status;
	}

	
}  // end of class
