package cmdbuild.action_forms;

import cmdbuild.db.DBService;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.*;

import cmdbuild.utils.MultiLanguage;
import cmdbuild.utils.SecurityDescriptor;
import cmdbuild.wizards.WizardReport;

public class CreateReportForm extends ActionForm {

	static final long serialVersionUID = 1L;
	private String method;
	private WizardReport rep; // HTML producer 
	private int reportPage;  // 1..n
	private int reportSubPage; // used in page2  0..n
	private String mpath;	// path to delete/save     0A1A5A etc...

	public void reset(ActionMapping mapping, HttpServletRequest request) {
		System.out.println("**CREATEREPORT RESET**");
		reportPage = 1;
	    if (request.getParameter("reportpage") != null){
			reportPage = Integer.parseInt(request.getParameter("reportpage"));
			request.getSession().setAttribute("reportpage",reportPage+"");
	    } else if (request.getSession().getAttribute("reportpage") != null){
			reportPage = Integer.parseInt((String)request.getSession().getAttribute("reportpage"));
		} 
	    reportSubPage = 0;
	    if (request.getParameter("reportsubpage") != null){
			reportSubPage = Integer.parseInt(request.getParameter("reportsubpage"));
			request.getSession().setAttribute("reportsubpage",reportSubPage+"");
	    } else if (request.getSession().getAttribute("reportsubpage") != null){
			reportSubPage = Integer.parseInt((String)request.getSession().getAttribute("reportsubpage"));
		} 
	    DBService db = (DBService)servlet.getServletContext().getAttribute("db");
	    MultiLanguage multilanguage = (MultiLanguage)request.getSession().getAttribute("multilanguage");
	    if (request.getSession().getAttribute("report")!=null){
	    	rep = (WizardReport)request.getSession().getAttribute("report");	
	    	//System.out.println("getting report from session");
	    } else {
	    	rep = new WizardReport(db,multilanguage,"createReport");
			// getting user from session
			SecurityDescriptor user = null;
			if (request.getSession().getAttribute("user")!=null){
				user = (SecurityDescriptor)request.getSession().getAttribute("user");
			}
			rep.setUser(user);
			request.getSession().setAttribute("report",rep);
			//System.out.println("creating report");
	    }
	    rep.setSubPage(reportSubPage);
	    rep.getDataForPage(request,reportPage);
	    //request.setAttribute("importForm",this);
	}

	public ActionErrors validate(ActionMapping arg0, HttpServletRequest arg1) {
		ActionErrors errors = new ActionErrors();
		//System.out.println("**VALIDATE** page="+reportPage);
		System.out.println("**VALIDATE**");
		if (reportPage==1){
			//System.out.println("title="+arg1.getParameter("title")+"*");
			if (arg1.getParameter("title")==null || arg1.getParameter("title").length()==0){
				errors.add("createreport", new ActionMessage("name.required"));
			}
		}
		if (reportPage==4){
			if (rep.getQueryFactory().getOrders().size()==0){
				errors.add("createreport", new ActionMessage("report.useless"));
			}
		}
		return errors;
	}

	
	public String getMethod() {
		return method;
	}
	public void setMethod(String method) {
		this.method = method;
	}
	public WizardReport getRep() {
		return rep;
	}
	public void setRep(WizardReport rep) {
		this.rep = rep;
	}
	public int getReportPage() {
		return reportPage;
	}
	public void setReportPage(int reportPage) {
		this.reportPage = reportPage;
	}
	public int getSubPage() {
		return reportSubPage;
	}
	public void setSubPage(int subPage) {
		this.reportSubPage = subPage;
	}
	public String getMpath() {
		return mpath;
	}
	public void setMpath(String mpath) {
		this.mpath = mpath;
	}
	public int getReportSubPage() {
		return reportSubPage;
	}
	public void setReportSubPage(int reportSubPage) {
		this.reportSubPage = reportSubPage;
	}
	
	
} // end of class
