package cmdbuild.action_forms;
import java.sql.*;
import java.util.*;

import cmdbuild.presentation.HTMLclass;
import cmdbuild.collection.*;
import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBclass;
import cmdbuild.elements.CMDBlookup;
import cmdbuild.utils.MultiLanguage;
import cmdbuild.utils.SecurityDescriptor;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionMapping;

public class FindRelationForm extends ActionFormTemplate {

	static final long serialVersionUID = 1L;
	private String className;
	private int classId;
	private String method;
	private String mode;
	private String search; 
	private HTMLclass relation; // object that generates HTML code
	private Vector columnVector;  // contains a list of parameters (attributes) to display
	private Vector rowIdVector; // contains all the row from the query
	private Vector attributeBeanVector;
	private Vector lookupVector; // contains objects lookup where name=type & description=<option></option>...
	private Hashtable referenceHash;
	private int currentPage=1;  // the first page corrisponds to vector[0]
	private int totalPages=0;
	private int rowId;  // contains the real id of the row
	private Collection classCollection; // only used in mode modify e create
	private String openerFormName; // used to store information about a class relation
	private String assetNo;
	private String description;
	private String oggetto; // this string is sent to complete createRelation form
	private LabelsBean labelsBean;


	public FindRelationForm() {
		super();
		// TODO Auto-generated constructor stub
	}
	
	public void reset(ActionMapping mapping, HttpServletRequest request) {
		System.out.println("**FINFRELATIONFORM**");
		ErrorBean err = null;
		openerFormName="createRelationForm"; // the form that opens this windows		
		relation = null;
		lookupVector=new Vector();
        DBService db = (DBService)servlet.getServletContext().getAttribute("db");
		CMDBclass CMDB = new CMDBclass(db);
	    if ( classCollection == null ) {
	    	classCollection = new ArrayList();
			try {
				classCollection = CMDB.selectAllClass();		       
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
	    }
		
		if (request.getParameter("class") != null){
			className = request.getParameter("class");
			request.getSession().setAttribute("class",className);
		} else if (request.getSession().getAttribute("class") != null){
 			className = (String)request.getSession().getAttribute("class");
		}
		if (request.getParameter("page") != null){
			currentPage = Integer.parseInt(request.getParameter("page"));
			request.getSession().setAttribute("page",""+currentPage);
		} else if (request.getSession().getAttribute("page") != null){
 			currentPage = Integer.parseInt((String) request.getSession().getAttribute("page"));
		}
		if (request.getParameter("mode") != null){
			mode = request.getParameter("mode");
			request.getSession().setAttribute("mode",mode);
		} else if (request.getSession().getAttribute("mode") != null){
			mode = (String) request.getSession().getAttribute("mode");
		} else {
			mode="";
		}

		System.out.println("currentPage="+currentPage);		
		System.out.println("name="+className);
        // getting class ID
		try {
			classId = CMDB.selectClassByName(className).getId();		       
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
        FilterBean filterBean = null;
        if (rowIdVector == null){
        	String baseQuery = "SELECT \"Id\" FROM \""+className+"\" ";
        	filterBean = (FilterBean)request.getSession().getAttribute("filterRelationBean");
        	if (filterBean == null){
        		try {
        			rowIdVector = CMDB.selectCardsId(baseQuery) ;		       
        		} catch (SQLException e) {
        			// TODO Auto-generated catch block
        			e.printStackTrace();
        		}
        	} else if (filterBean.getClassName().equals(className)){
        		// eventualmente vedere se name viene da request e in tal caso ricaricare da database
        		rowIdVector = filterBean.getRowIdVector();
        	} else { // filterBean.getClassName() != name
        		try {
        			rowIdVector = CMDB.selectCardsId(baseQuery) ;
        			request.getSession().setAttribute("filterRelationBean",null);
        		} catch (SQLException e) {
        			// TODO Auto-generated catch block
        			e.printStackTrace();
        		}
        	}
        } 
		totalPages = rowIdVector.size();
		if (rowIdVector==null){System.out.println("rowIdVector  nullo!");}
		if (rowIdVector.size()>0){
			if(currentPage < 1){
				currentPage = 1;
			} else if (currentPage>totalPages){
				currentPage = 1;
			}
			rowId = ((IdBean)rowIdVector.elementAt(currentPage-1)).getId(); // -1 beacause it's a vector
		} else { // There aren't cards
			currentPage = 0;
		}
		if (rowId==0){System.out.println("rowId  nullo!");}
		System.out.println("rowId in card.reset="+rowId);
		// get extra attributes for the class
		try {
			attributeBeanVector = CMDB.selectAllAttribute(className,"rw") ;		       
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		try {
			columnVector = CMDB.selectCard(className,rowId,attributeBeanVector);		       
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		if (columnVector==null){System.out.println("columnVector  nullo!");}
		// creating lookupVector if there are lookups
		Enumeration enu = columnVector.elements();
		AssetBean ab = null;
		Vector options= new Vector();
		if (enu==null){ System.out.println("enum  nullo"); }
		CMDBlookup LOOKUP = new CMDBlookup(db);
		referenceHash = new Hashtable();
		// creating lookupVector if there are lookups
		lookupVector = new Vector();
		referenceHash = new Hashtable();
		HashSet hash = new HashSet();
		while (enu.hasMoreElements()){
			ab = (AssetBean)enu.nextElement();
			if (ab.getType()==AttributeBean.LOOKUP){
				hash.add(ab.getLookup());
			}
			if (ab.getType()==AttributeBean.REFERENCE){
				try {
					if (!referenceHash.containsKey(ab.getReference()) && ab.getReference().length()>0){ // don't get duplicates
						DEBUG.println("Getting refrence for "+ab.getReference());
						options = LOOKUP.selectAllReference(ab.getReference());
						referenceHash.put(ab.getReference(),options);
					}
				} catch (SQLException e) {
					err = new ErrorBean("findrelation.jsp",e);
					e.printStackTrace();
				}
			}
		}
		// getting lookups
		try {
			options = new Vector();
			options.addAll(hash);
			lookupVector = LOOKUP.selectLookupByTypes(options);
		} catch (SQLException e) {
			err = new ErrorBean("findrelation.jsp",e);
			e.printStackTrace();
		}
		// cleaning page when page=0
		if (currentPage==0){
			Enumeration eni = columnVector.elements();
			AssetBean asb = null;
			while (eni.hasMoreElements()){
				asb = (AssetBean)eni.nextElement();
				asb.setValue(null);
			}
		}
		// getting general class info
        ClassBean bean = new ClassBean();
		try {
			bean= CMDB.selectClassByName(className);	
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		try {
			labelsBean = CMDB.selectCardLabels(className,rowId);		       
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		oggetto = labelsBean.getCode()+" - "+labelsBean.getDescription();
		// prevents javascript problem
		char sq = '\'';
		char dq = '\"';
		char sp = ' ';
		oggetto=oggetto.replace(dq,sp);
		oggetto=oggetto.replace(sq,sp);

		// Creating card Asset
		//relation = new Relation(className,bean.getCategory(),columnVector,lookupVector);
		relation = new HTMLclass();
		MultiLanguage multilanguage = (MultiLanguage)request.getSession().getAttribute("multilanguage");
		relation.setMultilanguage(multilanguage);
		relation.setClassName(className);
		relation.setCategory(bean.getCategory());
		relation.setAssetVector(columnVector);
		relation.setLookupVector(lookupVector);
		relation.setReferenceHash(referenceHash);
		relation.getHeader().getCreate().setVisible(false);
		relation.getHeader().getModify().setVisible(false);
		relation.getHeader().getFilter().setVisible(false);
		relation.getHeader().getNofilter().setVisible(false);
		relation.getHeader().getDelete().setVisible(false);
		relation.getHeader().getCheckFilter().setVisible(false);
		// settings arrows
		if (currentPage==0){
			relation.getHeader().getFirst().setUrl("findrelation.jsp?class="+className+"&page=0");
			relation.getHeader().getPrev().setUrl("findrelation.jsp?class="+className+"&page=0");
			relation.getHeader().getNext().setUrl("findrelation.jsp?class="+className+"&page=0");
		} else if (currentPage==1){
			relation.getHeader().getFirst().setUrl("findrelation.jsp?class="+className+"&page=1");
			relation.getHeader().getPrev().setUrl("findrelation.jsp?class="+className+"&page=1");
			relation.getHeader().getNext().setUrl("findrelation.jsp?class="+className+"&page=2");
		} else if(currentPage==totalPages) {
			relation.getHeader().getFirst().setUrl("findrelation.jsp?class="+className+"&page=1");
			relation.getHeader().getPrev().setUrl("findrelation.jsp?class="+className+"&page="+(totalPages-1));
			relation.getHeader().getNext().setUrl("findrelation.jsp?class="+className+"&page="+totalPages);
		} else {
			relation.getHeader().getFirst().setUrl("findrelation.jsp?class="+className+"&page=1");
			relation.getHeader().getPrev().setUrl("findrelation.jsp?class="+className+"&page="+(currentPage-1));
			relation.getHeader().getNext().setUrl("findrelation.jsp?class="+className+"&page="+(currentPage+1));
		}
		relation.getHeader().getLast().setUrl("findrelation.jsp?class="+className+"&page="+totalPages);
		// setting current page
		relation.getHeader().getPage().setCurrent(currentPage);
		relation.getHeader().getPage().setTotal(totalPages);
		relation.getHeader().getLabel().setLabel("&nbsp;");
		// setting calendar
		relation.setFormName("findRelation");
		String stat="";
		try {
			stat = CMDB.getCardStatus(className,rowId);		       
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		// getting user from session
		SecurityDescriptor user = null;
		String us = null;
		if (request.getSession().getAttribute("user")!=null){
			user = (SecurityDescriptor)request.getSession().getAttribute("user");
			us = user.getUserName();
		}
		if (stat==null){
			try {
				CMDB.setCardStatus(className,rowId,"A",us);	
				stat = "A";
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		if (stat.equals("") || stat.equals("A")){
			relation.setDeleted(false);
		} else {
			relation.setDeleted(true);
		}
		if (err!=null){
			request.getSession().setAttribute("error",err);
		}
	}

	/*
	public ActionErrors validate(ActionMapping arg0, HttpServletRequest arg1) {
		System.out.println("**VALIDATE**");
		ActionErrors errors = new ActionErrors();
		AssetBean ab = null;
		String tname = "";
		String target="";
		Enumeration en = columnVector.elements();
		while (en.hasMoreElements()){
			ab = (AssetBean)en.nextElement();
			if (ab.getAMandatory().equals("Y")){
				tname = ab.getAName();
				target= arg1.getParameter(tname);
				System.out.println("target is="+tname+"target value="+target);
				if (target == null || target.trim().equals("")){
					errors.add("target", new ActionMessage("form.field.required",tname));
				} else { // if there is something
					if (ab.getAType().equals("int4")){
						try {
							Integer.parseInt(target);
						} catch (NumberFormatException e){
							errors.add("aDefault", new ActionMessage("precision.to.integer"));
						}
					} // end numeric
					if (ab.getAType().equals("float8")){
						try {
							Double.parseDouble(target);
						} catch (NumberFormatException e){
							errors.add("aDefault", new ActionMessage("precision.to.double"));
						}
					} // end numeric
					if (ab.getAType().equals("numeric")){
						try {
							Double.parseDouble(target);
						} catch (NumberFormatException e){
							errors.add("aDefault", new ActionMessage("precision.to.double"));
						}
					} // end numeric
				} // end else	
			} else {  // not mandatory
				tname = ab.getAName();
				target= arg1.getParameter(tname);
				System.out.println("target value="+target);
				if (target != null && !target.trim().equals("")){ // if there is something
					if (ab.getAType().equals("int4")){
						try {
							Integer.parseInt(target);
						} catch (NumberFormatException e){
							errors.add("aDefault", new ActionMessage("precision.to.integer"));
						}
					} // end numeric
					if (ab.getAType().equals("float8")){
						try {
							Double.parseDouble(target);
						} catch (NumberFormatException e){
							errors.add("aDefault", new ActionMessage("precision.to.double"));
						}
					} // end numeric
					if (ab.getAType().equals("numeric")){
						try {
							Double.parseDouble(target);
						} catch (NumberFormatException e){
							errors.add("aDefault", new ActionMessage("precision.to.double"));
						}
					} // end numeric
				} // end else	
			}
		}
		return errors;
	}
	*/
	
	public HTMLclass getRelation() {
		return relation;
	}
	public void setRelation(HTMLclass relation) {
		this.relation = relation;
	}
	public Vector getAttributeBeanVector() {
		return attributeBeanVector;
	}
	public void setAttributeBeanVector(Vector attributeBeanVector) {
		this.attributeBeanVector = attributeBeanVector;
	}
	public Collection getClassCollection() {
		return classCollection;
	}
	public void setClassCollection(Collection classCollection) {
		this.classCollection = classCollection;
	}
	public Vector getColumnVector() {
		return columnVector;
	}
	public void setColumnVector(Vector columnVector) {
		this.columnVector = columnVector;
	}
	public int getCurrentPage() {
		return currentPage;
	}
	public void setCurrentPage(int currentPage) {
		this.currentPage = currentPage;
	}
	public Vector getLookupVector() {
		return lookupVector;
	}
	public void setLookupVector(Vector lookupVector) {
		this.lookupVector = lookupVector;
	}
	public String getMethod() {
		return method;
	}
	public void setMethod(String method) {
		this.method = method;
	}
	public String getClassName() {
		return className;
	}
	public void setClassName(String className) {
		this.className = className;
	}

	public int getRowId() {
		return rowId;
	}
	public void setRowId(int rowId) {
		this.rowId = rowId;
	}
	public Vector getRowIdVector() {
		return rowIdVector;
	}
	public void setRowIdVector(Vector rowIdVector) {
		this.rowIdVector = rowIdVector;
	}
	public String getSearch() {
		return search;
	}
	public void setSearch(String search) {
		this.search = search;
	}
	public int getTotalPages() {
		return totalPages;
	}
	public void setTotalPages(int totalPages) {
		this.totalPages = totalPages;
	}
	public String getMode() {
		return mode;
	}
	public void setMode(String mode) {
		this.mode = mode;
	}
	public String getOpenerFormName() {
		return openerFormName;
	}
	public void setOpenerFormName(String openerFormName) {
		this.openerFormName = openerFormName;
	}
	public int getClassId() {
		return classId;
	}
	public void setClassId(int classId) {
		this.classId = classId;
	}
	public String getAssetNo() {
		return assetNo;
	}
	public void setAssetNo(String assetNo) {
		this.assetNo = assetNo;
	}
	public String getDescription() {
		return description;
	}
	public void setDescription(String description) {
		this.description = description;
	}
	public String getOggetto() {
		return oggetto;
	}
	public void setOggetto(String oggetto) {
		this.oggetto = oggetto;
	}
	public LabelsBean getLabelsBean() {
		return labelsBean;
	}
	public void setLabelsBean(LabelsBean labelsBean) {
		this.labelsBean = labelsBean;
	}
	public Hashtable getReferenceHash() {
		return referenceHash;
	}
	public void setReferenceHash(Hashtable referenceHash) {
		this.referenceHash = referenceHash;
	}

} // end class
