package cmdbuild.action_forms;
import java.sql.*;
import java.util.*;

import cmdbuild.presentation.HTMLclass;
import cmdbuild.utils.MultiLanguage;
import cmdbuild.utils.Settings;
import cmdbuild.collection.*;
import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBclass;
import cmdbuild.elements.CMDBlookup;
import cmdbuild.elements.CMDBmap;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;

public class HistoryForm extends ActionFormTemplate {

	static final long serialVersionUID = 1L;
	private String className;
	private int classId;
	private String classDescription="";
	private String method;
	private String mode;
	private String targetClass; // used to implement "go to page" 
	private String targetObjId; // used to implement "go to page"
	private String search; 
	private HTMLclass presentation; // object that generates HTML code
	private Vector columnVector;  // contains a list of parameters (attributes) to display
	private Vector rowIdVector; // contains all the row from the query
	private Vector attributeBeanVector;
	private Vector lookupVector;
	private Hashtable referenceHash;
	private Vector historyVector;
	private Vector mapVector;
	private int currentPage=1;  // the first page corrisponds to vector[0]
	private int totalPages=0;
	private int rowId;  // contains the real id of the row
	private LabelsBean labelsBean; 

	public HistoryForm() {
		super();
	}
	
	public void reset(ActionMapping mapping, HttpServletRequest request) {
		System.out.println("**HISTORYFORM**");
		ErrorBean err = null;
		historyVector = new Vector();
		// setting in the session historyForm
		request.getSession().setAttribute("historyForm",this);
				
		if (request.getParameter("class") != null){
			className = request.getParameter("class");
			request.getSession().setAttribute("class",className);
		} else if (request.getSession().getAttribute("class") != null){
			className = (String)request.getSession().getAttribute("class");
		} else {
			Settings sett = (Settings)request.getSession().getAttribute("settings");
			className = sett.getStartingClass();
		}
		if (request.getParameter("page") != null){
			currentPage = Integer.parseInt(request.getParameter("page"));
			request.getSession().setAttribute("page",""+currentPage);
		} else if (request.getSession().getAttribute("page") != null){
 			currentPage = Integer.parseInt((String) request.getSession().getAttribute("page"));
		}

		System.out.println("name="+className+" currentPage="+currentPage);

        DBService db = (DBService)servlet.getServletContext().getAttribute("db");
        CMDBclass CMDB = new CMDBclass(db);
        CMDBmap MAP = new CMDBmap(db);
		// *** managing filter ***
		String baseQuery = "";
		// replacing select parameters with "Id"
		baseQuery = "SELECT \"Id\" FROM \""+className+"\" WHERE \"Status\"='A'";
        Hashtable filter = null;
        FilterBean fb = null;
        if (request.getSession().getAttribute("filter")!=null){
        	filter = (Hashtable)request.getSession().getAttribute("filter");
        	if (filter.containsKey(className)){
        		fb = (FilterBean)filter.get(className);
        		try {
            		rowIdVector = CMDB.selectCardsId(fb.getQuery());
        		} catch (SQLException e) {
        			e.printStackTrace();
        		}
        	} else {
        		try {
            		rowIdVector = CMDB.selectCardsId(baseQuery);
        		} catch (SQLException e) {
        			e.printStackTrace();
        		}
        	}
        } else {
    		try {
        		rowIdVector = CMDB.selectCardsId(baseQuery);
    		} catch (SQLException e) {
    			e.printStackTrace();
    		}
        }

        totalPages = rowIdVector.size();
		if (rowIdVector==null){System.out.println("rowIdVector  nullo!");}
		if (rowIdVector.size()>0){
			if(currentPage < 1){
				currentPage = 1;
			} else if (currentPage>totalPages){
				currentPage = 1;
			}
			rowId = ((IdBean)rowIdVector.elementAt(currentPage-1)).getId(); // -1 beacause it's a vector
			classId = ((IdBean)rowIdVector.elementAt(currentPage-1)).getClassId();
		} else { // There aren't cards
			currentPage = 0;
		}
		if (rowId==0){System.out.println("rowId  nullo!");}
		// get extra attributes for the class
		try {
			attributeBeanVector = CMDB.selectAllAttribute(className,"rw") ;		       
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		if (attributeBeanVector!=null && attributeBeanVector.size()>0){
			classDescription = ((AttributeBean)attributeBeanVector.elementAt(0)).getClassBean().getDescription(); 
		}
		try {
			columnVector = CMDB.selectCard(className,rowId,attributeBeanVector);		       
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		if (columnVector==null){System.out.println("columnVector  nullo!");}
		// creating lookupVector if there are lookups
		lookupVector = new Vector();
		referenceHash = new Hashtable();
		HashSet hash = new HashSet();
		AssetBean ab = null;
		Vector options = null;
		CMDBlookup LOOKUP = new CMDBlookup(db);
		Enumeration enu = columnVector.elements();
		while (enu.hasMoreElements()){
			ab = (AssetBean)enu.nextElement();
			if (ab.getType()==AttributeBean.LOOKUP){
				hash.add(ab.getLookup());
			}
			if (ab.getType()==AttributeBean.REFERENCE){
				try {
					if (!referenceHash.containsKey(ab.getReference()) && ab.getReference().length()>0){ // don't get duplicates
						DEBUG.println("Getting refrence for "+ab.getReference());
						options = LOOKUP.selectAllReference(ab.getReference());
						referenceHash.put(ab.getReference(),options);
					}
				} catch (SQLException e) {
					err = new ErrorBean("historyform.jsp",e);
					e.printStackTrace();
				}
			}
		}
		// getting lookups
		try {
			options = new Vector();
			options.addAll(hash);
			lookupVector = LOOKUP.selectLookupByTypes(options);
		} catch (SQLException e) {
			err = new ErrorBean("historyform.jsp",e);
			e.printStackTrace();
		}
		System.out.println("lookup.size="+lookupVector.size());

		// getting _history 
		try {
			historyVector = CMDB.selectHistory(className,classId,rowId);		       
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		// getting history of relations
		try {
			mapVector = MAP.selectHistoryRelations(classId,rowId,DomainBean.NORMAL);		       
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		historyVector.addAll(mapVector);
		// getting labels
		try {
			labelsBean = CMDB.selectCardLabels(className,rowId);		       
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		// Creating card History
		//history = new History(historyVector,columnVector,lookupVector);
		presentation = (HTMLclass)CMDB.getPresentation();
		MultiLanguage multilanguage = (MultiLanguage)request.getSession().getAttribute("multilanguage");
		presentation.setMultilanguage(multilanguage);
		presentation.setHistoryVector(historyVector);
		presentation.setAssetVector(columnVector);
		presentation.setLookupVector(lookupVector);
		presentation.setReferenceHash(referenceHash);
		presentation.getHeader().getCreate().setVisible(false);
		presentation.getHeader().getModify().setVisible(false);
		presentation.getHeader().getFilter().setVisible(false);
		presentation.getHeader().getDelete().setVisible(false);
		presentation.getHeader().getNofilter().setVisible(false);
		// settings arrows
		if (currentPage==0){
			presentation.getHeader().getFirst().setUrl("history.jsp?class="+className+"&page=0");
			presentation.getHeader().getPrev().setUrl("history.jsp?class="+className+"&page=0");
			presentation.getHeader().getNext().setUrl("history.jsp?class="+className+"&page=0");
		} else if (currentPage==1){
			presentation.getHeader().getFirst().setUrl("history.jsp?class="+className+"&page=1");
			presentation.getHeader().getPrev().setUrl("history.jsp?class="+className+"&page=1");
			presentation.getHeader().getNext().setUrl("history.jsp?class="+className+"&page=2");
		} else if(currentPage==totalPages) {
			presentation.getHeader().getFirst().setUrl("history.jsp?class="+className+"&page=1");
			presentation.getHeader().getPrev().setUrl("history.jsp?class="+className+"&page="+(totalPages-1));
			presentation.getHeader().getNext().setUrl("history.jsp?class="+className+"&page="+totalPages);
		} else {
			presentation.getHeader().getFirst().setUrl("history.jsp?class="+className+"&page=1");
			presentation.getHeader().getPrev().setUrl("history.jsp?class="+className+"&page="+(currentPage-1));
			presentation.getHeader().getNext().setUrl("history.jsp?class="+className+"&page="+(currentPage+1));
		}
		presentation.getHeader().getLast().setUrl("history.jsp?class="+className+"&page="+totalPages);
		// setting current page
		presentation.getHeader().getPage().setCurrent(currentPage);
		presentation.getHeader().getPage().setTotal(totalPages);
		presentation.getHeader().getCheckFilter().setVisible(false);
		if (currentPage!=0){
			// setting label
			presentation.getHeader().getLabel().setLabel(classDescription+" - "+labelsBean.getCode()+"<BR>"+labelsBean.getDescription());
		} else {
			presentation.getHeader().getLabel().setLabel(" - ");
		}

		// this is passed to popup 
		presentation.setClassName(className);
		if (err!=null){
			request.getSession().setAttribute("error",err);
		}
	}

	public ActionErrors validate(ActionMapping arg0, HttpServletRequest arg1) {
		System.out.println("**VALIDATE**");
		ActionErrors errors = new ActionErrors();
		AssetBean ab = null;
		//String tname = "";
		String target="";
		Enumeration en = columnVector.elements();
		while (en.hasMoreElements()){
			ab = (AssetBean)en.nextElement();
			if (ab.getMandatory().equals("Y")){
				//tname = ab.getName();
				target= arg1.getParameter(target);
				System.out.println("target value="+target);
				if (target == null || target.trim().equals("")){
					errors.add("target", new ActionMessage("form.field.required",target));
				}
			}
		}
		return errors;
	}
	
	public Vector getAttributeBeanVector() {
		return attributeBeanVector;
	}
	public void setAttributeBeanVector(Vector attributeBeanVector) {
		this.attributeBeanVector = attributeBeanVector;
	}
	public Vector getColumnVector() {
		return columnVector;
	}
	public void setColumnVector(Vector columnVector) {
		this.columnVector = columnVector;
	}
	public int getCurrentPage() {
		return currentPage;
	}
	public void setCurrentPage(int currentPage) {
		this.currentPage = currentPage;
	}
	public String getMethod() {
		return method;
	}
	public void setMethod(String method) {
		this.method = method;
	}
	public String getClassName() {
		return className;
	}
	public void setClassName(String className) {
		this.className = className;
	}

	public int getRowId() {
		return rowId;
	}
	public void setRowId(int rowId) {
		this.rowId = rowId;
	}
	public Vector getRowIdVector() {
		return rowIdVector;
	}
	public void setRowIdVector(Vector rowIdVector) {
		this.rowIdVector = rowIdVector;
	}
	public String getSearch() {
		return search;
	}
	public void setSearch(String search) {
		this.search = search;
	}
	public int getTotalPages() {
		return totalPages;
	}
	public void setTotalPages(int totalPages) {
		this.totalPages = totalPages;
	}
	public String getMode() {
		return mode;
	}
	public void setMode(String mode) {
		this.mode = mode;
	}
	public Vector getMapVector() {
		return mapVector;
	}
	public void setMapVector(Vector mapVector) {
		this.mapVector = mapVector;
	}
	public String getTargetClass() {
		return targetClass;
	}
	public void setTargetClass(String targetClass) {
		this.targetClass = targetClass;
	}
	public String getTargetObjId() {
		return targetObjId;
	}
	public void setTargetObjId(String targetObjId) {
		this.targetObjId = targetObjId;
	}
	public Vector getLookupVector() {
		return lookupVector;
	}
	public void setLookupVector(Vector lookupVector) {
		this.lookupVector = lookupVector;
	}
	public LabelsBean getLabelsBean() {
		return labelsBean;
	}
	public void setLabelsBean(LabelsBean labelsBean) {
		this.labelsBean = labelsBean;
	}
	public String getClassDescription() {
		return classDescription;
	}
	public void setClassDescription(String classDescription) {
		this.classDescription = classDescription;
	}
	public int getClassId() {
		return classId;
	}
	public void setClassId(int classId) {
		this.classId = classId;
	}
	public Vector getHistoryVector() {
		return historyVector;
	}
	public void setHistoryVector(Vector historyVector) {
		this.historyVector = historyVector;
	}
	public HTMLclass getPresentation() {
		return presentation;
	}
	public void setPresentation(HTMLclass presentation) {
		this.presentation = presentation;
	}
	public Hashtable getReferenceHash() {
		return referenceHash;
	}
	public void setReferenceHash(Hashtable referenceHash) {
		this.referenceHash = referenceHash;
	}
	

} // end class
