package cmdbuild.action_forms;
import java.sql.*;
import java.util.*;

import cmdbuild.collection.*;
import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBclass;
import cmdbuild.elements.CMDBmap;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;

public class ModifyRelationForm extends ActionForm {

	static final long serialVersionUID = 1L;
	private String className;
	private int class1id; //
	private int obj1id;   //
	private int class2id;  //
	private int obj2id;   //
	private int classnewid;
	private int objnewid;
	private String method;
	private String search; 
	private String domain;
	private String domainToSearch;
	private String oggetto; 
    private String domainRealName;
    private int domainId;
    private boolean direct;
    private Vector attributeBeanVector;
    private Vector columnVector;
    private String pageToForward;
    private String classToForward;
	
	public ModifyRelationForm() {
		super();
		// TODO Auto-generated constructor stub
	}
	
	/* (non-Javadoc)
	 * @see org.apache.struts.action.ActionForm#reset(org.apache.struts.action.ActionMapping, javax.servlet.http.HttpServletRequest)
	 */
	public void reset(ActionMapping mapping, HttpServletRequest request) {
		
		System.out.println("**MODIFYRELATION RESET**");
		if (request.getParameter("class1id") != null){
			class1id = Integer.parseInt(request.getParameter("class1id"));
		} 
		if (request.getParameter("obj1id") != null){
			obj1id = Integer.parseInt(request.getParameter("obj1id"));
		}
		if (request.getParameter("class2id") != null){
			class2id = Integer.parseInt(request.getParameter("class2id"));
		} 
		if (request.getParameter("obj2id") != null){
			obj2id = Integer.parseInt(request.getParameter("obj2id"));
		} 
		if (request.getParameter("domain") != null){
			domainRealName = request.getParameter("domain");
			request.getSession().setAttribute("domain",domainRealName);
		} else if (request.getSession().getAttribute("domain")!=null){
			domainRealName = (String)request.getSession().getAttribute("domain");
		}
		if (request.getParameter("domainid") != null){
			domainId = Integer.parseInt(request.getParameter("domainid"));
		}
		if (request.getParameter("direct") != null){
			String dir = request.getParameter("direct");
			System.out.println("dir="+dir);
			if (dir.equals("true")){
				direct = true; 
			} else {
				direct = false;
			}
		}
        DBService db = (DBService)servlet.getServletContext().getAttribute("db");
        CMDBclass CMDB = new CMDBclass(db);
		ClassBean cb = null;
		try {
    		cb = CMDB.selectClassById(class2id);
		} catch (SQLException e) {
			e.printStackTrace();
		}
		className = cb.getName();
		request.getSession().setAttribute("class",className);

		System.out.println("direct="+direct);
		System.out.println("domainRealName="+domainRealName);
		System.out.println("className="+className);
		System.out.println("CRF class1id="+class1id+" obj1id="+obj1id);
        DomainBean dm = null;
        CMDBmap MAP = new CMDBmap(db);
        try {
			 dm = (DomainBean)MAP.selectDomainByName(domainRealName);		       
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		if (direct){
			domain = dm.getDirectDescription();
		} else {
			domain = dm.getInverseDescription();
		}
		// get extra attributes for the class
		try {
			attributeBeanVector = CMDB.selectAllAttribute(className,"rw") ;		       
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		if (attributeBeanVector == null){
			System.out.println("attributeBeanVector  nullo");
		}
		try {
			columnVector = CMDB.selectCard(className,obj2id,attributeBeanVector);		       
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		if (columnVector==null){System.out.println("columnVector  nullo!");}
		Enumeration eni = columnVector.elements();
		AssetBean ass = null;
		while (eni.hasMoreElements()){
			ass = (AssetBean)eni.nextElement();
			if (ass.getName().equals("AssetNo")){
				oggetto = ass.getValue();
			}
		}
	}

	public ActionErrors validate(ActionMapping arg0, HttpServletRequest arg1) {
		System.out.println("**VALIDATE**");
		ActionErrors errors = new ActionErrors();
		if ( oggetto == null || oggetto.trim().equals("")){
			errors.add("oggetto", new ActionMessage("oggetto.required"));
		}
		ModifyRelationForm form = (ModifyRelationForm)arg1.getAttribute("modifyRelationForm"); 
		DomainBean domain = null;
		classnewid = form.getClassnewid();
		objnewid = form.getObjnewid();
		DBService db = (DBService)servlet.getServletContext().getAttribute("db");
		CMDBmap MAP = new CMDBmap(db);
		try {
			 domain = MAP.selectDomainByName(domainRealName);
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		// find if the object selected was already associated (in this domain) with an other Asset
		Vector relationVector = null;
		if (domain.getCardinality()!=null && domain.getCardinality().indexOf("1")!=-1){
			String cardin = "";
			if (direct){
				cardin = domain.getCardinality();
				cardin = cardin.substring(0,cardin.indexOf(":"));
			} else {
				cardin = domain.getCardinality();
				cardin = cardin.substring(cardin.lastIndexOf(":")+1,cardin.length());
			}
			System.out.println("cardin="+cardin);
			if (cardin.equals("1")){
				try {
					relationVector = MAP.selectRelations(classnewid,objnewid,0,0,DomainBean.ALL);
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				Enumeration en = relationVector.elements();
				RelationBean rb = null;
				while (en.hasMoreElements()){
					rb = (RelationBean)en.nextElement();
					if (rb.getDomainId()==domain.getId()){
						errors.add("oggetto", new ActionMessage("relation.alreadylinked"));
						break;
					}
				}
			}
		}
		return errors;
	}

	public int getClass1id() {
		return class1id;
	}
	public void setClass1id(int class1id) {
		this.class1id = class1id;
	}
	public int getClass2id() {
		return class2id;
	}
	public void setClass2id(int class2id) {
		this.class2id = class2id;
	}
	public int getObj1id() {
		return obj1id;
	}
	public void setObj1id(int obj1id) {
		this.obj1id = obj1id;
	}
	public int getObj2id() {
		return obj2id;
	}
	public void setObj2id(int obj2id) {
		this.obj2id = obj2id;
	}
	public String getClassName() {
		return className;
	}
	public void setClassName(String className) {
		this.className = className;
	}
	public String getDomain() {
		return domain;
	}
	public void setDomain(String domain) {
		this.domain = domain;
	}
	public String getMethod() {
		return method;
	}
	public void setMethod(String method) {
		this.method = method;
	}
	public String getOggetto() {
		return oggetto;
	}
	public void setOggetto(String oggetto) {
		this.oggetto = oggetto;
	}
	public String getSearch() {
		return search;
	}
	public void setSearch(String search) {
		this.search = search;
	}
	public String getDomainToSearch() {
		return domainToSearch;
	}
	public void setDomainToSearch(String domainToSearch) {
		this.domainToSearch = domainToSearch;
	}
	public boolean isDirect() {
		return direct;
	}
	public void setDirect(boolean direct) {
		this.direct = direct;
	}
	public int getDomainId() {
		return domainId;
	}
	public void setDomainId(int domainId) {
		this.domainId = domainId;
	}
	public String getDomainRealName() {
		return domainRealName;
	}
	public void setDomainRealName(String domainRealName) {
		this.domainRealName = domainRealName;
	}
	public Vector getAttributeBeanVector() {
		return attributeBeanVector;
	}
	public void setAttributeBeanVector(Vector attributeBeanVector) {
		this.attributeBeanVector = attributeBeanVector;
	}
	public Vector getColumnVector() {
		return columnVector;
	}
	public void setColumnVector(Vector columnVector) {
		this.columnVector = columnVector;
	}
	public String getClassToForward() {
		return classToForward;
	}
	public void setClassToForward(String classToForward) {
		this.classToForward = classToForward;
	}
	public String getPageToForward() {
		return pageToForward;
	}
	public void setPageToForward(String pageToForward) {
		this.pageToForward = pageToForward;
	}
	public int getClassnewid() {
		return classnewid;
	}
	public void setClassnewid(int classnewid) {
		this.classnewid = classnewid;
	}
	public int getObjnewid() {
		return objnewid;
	}
	public void setObjnewid(int objnewid) {
		this.objnewid = objnewid;
	}
	
	
} // end class
