package cmdbuild.action_forms;
import java.sql.*;
import java.util.*;

import cmdbuild.presentation.HTMLclass;
import cmdbuild.collection.*;
import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBclass;
import cmdbuild.elements.CMDBlookup;
import cmdbuild.utils.MultiLanguage;
import cmdbuild.utils.SecurityDescriptor;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionMapping;

public class PopupInfoCardForm extends ActionFormTemplate {

	static final long serialVersionUID = 1L;
	private String className;
	private String classDescription="";
	private String method;
	private int classId;
	private int objId;
	private HTMLclass presentation; // object that generates HTML code
	private Vector columnVector;  // contains a list of parameters (attributes) to display
	private Vector attributeBeanVector;
	private Vector lookupVector; // contains objects lookup where name=type & description=<option></option>...
	private Hashtable referenceHash;

	public PopupInfoCardForm() {
		super();
		// TODO Auto-generated constructor stub
	}
	
	public void reset(ActionMapping mapping, HttpServletRequest request) {
		System.out.println("**POPUPINFOCARD RESET**");
		lookupVector=new Vector();
		ErrorBean err = null;
		if (request.getParameter("class") != null){
			className = request.getParameter("class");
		}
		if (request.getParameter("classid") != null){
			try {
				classId = Integer.parseInt(request.getParameter("classid"));
			} catch (NumberFormatException e) {
				classId = 0;
			}
		} 
		if (request.getParameter("objid") != null){
			try {
				objId = Integer.parseInt(request.getParameter("objid"));
			} catch (NumberFormatException e) {
				objId = 0;
			}
		}
        DBService db = (DBService)servlet.getServletContext().getAttribute("db");
        CMDBclass CMDB = new CMDBclass(db);
		if (CMDB.getBean()==null){
			try {
				CMDB.setBean(CMDB.selectClassByName(className));
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		// get extra attributes for the class
		try {
			attributeBeanVector = CMDB.selectAllAttribute(className,"rw") ;		       
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		if (attributeBeanVector!=null && attributeBeanVector.size()>0){
			classDescription= ((AttributeBean)attributeBeanVector.elementAt(0)).getClassBean().getDescription(); 
		}
		try {
			columnVector = CMDB.selectCard(className,objId,attributeBeanVector);		       
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		if (columnVector==null){System.out.println("columnVector  nullo!");}
		// creating lookupVector if there are lookups
		lookupVector = new Vector();
		referenceHash = new Hashtable();
		HashSet hash = new HashSet();
		AssetBean ab = null;
		Vector options = null;
		CMDBlookup LOOKUP = new CMDBlookup(db);
		Enumeration enu = columnVector.elements();
		while (enu.hasMoreElements()){
			ab = (AssetBean)enu.nextElement();
			if (ab.getType()==AttributeBean.LOOKUP){
				hash.add(ab.getLookup());
			}
			if (ab.getType()==AttributeBean.REFERENCE){
				try {
					if (!referenceHash.containsKey(ab.getReference()) && ab.getReference().length()>0){ // don't get duplicates
						DEBUG.println("Getting refrence for "+ab.getReference());
						options = LOOKUP.selectAllReference(ab.getReference());
						referenceHash.put(ab.getReference(),options);
					}
				} catch (SQLException e) {
					err = new ErrorBean("popupinfocard.jsp",e);
					e.printStackTrace();
				}
			}
		}
		// getting lookups
		try {
			options = new Vector();
			options.addAll(hash);
			lookupVector = LOOKUP.selectLookupByTypes(options);
		} catch (SQLException e) {
			err = new ErrorBean("popupinfocard.jsp",e);
			e.printStackTrace();
		}
		// getting general class info
        ClassBean bean = new ClassBean();
		try {
			bean= CMDB.selectClassByName(className);	
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		// getting user from session
		SecurityDescriptor user = null;
		String us = null;
		if (request.getSession().getAttribute("user")!=null){
			user = (SecurityDescriptor)request.getSession().getAttribute("user");
			us = user.getUserName();
		}
		// Creating card Asset
		//asset = new Asset(className,columnVector,lookupVector);
		CMDB = CMDB.load(CMDB,CMDB.getBean().getManager());
		presentation = (HTMLclass)CMDB.getPresentation();
		MultiLanguage multilanguage = (MultiLanguage)request.getSession().getAttribute("multilanguage");
		presentation.setMultilanguage(multilanguage);
		presentation.setClassName(className);
		presentation.setAssetVector(columnVector);
		presentation.setLookupVector(lookupVector);
		presentation.setReferenceHash(referenceHash);
		presentation.setCategory(bean.getCategory());
		presentation.setClassDescription(classDescription);
		presentation.setUser(user);
		presentation.getHeader().setVisible(false);
		String stat="";
		try {
			stat = CMDB.getCardStatus(className,objId);		       
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		if (stat==null){
			try {
				CMDB.setCardStatus(className,objId,"A",us);	
				stat = "A";
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		if (stat.equals("") || stat.equals("A")){
			presentation.setDeleted(false);
		} else {
			presentation.setDeleted(true);
		}
		if (err!=null){
			request.getSession().setAttribute("error",err);
		}
	}

	public ActionErrors validate(ActionMapping arg0, HttpServletRequest arg1) {
		System.out.println("**VALIDATE**");
		ActionErrors errors = new ActionErrors();
		return errors;
	}
	public Vector getAttributeBeanVector() {
		return attributeBeanVector;
	}
	public void setAttributeBeanVector(Vector attributeBeanVector) {
		this.attributeBeanVector = attributeBeanVector;
	}
	public int getClassId() {
		return classId;
	}
	public void setClassId(int classId) {
		this.classId = classId;
	}
	public String getClassName() {
		return className;
	}
	public void setClassName(String className) {
		this.className = className;
	}
	public Vector getColumnVector() {
		return columnVector;
	}
	public void setColumnVector(Vector columnVector) {
		this.columnVector = columnVector;
	}
	public Vector getLookupVector() {
		return lookupVector;
	}
	public void setLookupVector(Vector lookupVector) {
		this.lookupVector = lookupVector;
	}
	public String getMethod() {
		return method;
	}
	public void setMethod(String method) {
		this.method = method;
	}
	public int getObjId() {
		return objId;
	}
	public void setObjId(int objId) {
		this.objId = objId;
	}
	public String getClassDescription() {
		return classDescription;
	}
	public void setClassDescription(String classDescription) {
		this.classDescription = classDescription;
	}
	public HTMLclass getPresentation() {
		return presentation;
	}
	public void setPresentation(HTMLclass presentation) {
		this.presentation = presentation;
	}
	
} // end class
