package cmdbuild.action_forms;
import java.sql.*;
import java.util.*;

import cmdbuild.presentation.HTMLclass;
import cmdbuild.collection.*;
import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBclass;
import cmdbuild.elements.CMDBlookup;
import cmdbuild.utils.MultiLanguage;
import cmdbuild.utils.SecurityDescriptor;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionMapping;

public class PopupInfoNoteForm extends ActionFormTemplate {

	static final long serialVersionUID = 1L;
	private String className;
	private String classDescription="";
	private String method;
	private String notes;
	private HTMLclass presentation; // object that generates HTML code
	private Vector attributeBeanVector;
	private Vector columnVector;  // contains a list of parameters (attributes) to display
	private Vector lookupVector;
	private Hashtable referenceHash;
	private int rowId;  // contains the real id of the row
	private String manager;

	public PopupInfoNoteForm() {
		super();
	}
	
	public void reset(ActionMapping mapping, HttpServletRequest request) {
		System.out.println("**POPUPINFONOTE**");
		ErrorBean err = null;
		if (request.getParameter("class") != null){
			className = request.getParameter("class");
		}
		if (request.getParameter("objid") != null){
			rowId = Integer.parseInt(request.getParameter("objid"));
		}
        DBService db = (DBService)servlet.getServletContext().getAttribute("db");
		CMDBclass CMDB = new CMDBclass(db);
		// get extra attributes for the class
		try {
			attributeBeanVector = CMDB.selectAllAttribute(className,"rw") ;		       
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		CMDB = CMDB.load(CMDB,CMDB.getBean().getManager());
		manager = CMDB.getBean().getManager();
		if (attributeBeanVector!=null && attributeBeanVector.size()>0){
			classDescription = ((AttributeBean)attributeBeanVector.elementAt(0)).getClassBean().getDescription(); 
		}
		// searching for baseDSPs
		Enumeration en = attributeBeanVector.elements();
		AttributeBean atb = null;
		boolean baseDSPs = false;
		while (en.hasMoreElements()){
			atb = (AttributeBean)en.nextElement();
			if (atb.getBaseDSP().equals("true")){
				baseDSPs = true;
				break;
			}
		}
		lookupVector = new Vector();
		referenceHash = new Hashtable();
		columnVector = new Vector();
		if (baseDSPs){
			try {
				columnVector = CMDB.selectCard(className,rowId,attributeBeanVector);		       
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			if (columnVector==null){System.out.println("columnVector  nullo!");}
			// creating lookupVector if there are lookups
			HashSet hash = new HashSet();
			AssetBean ab = null;
			Vector options = null;
			CMDBlookup LOOKUP = new CMDBlookup(db);
			Enumeration enu = columnVector.elements();
			while (enu.hasMoreElements()){
				ab = (AssetBean)enu.nextElement();
				if (ab.getType()==AttributeBean.LOOKUP){
					hash.add(ab.getLookup());
				}
				if (ab.getType()==AttributeBean.REFERENCE){
					try {
						if (!referenceHash.containsKey(ab.getReference()) && ab.getReference().length()>0){ // don't get duplicates
							DEBUG.println("Getting reference for "+ab.getReference());
							options = LOOKUP.selectAllReference(ab.getReference());
							referenceHash.put(ab.getReference(),options);
						}
					} catch (SQLException e) {
						err = new ErrorBean("popupinfonote.jsp",e);
						e.printStackTrace();
					}
				}
			}
			// getting lookups
			try {
				options = new Vector();
				options.addAll(hash);
				lookupVector = LOOKUP.selectLookupByTypes(options);
			} catch (SQLException e) {
				err = new ErrorBean("popupinfonote.jsp",e);
				e.printStackTrace();
			}
			System.out.println("lookup.size="+lookupVector.size());
		}
		try {
			notes = CMDB.getCardNotes(className,rowId);		       
		} catch (SQLException e) {
			// this class has no field named Notes
			notes = null;
			//e.printStackTrace();
		}
		// getting user from session
		SecurityDescriptor user = null;
		if (request.getSession().getAttribute("user")!=null){
			user = (SecurityDescriptor)request.getSession().getAttribute("user");
		}
		DEBUG.println("columnVector="+columnVector+" lookupVector="+lookupVector+" referenceHash="+referenceHash);		
		
		CMDB = CMDB.load(CMDB,CMDB.getBean().getManager());
		presentation = (HTMLclass)CMDB.getPresentation();
		MultiLanguage multilanguage = (MultiLanguage)request.getSession().getAttribute("multilanguage");
		presentation.setMultilanguage(multilanguage);
		DEBUG.println("columnVector="+columnVector+" lookupVector="+lookupVector+" referenceHash="+referenceHash);
		presentation.setAssetVector(columnVector);
		presentation.setLookupVector(lookupVector);
		presentation.setReferenceHash(referenceHash);
		presentation.setNotes(notes);
		presentation.setUser(user);
		presentation.setClassName(className);
		presentation.getHeader().setVisible(false);
		presentation.setDisableEditing(true);
		if (err!=null){
			request.getSession().setAttribute("error",err);
		}
	}

	public ActionErrors validate(ActionMapping arg0, HttpServletRequest arg1) {
		System.out.println("**NOTE VALIDATE**");
		ActionErrors errors = new ActionErrors();
		return errors;
	}
	
	public String getMethod() {
		return method;
	}
	public void setMethod(String method) {
		this.method = method;
	}
	public int getRowId() {
		return rowId;
	}
	public void setRowId(int rowId) {
		this.rowId = rowId;
	}
	public Vector getAttributeBeanVector() {
		return attributeBeanVector;
	}
	public void setAttributeBeanVector(Vector attributeBeanVector) {
		this.attributeBeanVector = attributeBeanVector;
	}
	public Vector getColumnVector() {
		return columnVector;
	}
	public void setColumnVector(Vector columnVector) {
		this.columnVector = columnVector;
	}
	public Vector getLookupVector() {
		return lookupVector;
	}
	public void setLookupVector(Vector lookupVector) {
		this.lookupVector = lookupVector;
	}
	public String getNotes() {
		return notes;
	}
	public void setNotes(String notes) {
		this.notes = notes;
	}
	public String getClassDescription() {
		return classDescription;
	}
	public void setClassDescription(String classDescription) {
		this.classDescription = classDescription;
	}
	public String getClassName() {
		return className;
	}
	public void setClassName(String className) {
		this.className = className;
	}
	public HTMLclass getPresentation() {
		return presentation;
	}
	public void setPresentation(HTMLclass presentation) {
		this.presentation = presentation;
	}
	public String getManager() {
		return manager;
	}
	public void setManager(String manager) {
		this.manager = manager;
	}
	public Hashtable getReferenceHash() {
		return referenceHash;
	}
	public void setReferenceHash(Hashtable referenceHash) {
		this.referenceHash = referenceHash;
	}
	

} // end class
