package cmdbuild.action_forms;
import java.sql.*;
import java.util.*;

import cmdbuild.presentation.HTMLclass;
import cmdbuild.collection.*;
import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBclass;
import cmdbuild.elements.CMDBlookup;
import cmdbuild.elements.CMDBmap;
import cmdbuild.utils.MultiLanguage;
import cmdbuild.utils.SecurityDescriptor;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionMapping;

public class PopupInfoRelationForm extends ActionFormTemplate {

	static final long serialVersionUID = 1L;
	private String className;
	private String classDescription="";
	private int classId;
	private String method;
	private String mode;
	private int domainType;
	/*
	private String targetClass; // used to implement "go to page" 
	private String targetClassId; // used for implement delete
	private String targetObjId; // used to implement "go to page"
	private String targetDomain; // used for implement delete
	private String targetDomainId; // used for implement delete
	private String direct; // used for implement delete
	private String search;
	*/ 
	private HTMLclass presentation; // object that generates HTML code
	private Vector columnVector;  // contains a list of parameters (attributes) to display
	private Vector rowIdVector; // contains all the row from the query
	private Vector attributeBeanVector;
	private Vector relationVector;
	private Vector lookupVector; // contains objects lookup where name=type & description=<option></option>...
	private Hashtable referenceHash;
	private int currentPage=1;  // the first page corrisponds to vector[0]
	private int totalPages=0;
	private int rowId;  // contains the real id of the row
	private LabelsBean labelsBean;

	public PopupInfoRelationForm() {
		super();
	}
	
	public void reset(ActionMapping mapping, HttpServletRequest request) {
		System.out.println("**POPUPINFORELATIONFORM**");
		ErrorBean err = null;
		presentation = new HTMLclass();
		lookupVector=new Vector();
		relationVector = new Vector();

		// setting in the session relationForm
		request.getSession().setAttribute("relationForm",this);
		
        DBService db = (DBService)servlet.getServletContext().getAttribute("db");
        CMDBclass CMDB = new CMDBclass(db);
        /*
		if (request.getParameter("class") != null){
			className = request.getParameter("class");
			request.getSession().setAttribute("class",className);
		} else if (request.getSession().getAttribute("class") != null){
			className = (String)request.getSession().getAttribute("class");
		} else {
			className = "Asset";
		}
		*/
		if (request.getParameter("class") != null){
			className = request.getParameter("class");
		}	
		// classid is passed from search.jsp if classname is Asset
		if (request.getParameter("classid") != null){
			classId = Integer.parseInt(request.getParameter("classid"));
			ClassBean cb = null;
			try {
				cb = CMDB.selectClassById(classId);
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			className = cb.getName();
			request.getSession().setAttribute("class",className);
		}
		if (CMDB.getBean()==null){
			try {
				CMDB.setBean(CMDB.selectClassByName(className));
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		if (request.getParameter("objid") != null){
			rowId = Integer.parseInt(request.getParameter("objid"));
		}
		if (request.getParameter("domainType") != null){
			domainType = Integer.parseInt(request.getParameter("domaintype"));
		}
		String baseQuery = "";
		baseQuery = "SELECT \"Id\" FROM \""+className+"\" WHERE \"Status\"='A'";
   		try {
       		rowIdVector = CMDB.selectCardsId(baseQuery);
   		} catch (SQLException e) {
   			e.printStackTrace();
   		}
   		// calculating currentPage
   		Enumeration encp = rowIdVector.elements();
   		IdBean ib = null;
   		currentPage = 0;
   		while(encp.hasMoreElements()){
   			currentPage++;
   			ib = (IdBean)encp.nextElement();
   			if (ib.getId()==rowId){
   				break;
   			}
   		}
		totalPages = rowIdVector.size();
		// getting supage
		int subpage=0;
		if (request.getParameter("subpage")!=null){
			subpage = Integer.parseInt(request.getParameter("subpage"));
		} 
		// used for popup windows
		if (className!=null && currentPage!=0){
			request.getSession().setAttribute("classToForward",className);
			request.getSession().setAttribute("pageToForward",(currentPage+""));
			System.out.println("**PAGE TO FORWARD**"+className+"-"+currentPage);
		}
		if (rowIdVector.size()>0){
			if(currentPage < 1){
				currentPage = 1;
			} else if (currentPage>totalPages){
				currentPage = 1;
			}
			rowId = ((IdBean)rowIdVector.elementAt(currentPage-1)).getId(); // -1 beacause it's a vector
		} else { // There aren't cards
			currentPage = 0;
		}
		// get extra attributes for the class
		try {
			attributeBeanVector = CMDB.selectAllAttribute(className,"rw") ;		       
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		if (attributeBeanVector!=null && attributeBeanVector.size()>0){
			classDescription = ((AttributeBean)attributeBeanVector.elementAt(0)).getClassBean().getDescription(); 
		}
		try {
			columnVector = CMDB.selectCard(className,rowId,attributeBeanVector);		       
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		if (columnVector==null){System.out.println("columnVector  nullo!");}
		// creating lookupVector if there are lookups
		lookupVector = new Vector();
		referenceHash = new Hashtable();
		HashSet hash = new HashSet();
		AssetBean ab = null;
		Vector options = null;
		CMDBlookup LOOKUP = new CMDBlookup(db);
		Enumeration enu = columnVector.elements();
		while (enu.hasMoreElements()){
			ab = (AssetBean)enu.nextElement();
			if (ab.getType()==AttributeBean.LOOKUP){
				hash.add(ab.getLookup());
			}
			if (ab.getType()==AttributeBean.REFERENCE){
				try {
					if (!referenceHash.containsKey(ab.getReference()) && ab.getReference().length()>0){ // don't get duplicates
						DEBUG.println("Getting refrence for "+ab.getReference());
						options = LOOKUP.selectAllReference(ab.getReference());
						referenceHash.put(ab.getReference(),options);
					}
				} catch (SQLException e) {
					err = new ErrorBean("popupinforelation.jsp",e);
					e.printStackTrace();
				}
			}
		}
		// getting lookups
		try {
			options = new Vector();
			options.addAll(hash);
			lookupVector = LOOKUP.selectLookupByTypes(options);
		} catch (SQLException e) {
			err = new ErrorBean("popupinforelation.jsp",e);
			e.printStackTrace();
		}
		if (classId==0){
			// getting class ID
			try {
				classId = CMDB.selectClassByName(className).getId();
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		int offset;
		if (subpage==0 || subpage==1){
			//subpage=1;
			offset=0;
		} else {
			offset=(subpage-1)*presentation.getResultsForPage();
		}
		int totalSubPages = 0;
		CMDBmap MAP = new CMDBmap(db);
		try {
			relationVector = MAP.selectRelations(classId,rowId,presentation.getResultsForPage(),offset,domainType);
			String quer = "SELECT * FROM relationlist WHERE idclass1="+classId+" AND idobj1="+rowId+" AND status='A'";
			totalSubPages = CMDB.countCards(quer);
			if (totalSubPages==1){ // patch
				subpage=1;
			}
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		System.out.println(" relationVector.size "+relationVector.size());
		
		RelationBean rb = null;
		Hashtable cardin = new Hashtable(); 
		Enumeration enume = relationVector.elements();
		int count;
		while (enume.hasMoreElements()){
			rb = (RelationBean)enume.nextElement();
			 // count relations for every domain and put in the session for createRelation
			 if (!cardin.containsKey(rb.getDomainRealName())){
				 cardin.put(rb.getDomainRealName(),1+"");
			 } else {
				 count = 1 + Integer.parseInt( (String)cardin.get(rb.getDomainRealName()) );
				 cardin.put(rb.getDomainRealName(),count+"");
			 }
			 //System.out.println("RelationForm classdescription is "+rb.getClassDescription());
		}
		request.getSession().setAttribute("cardinHashTable",cardin);
		try {
			labelsBean = CMDB.selectCardLabels(className,rowId);		       
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		// getting user from session
		SecurityDescriptor user = null;
		if (request.getSession().getAttribute("user")!=null){
			user = (SecurityDescriptor)request.getSession().getAttribute("user");
		}
		// Creating card Relation
		//relation = new Relation(columnVector,lookupVector,relationVector,classId,rowId);
		CMDB = CMDB.load(CMDB,CMDB.getBean().getManager());
		presentation = (HTMLclass)CMDB.getPresentation();
		MultiLanguage multilanguage = (MultiLanguage)request.getSession().getAttribute("multilanguage");
		presentation.setMultilanguage(multilanguage);
		presentation.setAssetVector(columnVector);
		presentation.setLookupVector(lookupVector);
		presentation.setReferenceHash(referenceHash);
		presentation.setRelationVector(relationVector);
		presentation.setClass1id(classId);
		presentation.setObj1id(rowId);
		presentation.setUser(user);
		presentation.setHideLinks(true);
		if (user.isAllowed(className,3)){
			presentation.getHeader().getCreate().setUrl("createpresentation.jsp?class="+className+"&page="+currentPage+"&class1id="+classId+"&obj1id="+rowId);
			presentation.getHeader().getCreate().setWhere("popup");
		} else {
			presentation.getHeader().getCreate().setUrl("javascript:alert('Non hai i permessi necessari');");
			presentation.getHeader().getCreate().setWhere("inner");
		}
		presentation.getHeader().getModify().setVisible(false);
		presentation.getHeader().getFilter().setVisible(false);
		presentation.getHeader().getDelete().setVisible(false);
		presentation.getHeader().getNofilter().setVisible(false);
		// settings arrows
		if (currentPage==0){
			presentation.getHeader().getFirst().setUrl("presentation.jsp?class="+className+"&page=0");
			presentation.getHeader().getPrev().setUrl("presentation.jsp?class="+className+"&page=0");
			presentation.getHeader().getNext().setUrl("presentation.jsp?class="+className+"&page=0");
		} else if (currentPage==1){
			presentation.getHeader().getFirst().setUrl("presentation.jsp?class="+className+"&page=1");
			presentation.getHeader().getPrev().setUrl("presentation.jsp?class="+className+"&page=1");
			presentation.getHeader().getNext().setUrl("presentation.jsp?class="+className+"&page=2");
		} else if(currentPage==totalPages) {
			presentation.getHeader().getFirst().setUrl("presentation.jsp?class="+className+"&page=1");
			presentation.getHeader().getPrev().setUrl("presentation.jsp?class="+className+"&page="+(totalPages-1));
			presentation.getHeader().getNext().setUrl("presentation.jsp?class="+className+"&page="+totalPages);
		} else {
			presentation.getHeader().getFirst().setUrl("presentation.jsp?class="+className+"&page=1");
			presentation.getHeader().getPrev().setUrl("presentation.jsp?class="+className+"&page="+(currentPage-1));
			presentation.getHeader().getNext().setUrl("presentation.jsp?class="+className+"&page="+(currentPage+1));
		}
		presentation.getHeader().getLast().setUrl("presentation.jsp?class="+className+"&page="+totalPages);
		// setting current page
		presentation.getHeader().getPage().setCurrent(currentPage);
		presentation.getHeader().getPage().setTotal(totalPages);
		presentation.getHeader().setVisible(false);
		if (currentPage!=0){
			// setting label
			presentation.getHeader().getLabel().setLabel(classDescription+" - "+labelsBean.getCode()+"<BR>"+labelsBean.getDescription());
		} else {
			presentation.getHeader().getLabel().setLabel(" - ");
		}
		// this is passed to popup modifypresentation
		presentation.setClassName(className);
		// managing shows of 30 rows for page
		presentation.setSubpage(subpage);
		presentation.setTotalPages(totalSubPages);
		// disable operations if className=Asset
		if (className.equals("Asset")){
			presentation.getHeader().getCreate().setUrl("javascript:alert('Classe non modificabile');");
			presentation.getHeader().getCreate().setWhere("inner");
		}
		presentation.setDisableEditing(true); 
		if (err!=null){
			request.getSession().setAttribute("error",err);
		}
	}

	public Vector getAttributeBeanVector() {
		return attributeBeanVector;
	}
	public void setAttributeBeanVector(Vector attributeBeanVector) {
		this.attributeBeanVector = attributeBeanVector;
	}
	public Vector getColumnVector() {
		return columnVector;
	}
	public void setColumnVector(Vector columnVector) {
		this.columnVector = columnVector;
	}
	public int getCurrentPage() {
		return currentPage;
	}
	public void setCurrentPage(int currentPage) {
		this.currentPage = currentPage;
	}
	public Vector getLookupVector() {
		return lookupVector;
	}
	public void setLookupVector(Vector lookupVector) {
		this.lookupVector = lookupVector;
	}
	public String getMethod() {
		return method;
	}
	public void setMethod(String method) {
		this.method = method;
	}
	public String getClassName() {
		return className;
	}
	public void setClassName(String className) {
		this.className = className;
	}

	public int getRowId() {
		return rowId;
	}
	public void setRowId(int rowId) {
		this.rowId = rowId;
	}
	public Vector getRowIdVector() {
		return rowIdVector;
	}
	public void setRowIdVector(Vector rowIdVector) {
		this.rowIdVector = rowIdVector;
	}
	public int getTotalPages() {
		return totalPages;
	}
	public void setTotalPages(int totalPages) {
		this.totalPages = totalPages;
	}
	public String getMode() {
		return mode;
	}
	public void setMode(String mode) {
		this.mode = mode;
	}
	public int getClassId() {
		return classId;
	}
	public void setClassId(int classId) {
		this.classId = classId;
	}
	public LabelsBean getLabelsBean() {
		return labelsBean;
	}
	public void setLabelsBean(LabelsBean labelsBean) {
		this.labelsBean = labelsBean;
	}
	public String getClassDescription() {
		return classDescription;
	}
	public void setClassDescription(String classDescription) {
		this.classDescription = classDescription;
	}
	public HTMLclass getPresentation() {
		return presentation;
	}
	public void setPresentation(HTMLclass presentation) {
		this.presentation = presentation;
	}
	public Vector getRelationVector() {
		return relationVector;
	}
	public void setRelationVector(Vector relationVector) {
		this.relationVector = relationVector;
	}
	public Hashtable getReferenceHash() {
		return referenceHash;
	}
	public void setReferenceHash(Hashtable referenceHash) {
		this.referenceHash = referenceHash;
	}

} // end class
