package cmdbuild.action_forms;
import java.sql.*;
import java.util.*;

import cmdbuild.presentation.HTMLclass;
import cmdbuild.utils.MultiLanguage;
import cmdbuild.collection.*;
import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBclass;
import cmdbuild.elements.CMDBlookup;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionMapping;

public class SearchPopupForm extends ActionFormTemplate {

	static final long serialVersionUID = 1L;
	private String name;
	private String classDescription="";
	private String method;
	private String mode;
	private String search; 
	private HTMLclass presentation; // object that generates HTML code
	private Vector rowIdVector; // contains all the row from the query
	private Vector attributeBeanVector;
	private Vector lookupVector; // contains objects lookup where name=type & description=<option></option>...
	private Hashtable referenceHash;
	private int rowId;  // contains the real id of the row
	private String inputName; // this is the tesxtarea name in searchForm
	
	public SearchPopupForm() {
		super();
	}

	public void reset(ActionMapping mapping, HttpServletRequest request) {
		System.out.println("**SEARCHPOPUPFORM RESET**");
		ErrorBean err = null;
		if (request.getParameter("searchname") != null){
			name = request.getParameter("searchname");
			request.getSession().setAttribute("searchname",name);
		} else if (request.getSession().getAttribute("searchname") != null){
 			name = (String)request.getSession().getAttribute("searchname");
		}
		if (request.getParameter("inputname") != null){
			inputName = request.getParameter("inputname");
			request.getSession().setAttribute("inputname",inputName);
		} else if (request.getSession().getAttribute("inputname") != null){
 			inputName = (String)request.getSession().getAttribute("inputname");
		}

        DBService db = (DBService)servlet.getServletContext().getAttribute("db");
        CMDBclass CMDB = new CMDBclass(db);
        // get extra attributes for the class
		try {
			attributeBeanVector = CMDB.selectAllAttribute(name,"rw") ;		       
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		if (attributeBeanVector!=null && attributeBeanVector.size()>0){
			classDescription= ((AttributeBean)attributeBeanVector.elementAt(0)).getClassBean().getDescription(); 
		}
		// creating lookupVector if there are lookups
		lookupVector = new Vector();
		referenceHash = new Hashtable();
		HashSet hash = new HashSet();
		AttributeBean ab = null;
		Vector options = null;
		CMDBlookup LOOKUP = new CMDBlookup(db);
		Enumeration enu = attributeBeanVector.elements();
		while (enu.hasMoreElements()){
			ab = (AttributeBean)enu.nextElement();
			if (ab.getType()==AttributeBean.LOOKUP){
				hash.add(ab.getLookup());
			}
			if (ab.getType()==AttributeBean.REFERENCE){
				try {
					if (!referenceHash.containsKey(ab.getReference()) && ab.getReference().length()>0){ // don't get duplicates
						DEBUG.println("Getting refrence for "+ab.getReference());
						options = LOOKUP.selectAllReference(ab.getReference());
						referenceHash.put(ab.getReference(),options);
					}
				} catch (SQLException e) {
					err = new ErrorBean("searchpopup.jsp",e);
					e.printStackTrace();
				}
			}
		}
		// getting lookups
		try {
			options = new Vector();
			options.addAll(hash);
			lookupVector = LOOKUP.selectLookupByTypes(options);
		} catch (SQLException e) {
			err = new ErrorBean("searchpopup.jsp",e);
			e.printStackTrace();
		}
		//System.out.println("lookup.size="+lookupVector.size());
		CMDB = CMDB.load(CMDB,CMDB.getBean().getManager());
		presentation = (HTMLclass)CMDB.getPresentation();
		MultiLanguage multilanguage = (MultiLanguage)request.getSession().getAttribute("multilanguage");
		presentation.setMultilanguage(multilanguage);
		presentation.setClassName(name);
		presentation.setInputName(inputName);
		presentation.setAttributeVector(attributeBeanVector);
		presentation.setLookupVector(lookupVector);
		presentation.setReferenceHash(referenceHash);
		presentation.setClassDescription(classDescription);
		presentation.getHeader().getCreate().setVisible(false);
		presentation.getHeader().getModify().setVisible(false);
		presentation.getHeader().getFilter().setVisible(false);
		presentation.getHeader().getNofilter().setVisible(false);
		presentation.getHeader().getDelete().setVisible(false);
		// settings arrows
		presentation.getHeader().getFirst().setVisible(false);
		presentation.getHeader().getPrev().setVisible(false);
		presentation.getHeader().getNext().setVisible(false);
		presentation.getHeader().getLast().setVisible(false);
		// setting current page
		presentation.getHeader().getPage().setVisible(false);
		presentation.getHeader().getLabel().setVisible(false);
		// setting calendar reference
		presentation.setFormName("searchPopupForm");
		
		if (err!=null){
			request.getSession().setAttribute("error",err);
		}
	}

	/*
	public ActionErrors validate(ActionMapping arg0, HttpServletRequest arg1) {
		System.out.println("**VALIDATE**");
		System.out.println("Mode is "+mode);
		ActionErrors errors = new ActionErrors();
		AssetBean ab = null;
		String tname = "";
		String target="";
		Enumeration en = columnVector.elements();
		while (en.hasMoreElements()){
			ab = (AssetBean)en.nextElement();
			if (ab.getAMandatory().equals("Y")){
				tname = ab.getAName();
				target= arg1.getParameter(tname);
				System.out.println("target is "+tname+"target value="+target);
				if (target == null || target.trim().equals("")){ // ,tname
					errors.add(tname, new ActionMessage("par.required",tname));
				} else { // if there is something
					if (ab.getAType().equals("int4")){
						try {
							Integer.parseInt(target);
						} catch (NumberFormatException e){
							errors.add(tname, new ActionMessage("par.precision.to.integer",tname));
						}
					} // end numeric
					if (ab.getAType().equals("float8")){
						try {
							Double.parseDouble(target);
						} catch (NumberFormatException e){
							errors.add(tname, new ActionMessage("par.precision.to.double",tname));
						}
					} // end numeric
					if (ab.getAType().equals("numeric")){
						try {
							Double.parseDouble(target);
						} catch (NumberFormatException e){
							errors.add(tname, new ActionMessage("par.precision.to.double",tname));
						}
					} // end numeric
				} // end else	
			} else {  // not mandatory
				tname = ab.getAName();
				target= arg1.getParameter(tname);
				System.out.println("target value="+target);
				if (target != null && !target.trim().equals("")){ // if there is something
					if (ab.getAType().equals("int4")){
						try {
							Integer.parseInt(target);
						} catch (NumberFormatException e){
							errors.add(tname, new ActionMessage("par.precision.to.integer",tname));
						}
					} // end numeric
					if (ab.getAType().equals("float8")){
						try {
							Double.parseDouble(target);
						} catch (NumberFormatException e){
							errors.add(tname, new ActionMessage("par.precision.to.double",tname));
						}
					} // end numeric
					if (ab.getAType().equals("numeric")){
						try {
							Double.parseDouble(target);
						} catch (NumberFormatException e){
							errors.add(tname, new ActionMessage("par.precision.to.double",tname));
						}
					} // end numeric
				} // end else	
			}
		}
		return errors;
	}
	*/
	
	public Vector getAttributeBeanVector() {
		return attributeBeanVector;
	}
	public void setAttributeBeanVector(Vector attributeBeanVector) {
		this.attributeBeanVector = attributeBeanVector;
	}
	public Vector getLookupVector() {
		return lookupVector;
	}
	public void setLookupVector(Vector lookupVector) {
		this.lookupVector = lookupVector;
	}
	public String getMethod() {
		return method;
	}
	public void setMethod(String method) {
		this.method = method;
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public int getRowId() {
		return rowId;
	}
	public void setRowId(int rowId) {
		this.rowId = rowId;
	}
	public Vector getRowIdVector() {
		return rowIdVector;
	}
	public void setRowIdVector(Vector rowIdVector) {
		this.rowIdVector = rowIdVector;
	}
	public String getSearch() {
		return search;
	}
	public void setSearch(String search) {
		this.search = search;
	}
	public String getMode() {
		return mode;
	}
	public void setMode(String mode) {
		this.mode = mode;
	}
	public String getInputName() {
		return inputName;
	}
	public void setInputName(String inputName) {
		this.inputName = inputName;
	}
	public String getClassDescription() {
		return classDescription;
	}
	public void setClassDescription(String classDescription) {
		this.classDescription = classDescription;
	}
	public HTMLclass getPresentation() {
		return presentation;
	}
	public void setPresentation(HTMLclass presentation) {
		this.presentation = presentation;
	}

} // end class
