package cmdbuild.actions;

import java.sql.SQLException;
import java.util.*;

import cmdbuild.action_forms.CardForm;
import cmdbuild.collection.AssetBean;
import cmdbuild.collection.ClassBean;
import cmdbuild.collection.ErrorBean;
import cmdbuild.collection.AttributeBean;
import cmdbuild.collection.IdBean;
import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBclass;
import cmdbuild.elements.CMDBplanner;
import cmdbuild.utils.CleaningVector;
import cmdbuild.utils.SecurityDescriptor;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

public class CardAction extends DispatchActionTemplate {

	public ActionForward create(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		DEBUG.println("**CREATE**");
		DBService db = (DBService)servlet.getServletContext().getAttribute("db");
		ErrorBean err = null;
		Vector columnVector = null;
		AssetBean bean = null;
		String name = ((CardForm)form).getClassName();
		columnVector = ((CardForm)form).getColumnVector();
		Enumeration en = columnVector.elements();
		String value;
		String str ="";
		Vector dateExpireGroup = new Vector();
		Vector warnings = new Vector();
		// getting values from request
		while (en.hasMoreElements()){
			bean = (AssetBean)en.nextElement();
			value = request.getParameter(bean.getName());
			if (bean.getType()==AttributeBean.BOOLEAN){
				if (value.equals("S")){
					value="true";
				} else {
					value = "false";
				}
			}
			if (bean.getType()==AttributeBean.DATE && bean.isDateExpire()){
				dateExpireGroup.add(bean);
				str = request.getParameter(bean.getName()+"datewarning");
				if (str==null){
					str = "";
				}
				DEBUG.println("datewarning value="+str);
				warnings.add(str);
			}
			bean.setValue(value);
		}
		// adding idclass idcategory
		AssetBean as = (AssetBean)columnVector.elementAt(0);
		Vector colVect = new Vector();
		AssetBean ass1 = new AssetBean();
		ass1.setName("IdClass");
		ass1.setType("int4");
		ass1.setValue(as.getClassBean().getId()+"");
		AssetBean ass2 = new AssetBean();
		ass2.setName("IdCategory");
		ass2.setType("int4");
		ass2.setValue(as.getClassBean().getIdCategory()+"");
		colVect.add(ass1);
		colVect.add(ass2);
		colVect.addAll(columnVector);
		columnVector=colVect;
		// setting attributes to be cleaned if are ''
		CleaningVector clean = new CleaningVector(columnVector);
		columnVector = clean.getCleanedVector();
		// cleaning the null parameters
		AssetBean ass = null;
		for (int ii=columnVector.size()-1;ii>-1;ii--){
			ass = (AssetBean)columnVector.elementAt(ii);
			if (ass.isToDelete()){
				//DEBUG.println("Removing "+ass.getAName());
				columnVector.remove(ii);
			} else {
				//DEBUG.println("Not removing "+ass.getAName());
			}
		}
		// adding Status
		AssetBean stat = new AssetBean();
		stat.setName("Status");
		stat.setSQLType("varchar");
		stat.setType("varchar");
		stat.setValue("A");
		columnVector.add(stat);
		boolean ok = false;
		// getting user from session
		SecurityDescriptor user = null;
		String us = null;
		if (request.getSession().getAttribute("user")!=null){
			user = (SecurityDescriptor)request.getSession().getAttribute("user");
			us = user.getUserName();
		}
		CMDBclass CMDB = new CMDBclass(db);
		try {
			ok = CMDB.createCard(name,columnVector,us);			
		} catch( SQLException e ) { // patch postgres bug
			err = new ErrorBean("card.jsp",e);
			e.printStackTrace();
		}
		if (ok){
			DEBUG.println("Scheda creata");
			//request.getSession().setAttribute("mode","show");
			//request.getSession().setAttribute("filterBean",null);
			int Id = 0;
			IdBean ib = null;
			Vector rowIdVector = null;
    		try {
    			String query = "SELECT \"Id\" FROM \""+name+"\" WHERE \"Status\"='A' ";
    			rowIdVector = CMDB.selectCardsId(query);
    			Id = CMDB.getCardId(name,columnVector);
    			// updating expiration dates
    			if (dateExpireGroup.size()>0){
    				CMDBplanner PLAN = new CMDBplanner(db);
    				Vector ids = PLAN.selectDateWarningId(Id);
    				PLAN.modifyDateWarning(dateExpireGroup,warnings,ids);
    			}
    		} catch (SQLException e) {
    			err = new ErrorBean("card.jsp",e);
    			e.printStackTrace();
    		}
    		// getting the page
    		int page = 1;
    		Enumeration enim = rowIdVector.elements();
    		while (enim.hasMoreElements()){
    			ib = (IdBean)enim.nextElement();
    			if (Id==ib.getId()){
    				break;
    			}
    			page++;
    		}
    		int totpages = ((CardForm)form).getTotalPages();
    		if (totpages!=0 && page>totpages+1){
    			page=totpages+1;
    		}
    		((CardForm)form).setMode("show");
    		// sending to page
    		request.getSession().setAttribute("page",(page+""));
    		((CardForm)form).setCurrentPage(page);
    		//request.setAttribute("page",(page+""));
    		request.getSession().setAttribute("filterBean",null);
    		DEBUG.println("CA-create page is "+page);
		}
		if (err==null){
			((CardForm)form).reset(mapping,request);
			request.getSession().setAttribute("mode","show");
			return mapping.findForward("create");
		} else {
			DEBUG.println("Scheda non creata");
			request.getSession().setAttribute("error",err);
			return mapping.findForward("error");
		}
	}
	
	public ActionForward modify(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		DEBUG.println("**MODIFY**");
		DBService db = (DBService)servlet.getServletContext().getAttribute("db");
		ErrorBean err = null;
		CMDBclass CMDB = new CMDBclass(db);
		Vector columnVector = null;
		AssetBean bean = null;
		String name = ((CardForm)form).getClassName();
		columnVector = ((CardForm)form).getColumnVector();
		int id = ((CardForm)form).getObjId();
		DEBUG.println("rowId prima della modifica="+id);
		Enumeration en = columnVector.elements();
		int i=0;
		while (en.hasMoreElements()){
			bean = (AssetBean)en.nextElement();
			if (bean.getName().equals("Notes") || bean.getName().equals("IdCategory")){
				columnVector.remove(i);
				DEBUG.println("Removing "+bean.getName());
			}
			i++;
		}
		String value="";
		en = columnVector.elements();
		Vector dateExpireGroup = new Vector();
		Vector warnings = new Vector();
		// setting the couple (name,value);
		String str = "";
		while (en.hasMoreElements()){
			bean = (AssetBean)en.nextElement();
			// recovers values from the query string
			value = (String)request.getParameter(bean.getName());
			value = request.getParameter(bean.getName());
			if (bean.getType()==AttributeBean.BOOLEAN){
				if (value.equals("S")){
					value="true";
				} else {
					value = "false";
				}
			}
			if (bean.getType()==AttributeBean.DATE && bean.isDateExpire()){
				dateExpireGroup.add(bean);
				str = request.getParameter(bean.getName()+"datewarning");
				if (str==null){
					str = "";
				}
				DEBUG.println("datewarning value="+str);
				warnings.add(str);
			}
			bean.setValue(value);
			DEBUG.println("nome="+bean.getName()+" valore="+value);
		}
		// cleaning the null parameters
		AssetBean ass = null;
		for (int ii=columnVector.size()-1;ii>-1;ii--){
			ass = (AssetBean)columnVector.elementAt(ii);
			if (ass.isToDelete()){
				//DEBUG.println("Removing "+ass.getAName());
				columnVector.remove(ii);
			} else {
				//DEBUG.println("Not removing "+ass.getAName());
			}
		}
		// getting user from session
		SecurityDescriptor user = null;
		String us = null;
		if (request.getSession().getAttribute("user")!=null){
			user = (SecurityDescriptor)request.getSession().getAttribute("user");
			us = user.getUserName();
		}
		boolean ok = false;
		try {
			ok = CMDB.modifyCard(name,id,columnVector,us);
			// updating expiration dates
			if (dateExpireGroup.size()>0){
				CMDBplanner PLAN = new CMDBplanner(db);
				Vector ids = PLAN.selectDateWarningId(id);
				PLAN.modifyDateWarning(dateExpireGroup,warnings,ids);
			}
		} catch (SQLException e){
			err = new ErrorBean("card.jsp",e);
		}
		((CardForm)form).setMode("show");
		if (ok && err==null){
			DEBUG.println("Scheda modificata");
			request.getSession().setAttribute("mode","show");
			((CardForm)form).reset(mapping,request);
			return mapping.findForward("modify");
		} else {
			request.getSession().setAttribute("error",err);
			DEBUG.println("Scheda non modificata");
			return mapping.findForward("error");
		}
	}

	public ActionForward delete(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		DEBUG.println("**DELETE**");
		DBService db = (DBService)servlet.getServletContext().getAttribute("db");
		ErrorBean err = null;
		CMDBclass CMDB = new CMDBclass(db);
		String className = ((CardForm)form).getClassName();
		int objId = ((CardForm)form).getObjId();
		String status = "";
		try {
			status = CMDB.getCardStatus(className,objId);
		} catch (SQLException e){
			err = new ErrorBean("card.jsp",e);
		}
		// changing status
		if (status.equals("") || status.equals("A")){
			status = "N";
		} else { // N
			status = "A";
		}
		DEBUG.println("Setting status "+status+" for "+className+" id="+objId);
		// getting user from session
		SecurityDescriptor user = null;
		String us = null;
		if (request.getSession().getAttribute("user")!=null){
			user = (SecurityDescriptor)request.getSession().getAttribute("user");
			us = user.getUserName();
		}
		try {
			CMDB.setCardStatus(className,objId,status,us);	
		} catch (SQLException e){
			err = new ErrorBean("card.jsp",e);
		}
		//db.deleteCard(className,objId);
		if (err==null){
			((CardForm)form).reset(mapping,request);
			request.getSession().setAttribute("mode","show");
			return mapping.findForward("delete");
		} else {
			request.getSession().setAttribute("error",err);
			return mapping.findForward("error");
		}
	}
	public ActionForward deletedetail(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		DEBUG.println("**DELETEDETAIL**");
		DBService db = (DBService)servlet.getServletContext().getAttribute("db");
		ErrorBean err = null;
		CMDBclass CMDB = new CMDBclass(db);
		String targetClass = request.getParameter("targetClass");
		int classId = 0;
		ClassBean cb = new ClassBean();
		try {
			classId = Integer.parseInt(targetClass);
		} catch (NumberFormatException e1) {
		}
		try {
			cb = CMDB.selectClassById(classId);
		} catch (SQLException e) {
			err = new ErrorBean();
			e.printStackTrace();
		}
		int objId = 0;
		if (request.getParameter("targetObjId")!=null){
			try {
				objId = Integer.parseInt(request.getParameter("targetObjId"));
			} catch (NumberFormatException e) {
			}
		}
		//DEBUG.println("className="+className+" objid="+objId);
		// getting user from session
		SecurityDescriptor user = null;
		String us = null;
		if (request.getSession().getAttribute("user")!=null){
			user = (SecurityDescriptor)request.getSession().getAttribute("user");
			us = user.getUserName();
		}
		if (objId!=0){
			try {
				CMDB.setCardStatus(cb.getName(),objId,"N",us);	
			} catch (SQLException e){
				err = new ErrorBean("card.jsp",e);
			}
		}
		if (err==null){
			//request.getSession().setAttribute("mode","show");
			String md = request.getParameter("masterDetail");
			int id = ((CardForm)form).getObjId();
			request.getSession().setAttribute("masterdetail",md);
			request.getSession().setAttribute("objid",id+"");
			((CardForm)form).reset(mapping,request);
			return mapping.findForward("deletedetail");
		} else {
			request.getSession().setAttribute("error",err);
			return mapping.findForward("error");
		}
	}

	public ActionForward gotopage(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		DEBUG.println("**GOTOPAGE**");
		DBService db = (DBService)servlet.getServletContext().getAttribute("db");
       CMDBclass CMDB = new CMDBclass(db);
		ErrorBean err = null;
		String targetClass = request.getParameter("targetClass");
		int classId = 0;
		ClassBean cb = new ClassBean();
		try {
			classId = Integer.parseInt(targetClass);
		} catch (NumberFormatException e1) {
		}
		try {
			cb = CMDB.selectClassById(classId);
		} catch (SQLException e) {
			err = new ErrorBean();
			e.printStackTrace();
		}
		int rowId = Integer.parseInt( ((CardForm)form).getTargetObjId() );
		DEBUG.println("targetc="+cb.getName()+" targeto="+rowId);
		Vector rowIdVector = null;
		String baseQuery = "";
		// replacing select parameters with "Id"
		baseQuery = "SELECT \"Id\" FROM \""+cb.getName()+"\" WHERE \"Status\"='A'";
   		try {
       		rowIdVector = CMDB.selectCardsId(baseQuery);
   		} catch (SQLException e) {
   			err = new ErrorBean("card.jsp",e);
   			//e.printStackTrace();
   		}
		IdBean id = null;
		Enumeration eni = rowIdVector.elements();
		int page = 1;
		while (eni.hasMoreElements()){
			id = (IdBean)eni.nextElement();
			if (rowId==id.getId()){
				break;
			}
			page++;
		}
		if (err==null){
			request.getSession().setAttribute("class",cb.getName());
			request.getSession().setAttribute("page",(page+""));
			((CardForm)form).reset(mapping,request);
			return mapping.findForward("gotopage");
		} else {
			request.getSession().setAttribute("error",err);
			return mapping.findForward("error");
		}
	}

	public ActionForward search(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		DEBUG.println("**SEARCH**");
		String search = ((CardForm)form).getSearch();
		//DEBUG.println("Search action="+search);
		((CardForm)form).setClassName(search);
		request.getSession().setAttribute("class",search);
		// calling reset method
		((CardForm)form).reset(mapping,request);
		return mapping.findForward("search");
	}
	
	public ActionForward copy(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		DEBUG.println("**COPY**");
		Vector vett = ((CardForm)form).getColumnVector();
		String name = ((CardForm)form).getClassName();
		Hashtable copypaste = null;
		//DEBUG.println("vett.size="+vett.size());
		if (request.getSession().getAttribute("copypaste")==null){
			copypaste = new Hashtable();
			copypaste.put(name,vett);
			request.getSession().setAttribute("copypaste",copypaste);
		} else {
			copypaste = (Hashtable)request.getSession().getAttribute("copypaste");
			copypaste.put(name,vett); // eventually overwrite old value
			request.getSession().setAttribute("copypaste",copypaste);
		}
		// calling reset method
		((CardForm)form).reset(mapping,request);
		return mapping.findForward("copy");
	   }
	
	public ActionForward paste(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		DEBUG.println("**PASTE**");
		request.getSession().setAttribute("mode","create");
		request.getSession().setAttribute("usecopypaste",new Boolean(true));
		request.setAttribute("mode","create");
		((CardForm)form).reset(mapping,request);
		return mapping.findForward("paste");
	   }
	
} // end of class
