package cmdbuild.actions;

import java.sql.SQLException;
import java.util.*;

import cmdbuild.action_forms.CardPopupForm;
import cmdbuild.collection.AssetBean;
import cmdbuild.collection.ClassBean;
import cmdbuild.collection.ErrorBean;
import cmdbuild.collection.AttributeBean;
import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBclass;
import cmdbuild.elements.CMDBplanner;
import cmdbuild.utils.CleaningVector;
import cmdbuild.utils.SecurityDescriptor;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

public class CardPopupAction extends DispatchActionTemplate {

	public ActionForward create(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		DEBUG.println("**CREATE**");
		DBService db = (DBService)servlet.getServletContext().getAttribute("db");
		ErrorBean err = null;
		Vector columnVector = null;
		AssetBean bean = null;
		String name = ((CardPopupForm)form).getSearch();
		CMDBclass CMDB = new CMDBclass(db);
		ClassBean cb = null;
		try {
			cb = CMDB.selectClassByName(name);
		} catch (SQLException e) {
			err = new ErrorBean("cardpopup.jsp",e);
			e.printStackTrace();
		}
		columnVector = ((CardPopupForm)form).getColumnVector();
		Enumeration en = columnVector.elements();
		String value;
		String str ="";
		Vector dateExpireGroup = new Vector();
		Vector warnings = new Vector();
		// getting values from request
		while (en.hasMoreElements()){
			bean = (AssetBean)en.nextElement();
			value = request.getParameter(bean.getName());
			if (bean.getType()==AttributeBean.BOOLEAN){
				if (value.equals("S")){
					value="true";
				} else {
					value = "false";
				}
			}
			if (bean.getType()==AttributeBean.DATE && bean.isDateExpire()){
				dateExpireGroup.add(bean);
				str = request.getParameter(bean.getName()+"datewarning");
				if (str==null){
					str = "";
				}
				DEBUG.println("datewarning value="+str);
				warnings.add(str);
			}
			bean.setValue(value);
		}
		// adding idclass idcategory
		AssetBean as = (AssetBean)columnVector.elementAt(0);
		Vector colVect = new Vector();
		AssetBean ass1 = new AssetBean();
		ass1.setName("IdClass");
		ass1.setType("int4");
		ass1.setValue(cb.getId()+"");
		AssetBean ass2 = new AssetBean();
		ass2.setName("IdCategory");
		ass2.setType("int4");
		ass2.setValue(as.getClassBean().getIdCategory()+"");
		colVect.add(ass1);
		colVect.add(ass2);
		colVect.addAll(columnVector);
		columnVector=colVect;
		// setting attributes to be cleaned if are ''
		CleaningVector clean = new CleaningVector(columnVector);
		columnVector = clean.getCleanedVector();
		// cleaning the null parameters
		AssetBean ass = null;
		for (int ii=columnVector.size()-1;ii>-1;ii--){
			ass = (AssetBean)columnVector.elementAt(ii);
			if (ass.isToDelete()){
				//DEBUG.println("Removing "+ass.getAName());
				columnVector.remove(ii);
			} else {
				//DEBUG.println("Not removing "+ass.getAName());
			}
		}
		// adding Status
		AssetBean stat = new AssetBean();
		stat.setName("Status");
		stat.setSQLType("varchar");
		stat.setType("varchar");
		stat.setValue("A");
		columnVector.add(stat);
		boolean ok = false;
		// getting user from session
		SecurityDescriptor user = null;
		String us = null;
		if (request.getSession().getAttribute("user")!=null){
			user = (SecurityDescriptor)request.getSession().getAttribute("user");
			us = user.getUserName();
		}
		try {
			ok = CMDB.createCard(name,columnVector,us);			
		} catch( SQLException e ) { // patch postgres bug
			err = new ErrorBean("cardpopup.jsp",e);
			e.printStackTrace();
		}
		if (err==null && ok){
			DEBUG.println("Scheda creata");
			((CardPopupForm)form).reset(mapping,request);
			String close="ok";
			request.getSession().setAttribute("close",close);
			return mapping.findForward("create");
		} else {
			DEBUG.println("Scheda non creata");
			request.getSession().setAttribute("error",err);
			return mapping.findForward("error");
		}
	}
	
	public ActionForward modify(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		DEBUG.println("**MODIFY**");
		DBService db = (DBService)servlet.getServletContext().getAttribute("db");
		ErrorBean err = null;
		CMDBclass CMDB = new CMDBclass(db);
		Vector columnVector = null;
		AssetBean bean = null;
		String name = ((CardPopupForm)form).getDetailClass();
		columnVector = ((CardPopupForm)form).getColumnVector();
		int id = ((CardPopupForm)form).getDetailObjId();
		DEBUG.println("rowId prima della modifica="+id);
		Enumeration en = columnVector.elements();
		int i=0;
		while (en.hasMoreElements()){
			bean = (AssetBean)en.nextElement();
			if (bean.getName().equals("Notes") || bean.getName().equals("IdCategory")){
				columnVector.remove(i);
				DEBUG.println("Removing "+bean.getName());
			}
			i++;
		}
		String value="";
		en = columnVector.elements();
		Vector dateExpireGroup = new Vector();
		Vector warnings = new Vector();
		// setting the couple (name,value);
		String str = "";
		while (en.hasMoreElements()){
			bean = (AssetBean)en.nextElement();
			// recovers values from the query string
			value = (String)request.getParameter(bean.getName());
			value = request.getParameter(bean.getName());
			if (bean.getType()==AttributeBean.BOOLEAN){
				if (value.equals("S")){
					value="true";
				} else {
					value = "false";
				}
			}
			if (bean.getType()==AttributeBean.DATE && bean.isDateExpire()){
				dateExpireGroup.add(bean);
				str = request.getParameter(bean.getName()+"datewarning");
				if (str==null){
					str = "";
				}
				DEBUG.println("datewarning value="+str);
				warnings.add(str);
			}
			bean.setValue(value);
			DEBUG.println("nome="+bean.getName()+" valore="+value);
		}
		// cleaning the null parameters
		AssetBean ass = null;
		for (int ii=columnVector.size()-1;ii>-1;ii--){
			ass = (AssetBean)columnVector.elementAt(ii);
			if (ass.isToDelete()){
				//DEBUG.println("Removing "+ass.getAName());
				columnVector.remove(ii);
			} else {
				//DEBUG.println("Not removing "+ass.getAName());
			}
		}
		// getting user from session
		SecurityDescriptor user = null;
		String us = null;
		if (request.getSession().getAttribute("user")!=null){
			user = (SecurityDescriptor)request.getSession().getAttribute("user");
			us = user.getUserName();
		}
		boolean ok = false;
		try {
			ok = CMDB.modifyCard(name,id,columnVector,us);
			// updating expiration dates
			if (dateExpireGroup.size()>0){
				CMDBplanner PLAN = new CMDBplanner(db);
				Vector ids = PLAN.selectDateWarningId(id);
				PLAN.modifyDateWarning(dateExpireGroup,warnings,ids);
			}
		} catch (SQLException e){
			err = new ErrorBean("cardpopup.jsp",e);
		}
		((CardPopupForm)form).setMode("show");
		if (ok && err==null){
			DEBUG.println("Scheda modificata");
			((CardPopupForm)form).reset(mapping,request);
			String close="ok";
			request.getSession().setAttribute("close",close);
			request.getSession().setAttribute("mode","show");
			((CardPopupForm)form).reset(mapping,request);
			return mapping.findForward("modify");
		} else {
			request.getSession().setAttribute("error",err);
			DEBUG.println("Scheda non modificata");
			return mapping.findForward("error");
		}
	}
	
	public ActionForward search(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		DEBUG.println("**SEARCH**");
		CardPopupForm f = ((CardPopupForm)form); 
		String search = f.getSearch();
		f.setDetailClass(search);
		f.setMode("create");
		// calling reset method
		((CardPopupForm)form).reset(mapping,request);
		return mapping.findForward("search");
	}
	
} // end of class
