package cmdbuild.actions;


import cmdbuild.collection.ClassBean;
import cmdbuild.utils.ClassFamily;

import java.sql.SQLException;
import java.util.Collection;
import java.util.Enumeration;
import java.util.HashSet;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Vector;

import cmdbuild.action_forms.CreateAttributeForm;
import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBclass;
import cmdbuild.collection.AttributeBean;
import cmdbuild.collection.DomainBean;
import cmdbuild.collection.ErrorBean;
import cmdbuild.collection.LookupBean;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

public class CreateAttributeAction extends DispatchActionTemplate {

	public ActionForward create(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {

		AttributeBean ab = new AttributeBean();
		CreateAttributeForm f = ((CreateAttributeForm)form);
		String tabname = (String) request.getSession().getAttribute("class");
		String name = f.getAName();
		boolean isSuperClass = f.isSuperClass();
		ab.setName(name);
		ab.setIndex(f.getAIndex());
		String description = f.getADescription();
		ab.setDescription(description);
		int type = f.getAType();
		String SQLtype="";
		String extraInput="";
		if (type==AttributeBean.DECIMAL){
			extraInput = f.getExtraInput();
			extraInput = extraInput.replace('.',',');
			SQLtype = ab.javaToDb(AttributeBean.DECIMAL)+"("+extraInput+")";
			ab.setSQLType(SQLtype);
		} else if (type==AttributeBean.STRING) {
			extraInput = f.getExtraInput();
			SQLtype = ab.javaToDb(AttributeBean.STRING)+"("+extraInput+")";
			ab.setSQLType(SQLtype);
		} else if (type==AttributeBean.LOOKUP){
			ab.setSQLType(ab.javaToDb(AttributeBean.LOOKUP)); // defined in database table LookUp
			ab.setLookup(f.getALookup());
		} else if (type==AttributeBean.REFERENCE){
			ab.setSQLType(ab.javaToDb(AttributeBean.REFERENCE)); // defined in database table LookUp
			ab.setReferenceDomain(f.getAReferenceDomain());
			ab.setReferenceType(f.getAReferenceType());
			Collection domainCollection = f.getDomainCollection();
			Iterator it = domainCollection.iterator();
			DomainBean dm = null;
			while (it.hasNext()){
				dm = (DomainBean) it.next();
				if (dm.getName().equals(ab.getReferenceDomain())){
					break;
				}
			}
			HashSet family = (HashSet) request.getSession().getAttribute("family");
			if (family.contains(dm.getStartClass())){
				ab.setReference(dm.getEndClass());
				ab.setReferenceDirect(true);
			} else {
				ab.setReference(dm.getStartClass());
				ab.setReferenceDirect(false);
			}
		} else if (type==AttributeBean.DATE){
			extraInput = request.getParameter("ADateExpire");
			DEBUG.println("dateexpire="+extraInput);
			if (extraInput!=null && extraInput.equals("on")){
				ab.setDateExpire(true);
			}
			SQLtype=ab.javaToDb(type);
			ab.setSQLType(SQLtype);
		} else { // for the othes aType
			SQLtype=ab.javaToDb(type);
			ab.setSQLType(SQLtype);
		}
		//DEBUG.println("sqltype="+ab.getSQLType());
		String mandatory = request.getParameter("AMandatory");
		DEBUG.println("manadatory"+mandatory);
		ab.setMandatory(mandatory);
		String defaultValue = null;
		// get default
		defaultValue = f.getADefault();
		if (type==AttributeBean.LOOKUP){
			String def = request.getParameter("ADefault");
			DEBUG.println("def="+def);
			ab.setDefaultValue("");
			if (def!=null && def.length()>0){
				int adl;
				try {
					adl = Integer.parseInt(def);
					ab.setDefaultValue(adl+"");
				} catch (NumberFormatException e) {
					e.printStackTrace();
				}
			}
		} else if (type==AttributeBean.REFERENCE){
			ab.setDefaultValue("");
		} else {
			ab.setDefaultValue(defaultValue);
		}
		String basedsp = f.getBaseDSP();
		String base;
		if (basedsp!=null && basedsp.equals("on")){
			base = "true";
		} else {
			base = "false";
		}
		ab.setBaseDSP(base);
		String status = f.getAStatus();
		ab.setStatus(status);
		ErrorBean err = null;
		DBService db = (DBService)servlet.getServletContext().getAttribute("db");
		CMDBclass CMDB = new CMDBclass(db);
		boolean ok = false;
		ClassBean cb = null;
		try {
			ok = CMDB.createAttribute(tabname,ab);
			if (isSuperClass){
		        Vector treeVector = CMDB.selectClassTree();
				ClassFamily cf = new ClassFamily(tabname,treeVector); 
				Vector childs = cf.descendantsOf(tabname);
				Enumeration en = childs.elements();
				while (en.hasMoreElements()){
					cb = (ClassBean) en.nextElement();
					CMDB.modifyAttributeComment(cb.getName(),name,ab);
				}
			}
		} catch (SQLException e){
			err = new ErrorBean("createattribute.jsp",e);
			e.printStackTrace();
		}
		if (ok && err == null){
			DEBUG.println("Tabella modificata");
			String close="ok";
			request.getSession().setAttribute("close",close);
			return mapping.findForward("create");
		} else {
			DEBUG.println("Tabella non modificata " + tabname);
			request.getSession().setAttribute("error",err);
			return mapping.findForward("error");
		}
	} // end action
	
	public ActionForward addType(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		DEBUG.println("**ADDTYPE**");
		CreateAttributeForm f = ((CreateAttributeForm)form);
		int type = f.getAType();
		LookupBean lb = null;
		Hashtable lookupHash = (Hashtable) request.getSession().getAttribute("lookupHash");
		if (type==AttributeBean.LOOKUP){ // getting default for this type
			if (f.getALookup()!=null && f.getALookup().length()>0){
				lb = (LookupBean) lookupHash.get(f.getALookup());
				if (lb!=null){
					DEBUG.println("setting lookup default");
					f.setADefault(lb.getDescription());
					f.setADefaultLookup(lb.getId());
				}
			}
		}	
		return mapping.findForward("addType");
	}
	
	public ActionForward loadDefaultLookup(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		DEBUG.println("**loadDefaultLookup**");
		CreateAttributeForm f = ((CreateAttributeForm)form);
		int type = f.getAType();
		LookupBean lb = null;
		Hashtable lookupHash = (Hashtable) request.getSession().getAttribute("lookupHash");
		if (type==AttributeBean.LOOKUP){ // getting default for this type
			if (f.getALookup()!=null && f.getALookup().length()>0){
				lb = (LookupBean) lookupHash.get(f.getALookup());
				if (lb!=null){
					f.setADefault(lb.getDescription());
					f.setADefaultLookup(lb.getId());
				}
			}
		}	
		//request.getSession().setAttribute("class",classname); // lo salvo nella sessione
		return mapping.findForward("loadDefaultLookup");
	}

} // end of class
