package cmdbuild.actions;


import java.sql.SQLException;

import cmdbuild.action_forms.CreateDomainForm;
import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBmap;
import cmdbuild.collection.DomainBean;
import cmdbuild.collection.ErrorBean;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

public class CreateDomainAction extends DispatchActionTemplate {

	public ActionForward create(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		CreateDomainForm f = ((CreateDomainForm)form);
		DomainBean bean = new DomainBean();
		bean.setName(f.getName());
		bean.setDirectDescription(f.getDirectDescription());
		bean.setInverseDescription(f.getInverseDescription());
		bean.setStartClass(f.getStartClass());
		bean.setEndClass(f.getEndClass());
		bean.setCardinality(f.getCard1()+":"+f.getCard2());
		bean.setMasterDetail(f.isMasterDetail());
		bean.setStatus(f.getStatus());
		// String category = ((CreateTableForm)form).getCategory();
		DBService db = (DBService)servlet.getServletContext().getAttribute("db");
		CMDBmap MAP = new CMDBmap(db);
		boolean ok = false;
		ErrorBean err = null;
		try {
			MAP.createDomain(bean);
			ok = true;
		} catch (SQLException e) {
			err=new ErrorBean("",e);
		} 
		if (ok && err==null){
			DEBUG.println("Dominio creato " + bean.getName());
			String close="ok";
			request.getSession().setAttribute("close",close);
			return mapping.findForward("create");
		} else {
			DEBUG.println("Dominio non creato");
			return mapping.findForward("error");
		}
	}
} // end of class
