package cmdbuild.actions;

import java.util.Enumeration;
import java.util.HashSet;
import java.util.Hashtable;
import java.util.StringTokenizer;
import java.util.Vector;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.*;
import org.apache.struts.actions.DispatchAction;

import cmdbuild.action_forms.CreateReportForm;
import cmdbuild.collection.AttributeBean;
import cmdbuild.collection.ClassBean;
import cmdbuild.collection.ReportMenuBean;
import cmdbuild.utils.MultiLanguage;
import cmdbuild.wizards.WizardReport;
import cmdbuild.wizards.reportutils.ReportFilter;
import cmdbuild.wizards.reportutils.ReportQueryFactory;

public class CreateReportAction extends DispatchAction {

	public ActionForward back(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		System.out.println("**BACK**");
		int page = ((CreateReportForm)form).getReportPage();
		int subpage = ((CreateReportForm)form).getSubPage();
		int nsubpages = ((CreateReportForm)form).getRep().getNSubPages();
		if (page>1){
			if (page==2){
				//request.getSession().setAttribute("m",null);
				//((CreateReportForm)form).getRep().getQueryFactory().clearPaths();
				page--;
			} else if (page==3){
				if (subpage==0){
					page--;
				} else {
					subpage--;
				}
			} else if (page==4){
				page--;
				subpage = nsubpages;
			} else {
				page--;
			}
			request.getSession().setAttribute("reportsubpage",""+subpage);
			request.getSession().setAttribute("reportpage",""+page);
		}
		form.reset(mapping,request);
		return mapping.findForward("back");
	}
	
	public ActionForward next(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		System.out.println("**NEXT**");
		int page = ((CreateReportForm)form).getReportPage();
		int subpage = ((CreateReportForm)form).getSubPage();
		int nsubpages = ((CreateReportForm)form).getRep().getNSubPages();
		WizardReport rep = ((CreateReportForm)form).getRep();
		if (page>0){
			switch (page) {
            case 1: //request.getSession().setAttribute("rm",null);
					rep.actionForPage(request,page);
					page++;
            		break;
            case 2: rep.actionForPage(request,page);
            		subpage = 0;
            		page++;
            		break;
            case 3: if (subpage<nsubpages){
						rep.actionForPage(request,page);
						subpage++;
					} else { // subpage == nsubpages change page
						rep.actionForPage(request,page);
						page++;
					}
            		break;
            default: rep.actionForPage(request,page);
					 page++;
					 break;
			}
			request.getSession().setAttribute("reportsubpage",""+subpage);
			request.getSession().setAttribute("reportpage",""+page);
		}
		form.reset(mapping,request);
		if (request.getSession().getAttribute("error")!=null){
			return mapping.findForward("error");
		} else {
			return mapping.findForward("next");
		}
	}
	
	// add path, page 2
	public ActionForward add(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		System.out.println("**ADD**");
		String mpath = request.getParameter("mpath");
		Vector levels = ((CreateReportForm)form).getRep().getMenu().getLevels();
		Hashtable classHash = ((CreateReportForm)form).getRep().getClassHash();
		Vector level = null;
		StringTokenizer tok = new StringTokenizer(mpath,"A",false);
		String mtok = "";
		int mlevel = 0;
		ReportMenuBean menu = null;
		Vector res = new Vector();
		String actualPath = "";
		String select = "";
		while (tok.hasMoreTokens()){
			mtok = tok.nextToken();
			int mtokn = Integer.parseInt(mtok);
			level = (Vector)levels.elementAt(mlevel);
			menu = (ReportMenuBean)level.elementAt(mtokn);
			// new 
			actualPath = mpath.substring(0,mlevel*2+2);
			select = request.getParameter(actualPath);
			if (select!=null && select.length()>0){
				if (menu.isDirect()){
					menu.setClass2(select);
					menu.setDescription2(((ClassBean)classHash.get(select)).getDescription());
					menu.setText(menu.getRelation()+" "+menu.getDescription2());
				} else {
					menu.setClass1(select);
					menu.setDescription1(((ClassBean)classHash.get(select)).getDescription());
					menu.setText(menu.getRelation()+" "+menu.getDescription1());
				}
			}
			res.add(menu);
			mlevel++;
		}
		((CreateReportForm)form).getRep().getQueryFactory().addPaths(res,mpath);
		// crating path title
		String str = "";
		Enumeration en = res.elements();
		while (en.hasMoreElements()){
			menu = (ReportMenuBean) en.nextElement();
			str += " "+menu.getText();
		}
		int n = ((CreateReportForm)form).getRep().getQueryFactory().countPaths();
		((CreateReportForm)form).getRep().getQueryFactory().setTitle(str,n);
		// save andOr
		String andOr = request.getParameter("andor");
		((CreateReportForm)form).getRep().getChoice().put("andOr",andOr);
		form.reset(mapping,request);
		return mapping.findForward("add");
	}

	// remove path, page 2
	public ActionForward remove(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		System.out.println("**REMOVE**");
		String mpath = request.getParameter("mpath");
		int target = Integer.parseInt(mpath);
		((CreateReportForm)form).getRep().getQueryFactory().removePaths(target);
		// save andOr
		String andOr = request.getParameter("andor");
		((CreateReportForm)form).getRep().getChoice().put("andOr",andOr);
		form.reset(mapping,request);
		return mapping.findForward("remove");
	}

	public ActionForward addfilter(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		System.out.println("**ADDFILTER**");
		// save information for filters
		ReportQueryFactory queryFactory = ((CreateReportForm)form).getRep().getQueryFactory();
		int subPage = ((CreateReportForm)form).getRep().getSubPage();
		Vector vett = queryFactory.getFiltersForPage(subPage);
		Hashtable attributesHash = ((CreateReportForm)form).getRep().getAttributesHash();
		Vector lookupVector = ((CreateReportForm)form).getRep().getLookupVector();
		ReportFilter rf = null;
		String val = "";
		String tip = "";
		AttributeBean ab = null;
		Enumeration en = vett.elements();
		Enumeration eni = null;
		int i = 0;
		while (en.hasMoreElements()){
			rf = (ReportFilter) en.nextElement();
			eni = rf.getRequestParam().elements();
			// clear old values
			rf.clearValues();
			i = 0;
			while(eni.hasMoreElements()){
				tip = (String) eni.nextElement();
				val = request.getParameter(tip);
				if (val!=null){
					rf.setValueAt(val,i);
				}
				//System.out.println(tip+"="+val);
				i++;
			}
			rf.validate();
			rf.mapAlias(queryFactory.getSelectForPage(subPage));
			//System.out.println("rf alias="+rf.getAlias()+" halfValid?"+rf.isHalfValid()+" fullValid? "+rf.isFullValid());
			if (rf.isHalfValid()){
				// setting attribute info
				//System.out.println("rf class="+rf.getRequestClass());
				vett = (Vector) attributesHash.get(rf.getRequestClass());
				rf.setAttributeVector(vett);
				rf.setLookupVector(lookupVector);
				eni = vett.elements();
				while (eni.hasMoreElements()){
					ab = (AttributeBean) eni.nextElement();
					//System.out.println("rf attribute="+rf.getRequestAttribute()+"=?"+ab.getName()+"?");
					if (ab.getName().equals(rf.getRequestAttribute())){
						//System.out.println("rf attribute="+rf.getRequestAttribute()+"=?"+ab.getName()+" setted");
						rf.setAttributeBean(ab);
						break;
					}
				}		
			}
		}
		// creating a new filter
		MultiLanguage multilanguage = ((CreateReportForm)form).getRep().getMultilanguage();
		Hashtable chash = ((CreateReportForm)form).getRep().getClassHash();
		Vector cl = new Vector();
		Vector svett = (Vector) ((CreateReportForm)form).getRep().getQueryFactory().getInvolvedClassesForPage(subPage);
		Vector svett2 = (Vector) svett.clone();
		String target = "";
		en = svett2.elements();
		// skip first class if subPage!=0
		if (subPage!=0 && en.hasMoreElements()){
			en.nextElement();
			//System.out.println("skipping first element of cl");
		}
		while (en.hasMoreElements()){
			target = (String) en.nextElement();
			cl.add(chash.get(target));
		}
		int count = ((CreateReportForm)form).getRep().getQueryFactory().getFiltersForPage(subPage).size();
		rf = new ReportFilter(multilanguage,cl,count);
		rf.setSubPage(subPage);
		//System.out.println("**ADDFILTER** adding filter for subPage="+subPage);
		((CreateReportForm)form).getRep().getQueryFactory().addFilterForPage(rf,subPage);
		// before refresh save select values
		ClassBean cb = null;
		String[] alres;
		Vector vett2 = null;
		AttributeBean ab2 = null;
		en = queryFactory.getSelectForPage(subPage).elements();
		//System.out.println("saving select values, selects are "+queryFactory.getSelectForPage(subPage).size());
		while (en.hasMoreElements()){
			cb = (ClassBean) en.nextElement();
			tip = (String) queryFactory.getTitle(subPage);
			alres = (String[]) request.getParameterValues(cb.getComment());
			if (alres!=null){
				//System.out.println("alres.length="+alres.length);
			}
			if (alres!=null){
				vett = new Vector();
				for (int ii =0;ii<alres.length;ii++){
					vett.add(alres[ii]);
				}
				HashSet hs = new HashSet(vett);
				//System.out.println("hs.size= "+hs.size()+"== vett.size="+vett.size());
				Vector va = (Vector) attributesHash.get(cb.getName());
				//System.out.println("attributes of "+cb.getName()+" are="+va.size());
				eni = va.elements();
				vett2 = new Vector();
				while (eni.hasMoreElements()){
					ab = (AttributeBean) eni.nextElement();
					ab2 = AttributeBean.getCopyOf(ab);
					if (hs.contains(ab.getName())){
						ab2.setComment(tip); 
						// saving alias1, alias2 etc....
						//System.out.println("setting comment="+cb.getComment());
						ab2.getClassBean().setComment(cb.getComment());
						//System.out.println("adding "+ab2.getName()+" for "+ab2.getClassBean().getName());
						vett2.add(ab2);
					}
				}
				queryFactory.setAttributesToPrint(cb.getComment(),vett2,subPage);
			}
		}
		form.reset(mapping,request);
		return mapping.findForward("addfilter");
	}
	public ActionForward removefilter(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		System.out.println("**REMOVEFILTER**");
		// save information for filters
		ReportQueryFactory queryFactory = ((CreateReportForm)form).getRep().getQueryFactory();
		int subPage = ((CreateReportForm)form).getRep().getSubPage();
		Vector vett = queryFactory.getFiltersForPage(subPage);
		Hashtable attributesHash = ((CreateReportForm)form).getRep().getAttributesHash();
		Vector lookupVector = ((CreateReportForm)form).getRep().getLookupVector();
		ReportFilter rf = null;
		String val = "";
		String tip = "";
		AttributeBean ab = null;
		Enumeration en = vett.elements();
		Enumeration eni = null;
		int i = 0;
		while (en.hasMoreElements()){
			rf = (ReportFilter) en.nextElement();
			eni = rf.getRequestParam().elements();
			// clear old values
			rf.clearValues();
			i = 0;
			while(eni.hasMoreElements()){
				tip = (String) eni.nextElement();
				val = request.getParameter(tip);
				if (val!=null){
					rf.setValueAt(val,i);
				}
				//System.out.println(tip+"="+val);
				i++;
			}
			rf.validate();
			rf.mapAlias(queryFactory.getSelectForPage(subPage));
			//System.out.println("rf alias="+rf.getAlias()+" halfValid?"+rf.isHalfValid()+" fullValid? "+rf.isFullValid());
			if (rf.isHalfValid()){
				// setting attribute info
				//System.out.println("rf class="+rf.getRequestClass());
				vett = (Vector) attributesHash.get(rf.getRequestClass());
				rf.setAttributeVector(vett);
				rf.setLookupVector(lookupVector);
				eni = vett.elements();
				while (eni.hasMoreElements()){
					ab = (AttributeBean) eni.nextElement();
					//System.out.println("rf attribute="+rf.getRequestAttribute()+"=?"+ab.getName()+"?");
					if (ab.getName().equals(rf.getRequestAttribute())){
						//System.out.println("rf attribute="+rf.getRequestAttribute()+"=?"+ab.getName()+" setted");
						rf.setAttributeBean(ab);
						break;
					}
				}		
			}
		}
		// removing the target filter
		String mpath = request.getParameter("mpath");
		int target = Integer.parseInt(mpath);
		((CreateReportForm)form).getRep().getQueryFactory().removeFilterAtPage(subPage,target);
		// before refresh save select values
		ClassBean cb = null;
		String[] alres;
		Vector vett2 = null;
		AttributeBean ab2 = null;
		en = queryFactory.getSelectForPage(subPage).elements();
		//System.out.println("saving select values, selects are "+queryFactory.getSelectForPage(subPage).size());
		while (en.hasMoreElements()){
			cb = (ClassBean) en.nextElement();
			tip = (String) queryFactory.getTitle(subPage);
			alres = (String[]) request.getParameterValues(cb.getComment());
			if (alres!=null){
				//System.out.println("alres.length="+alres.length);
			}
			if (alres!=null){
				vett = new Vector();
				for (int ii =0;ii<alres.length;ii++){
					vett.add(alres[ii]);
				}
				HashSet hs = new HashSet(vett);
				//System.out.println("hs.size= "+hs.size()+"== vett.size="+vett.size());
				Vector va = (Vector) attributesHash.get(cb.getName());
				//System.out.println("attributes of "+cb.getName()+" are="+va.size());
				eni = va.elements();
				vett2 = new Vector();
				while (eni.hasMoreElements()){
					ab = (AttributeBean) eni.nextElement();
					ab2 = AttributeBean.getCopyOf(ab);
					if (hs.contains(ab.getName())){
						ab2.setComment(tip); 
						// saving alias1, alias2 etc....
						//System.out.println("setting comment="+cb.getComment());
						ab2.getClassBean().setComment(cb.getComment());
						//System.out.println("adding "+ab2.getName()+" for "+ab2.getClassBean().getName());
						vett2.add(ab2);
					}
				}
				queryFactory.setAttributesToPrint(cb.getComment(),vett2,subPage);
			}
		}
		form.reset(mapping,request);
		return mapping.findForward("removefilter");
	}
	
	public ActionForward up(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		System.out.println("**UP**");
		// getting preferences for orders
		// CH TA TF
		Vector vett = ((CreateReportForm)form).getRep().getQueryFactory().getOrders();
		AttributeBean ab = null;
		Enumeration en = vett.elements();
		String value = "";
		while (en.hasMoreElements()){
			ab = (AttributeBean) en.nextElement();
			// columnHeader
			value = request.getParameter(ab.getClassBean().getComment()+ab.getName()+"CH");
			if (value!=null){
				ab.setDefaultValue(value);
				//System.out.println("setting CH="+value);
			}
			// Text alignment
			value = request.getParameter(ab.getClassBean().getComment()+ab.getName()+"TA");
			if (value!=null){
				ab.setBaseDSP(value);
				//System.out.println("setting TA="+value);
			}
			// Text format
			value = request.getParameter(ab.getClassBean().getComment()+ab.getName()+"TF");
			if (value!=null){
				ab.setMode(value);
				//System.out.println("setting TF="+value);
			}
		}
		// doing up
		String mpath = request.getParameter("mpath");
		int target = Integer.parseInt(mpath);
		//System.out.println("mpath="+mpath);
		((CreateReportForm)form).getRep().getQueryFactory().upOrderAt(target);
		form.reset(mapping,request);
		return mapping.findForward("up");
	}

	public ActionForward down(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		System.out.println("**DOWN**");
		// getting preferences for orders
		// CH TA TF
		Vector vett = ((CreateReportForm)form).getRep().getQueryFactory().getOrders();
		AttributeBean ab = null;
		Enumeration en = vett.elements();
		String value = "";
		while (en.hasMoreElements()){
			ab = (AttributeBean) en.nextElement();
			// columnHeader
			value = request.getParameter(ab.getClassBean().getComment()+ab.getName()+"CH");
			if (value!=null){
				ab.setDefaultValue(value);
				//System.out.println("setting CH="+value);
			}
			// Text alignment
			value = request.getParameter(ab.getClassBean().getComment()+ab.getName()+"TA");
			if (value!=null){
				ab.setBaseDSP(value);
				//System.out.println("setting TA="+value);
			}
			// Text format
			value = request.getParameter(ab.getClassBean().getComment()+ab.getName()+"TF");
			if (value!=null){
				ab.setMode(value);
				//System.out.println("setting TF="+value);
			}
		}
		// doing down
		String mpath = request.getParameter("mpath");
		int target = Integer.parseInt(mpath);
		//System.out.println("mpath="+mpath);
		((CreateReportForm)form).getRep().getQueryFactory().downOrderAt(target);
		form.reset(mapping,request);
		return mapping.findForward("down");
	}
	
	public ActionForward upper(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		System.out.println("**UPPER**");
		// getting preferences for orders
		// CH TA TF
		Vector vett = ((CreateReportForm)form).getRep().getQueryFactory().getOrders();
		AttributeBean ab = null;
		Enumeration en = vett.elements();
		String value = "";
		while (en.hasMoreElements()){
			ab = (AttributeBean) en.nextElement();
			// columnHeader
			value = request.getParameter(ab.getClassBean().getComment()+ab.getName()+"CH");
			if (value!=null){
				ab.setDefaultValue(value);
				//System.out.println("setting CH="+value);
			}
			// Text alignment
			value = request.getParameter(ab.getClassBean().getComment()+ab.getName()+"TA");
			if (value!=null){
				ab.setBaseDSP(value);
				//System.out.println("setting TA="+value);
			}
			// Text format
			value = request.getParameter(ab.getClassBean().getComment()+ab.getName()+"TF");
			if (value!=null){
				ab.setMode(value);
				//System.out.println("setting TF="+value);
			}
		}
		// doing up
		String mpath = request.getParameter("mpath");
		int target = Integer.parseInt(mpath);
		//System.out.println("mpath="+mpath);
		((CreateReportForm)form).getRep().getQueryFactory().upperOrderAt(target);
		form.reset(mapping,request);
		return mapping.findForward("upper");
	}

	public ActionForward lower(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		System.out.println("**LOWER**");
		// getting preferences for orders
		// CH TA TF
		Vector vett = ((CreateReportForm)form).getRep().getQueryFactory().getOrders();
		AttributeBean ab = null;
		Enumeration en = vett.elements();
		String value = "";
		while (en.hasMoreElements()){
			ab = (AttributeBean) en.nextElement();
			// columnHeader
			value = request.getParameter(ab.getClassBean().getComment()+ab.getName()+"CH");
			if (value!=null){
				ab.setDefaultValue(value);
				//System.out.println("setting CH="+value);
			}
			// Text alignment
			value = request.getParameter(ab.getClassBean().getComment()+ab.getName()+"TA");
			if (value!=null){
				ab.setBaseDSP(value);
				//System.out.println("setting TA="+value);
			}
			// Text format
			value = request.getParameter(ab.getClassBean().getComment()+ab.getName()+"TF");
			if (value!=null){
				ab.setMode(value);
				//System.out.println("setting TF="+value);
			}
		}
		// doing down
		String mpath = request.getParameter("mpath");
		int target = Integer.parseInt(mpath);
		//System.out.println("mpath="+mpath);
		((CreateReportForm)form).getRep().getQueryFactory().lowerOrderAt(target);
		form.reset(mapping,request);
		return mapping.findForward("lower");
	}
	
} // end class
