
package cmdbuild.actions;

import java.sql.SQLException;

import cmdbuild.action_forms.DomainForm;
import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBmap;
import cmdbuild.collection.DomainBean;
import cmdbuild.collection.ErrorBean;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.actions.DispatchAction;

public class DomainAction extends DispatchAction {

	public ActionForward del(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		String target = ((DomainForm)form).getTarget(); // hidden tags
		String classname = ((DomainForm)form).getName(); //domains associated with  
        DBService db = (DBService)servlet.getServletContext().getAttribute("db");
        CMDBmap MAP = new CMDBmap(db);
        ErrorBean err = null;
		DomainBean bean = null;
		try {
			bean = MAP.selectDomainByName(target) ;		       
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			err = new ErrorBean("domain.jsp",e);
		}
		boolean empty = false;
		try {
			empty = MAP.isEmpy(target) ;		       
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			err = new ErrorBean("domain.jsp",e);
		}
		System.out.println("trying deletion");
		if (empty){
			try {
				MAP.deleteDomain(target);
			} catch (SQLException e){
				err = new ErrorBean("domain.jsp",e);
			}
		} else {
			try {
				if (bean.getStatus().equals("active")){ // changing status
					bean.setStatus("noactive");
				} else {
					bean.setStatus("active");
				}
				MAP.modifyDomain(target,bean);
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				err = new ErrorBean("domain.jsp",e);
			}
		}
		if (err==null){
			// to refresh page
			try {
				((DomainForm)form).setDomainBeanVector( MAP.selectDomainByClass(classname) );
			} catch (SQLException e){
				err = new ErrorBean("domain.jsp",e);
			}
			((DomainForm)form).reset(mapping,request);
			return mapping.findForward("del");
		} else {
			request.getSession().setAttribute("error",err);
			return mapping.findForward("error");
		}
	}
	
	public ActionForward filter(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		// refreshing page
		String superClassFilter = ""; 
		if (request.getParameter("superClassDomain")!=null){
			superClassFilter = request.getParameter("superClassDomain");
		}
		//System.out.println("in FILTER superClassFilter="+superClassFilter+" dom="+request.getParameter("superClassDomain")+" for scf"+((DomainForm)form).getSuperClassFilter());
		if (superClassFilter.equals("on")){
			request.getSession().setAttribute("superClassDomain","on");
		} else {
			request.getSession().setAttribute("superClassDomain","");
		}
		// refreshing page
		((DomainForm)form).reset(mapping,request);
		return mapping.findForward("filter");
	}

} // end of class
