package cmdbuild.actions;

import java.sql.SQLException;
import java.util.Enumeration;
import java.util.Vector;

import cmdbuild.action_forms.GroupForm;
import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBgroup;
import cmdbuild.collection.ErrorBean;
import cmdbuild.collection.SecurityBean;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.actions.DispatchAction;

public class GroupAction extends DispatchAction {

	
	public ActionForward del(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
        DBService db = (DBService)servlet.getServletContext().getAttribute("db");
        String target = ((GroupForm)form).getTarget();
        int targetId = Integer.parseInt(target);
        Vector policyVector = ((GroupForm)form).getPolicyVector();
        System.out.println("targetId="+targetId);
        SecurityBean sb = null; 
        SecurityBean delsb = null;
       	int i = 0;
       	Enumeration en = policyVector.elements();
       	while(en.hasMoreElements()){
       		sb = (SecurityBean)en.nextElement();
       		if (sb.getClassId()==targetId){
       			delsb = sb;
       			policyVector.removeElementAt(i);
       			break;
       		}
       		i++;
        }
       	ErrorBean err = null;
        System.out.println("targetId="+targetId);
        System.out.println("delsb.classId="+delsb.getClassId());
        System.out.println("trying deletion");
        CMDBgroup GROUP = new CMDBgroup(db);
		try {
			GROUP.removePolicy(delsb);
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			err = new ErrorBean("group.jsp",e);
		}
		if (err==null){
			// to refresh page
			((GroupForm)form).reset(mapping,request);
			return mapping.findForward("del");

		} else {
			request.getSession().setAttribute("error",err);
			return mapping.findForward("error");
		}
	}

	public ActionForward modify(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
        DBService db = (DBService)servlet.getServletContext().getAttribute("db");
        CMDBgroup GROUP = new CMDBgroup(db);
        String group = ((GroupForm)form).getGroup();
        Vector policyVector = ((GroupForm)form).getPolicyVector();
        String us = ((GroupForm)form).getUser().getUserName();
        SecurityBean sb = null;
        ErrorBean err = null;
        try{
        	policyVector = GROUP.selectGroupByName(group);
        } catch (SQLException e){
        	err = new ErrorBean("group.jsp",e);
        }
       	Enumeration en = policyVector.elements();
  		System.out.println("policyVector.size="+policyVector.size());
   		while (en.hasMoreElements()){
       		sb = (SecurityBean)en.nextElement();
       		System.out.println("className="+sb.getClassName()+" value="+request.getParameter(sb.getClassName()));
       		if (request.getParameter(sb.getClassName())!=null){
       			sb.setMode(request.getParameter(sb.getClassName()));
       		} else { // patch
       			sb.setMode("r");
       		}
   		}
        try {
        	GROUP.modifyPolicy(policyVector,us);
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		if (err==null){
			// to refresh page
			((GroupForm)form).reset(mapping,request);
			return mapping.findForward("modify");
		} else {
			request.getSession().setAttribute("error",err);
			return mapping.findForward("error");
		}
	}
	
	public ActionForward search(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		String search = ((GroupForm)form).getSearch();
		System.out.println("Stringa search ="+search);
		((GroupForm)form).setGroup(search);
		request.getSession().setAttribute("group",search);
		// refreshing page
		((GroupForm)form).reset(mapping, request);
		return mapping.findForward("search");
	}

} // end of class
