package cmdbuild.actions;

import java.sql.SQLException;
import java.util.Collection;
import java.util.HashSet;
import java.util.Hashtable;
import java.util.Iterator;

import cmdbuild.action_forms.ModifyAttributeForm;
import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBclass;
import cmdbuild.collection.AttributeBean;
import cmdbuild.collection.DomainBean;
import cmdbuild.collection.ErrorBean;
import cmdbuild.collection.LookupBean;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

public class ModifyAttributeAction extends DispatchActionTemplate {

	public ActionForward modify(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		AttributeBean ab = new AttributeBean();
		ModifyAttributeForm f = ((ModifyAttributeForm)form);
		String tabname = (String) request.getSession().getAttribute("class");
		String mode = f.getAMode();
		boolean ok = false;
		ErrorBean err = null;
		DBService db = (DBService)servlet.getServletContext().getAttribute("db");
		CMDBclass CMDB = new CMDBclass(db);
		if (mode!=null && mode.equals("write")){ // write mode
			String newname = f.getAName();
			String oldname = f.getName(); // oldname
			ab.setName(oldname);
			ab.setIndex(f.getAIndex());
			String description = f.getADescription();
			ab.setDescription(description);
			int type = f.getAType();
			String SQLtype="";
			String extraInput="";
			if (type==AttributeBean.DECIMAL){
				extraInput = f.getExtraInput();
				extraInput = extraInput.replace('.',',');
				SQLtype = ab.javaToDb(AttributeBean.DECIMAL)+"("+extraInput+")";
				ab.setSQLType(SQLtype);
			} else if (type==AttributeBean.STRING) {
				extraInput = f.getExtraInput();
				SQLtype = ab.javaToDb(AttributeBean.STRING)+"("+extraInput+")";
				ab.setSQLType(SQLtype);
			} else if (type==AttributeBean.LOOKUP){
				ab.setSQLType(ab.javaToDb(AttributeBean.LOOKUP)); // defined in database table LookUp
				ab.setLookup(f.getALookup());
			} else if (type==AttributeBean.REFERENCE){
				ab.setSQLType(ab.javaToDb(AttributeBean.REFERENCE)); // defined in database table LookUp
				ab.setReferenceDomain(f.getAReferenceDomain());
				ab.setReferenceType(f.getAReferenceType());
				Collection domainCollection = f.getDomainCollection();
				Iterator it = domainCollection.iterator();
				DomainBean dm = null;
				while (it.hasNext()){
					dm = (DomainBean) it.next();
					if (dm.getName().equals(ab.getReferenceDomain())){
						break;
					}
				}
				HashSet family = (HashSet) request.getSession().getAttribute("family");
				if (family.contains(dm.getStartClass())){
					ab.setReference(dm.getEndClass());
				} else {
					ab.setReference(dm.getStartClass());
				}
			} else if (type==AttributeBean.DATE){
				extraInput = request.getParameter("ADateExpire");
				DEBUG.println("dateexpire="+extraInput);
				if (extraInput!=null && extraInput.equals("on")){
					ab.setDateExpire(true);
				}
				SQLtype=ab.javaToDb(type);
				ab.setSQLType(SQLtype);
			} else { // for the othes aType
				SQLtype=ab.javaToDb(type);
				ab.setSQLType(SQLtype);
			}
			String mandatory="";
			mandatory = f.getAMandatory();
			ab.setMandatory(mandatory);
			String defaultValue = null;
			// get default
			defaultValue = f.getADefault();
			if (type==AttributeBean.LOOKUP){
				String def = request.getParameter("ADefault");
				DEBUG.println("def="+def);
				ab.setDefaultValue("");
				if (def!=null && def.length()>0){
					int adl;
					try {
						adl = Integer.parseInt(def);
						ab.setDefaultValue(adl+"");
					} catch (NumberFormatException e) {
						e.printStackTrace();
					}
				}
			} else if (type==AttributeBean.REFERENCE){
				ab.setDefaultValue("");
			} else {
				ab.setDefaultValue(defaultValue);
			}
			String basedsp = f.getBaseDSP();
			String base;
			if (basedsp!=null && basedsp.equals("on")){
				base = "true";
			} else {
				base = "false";
			}
			ab.setBaseDSP(base);
			String status = f.getAStatus();
			ab.setStatus(status);
			try { // try
				ok = CMDB.modifyAttribute(tabname,newname,ab);
			} catch (SQLException e){
				ok = false;
				err = new ErrorBean("modifyattribute.jsp",e);
			}
		} else { // read mode
			String comment = ((ModifyAttributeForm)form).getAComment(); 
			String aName = ((ModifyAttributeForm)form).getName(); 
			String description = ((ModifyAttributeForm)form).getADescription();
			String basedsp = ((ModifyAttributeForm)form).getBaseDSP();
			if (basedsp!=null && basedsp.equals("on")){
				basedsp = "true";
			} else {
				basedsp = "false";
			}
			ab = new AttributeBean();
			String st = "";
			//EXECUTE 'COMMENT ON COLUMN \"'|| ClassName ||'\".\"'|| AttributeName || '\" IS ' || '\'MODE: write|DESCR: ' || AttributeDesc || '|INDEX: ' || AttributeIndex || '|LOOKUP: ' || AttributeLookUp || '|REFERENCEDOM: '|| AttributeReferenceDom || '|REFERENCETYPE: ' || AttributeReferenceType || '|REFERENCEDIECT: ' || AttributeReferenceDirect || '|DATEEXPIRE: ' || AttributeDateExpire || '|BASEDSP: '|| AttributeBaseDSP || '|STATUS: ' || AttributeStatus || '\'';
			if (comment.indexOf("MODE:")!=-1){
				st = comment.substring(comment.indexOf("MODE:"));
				if (st.indexOf("|")!=-1){
					st = st.substring(5,st.indexOf("|"));
				} else {
					st = st.substring(5,st.length());
				}
				st = st.trim();
				ab.setMode(st);
			} else {
				ab.setMode("");
			}
			ab.setDescription(description);
			if (comment.indexOf("INDEX:")!=-1){
				st = comment.substring(comment.indexOf("INDEX:"));
				if (st.indexOf("|")!=-1){
					st = st.substring(6,st.indexOf("|"));
				} else {
					st = st.substring(6,st.length());
				}
				st = st.trim();
				try {
					ab.setIndex(Integer.parseInt(st));
				} catch (NumberFormatException e) {
					ab.setIndex(0);
				}
			} else {
				ab.setIndex(0);
			}
			if (comment.indexOf("LOOKUP:")!=-1){
				st = comment.substring(comment.indexOf("LOOKUP:"));
				if (st.indexOf("|")!=-1){
					st = st.substring(7,st.indexOf("|"));
				} else {
					st = st.substring(7,st.length());
				}
				st = st.trim();
				ab.setLookup(st);
			} else {
				ab.setLookup("");
			}
			if (comment.indexOf("REFERENCEDOM:")!=-1){
				st = comment.substring(comment.indexOf("REFERENCEDOM:"));
				if (st.indexOf("|")!=-1){
					st = st.substring(13,st.indexOf("|"));
				} else {
					st = st.substring(13,st.length());
				}
				st = st.trim();
				ab.setReferenceDomain(st);
			} else {
				ab.setReferenceDomain("");
			}
			if (comment.indexOf("REFERENCETYPE:")!=-1){
				st = comment.substring(comment.indexOf("REFERENCETYPE:"));
				if (st.indexOf("|")!=-1){
					st = st.substring(14,st.indexOf("|"));
				} else {
					st = st.substring(14,st.length());
				}
				st = st.trim();
				ab.setReferenceType(st);
			} else {
				ab.setReferenceType("");
			}
			if (comment.indexOf("REFERENCEDIRECT:")!=-1){
				st = comment.substring(comment.indexOf("REFERENCEDIRECT:"));
				if (st.indexOf("|")!=-1){
					st = st.substring(16,st.indexOf("|"));
				} else {
					st = st.substring(16,st.length());
				}
				st = st.trim();
				if (st.length()>0 && st.equals("true")){
					ab.setReferenceDirect(true);	
				} else {
					ab.setReferenceDirect(true);
				}
			} else {
				ab.setReferenceDirect(false);
			}
			if (comment.indexOf("DATEEXPIRE:")!=-1){
				st = comment.substring(comment.indexOf("DATEEXPIRE:"));
				if (st.indexOf("|")!=-1){
					st = st.substring(11,st.indexOf("|"));
				} else {
					st = st.substring(11,st.length());
				}
				st = st.trim();
				if (st.length()>0 && st.equals("true")){
					ab.setDateExpire(true);	
				} else {
					ab.setDateExpire(false);
				}
			} else {
				ab.setDateExpire(false);
			}
			ab.setBaseDSP(basedsp);
			if (comment.indexOf("STATUS:")!=-1){
				st = comment.substring(comment.indexOf("STATUS:"));
				if (st.indexOf("|")!=-1){
					st = st.substring(7,st.indexOf("|"));
				} else {
					st = st.substring(7,st.length());
				}
				st = st.trim();
				ab.setStatus(st);
			} else {
				ab.setStatus("active");
			}
			try {
				ok = CMDB.modifyAttributeComment(tabname,aName,ab);
			} catch (SQLException e){
				ok = false;
				err = new ErrorBean("modifyattribute.jsp",e);
			}
		}
		DEBUG.println("ok="+ok);
		if (ok){
			DEBUG.println("Tabella modificata");
			String close="ok";
			request.getSession().setAttribute("close",close);
			return mapping.findForward("modify");
		} else {
			DEBUG.println("Tabella non modificata " + tabname);
			request.getSession().setAttribute("error",err);
			return mapping.findForward("error");
		}
	} // end action
	
	
	public ActionForward addType(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		DEBUG.println("**ADDTYPE**");
		ModifyAttributeForm f = ((ModifyAttributeForm)form);
		int type = f.getAType();
		LookupBean lb = null;
		Hashtable lookupHash = (Hashtable) request.getSession().getAttribute("lookupHash");
		if (type==AttributeBean.LOOKUP){ // getting default for this type
			if (f.getALookup()!=null && f.getALookup().length()>0){
				lb = (LookupBean) lookupHash.get(f.getALookup());
				if (lb!=null){
					DEBUG.println("setting lookup default");
					f.setADefault(lb.getDescription());
					f.setADefaultLookup(lb.getId());
				}
			}
		}	
		return mapping.findForward("addType");
	}
	
	public ActionForward loadDefaultLookup(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		DEBUG.println("**loadDefaultLookup**");
		ModifyAttributeForm f = ((ModifyAttributeForm)form);
		int type = f.getAType();
		LookupBean lb = null;
		Hashtable lookupHash = (Hashtable) request.getSession().getAttribute("lookupHash");
		if (type==AttributeBean.LOOKUP){ // getting default for this type
			if (f.getALookup()!=null && f.getALookup().length()>0){
				lb = (LookupBean) lookupHash.get(f.getALookup());
				if (lb!=null){
					f.setADefault(lb.getDescription());
					f.setADefaultLookup(lb.getId());
				}
			}
		}	
		//request.getSession().setAttribute("class",classname); // lo salvo nella sessione
		return mapping.findForward("loadDefaultLookup");
	} // end action
	
	/*
	public ActionForward addType(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		String classname = ((ModifyAttributeForm)form).getClassName();
		int type = ((ModifyAttributeForm)form).getAType();
		DEBUG.println("**MODIFYATTRIBUTEFORM ADDTYPE**");
		DBService db = (DBService)servlet.getServletContext().getAttribute("db");
		CMDBlookup LOOKUP = new CMDBlookup(db);
		if (type==AttributeBean.LOOKUP){ // getting default fro this type
			String lookup = ((ModifyAttributeForm)form).getALookup();
			LookupBean lb = null;
			Vector lookupVector = null;
			if (lookup!=null){
				try {
					lookupVector = LOOKUP.selectLookupByType(lookup);
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			if (lookupVector!= null && lookupVector.size()>0){
				lb = (LookupBean)lookupVector.elementAt(0);
				((ModifyAttributeForm)form).setADefault(lb.getDescription());
				((ModifyAttributeForm)form).setADefaultLookup(lb.getId());
				Enumeration en = lookupVector.elements();
				while(en.hasMoreElements()){
					lb = (LookupBean)en.nextElement();
					if (lb.isDefaultValue()){
						((ModifyAttributeForm)form).setADefault(lb.getDescription());
						((ModifyAttributeForm)form).setADefaultLookup(lb.getId());
						break;
					}
				}
			}
		}
		request.getSession().setAttribute("class",classname); // lo salvo nella sessione
		return mapping.findForward("addType");
	}
	
	public ActionForward addDefault(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		String classname = ((ModifyAttributeForm)form).getClassName();
		int type = ((ModifyAttributeForm)form).getAType();
		DEBUG.println("**MODIFYATTRIBUTEFORM ADDDEFAULT**");
		DBService db = (DBService)servlet.getServletContext().getAttribute("db");
		CMDBlookup LOOKUP = new CMDBlookup(db);
		if (type==AttributeBean.LOOKUP){ // getting default fro this type
			String lookup = ((ModifyAttributeForm)form).getALookup();
			LookupBean lb = null;
			Vector lookupVector = null;
			if (lookup!=null){
				try {
					lookupVector = LOOKUP.selectLookupByType(lookup);
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			if (lookupVector!= null){
				lb = (LookupBean)lookupVector.elementAt(0);
				((ModifyAttributeForm)form).setADefault(lb.getDescription());
				((ModifyAttributeForm)form).setADefaultLookup(lb.getId());
				Enumeration en = lookupVector.elements();
				while(en.hasMoreElements()){
					lb = (LookupBean)en.nextElement();
					if (lb.isDefaultValue()){
						((ModifyAttributeForm)form).setADefault(lb.getDescription());
						((ModifyAttributeForm)form).setADefaultLookup(lb.getId());
						break;
					}
				}
			}
		}
		request.getSession().setAttribute("class",classname); // lo salvo nella sessione
		return mapping.findForward("addDefault");
	}
	public ActionForward loadDefaultLookup(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		String classname = ((ModifyAttributeForm)form).getClassName();
		int type = ((ModifyAttributeForm)form).getAType();
		DEBUG.println("**MODIFYATTRIBUTEFORM LOADDEFAULTLOOKUP**");
		DBService db = (DBService)servlet.getServletContext().getAttribute("db");
		CMDBlookup LOOKUP = new CMDBlookup(db);
		if (type==AttributeBean.LOOKUP){ // getting default fro this type
			String lookup = ((ModifyAttributeForm)form).getALookup();
			LookupBean lb = null;
			Vector lookupVector = null;
			if (lookup!=null){
				try {
					lookupVector = LOOKUP.selectLookupByType(lookup);
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			if (lookupVector!= null){
				lb = (LookupBean)lookupVector.elementAt(0);
				((ModifyAttributeForm)form).setADefault(lb.getDescription());
				((ModifyAttributeForm)form).setADefaultLookup(lb.getId());
				Enumeration en = lookupVector.elements();
				while(en.hasMoreElements()){
					lb = (LookupBean)en.nextElement();
					if (lb.isDefaultValue()){
						((ModifyAttributeForm)form).setADefault(lb.getDescription());
						((ModifyAttributeForm)form).setADefaultLookup(lb.getId());
						break;
					}
				}
			}
		}
		request.getSession().setAttribute("class",classname); // lo salvo nella sessione
		return mapping.findForward("addDefault");
	}
	*/

} // end of class
