package cmdbuild.actions;


import java.sql.SQLException;

import cmdbuild.action_forms.ModifyDomainForm;
import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBclass;
import cmdbuild.elements.CMDBmap;
import cmdbuild.collection.AttributeBean;
import cmdbuild.collection.DomainBean;
import cmdbuild.collection.ErrorBean;

import java.util.Enumeration;
import java.util.Vector;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

public class ModifyDomainAction extends DispatchActionTemplate {

	public ActionForward modify(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		DEBUG.println("**MODIFY**");
		ModifyDomainForm f = ((ModifyDomainForm)form);
		//String newname = ((ModifyDomainForm)form).getName(); // newname
		DEBUG.println("oldname="+f.getDomain()+" newname="+f.getName());
		DomainBean bean = new DomainBean();
		bean.setName(f.getDomain()); // oldname
		bean.setDirectDescription(f.getDirectDescription());
		bean.setInverseDescription(f.getInverseDescription());
		bean.setStartClass(f.getStartClass());
		bean.setEndClass(f.getEndClass());
		bean.setCardinality(f.getCard1()+":"+f.getCard2());
		if (request.getParameter("masterDetail")!=null && request.getParameter("masterDetail").equals("on")){
			bean.setMasterDetail(true);
		} else {
			bean.setMasterDetail(false);
		}
		bean.setStatus(f.getStatus());
		// String category = ((CreateTableForm)form).getCategory();
		DBService db = (DBService)servlet.getServletContext().getAttribute("db");
		CMDBmap MAP = new CMDBmap(db);
		CMDBclass CMDB = new CMDBclass(db);
		ErrorBean err = null;
		AttributeBean ab = null;
		boolean ok = false;
		try {
			ok = MAP.modifyDomain(f.getName(),bean);
			// if name change, the update involved classes
			if (!f.getBean().equals(f.getDomain())){
				Vector targets = MAP.selectDomainInvolvedReferences(f.getDomain());
				Enumeration en = targets.elements();
				while (en.hasMoreElements()){
					ab = (AttributeBean) en.nextElement();
					CMDB.modifyAttributeComment(ab.getClassBean().getName(),ab.getName(),ab);
				}
			}
		} catch (SQLException e) {
			err=new ErrorBean("modifydomain.jsp",e);
			e.printStackTrace();
		} 
		if (ok && err==null){
			DEBUG.println("Dominio modificato " + f.getName());
			request.getSession().setAttribute("close","ok");
			return mapping.findForward("modify");
		} else {
			DEBUG.println("Dominio non modificato");
			request.getSession().setAttribute("error",err);
			return mapping.findForward("error");
		}
	}
} // end of class
