package cmdbuild.actions;

import java.sql.SQLException;
import java.util.*;

import cmdbuild.action_forms.RelationForm;
import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBclass;
import cmdbuild.elements.CMDBmap;
import cmdbuild.collection.FilterBean;
import cmdbuild.collection.IdBean;
import cmdbuild.utils.SecurityDescriptor;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.actions.DispatchAction;

public class RelationAction extends DispatchAction {

	/* (non-Javadoc)
	 * @see org.apache.struts.action.Action#execute(org.apache.struts.action.ActionMapping, org.apache.struts.action.ActionForm, javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */
	
	public ActionForward delete(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		System.out.println("**DELETE**");
		RelationForm myform = (RelationForm)form;
		int class1id = myform.getClassId();
		int obj1id = myform.getRowId();
		int class2id = Integer.parseInt(myform.getTargetClassId());
		int obj2id = Integer.parseInt(myform.getTargetObjId());
		String domainName = myform.getTargetDomain();
		int domainId = Integer.parseInt(myform.getTargetDomainId());
		boolean direct = Boolean.parseBoolean(myform.getDirect());
		DBService db = (DBService)servlet.getServletContext().getAttribute("db");
		boolean ok = false;
		// getting user from session
		SecurityDescriptor user = null;
		String us = null;
		if (request.getSession().getAttribute("user")!=null){
			user = (SecurityDescriptor)request.getSession().getAttribute("user");
			us = user.getUserName();
		}
		CMDBmap MAP = new CMDBmap(db);
		try {
			System.out.println("direct="+direct);
			if (direct){
				ok = MAP.deleteRelation(domainName,domainId,direct,class1id,obj1id,class2id,obj2id,us);
			} else { // .equals(domain.getInverseDescription())
				ok = MAP.deleteRelation(domainName,domainId,direct,class1id,obj1id,class2id,obj2id,us);
			}
		} catch (SQLException e) {
			// 	TODO Auto-generated catch block
			e.printStackTrace();
		}	
		if (ok){
			// refreshing page
			myform.reset(mapping,request);
			return mapping.findForward("delete");
		} else {
			return mapping.findForward("error");
		}
	}

	public ActionForward gotopage(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		System.out.println("**GOTOPAGE**");
		String className = ((RelationForm)form).getTargetClass();
		int rowId = Integer.parseInt( ((RelationForm)form).getTargetObjId() );
		Vector rowIdVector = null;
		DBService db = (DBService)servlet.getServletContext().getAttribute("db");
		// *** managing filter ***
		String baseQuery = "";
		// replacing select parameters with "Id"
		baseQuery = "SELECT \"Id\" FROM \""+className+"\" WHERE \"Status\"='A'";
        Hashtable filter = null;
        FilterBean fb = null;
        CMDBclass CMDB = new CMDBclass(db);
        if (request.getSession().getAttribute("filter")!=null){
        	filter = (Hashtable)request.getSession().getAttribute("filter");
        	if (filter.containsKey(className)){
        		fb = (FilterBean)filter.get(className);
        		try {
            		rowIdVector = CMDB.selectCardsId(fb.getQuery());
        		} catch (SQLException e) {
        			e.printStackTrace();
        		}
        	} else {
        		try {
            		rowIdVector = CMDB.selectCardsId(baseQuery);
        		} catch (SQLException e) {
        			e.printStackTrace();
        		}
        	}
        } else {
    		try {
        		rowIdVector = CMDB.selectCardsId(baseQuery);
    		} catch (SQLException e) {
    			e.printStackTrace();
    		}
        }
		IdBean id = null;
		Enumeration eni = rowIdVector.elements();
		int page = 1;
		while (eni.hasMoreElements()){
			id = (IdBean)eni.nextElement();
			if (rowId==id.getId()){
				break;
			}
			page++;
		}
		request.getSession().setAttribute("class",className);
		request.getSession().setAttribute("page",(page+""));
		return mapping.findForward("gotopage");
	}

	
} // end of class
