package cmdbuild.collection;

public class AssetBean extends AttributeBean {

	static final long serialVersionUID = 1L;
	private String value;
	private boolean toDelete;
	
	public AssetBean() {
		super();
		this.toDelete = false;
		this.value = "";
	}
	
	// generate AssetBean from AttributeBean
	public AssetBean(AttributeBean obj) {
		super();
	    ClassBean cb = obj.getClassBean();
	    this.setClassBean(ClassBean.getCopyOf(cb));
	    this.setName(obj.getName());
	    this.setSQLType(obj.getSQLType());
	    this.setType(obj.getType());
	    this.setLength(obj.getLength());
	    this.setMandatory(obj.getMandatory());
	    this.setDefaultValue(obj.getDefaultValue());
	    this.setMode(obj.getMode());
	    this.setDescription(obj.getDescription());
	    this.setLookup(obj.getLookup());
	    this.setReference(obj.getReference());
	    this.setReferenceDomain(obj.getReferenceDomain());
	    this.setReferenceType(obj.getReferenceType());
	    this.setDateExpire(obj.isDateExpire());
	    this.setStatus(obj.getStatus());
	    this.setComment(obj.getComment());
	    this.setIndex(obj.getIndex());
	    this.setDBIndex(obj.getDBIndex());
	    this.setBaseDSP(obj.getBaseDSP());
	    this.setExtraInput(obj.getExtraInput());
		this.toDelete = false;
		this.value = "";
	}

	
	/***********************/
	/* GETTERS AND SETTERS */
	/***********************/

	public String getValue() {
		if (value==null){
			value = "";
		}
		return value;
	}
	public void setValue(String value) {
		if (value!=null && this.getType()==AttributeBean.TIMESTAMP){
			if (value.indexOf(".")!=-1){ // if there is a "."
				// cutting
				this.value = value.substring(0,value.indexOf("."));
			} else {
				this.value = value;
			}
		} else {
			this.value = value;
		}
	}
	public boolean isToDelete() {
		return toDelete;
	}
	public void setToDelete(boolean toDelete) {
		this.toDelete = toDelete;
	}
	
} // end class
