package cmdbuild.collection;

import java.io.Serializable;

public class ClassBean implements Serializable{

	static final long serialVersionUID = 1L;
	private String name;
	private int id;
	private String description;
	private String mode;
	private String comment;
	private String category;
	private int idCategory;
	private String manager;
	private String status;
	private String parent;
	private boolean superClass = false;
	private boolean showMenu; // derived from master/detail domains

	public ClassBean() {
		super();
	}

	public ClassBean(String name, String description, int idCategory, String status) {
		super();
		this.name = name;
		this.description = description;
		this.idCategory = idCategory;
		this.status = status;
		this.superClass = false;
	}

	public ClassBean(String name, int id, String description, String status) {
		super();
		this.name = name;
		this.id = id;
		this.description = description;
		this.status = status;
		this.superClass = false;
	}

	public static ClassBean getCopyOf(ClassBean cb) {
		ClassBean copy = new ClassBean();
		copy.setName(cb.getName());
		copy.setId(cb.getId());
		copy.setDescription(cb.getDescription());
		copy.setMode(cb.getMode());
		copy.setComment(cb.getComment());
		copy.setCategory(cb.getCategory());
		copy.setIdCategory(cb.getIdCategory());
		copy.setManager(cb.getManager());
		copy.setStatus(cb.getStatus());
		copy.setParent(cb.getParent());
		copy.setSuperClass(cb.isSuperClass());
		copy.setShowMenu(cb.isShowMenu());
		return copy;
	}
	
	
	/***********************/
	/* GETTERS AND SETTERS */
	/***********************/

	public String getCategory() {
		return category;
	}
	public void setCategory(String category) {
		this.category = category;
	}
	public String getDescription() {
		return description;
	}
	public void setDescription(String description) {
		this.description = description;
	}
	public String getComment() {
		return comment;
	}
	public void setComment(String comment) {
		this.comment = comment;
	}
	public int getId() {
		return id;
	}
	public void setId(int id) {
		this.id = id;
	}
	public int getIdCategory() {
		return idCategory;
	}
	public void setIdCategory(int idCategory) {
		this.idCategory = idCategory;
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public String getStatus() {
		return status;
	}
	public void setStatus(String status) {
		this.status = status;
	}
	public String getManager() {
		return manager;
	}
	public void setManager(String manager) {
		this.manager = manager;
	}
	public String getMode() {
		return mode;
	}
	public void setMode(String mode) {
		this.mode = mode;
	}
	public String getParent() {
		return parent;
	}
	public void setParent(String parent) {
		this.parent = parent;
	}
	public boolean isSuperClass() {
		return superClass;
	}
	public void setSuperClass(boolean superClass) {
		this.superClass = superClass;
	}
	public boolean isShowMenu() {
		return showMenu;
	}
	public void setShowMenu(boolean showMenu) {
		this.showMenu = showMenu;
	}
	
} // end of class
