package cmdbuild.collection;

public class SecurityBean {

	private int id;
	private String description; // user info
	private String username; 
	private String password;
	private String group;
	private int groupId;
	private boolean administrator;
	private int classId;
	private String className;
	private String mode; // r=read/w=write/x=relation in database
	private int level; // 0=no permission 1=read 2=read/write 3=read/write/relations in application
	private String status; // User status, used by createUser/modifyUser
	
	
	public SecurityBean() {
		super();
		// TODO Auto-generated constructor stub
	}
	
	public SecurityBean(int classId, String className, int level) {
		super();
		// TODO Auto-generated constructor stub
		this.classId = classId;
		this.className = className;
		this.level = level;
	}

	
	/***********************/
	/* GETTERS AND SETTERS */
	/***********************/

	public String getClassName() {
		return className;
	}
	public void setClassName(String className) {
		this.className = className;
	}
	public int getClassId() {
		return classId;
	}
	public void setClassId(int classId) {
		this.classId = classId;
	}
	public int getLevel() {
		return level;
	}
	public void setLevel(int level) {
		this.level = level;
	}
	public String getMode() {
		return mode;
	}
	public void setMode(String mode) {
		this.mode = mode;
		if (mode==null || mode.length()==0){
			this.level=0;
		} else if (mode.equals("r")){
			this.level=1;
		} else if (mode.equals("w")){
			this.level=2;
		} else if (mode.equals("x")){
			this.level=3;
		}
	}
	public boolean isAdministrator() {
		return administrator;
	}
	public void setAdministrator(boolean administrator) {
		this.administrator = administrator;
	}
	public String getDescription() {
		return description;
	}
	public void setDescription(String description) {
		this.description = description;
	}
	public String getGroup() {
		return group;
	}
	public void setGroup(String group) {
		this.group = group;
	}
	public int getId() {
		return id;
	}
	public void setId(int id) {
		this.id = id;
	}
	public String getPassword() {
		return password;
	}
	public void setPassword(String password) {
		if (password!=null){
			this.password = password;
		} else {
			this.password = "";
		}
	}
	public String getUsername() {
		return username;
	}
	public void setUsername(String username) {
		this.username = username;
	}
	public String getStatus() {
		return status;
	}
	public void setStatus(String status) {
		if (status==null){
			this.status = "D";
		} else {
			this.status = status;
		}
	}
	public int getGroupId() {
		return groupId;
	}
	public void setGroupId(int groupId) {
		this.groupId = groupId;
	}
	
} // end of class
