package cmdbuild.elements;

import cmdbuild.collection.ClassBean;
import cmdbuild.db.DBService;

import java.sql.CallableStatement;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.sql.Types;


public class CMDBasset extends CMDBclass{
	
	String CREATE_CLASS = "{ ?= call createAsset(?,?,?,?,?,?,?) }"; // nome,descrizione,categoria,stato,parentclasse,superclass?,manager
	String MODIFY_CLASS = "{ ?= call modifyAsset(?,?,?,?,?,?,?) }";  // nome,nuovonome,descrizione,categoria,stato,superclass?,manager

	public CMDBasset() {
		super();
	}

	public CMDBasset(DBService db) {
		super(db);
	}
	
	// *********
	// **class**
	// *********
	public boolean createClass(ClassBean bean) throws SQLException {
		boolean ok = false;
		CallableStatement stm = null;
		System.out.println("createasset("+bean.getName()+","+bean.getDescription()+","+bean.getIdCategory()+","+bean.getStatus()+","+bean.getParent()+","+bean.isSuperClass()+","+bean.getManager()+")");
		Connection con = db.getConnection();
		try {
			stm = con.prepareCall(CREATE_CLASS);
			stm.registerOutParameter(1,Types.BOOLEAN);
			stm.setString(2,bean.getName());
			stm.setString(3,bean.getDescription());
			stm.setInt(4,bean.getIdCategory());
			stm.setString(5,bean.getStatus());
			stm.setString(6,bean.getParent());
			stm.setBoolean(7,bean.isSuperClass());
			stm.setString(8,bean.getManager());
			stm.execute();
			ok = true;
		} catch (SQLException ex) {
			throw ex;
		} finally {
			DBService.close(null, stm, con);
		}
		return ok;
	}
	public boolean modifyClass(String newname, ClassBean bean) throws SQLException {
		boolean ok = false;
		CallableStatement stm = null;
		System.out.println("modifyasset("+bean.getName()+","+newname+","+bean.getDescription()+","+bean.getIdCategory()+","+bean.getStatus()+","+bean.isSuperClass()+","+bean.getManager()+")");
		Connection con = db.getConnection();
		try {
			stm = con.prepareCall(MODIFY_CLASS);
			stm.registerOutParameter(1,Types.BOOLEAN);
			stm.setString(2,bean.getName());
			stm.setString(3,newname);
			stm.setString(4,bean.getDescription());
			stm.setInt(5,bean.getIdCategory());
			stm.setString(6,bean.getStatus());
			stm.setBoolean(7,bean.isSuperClass());
			stm.setString(8,bean.getManager());
			stm.execute();
			ok = true;
		} catch (SQLException ex) {
			throw ex;
		} finally {
			DBService.close(null, stm, con);
		}
		return ok;
	}
	// others 
	public boolean setCardNotes(String className, int Id, String notes, String user) throws SQLException {
		Statement stm = null;
		ResultSet rs = null;
		String query="";
		boolean result = false;
		if (user!=null){
			query = "UPDATE \""+className+"\" SET \"Notes\"='"+notes+"',\"User\"='"+user+"' WHERE \"Id\"="+Id;			
		} else {
			query = "UPDATE \""+className+"\" SET \"Notes\"='"+notes+"' WHERE \"Id\"="+Id;
		}
		System.out.println("Query SETCARDNOTES="+query);
		Connection con = db.getConnection();
		try {
			if ( con != null ) {
				stm = con.createStatement();
				stm.executeUpdate(query);
				result = true;
			}
		} catch( SQLException ex ) {
			throw ex;
		} finally {
			DBService.close(rs, stm, con);
		}
		return result;
	}
	public String getCardNotes(String className, int Id) throws SQLException {
		String notes="";
		PreparedStatement stm = null;
		ResultSet rs = null;
		String query = "SELECT \"Notes\" FROM \""+className+"\" WHERE \"Id\"='"+Id+"'";
		System.out.println("Query GETCARDNOTES="+query);
		Connection con = db.getConnection();
		try {
			if ( con != null ) {
				stm = con.prepareStatement(query);
				rs = stm.executeQuery();
				if ( rs.next() ) {
					notes = rs.getString(1);
				}
			}
		} catch( SQLException ex ) {
			throw ex;
		} finally {
			DBService.close(rs, stm, con);
		}
		if (notes==null){ // because null value is used when raises a SQL for classes without Notes 
			notes="";
		}
		return notes;
	}

} // end of class
