package cmdbuild.elements;

import cmdbuild.db.DBService;
import cmdbuild.collection.CategoryBean;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.LinkedList;
import java.util.List;
import java.util.Vector;

public class CMDBcategory {

	private DBService db;
	
	public CMDBcategory(DBService db) {
		super();
		// TODO Auto-generated constructor stub
		this.db = db;
	}

	// ************
	// **category**
	// ************
	public boolean createCategory(CategoryBean bean) throws SQLException {
		int r=0;
		boolean result;
		Statement stm = null;
		ResultSet rs = null;
		String query = "INSERT INTO \"Category\" (\"IdMacroCategory\",\"Number\",\"Description\",\"Status\") VALUES ("+bean.getMacroCategoryId()+","+bean.getNumber()+",'"+bean.getDescription()+"','"+bean.getStatus()+"')"; 
		//String query = "INSERT INTO \"LookUp\" (\"Type\",\"Number\",\"Description\",\"IsDefault\",\"Status\") VALUES ('"+bean.getLType()+"',"+bean.getLSequence()+",'"+bean.getLDescription()+"',"+bean.isLDefault()+",'"+bean.getLStatus()+"')";
		System.out.println("Query CREATECATEGORY="+query);
		Connection con = db.getConnection();		
		try {
			if ( con != null ) {
				stm = con.createStatement();
				r= stm.executeUpdate(query) ;
			}
		} catch( SQLException ex ) {
			throw ex;
		} finally {
			DBService.close(rs, stm, con);
		}
		if (r==1) {
			result = true;
		} else {
			result = false;
		}
		return result;
	}
	public boolean modifyCategory(CategoryBean bean) throws SQLException {
		int r=0;
		boolean result;
		Statement stm = null;
		ResultSet rs = null;
		String query = "UPDATE \"Category\" SET \"Number\"="+bean.getNumber()+" , \"Description\"='"+bean.getDescription()+"', \"Status\"='"+bean.getStatus()+"' WHERE \"Id\"="+bean.getId()+" ";
		System.out.println("Query MODIFYCATEGORY="+query);
		Connection con = db.getConnection();
		try {
			if ( con != null ) {
				stm = con.createStatement();
				r= stm.executeUpdate(query) ;
			}
		} catch( SQLException ex ) {
			throw ex;
		} finally {
			DBService.close(rs, stm, con);
		}
		if (r>0) {
			result = true;
		} else {
			result = false;
		}
		return result;
	}
	// ************
	// **category**
	// ************
	public List selectAllCategory() throws SQLException {
		List list = new LinkedList();
		ResultSet rs = null;
		PreparedStatement stm = null;
		String query = "SELECT \"Category\".\"Id\",\"Category\".\"IdMacroCategory\",\"MacroCategory\".\"Description\",\"Category\".\"Description\",\"Category\".\"Status\" FROM \"Category\",\"MacroCategory\" WHERE \"Category\".\"IdMacroCategory\"=\"MacroCategory\".\"Id\" ORDER BY \"MacroCategory\".\"Description\",\"Category\".\"Description\"; ";
		System.out.println("Query SELECTALLCATEGORY="+query);
		Connection con = db.getConnection();
		try {
			if ( con != null ) {
				stm = con.prepareStatement(query);
				rs = stm.executeQuery();
				CategoryBean categoryBean = null;
				while( rs.next() ) {
					categoryBean = setCategoryObject(rs);
					list.add(categoryBean);
				}
			}
		} catch( SQLException ex ) {
			throw ex;
		} finally {
			DBService.close(rs, stm, con);
		}
		return list;
	}
	public Vector selectCategoryByIdMacro(int idMacro) throws SQLException {
		Vector categoryVector = new Vector();
		ResultSet rs = null;
		PreparedStatement stm = null;
		String query = "SELECT \"Id\",\"IdMacroCategory\",\"Number\",\"Description\",\"Status\" FROM \"Category\" WHERE \"IdMacroCategory\"="+idMacro+" ORDER BY \"Category\".\"Description\"; ";
 		System.out.println("Query SELECTCATEGORYBYIDMACRO="+query);
 		CategoryBean bean = null;
 		Connection con = db.getConnection();
		try {
			if ( con != null ) {
				stm = con.prepareStatement(query);
				rs = stm.executeQuery();
				while( rs.next() ) {
					bean = new CategoryBean(rs.getInt(1),rs.getInt(2),rs.getInt(3),rs.getString(4),rs.getString(5));
					categoryVector.add(bean);
				}
			}
		} catch( SQLException ex ) {
			throw ex;
		} finally {
			DBService.close(rs, stm, con);
		}
		return categoryVector;
	}
	public CategoryBean selectCategoryByIds(int idMacro, int number) throws SQLException {
		ResultSet rs = null;
		PreparedStatement stm = null;
		String query = "SELECT \"Id\",\"IdMacroCategory\",\"Number\",\"Description\",\"Status\" FROM \"Category\" WHERE \"IdMacroCategory\"="+idMacro+" AND \"Number\"="+number+" ";
 		System.out.println("Query SELECTCATEGORYBYIDMACRO="+query);
 		CategoryBean bean = null;
 		Connection con = db.getConnection();
		try {
			if ( con != null ) {
				stm = con.prepareStatement(query);
				rs = stm.executeQuery();
				if( rs.next() ) {
					bean = new CategoryBean(rs.getInt(1),rs.getInt(2),rs.getInt(3),rs.getString(4),rs.getString(5));
				}
			}
		} catch( SQLException ex ) {
			throw ex;
		} finally {
			DBService.close(rs, stm, con);
		}
		return bean;
	}

	
	/**************************/
	/* USEFUL SETTING METHOTS */
	/**************************/
	
	private CategoryBean setCategoryObject(ResultSet rs) {
		CategoryBean categoryBean = new CategoryBean();		
		String cat="";
		try {
			categoryBean.setId( rs.getInt(1) ); 
			categoryBean.setMacroCategoryId( rs.getInt(2) );
			cat = rs.getString(3)+" - "+rs.getString(4);
			if (cat.length()>50) {
				cat = cat.substring(0,50);
				cat = cat+"...";
			}
			categoryBean.setDescription(cat);
			categoryBean.setStatus(rs.getString(5));
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return categoryBean;
	}

} // end of class
