package cmdbuild.elements;

import cmdbuild.db.DBService;
import cmdbuild.collection.LookupBean;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Enumeration;
import java.util.LinkedList;
import java.util.List;
import java.util.Vector;


public class CMDBlookup {
	
	private DBService db;
	
	private LookupBean bean;

	public CMDBlookup(DBService db) {
		super();
		// TODO Auto-generated constructor stub
		this.db = db;
	}

	// **********
	// **lookup**
	// **********
	public  boolean createLookup(LookupBean bean) throws SQLException {
		int r=0;
		boolean result;
		Statement stm = null;
		ResultSet rs = null;
		String query = "INSERT INTO \"LookUp\" (\"Type\",\"Number\",\"Description\",\"IsDefault\",\"Status\") VALUES ('"+bean.getType()+"',"+bean.getSequence()+",'"+bean.getDescription()+"',"+bean.isDefaultValue()+",'"+bean.getStatus()+"')";
		System.out.println("Query CREATELOOKUP="+query);
		Connection con = db.getConnection();
		try {
			if ( con != null ) {
				stm = con.createStatement();
				r= stm.executeUpdate(query) ;
			}
		} catch( SQLException ex ) {
			throw ex;
		} finally {
			DBService.close(rs, stm, con);
		}
		if (r==1) {
			result = true;
		} else {
			result = false;
		}
		return result;
	}
	public  boolean modifyLookup(int id, LookupBean bean) throws SQLException {
		int r=0;
		boolean result;
		Statement stm = null;
		ResultSet rs = null;
		String query = "UPDATE \"LookUp\" SET \"Type\"='"+bean.getType()+"', \"Number\"='"+bean.getSequence()+"', \"Description\"='"+bean.getDescription()+"', \"IsDefault\"='"+bean.isDefaultValue()+"', \"Status\"='"+bean.getStatus()+"' WHERE \"Id\"='"+id+"'";
		System.out.println("Query MODIFYLOOKUP="+query);
		Connection con = db.getConnection();
		try {
			if ( con != null ) {
				stm = con.createStatement();
				r= stm.executeUpdate(query) ;
			}
		} catch( SQLException ex ) {
			throw ex;
		} finally {
			DBService.close(rs, stm, con);
		}
		if (r>0) {
			result = true;
		} else {
			result = false;
		}
		return result;
	}
	// **********
	// **lookup**
	// **********
	public  Vector selectLookupByType(String type) throws SQLException {
		Vector lookupBeanVector = new Vector();
		ResultSet rs = null;
		PreparedStatement stm = null;
		LookupBean obj = null;
		String query = "SELECT \"Id\",\"Type\",\"Number\",\"Description\",\"IsDefault\",\"Status\" FROM \"LookUp\" WHERE \"LookUp\".\"Type\"='"+type+"' ORDER BY \"Type\",\"Description\";";
		System.out.println("Query SELECTLOOKUPBYTYPE="+query);
		Connection con = db.getConnection();
		try {
			if ( con != null ) {
				stm = con.prepareStatement(query);
				rs = stm.executeQuery();
				while ( rs.next() ) {
					obj = new LookupBean(rs.getInt(1),rs.getString(2),rs.getInt(3),rs.getString(4),rs.getBoolean(5),rs.getString(6));
					lookupBeanVector.add(obj);
				}
			}
		} catch( SQLException ex ) {
			throw ex;
		} finally {
			DBService.close(rs, stm, con);
		}
		return lookupBeanVector;
	}
	public  Vector selectAllLookup() throws SQLException {
		Vector lookupBeanVector = new Vector();
		ResultSet rs = null;
		PreparedStatement stm = null;
		LookupBean obj = null;
		String query = "SELECT \"Id\",\"Type\",\"Number\",\"Description\",\"IsDefault\",\"Status\" FROM \"LookUp\" ORDER BY \"Type\",\"Description\";";
		System.out.println("Query SELECTALLLOOKUP="+query);
		Connection con = db.getConnection();
		try {
			if ( con != null ) {
				stm = con.prepareStatement(query);
				rs = stm.executeQuery();
				while ( rs.next() ) {
					obj = new LookupBean(rs.getInt(1),rs.getString(2),rs.getInt(3),rs.getString(4),rs.getBoolean(5),rs.getString(6));
					lookupBeanVector.add(obj);
				}
			}
		} catch( SQLException ex ) {
			throw ex;
		} finally {
			DBService.close(rs, stm, con);
		}
		return lookupBeanVector;
	}
	public  Vector selectLookupByTypes(Vector typesVector) throws SQLException {
		Vector lookupBeanVector = new Vector();
		ResultSet rs = null;
		PreparedStatement stm = null;
		LookupBean obj = null;
		String types = "";
		if (typesVector.size()>0){
			Enumeration en = typesVector.elements();
			String str = "";
			while (en.hasMoreElements()){
				str = (String) en.nextElement();
				if (types.length()>0){
					types += " OR \"LookUp\".\"Type\"='"+str+"'";
				} else { // first time
					types = "\"LookUp\".\"Type\"='"+str+"'";
				}
			}
			String query = "SELECT \"Id\",\"Type\",\"Number\",\"Description\",\"IsDefault\",\"Status\" FROM \"LookUp\" WHERE "+types+" ORDER BY \"Type\",\"Description\"";
			System.out.println("Query SELECTLOOKUPBYTYPES="+query);
			Connection con = db.getConnection();
			try {
				if ( con != null ) {
					stm = con.prepareStatement(query);
					rs = stm.executeQuery();
					while ( rs.next() ) {
						obj = new LookupBean(rs.getInt(1),rs.getString(2),rs.getInt(3),rs.getString(4),rs.getBoolean(5),rs.getString(6));
						lookupBeanVector.add(obj);
					}
				}
			} catch( SQLException ex ) {
				throw ex;
			} finally {
				DBService.close(rs, stm, con);
			}
		}
		return lookupBeanVector;
	}
	public LookupBean selectLookupByTypeNumber(String type, int number) throws SQLException {
		ResultSet rs = null;
		PreparedStatement stm = null;
		LookupBean obj = null;
		String query = "SELECT \"Id\",\"Type\",\"Number\",\"Description\",\"IsDefault\",\"Status\" FROM \"LookUp\" WHERE \"LookUp\".\"Type\"='"+type+"' AND \"LookUp\".\"Number\"="+number+" ORDER BY \"Number\"";
		System.out.println("Query SELECTLOOKUPBYTYPENUMBER="+query);
		Connection con = db.getConnection();
		try {
			if ( con != null ) {
				stm = con.prepareStatement(query);
				rs = stm.executeQuery();
				if ( rs.next() ) {
					obj = new LookupBean(rs.getInt(1),rs.getString(2),rs.getInt(3),rs.getString(4),rs.getBoolean(5),rs.getString(6));
				}
			}
		} catch( SQLException ex ) {
			throw ex;
		} finally {
			DBService.close(rs, stm, con);
		}
		return obj;
	}
	public List selectLookupTypes() throws SQLException {
		List list = new LinkedList();
		ResultSet rs = null;
		PreparedStatement stm = null;
		LookupBean obj = null;
		String query = "SELECT DISTINCT \"LookUp\".\"Type\" FROM \"LookUp\" ORDER BY \"Type\" ";
		System.out.println("Query SELECTLOOKUPTYPES="+query);
		Connection con = db.getConnection();
		try {
			if ( con != null ) {
				stm = con.prepareStatement(query);
				rs = stm.executeQuery();
				while( rs.next() ) {
					obj = new LookupBean(); 
					obj.setType(rs.getString(1));
					list.add(obj);
				}
			}
		} catch( SQLException ex ) {
			throw ex;
		} finally {
			DBService.close(rs, stm, con);
		}
		return list;
	}
	// *************
	// **reference**
	// *************
	public  Vector selectAllReference(String className) throws SQLException {
		Vector referenceVector = new Vector();
		ResultSet rs = null;
		PreparedStatement stm = null;
		LookupBean obj = null;
		String query = "SELECT \"Id\",\"IdClass\",\"Description\",\"Status\" FROM \""+className+"\" WHERE \"Status\"='A' ORDER BY \"Description\";";
		System.out.println("Query SELECTALLREFERENCE="+query);
		Connection con = db.getConnection();
		try {
			if ( con != null ) {
				stm = con.prepareStatement(query);
				rs = stm.executeQuery();
				while ( rs.next() ) {
					obj = setReferenceObject(rs);
					obj.setType(className);
					referenceVector.add(obj);
				}
			}
		} catch( SQLException ex ) {
			throw ex;
		} finally {
			DBService.close(rs, stm, con);
		}
		return referenceVector;
	}
	
	/***********************/
	/* GETTERS AND SETTERS */
	/***********************/

	private LookupBean setReferenceObject(ResultSet rs) {
		LookupBean bean = new LookupBean();
		try {
			bean.setId(rs.getInt(1));	// id
			bean.setSequence(rs.getInt(2)); // IdClass
			bean.setDescription(rs.getString(3)); // description
			bean.setStatus(rs.getString(4)); // status
			// initialize others (not used)
			bean.setDefaultValue(false);
			bean.setType(""); 
		} catch (SQLException e) {
			e.printStackTrace();
		}		
		return bean;
	}
	
	public LookupBean getBean() {
		return bean;
	}
	public void setBean(LookupBean bean) {
		this.bean = bean;
	}
	
} // end of class
