package cmdbuild.elements;

import cmdbuild.db.DBService;
import cmdbuild.utils.Debug;
import cmdbuild.collection.AssetBean;
import cmdbuild.collection.AttributeBean;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Enumeration;
import java.util.Vector;

public class CMDBplanner extends CMDBclass{
	
	private static final String ExpirationTable = "Planner";
	private Debug DEBUG = new Debug();

	public CMDBplanner() {
		super();
	}

	public CMDBplanner(DBService db) {
		super(db);
	}
	
	/*
	 *  overload methods from class
	 */
	
	public Vector selectCards(Vector selectVector, String query, int limit, int offset) throws SQLException {
		System.out.println("Query PLANNERSELECTCARDS");
		Vector reportVector = new Vector();
		String beforeFrom = query.substring(0,query.indexOf("FROM"));
		beforeFrom = beforeFrom.replaceAll("Id","ActualId");
		beforeFrom = beforeFrom.replaceAll("ActualIdClass","IdClass");
		System.out.println("beforeFrom="+beforeFrom);
		String from = query.substring(query.indexOf("FROM"),query.indexOf("WHERE"));
		String where = query.substring(query.indexOf("WHERE"),query.length());
		beforeFrom += ", pg_description.description ";
		from += " LEFT JOIN pg_class on pg_class.oid=\"IdClass\" LEFT JOIN pg_description ON pg_description.objoid = pg_class.oid AND pg_description.objsubid = 0 ";
		query = beforeFrom + from + where;
		// adding order
		//query += " ORDER BY \"IdClass\",\"Id\" ";
		query += " ORDER BY \"Expiration\" DESC,\"Warning\" DESC,\"Description\",\"Code\" ";
		if (limit!=0){
			query+= " LIMIT "+limit;
		}
		if (offset!=0){
			query+= " OFFSET "+offset;
		}
		System.out.println("Query SELECTCARDS="+query);
		ResultSet rs = null;
		PreparedStatement stm = null;
		Vector assetVector = null;
		Connection con = db.getConnection();
		try {
			if ( con != null ) {
				stm = con.prepareStatement(query);
				rs = stm.executeQuery();
				while ( rs.next() ) {
					assetVector = setSearchResultObject(rs,selectVector);
					//System.out.println("reportVector: adding a new vetor of size "+assetVector.size());
					reportVector.add(assetVector);
				}
			}
		} catch( SQLException ex ) {
			throw ex;
		} finally {
			DBService.close(rs, stm, con);
		}
		return reportVector;
	}
	// used in searchForm, reports page
	public Vector selectCards(String className, Vector selectVector, int limit, int offset) throws SQLException {
		Vector reportVector = new Vector();
		Enumeration es = selectVector.elements();
		String query = "";
		AttributeBean ab = null;
		while(es.hasMoreElements()){
			ab = (AttributeBean)es.nextElement();
			if (query.equals("")){
				query = "SELECT \""+ab.getName()+"\"";
			} else {
				query +=", \""+ab.getName()+"\"";
			}
		}
		query += " FROM \""+className+"\" WHERE \"Status\"='A'";
		query += " ORDER BY \"IdClass\",\"Id\" ";
		if (limit!=0){
			query+= " LIMIT "+limit;
		}
		if (offset!=0){
			query+= " OFFSET "+offset;
		}
		System.out.println("Query SELECTCARDS="+query);
		ResultSet rs = null;
		PreparedStatement stm = null;
		Vector assetVector = null;
		Connection con = db.getConnection();
		try {
			if ( con != null ) {
				stm = con.prepareStatement(query);
				rs = stm.executeQuery();
				while ( rs.next() ) {
					assetVector = setResultObject(rs,selectVector);
					reportVector.add(assetVector);
				}
			}
		} catch( SQLException ex ) {
			throw ex;
		} finally {
			DBService.close(rs, stm, con);
		}
		return reportVector;
	}
	
	// **************
	// **Expiration**
	// **************
	public boolean modifyDateWarning(Vector assets, Vector warnings, Vector ids) throws SQLException {
		boolean result = false;
		ResultSet rs = null;
		String query = "";
		if (assets.size()!=warnings.size() || assets.size()!=ids.size()){
			return false;
		}
		Connection con = db.getConnection();
		Statement stm = con.createStatement();
		AssetBean as = null;
		String warning = "";
		Date dateW = null;
		long minus = 0;
		long res = 0;
		DateFormat formatter = new SimpleDateFormat("yyyy-MM-dd");
		for (int i=0;i<assets.size();i++){
			as = (AssetBean) assets.elementAt(i);
			warning = "";
			minus = 0;
			if (as.getValue()!=null && as.getValue().length()>0){
				DEBUG.println("as val="+as.getValue());
		        try {
					dateW = (Date)formatter.parse(as.getValue());
				} catch (ParseException e) {
					dateW = null;
					e.printStackTrace();
				}
		        DEBUG.println("warnings[i]="+warnings.elementAt(i));
				try {
					minus = Long.parseLong((String)warnings.elementAt(i))*24*60*60*1000;
				} catch (NumberFormatException e) {
					minus = 0;
					e.printStackTrace();
				}
				if (dateW!=null){
			        res = dateW.getTime()-minus;
			        dateW = new Date(res);
			        warning = formatter.format(dateW); // ISO
					query = "UPDATE \""+ExpirationTable+"\" SET \"Warning\"='"+warning+"' WHERE \"Id\"="+ids.elementAt(i)+" AND \"Status\"='A' ;";
					DEBUG.println("Query MODIFYDATEWARNINGBATCH="+query);
					stm.addBatch(query);
				}	
			}
		}		
		int tots[] = null;
		int tot = 0;
		try {
			if ( con != null ) {
				tots = stm.executeBatch();
				result = true;
			}
		} catch( SQLException ex ) {
			throw ex;
		} finally {
			DBService.close(rs, stm, con);
		}
		if (tots!=null){
			for (int i=0;i<tots.length;i++){
				tot = tot+tots[i];
			}
		}
		DEBUG.println(tot+" lines modified");
		return result;
	}
	
	// **************
	// **Expiration**
	// **************
	public Vector selectDateWarningId(int CurrentId) throws SQLException {
		ResultSet rs = null;
		PreparedStatement stm = null;
		Vector ids = new Vector(); // of string 
		String query = "";
		query = "SELECT \"Id\" FROM \""+ExpirationTable+"\" WHERE \"ActualId\"="+CurrentId+" AND \"Status\"='A';";
		DEBUG.println("Query SELECTDAYWARNINGID="+query);
		Connection con = db.getConnection();
		try {
			if ( con != null ) { // 
				stm = con.prepareStatement(query);
				rs = stm.executeQuery();
				while ( rs.next() ) {
					ids.add(rs.getString(1));
				}
			}
		} catch( SQLException ex ) {
			throw ex;
		} finally {
			DBService.close(rs, stm, con);
		}
		return ids;
	}
	
	/*
	 *  useful methods
	 */
	
	private Vector setSearchResultObject(ResultSet rs, Vector selectVector) {
		Vector assetVector = new Vector();
		AssetBean as = null;
		AttributeBean ab = null;
		String comment ="";
		try {
			Enumeration en = selectVector.elements();
			int i = 1;
			while (en.hasMoreElements()){
				ab = (AttributeBean)en.nextElement();
				if(ab.getName().equals("Id")){
					ab.setName("ActualId");
				}
				as = new AssetBean(ab);
				as.setValue(rs.getString(i));
				// adding class description
				comment = rs.getString(selectVector.size()+1); // this is the position of pg_description.description
				if (comment!=null && comment.indexOf("DESCR:")!=-1){
					comment = comment.substring(comment.indexOf("DESCR:")+7,comment.length());
					if (comment.indexOf("|")!=-1){
						comment = comment.substring(0,comment.indexOf("|"));
					}
					as.getClassBean().setDescription(comment);
				} else {
					as.getClassBean().setDescription("");
				}
				assetVector.add(as);
				i++;
			}
			// if the search name was Asset the overwrites every IdClass
			int IdClass = 0;
			Enumeration en2 = assetVector.elements();
			while (en2.hasMoreElements()){
				as = (AssetBean)en2.nextElement();
				if (as.getName().equals("IdClass")){
					IdClass = Integer.parseInt(as.getValue());
					break;
				}
			}
			Enumeration en3 = assetVector.elements();
			while (en3.hasMoreElements()){
				as = (AssetBean)en3.nextElement();
				as.getClassBean().setId(IdClass);
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}		
		return assetVector;
	}

	private Vector setResultObject(ResultSet rs, Vector selectVector) {
		Vector assetVector = new Vector();
		AssetBean as = null;
		AttributeBean ab = null;
		try {
			Enumeration en = selectVector.elements();
			int i = 1;
			while (en.hasMoreElements()){
				ab = (AttributeBean)en.nextElement();
				as = new AssetBean(ab);
				as.setValue(rs.getString(i));
				assetVector.add(as);
				i++;
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}		
		return assetVector;
	}

	
	
} // end of class
