package cmdbuild.elements;

import cmdbuild.db.DBService;
import cmdbuild.collection.AttributeBean;
import cmdbuild.collection.LookupBean;
import cmdbuild.collection.ReportBean;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.sql.CallableStatement;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;

public class CMDBreport extends CMDBtemplate{

	
	public CMDBreport(DBService db) {
		super(db);
	}

	// **********
	// **report**
	// **********
	public boolean createReport(ReportBean bean) throws SQLException {
		boolean ok = false;
		PreparedStatement stm = null;
		String query = "INSERT INTO \"Report\" (\"Code\",\"Description\",\"Status\",\"User\",\"Type\",\"Query\",\"SimpleReport\",\"RichReport\",\"Wizard\") VALUES (?,?,?,?,?,?,?,?,?); ";
		//String query = "INSERT INTO \"Report\" (\"Code\",\"Description\",\"Status\",\"User\",\"Type\",\"Query\",\"SimpleReport\") VALUES (?,?,?,?,?,?,?); ";
		String shortQuery = "INSERT INTO \"Report\" (\"Code\",\"Description\",\"Status\",\"User\",\"Type\",\"Query\") VALUES ('"+bean.getName()+"','"+bean.getDescription()+"','A','"+bean.getUser()+"','"+bean.getType()+"','"+bean.getQuery()+"'); ";
		System.out.println("Query CREATEREPORT="+shortQuery);
		Connection con = db.getConnection();
		int sr = 0;
		int rr = 0;
		int wr = 0;
		try {
			stm = con.prepareCall(query);
			stm.setString(1,bean.getName());
			stm.setString(2,bean.getDescription());
			stm.setString(3,"A");
			stm.setString(4,bean.getUser());
			stm.setString(5,bean.getType());
			stm.setString(6,bean.getQuery());
			byte[] bin = toByte(bean.getSimpleReport());
			sr = bin.length;
			stm.setBytes(7,bin);
			bin = toByte(bean.getRichReport());
			rr = bin.length;
			stm.setBytes(8,bin);
			bin = toByte(bean.getWizard());
			wr = bin.length;
			stm.setBytes(9,bin);
			System.out.println("sizes: SimpleReport="+sr+" RichReport="+rr+" WizardReport="+wr);
			stm.execute();
			ok = true;
		} catch (SQLException ex) {
			throw ex;
		} finally {
			DBService.close(null, stm, con);
		}
		return ok;
	}
	public boolean modifyReport(int id, ReportBean bean) throws SQLException {
		boolean ok = false;
		CallableStatement stm = null;
		String query = "UPDATE \"Report\" SET \"Code\"=?,\"Description\"=?,\"Status\"=?,\"User\"=?,\"Type\"=?,\"Query\"=?,\"SimpleReport\"=?,\"RichReport\"=?,\"Wizard\"=? WHERE \"Id\"=?;";
		String shortQuery = "UPDATE \"Report\" (\"Code\"="+bean.getName()+",\"Description\"="+bean.getDescription()+",\"Status\"="+bean.getStatus()+",\"User\"="+bean.getUser()+",\"Type\"="+bean.getType()+",\"Query\"="+bean.getQuery()+";";
		System.out.println("Query MODIFYREPORT="+shortQuery);
		Connection con = db.getConnection();
		int sr = 0;
		int rr = 0;
		int wr = 0;
		try {
			stm = con.prepareCall(query);
			stm.setString(1,bean.getName());
			stm.setString(2,bean.getDescription());
			stm.setString(3,"A");
			stm.setString(4,bean.getUser());
			stm.setString(5,bean.getType());
			stm.setString(6,bean.getQuery());
			byte[] bin = toByte(bean.getSimpleReport());
			sr = bin.length;
			stm.setBytes(7,bin);
			bin = toByte(bean.getRichReport());
			rr = bin.length;
			stm.setBytes(8,bin);
			bin = toByte(bean.getWizard());
			wr = bin.length;
			stm.setBytes(9,bin);
			// where
			stm.setInt(10,id);
			System.out.println("sizes: SimpleReport="+sr+" RichReport="+rr+" WizardReport="+wr);
			stm.execute();
			ok = true;
		} catch (SQLException ex) {
			throw ex;
		} finally {
			DBService.close(null, stm, con);
		}
		return ok;
	}
	public boolean deleteReportById(int id) throws SQLException{
		boolean ok = false;
		Statement stm = null;
		String query = "DELETE FROM \"Report\" WHERE \"Id\"="+id+";";
		System.out.println("Query DELETEREPORT="+query);
		Connection con = db.getConnection();
		try {
			stm = con.createStatement();
			stm.executeUpdate(query);
			ok = true;
		} catch (SQLException ex) {
			throw ex;
		} finally {
			DBService.close(null, stm, con);
		}
		return ok;
	}
	public Vector selectAllReport() throws SQLException {
		Vector vect = new Vector();
		ResultSet rs = null;
		PreparedStatement stm = null;
		ReportBean obj = null;
		String query = "SELECT \"Id\",\"Code\",\"Description\",\"Status\",\"User\",\"BeginDate\",\"Type\",\"Query\" FROM \"Report\"  WHERE \"Status\"='A';";
		System.out.println("Query SELECTALLREPORT="+query);
		Connection con = db.getConnection();
		try {
			if ( con != null ) {
				stm = con.prepareStatement(query);
				rs = stm.executeQuery();
				while( rs.next() ) {
					obj = setReportObject(rs);
					vect.add(obj);
				}
			}
		} catch( SQLException ex ) {
			throw ex;
		} finally {
			DBService.close(rs, stm, con);
		}
		return vect;
	}
	public ReportBean selectReportById(int Id) throws SQLException {
		ResultSet rs = null;
		PreparedStatement stm = null;
		ReportBean obj = null;
		String query = "SELECT \"Id\",\"Code\",\"Description\",\"Status\",\"User\",\"BeginDate\",\"Type\",\"Query\" FROM \"Report\" WHERE \"Id\"="+Id+";";
		System.out.println("Query SELECTREPORTBYID="+query);
		Connection con = db.getConnection();
		try {
			if ( con != null ) {
				stm = con.prepareStatement(query);
				rs = stm.executeQuery();
				if( rs.next() ) {
					obj = setReportObject(rs);
				}
			}
		} catch( SQLException ex ) {
			throw ex;
		} finally {
			DBService.close(rs, stm, con);
		}
		return obj;
	}
	public String selectReportQueryById(int Id) throws SQLException {
		ResultSet rs = null;
		PreparedStatement stm = null;
		String result = "";
		String query = "SELECT \"Query\" FROM \"Report\" WHERE \"Id\"="+Id+";";
		System.out.println("Query SELECTREPORTQUERYBYID="+query);
		Connection con = db.getConnection();
		try {
			if ( con != null ) {
				stm = con.prepareStatement(query);
				rs = stm.executeQuery();
				if( rs.next() ) {
					result = rs.getString(1);
				}
			}
		} catch( SQLException ex ) {
			throw ex;
		} finally {
			DBService.close(rs, stm, con);
		}
		return result;
	}
	public boolean setSimpleReport(int Id, Object obj) throws SQLException {
		int r=0;
		boolean result;
		PreparedStatement stm = null;
		ResultSet rs = null;
		String query = "UPDATE \"Report\" SET \"SimpleReport\"=? WHERE \"Id\"="+Id+";";
		System.out.println("Query SETSimpleReport="+query);
		Connection con = db.getConnection();
		try {
			if ( con != null ) {
				stm = con.prepareStatement(query);
				byte[] bin = toByte(obj);
				stm.setBytes(1,bin);
				r= stm.executeUpdate() ;
			}
		} catch( SQLException ex ) {
			throw ex;
		} finally {
			DBService.close(rs, stm, con);
		}
		if (r==1) {
			result = true;
		} else {
			result = false;
		}
		return result;
	}
	public Object getSimpleReport(int Id) throws SQLException {
		PreparedStatement stm = null;
		ResultSet rs = null;
		Object obj = null;
		String query = "SELECT \"SimpleReport\" FROM \"Report\" WHERE \"Id\"="+Id+";";	
		System.out.println("Query GETSimpleReport="+query);
		Connection con = db.getConnection();
		try {
			if ( con != null ) {
				stm = con.prepareStatement(query);
				rs = stm.executeQuery();
				if (rs.next()){
					byte[] bin = rs.getBytes(1);
					obj = fromByte(bin);
				}
			}
		} catch( SQLException ex ) {
			throw ex;
		} finally {
			DBService.close(rs, stm, con);
		}
		return obj;
	}
	
	
	public boolean setRichReport(int Id, Object obj) throws SQLException {
		int r=0;
		boolean result;
		PreparedStatement stm = null;
		ResultSet rs = null;
		String query = "UPDATE \"Report\" SET \"RichReport\"=? WHERE \"Id\"="+Id+";";
		System.out.println("Query SETSimpleReport="+query);
		Connection con = db.getConnection();
		try {
			if ( con != null ) {
				stm = con.prepareStatement(query);
				byte[] bin = toByte(obj);
				stm.setBytes(1,bin);
				r= stm.executeUpdate() ;
			}
		} catch( SQLException ex ) {
			throw ex;
		} finally {
			DBService.close(rs, stm, con);
		}
		if (r==1) {
			result = true;
		} else {
			result = false;
		}
		return result;
	}
	public Object getRichReport(int Id) throws SQLException {
		PreparedStatement stm = null;
		ResultSet rs = null;
		Object obj = null;
		String query = "SELECT \"RichReport\" FROM \"Report\" WHERE \"Id\"="+Id+";";	
		System.out.println("Query GETRichReport="+query);
		Connection con = db.getConnection();
		try {
			if ( con != null ) {
				stm = con.prepareStatement(query);
				rs = stm.executeQuery();
				if (rs.next()){
					byte[] bin = rs.getBytes(1);
					obj = fromByte(bin);
				}
			}
		} catch( SQLException ex ) {
			throw ex;
		} finally {
			DBService.close(rs, stm, con);
		}
		return obj;
	}
	public boolean setWizard(int Id, Object obj) throws SQLException {
		int r=0;
		boolean result;
		PreparedStatement stm = null;
		ResultSet rs = null;
		String query = "UPDATE \"Report\" SET \"Wizard\"=? WHERE \"Id\"="+Id+";";
		System.out.println("Query SETWizard="+query);
		Connection con = db.getConnection();
		try {
			if ( con != null ) {
				stm = con.prepareStatement(query);
				byte[] bin = toByte(obj);
				stm.setBytes(1,bin);
				r= stm.executeUpdate() ;
			}
		} catch( SQLException ex ) {
			throw ex;
		} finally {
			DBService.close(rs, stm, con);
		}
		if (r==1) {
			result = true;
		} else {
			result = false;
		}
		return result;
	}

	public Object getWizard(int Id) throws SQLException {
		PreparedStatement stm = null;
		ResultSet rs = null;
		Object obj = null;
		String query = "SELECT \"Wizard\" FROM \"Report\" WHERE \"Id\"="+Id+";";	
		System.out.println("Query GETWizard="+query);
		Connection con = db.getConnection();
		try {
			if ( con != null ) {
				stm = con.prepareStatement(query);
				rs = stm.executeQuery();
				if (rs.next()){
					byte[] bin = rs.getBytes(1);
					obj = fromByte(bin);
				}
			}
		} catch( SQLException ex ) {
			throw ex;
		} finally {
			DBService.close(rs, stm, con);
		}
		return obj;
	}

	public int testReportQuery(String query) throws SQLException {
		PreparedStatement stm = null;
		ResultSet rs = null;
		int result = -1;
		System.out.println("query="+query+" query.length="+query.length()+" i sel="+query.indexOf("SELECT")+" i fro="+query.indexOf("FROM")+" i ord"+query.indexOf("ORDER"));
		if (query!=null && query.length()>0 && query.indexOf("SELECT")!=-1 && query.indexOf("FROM")!=-1 && query.indexOf("ORDER")!=-1){
			query = query.substring(query.indexOf("FROM"),query.indexOf("ORDER"));
			query = "SELECT count(*) "+query;
			System.out.println("Query TESTREPORTQUERY="+query);
			Connection con = db.getConnection();
			try {
				if ( con != null ) {
					stm = con.prepareStatement(query);
					rs = stm.executeQuery();
					if (rs.next()){
						result = rs.getInt(1);
					}
				}
			} catch( SQLException ex ) {
				throw ex;
			} finally {
				DBService.close(rs, stm, con);
			}
		}
		return result;
	}
	
	public Vector executeReportQuery(String query, Vector attributeVector, Vector lookupVector, Hashtable referenceHash) throws SQLException {
		PreparedStatement stm = null;
		ResultSet rs = null;
		Hashtable AttributeMatch = new Hashtable();
		Hashtable lookup = new Hashtable();
		Hashtable referenceMap = new Hashtable();
		Enumeration en = lookupVector.elements();
		LookupBean lb = null;
		while (en.hasMoreElements()){
			lb = (LookupBean) en.nextElement();
			lookup.put(lb.getId()+"",lb.getDescription());
		}
		// generate reference mapping
		Vector vett = new Vector();
		en = referenceHash.elements();
		while (en.hasMoreElements()){
			vett.addAll( (Vector)en.nextElement() );
		}
		en = vett.elements();
		while (en.hasMoreElements()){
			lb = (LookupBean)en.nextElement();
			referenceMap.put(lb.getId()+"",lb.getDescription());
		}
		String str = "";
		AttributeBean ab = null;
		Vector rows = new Vector();
		Vector columns = new Vector();
		// setting column names
		en = attributeVector.elements();
		int i = 0;
		while (en.hasMoreElements()){
			ab = (AttributeBean)en.nextElement();
			//System.out.print("ab is "+ab);
			//System.out.print(ab.getClassBean().getComment()+ab.getName()+"=i="+i);
			AttributeMatch.put(i+"",ab);
			i++;	
		}
		//System.out.println("");
		//System.out.println("=====================================");
		if (query!=null && query.length()>0){
			System.out.println("Query EXECUTEREPORTQUERY="+query);
			Connection con = db.getConnection();
			try {
				if ( con != null ) {
					stm = con.prepareStatement(query);
					rs = stm.executeQuery();
					while (rs.next()){
						columns = new Vector();
						for (int j=0;j<attributeVector.size();j++){
							ab = (AttributeBean)AttributeMatch.get(j+"");
							//System.out.print("pos j="+j+" ab="+ab.getClassBean().getComment()+ab.getName()+" type="+ab.getType()+" ");
							if (ab.getType()==AttributeBean.DOUBLE || ab.getType()==AttributeBean.DECIMAL){
								//System.out.print(Double.valueOf(rs.getDouble(j+1))+" ");
								columns.add( (Double.valueOf(rs.getDouble(j+1))) );
							} else if (ab.getType()==AttributeBean.INTEGER){
								//System.out.print(Integer.valueOf(rs.getInt(j+1))+" ");
								columns.add( (Integer.valueOf(rs.getInt(j+1))) );
							} else if (ab.getType()==AttributeBean.LOOKUP){
								//System.out.print(" "+ab.getClassBean().getComment()+ab.getName()+"=");
								//System.out.print(rs.getString(j+1)+" ");
								str = rs.getString(j+1);
								if (str!=null && lookup.get(str)!=null){
									columns.add(lookup.get(str));
								} else {
									columns.add(rs.getString(j+1));	
								}
							} else if (ab.getType()==AttributeBean.REFERENCE){
								//System.out.print(" "+ab.getClassBean().getComment()+ab.getName()+"=");
								//System.out.print(rs.getString(j+1)+" ");
								str = rs.getString(j+1);
								if (str!=null && referenceMap.get(str)!=null){
									columns.add(referenceMap.get(str));
								} else {
									columns.add(rs.getString(j+1));	
								}
							} else { // String
								//System.out.print(rs.getString(j+1)+" ");
								columns.add(rs.getString(j+1));
							}
						}
						//System.out.println("");
						rows.add(columns);
					}
				}
			} catch( SQLException ex ) {
				throw ex;
			} finally {
				DBService.close(rs, stm, con);
			}
		}
		return rows;
	}

	
	/**************************/
	/* USEFUL SETTING METHOTS */
	/**************************/
	
	private ReportBean setReportObject(ResultSet rs) {
		ReportBean bean = new ReportBean();		
		try {
			bean.setId(rs.getInt(1));
			bean.setName(rs.getString(2));
			bean.setDescription(rs.getString(3));
			bean.setStatus(rs.getString(4));
			bean.setUser(rs.getString(5));
			bean.setBeginDate(rs.getString(6));
			bean.setType(rs.getString(7));
			bean.setQuery(rs.getString(8));
		} catch (SQLException e) {
			e.printStackTrace();
		}		
		return bean;
	}
	
	/*
	public static byte[] toByteS(Object obj){
		ByteArrayOutputStream baos = new ByteArrayOutputStream();
		ObjectOutputStream oout;
		try {
			oout = new ObjectOutputStream(baos);
			oout.writeObject(obj);
			oout.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return baos.toByteArray();
	}
	*/
	
	public static byte[] toByte(Object obj){
		byte[] bytes = new byte[0];
	    ByteArrayOutputStream out = new ByteArrayOutputStream() ;
	    ObjectOutputStream objOut;
		try {
			objOut = new ObjectOutputStream(out);
		    objOut.writeObject(obj) ;
		    objOut.flush() ;
		    bytes = out.toByteArray() ;
		    objOut.close() ;
		} catch (IOException e1) {
			e1.printStackTrace();
		}
		return bytes;
	}

	/*
	public static Object fromByteS(byte[] bin){
		if (bin != null) {
			ObjectInputStream objectIn;
			ByteArrayInputStream by;
			try {
				System.out.println("bytes[]"+bin);
				by = new ByteArrayInputStream(bin);
				System.out.println("by"+by);
				objectIn = new ObjectInputStream(by);
				return objectIn.readObject();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (ClassNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		return null;
	}
	*/

	public static Object fromByte(byte[] bin){
		Object obj = null;
		ObjectInputStream stream = null;
		if (bin != null) {
			// Deserialize from a byte array
			try {
				stream = new ObjectInputStream(new ByteArrayInputStream(bin));
				obj = stream.readObject();
				stream.close();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}  catch (ClassNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		return obj;
	}

	
	/*
	private byte[] serializeToByte(Object obj){
		ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
		ObjectOutputStream stream = null;
		// serialize object
		try {
			stream = new ObjectOutputStream(outputStream);
			stream.writeObject(obj);
			stream.flush();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		// get bytes of object
		byte[] modelBytes = outputStream.toByteArray();
		ByteArrayOutputStream arrayOutputStream = new ByteArrayOutputStream();
		DataOutputStream dataOutputStream = new DataOutputStream(arrayOutputStream);
		// convert to UTF8
		try {
			dataOutputStream.writeUTF(new String(modelBytes));
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		StringBuffer buffer = new StringBuffer();
		byte[] aaa = arrayOutputStream.toByteArray();
		for (int i = 0; i < aaa.length; i++) {
			buffer.append(getEscapedByte(aaa[i]));
		}
		return modelBytes;
	}
	*/
	
	/*
	private String getEscapedByte(byte b) {
		int c = (int)b & 0xFF;
		// special chars
		switch (c){
		// ZERO byte
			case 0:
			return "\\\\000";
			// apostroph '
			case 39:
			return "\\\\047";
			// backslash \
			case 92:
			return "\\\\134";
		}
		// non-printable characters
		if (c < 32 || c > 126){
			String cS = Integer.toString(c, 8);
			if (cS.length() == 1){
				return "\\00" + cS;
			}
			if (cS.length() == 2){
				return "\\0" + cS;
			}
			return "\\" + cS;
		}
		// printable characters
		return "" + (char)c;
	}
	*/	
	
} // end of class
