package cmdbuild.elements;

import cmdbuild.collection.SecurityBean;
import cmdbuild.db.DBService;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Vector;

public class CMDBuser extends CMDBclass {
	
	static final long serialVersionUID = 1L;
	public CMDBuser(DBService db) {
		super(db);
	}

	// ********
	// **user**
	// ********
	public  boolean createUser(SecurityBean sb, int[] role, String user) throws SQLException {
		// calculate column idobj1
		String query1 = "SELECT MAX(\"Id\")+1 FROM \"User\" ";
		System.out.println("Query1 CREATEUSER="+query1);
		int IdObj1 = 0;
		ResultSet rs1 = null;
		PreparedStatement pstm1 = null;
		Connection con = db.getConnection();
		try {
			if ( con != null ) {
				pstm1 = con.prepareStatement(query1);
				rs1 = pstm1.executeQuery();
				if ( rs1.next() ) { // while ( rs.next() ) {
					IdObj1 = rs1.getInt(1);
				}
			}
		} catch( SQLException ex ) {
			throw ex;
		} finally { // added**
			DBService.close(rs1, pstm1, null);
		}
		String query2 = "SELECT DISTINCT D.oid ,C1.oid,C2.oid FROM pg_class AS D, pg_class AS C1,pg_class AS C2 WHERE D.relname='Map_ruoli' AND C1.relname='User' AND C2.relname='Role'";
		System.out.println("Query2 CREATEUSER="+query2);
		int IdDomain = 0;
		int IdClass1 = 0;
		int IdClass2 = 0;
		int[] IdObj2 = role;
		ResultSet rs2 = null;
		PreparedStatement pstm2 = null;
		try {
			if ( con != null ) {
				pstm2 = con.prepareStatement(query2);
				rs2 = pstm2.executeQuery();
				if ( rs2.next() ) { // while ( rs.next() ) {
					IdDomain = rs2.getInt(1); // Domain
					IdClass1 = rs2.getInt(2); // User
					IdClass2 = rs2.getInt(3); // Role
				}
			}
		} catch( SQLException ex ) {
			throw ex;
		} finally { // added**
			DBService.close(rs1, pstm1, null);
		}
		boolean result=false;
		Statement stm34 = null;
		ResultSet rs34 = null;
		String query3 = "INSERT INTO \"User\" (\"Id\",\"Description\",\"Username\",\"Password\",\"User\",\"Status\") VALUES ("+IdObj1+",'"+sb.getDescription()+"','"+sb.getUsername()+"','"+sb.getPassword()+"','"+user+"','A'); ";
		System.out.println("Query3 CREATEUSER="+query3);
		if (con!=null){
			stm34 = con.createStatement();
			stm34.addBatch(query3);
		}
		String query4 = "";
		for (int i=0;i<role.length;i++){
			query4 = "INSERT INTO \"Map_ruoli\" (\"IdDomain\",\"IdClass1\",\"IdObj1\",\"IdClass2\",\"IdObj2\",\"Status\") VALUES ("+IdDomain+","+IdClass1+","+IdObj1+","+IdClass2+","+IdObj2[i]+",'A'); ";
			System.out.println("Query4 CREATEUSER="+query4);
			stm34.addBatch(query4);
		}
		try {
			if ( con != null ) {
				stm34.executeBatch();
				result = true;
			}
		} catch( SQLException ex ) {
			throw ex;
		} finally {
			DBService.close(rs34, stm34, con);
		}
		return result;
	}
	public  boolean modifyUser(SecurityBean sb, int[] role, String user) throws SQLException {
		boolean result=false;
		String query1 = "SELECT DISTINCT D.oid ,C1.oid,C2.oid FROM pg_class AS D, pg_class AS C1,pg_class AS C2 WHERE D.relname='Map_ruoli' AND C1.relname='User' AND C2.relname='Role'";
		System.out.println("Query1 MODIFYUSER="+query1);
		int IdDomain = 0;
		int IdClass1 = 0;
		int IdClass2 = 0;
		int IdObj1 = sb.getId();
		int[] IdObj2 = role;
		ResultSet rs1 = null;
		PreparedStatement pstm1 = null;
		Connection con = db.getConnection();
		try {
			if ( con != null ) {
				pstm1 = con.prepareStatement(query1);
				rs1 = pstm1.executeQuery();
				if ( rs1.next() ) { // while ( rs.next() ) {
					IdDomain = rs1.getInt(1); // Domain
					IdClass1 = rs1.getInt(2); // User
					IdClass2 = rs1.getInt(3); // Role
				}
			}
		} catch( SQLException ex ) {
			throw ex;
		} finally { // added**
			DBService.close(rs1, pstm1, null);
		}
		Statement stm23 = null;
		ResultSet rs23 = null;
		if (con!=null){
			stm23 = con.createStatement();
			String query2 = "UPDATE \"User\" SET \"Description\"='"+sb.getDescription()+"',\"Username\"='"+sb.getUsername()+"',\"Password\"='"+sb.getPassword()+"',\"User\"='"+user+"',\"Status\"='"+sb.getStatus()+"' WHERE \"Id\"="+sb.getId()+"; ";
			stm23.addBatch(query2);
			System.out.println("Query1 MODIFYUSER="+query2);
		}
		String query3 = "";
		for (int i=0;i<role.length;i++){
			query3 = "DELETE FROM \"Map_ruoli\" WHERE \"IdObj1\"="+sb.getId()+"; ";
			System.out.println("Query3 MODIFYUSER="+query3);
			stm23.addBatch(query3);
		}
		String query4 = "";
		for (int i=0;i<role.length;i++){
			query4 = "INSERT INTO \"Map_ruoli\" (\"IdDomain\",\"IdClass1\",\"IdObj1\",\"IdClass2\",\"IdObj2\",\"Status\") VALUES ("+IdDomain+","+IdClass1+","+IdObj1+","+IdClass2+","+IdObj2[i]+",'A'); ";
			System.out.println("Query4 MODIFYUSER="+query4);
			stm23.addBatch(query4);
		}
		try {
			if ( con != null ) {
				stm23.executeBatch();
				result = true;
			}
		} catch( SQLException ex ) {
			throw ex;
		} finally {
			DBService.close(rs23, stm23, con);
		}
		return result;
	}
	public  boolean deleteUser(SecurityBean sb) throws SQLException {
		int r[]={0,0};
		boolean result;
		Statement stm12 = null;
		ResultSet rs12 = null;
		String query1 = "DELETE FROM \"Map_ruoli\" WHERE \"IdObj1\"="+sb.getId()+"; ";
		String query2 = "DELETE FROM \"User\" WHERE \"Id\"="+sb.getId()+"; ";
		System.out.println("DELETEQuery1 AND Query2 DELETEUSER="+query1+" AND "+query2);
		Connection con = db.getConnection();
		try {
			if ( con != null ) {
				stm12 = con.createStatement();
				stm12.addBatch(query1);
				stm12.addBatch(query2);
				r= stm12.executeBatch();
			}
		} catch( SQLException ex ) {
			throw ex;
		} finally {
			DBService.close(rs12, stm12, con);
		}
		if (r[0]==1 && r[1]==1) {
			result = true;
		} else {
			result = false;
		}
		return result;
	}
	// **********
	// **policy**
	// **********
	public Vector selectAllPolicy() throws SQLException {
		Vector policyVector = new Vector();
		SecurityBean sb = null;
		ResultSet rs = null;
		PreparedStatement stm = null;
		String query = "SELECT \"Id\",\"Description\",\"Username\",\"Password\",\"Status\",\"Group\",\"GroupId\",\"Administrator\",\"ClassId\",\"ClassName\",\"Mode\" FROM cmdbpolicycatalog";
		System.out.println("Query SELECTALLPOLICY="+query);
		Connection con = db.getConnection();
		try {
			if ( con != null ) {
				stm = con.prepareStatement(query);
				rs = stm.executeQuery();
				while( rs.next() ) {
					sb = setSecurityObject(rs);
					policyVector.add(sb);
				}
			}
		} catch( SQLException ex ) {
			throw ex;
		} finally {
			DBService.close(rs, stm, con);
		}
		return policyVector;
	}
	public Vector selectPolicyByUsername(String username) throws SQLException {
		Vector policyVector = new Vector();
		SecurityBean sb = null;
		ResultSet rs = null;
		PreparedStatement stm = null;
		String query = "SELECT \"Id\",\"Description\",\"Username\",\"Password\",\"Status\",\"Group\",\"GroupId\",\"Administrator\",\"ClassId\",\"ClassName\",\"Mode\" FROM cmdbpolicycatalog WHERE \"Username\"='"+username+"' ";
		System.out.println("Query SELECTPOLICYBYUSERNAME="+query);
		Connection con = db.getConnection();
		try {
			if ( con != null ) {
				stm = con.prepareStatement(query);
				rs = stm.executeQuery();
				while( rs.next() ) {
					sb = setSecurityObject(rs);
					policyVector.add(sb);
				}
			}
		} catch( SQLException ex ) {
			throw ex;
		} finally {
			DBService.close(rs, stm, con);
		}
		return policyVector;
	}

	
	/**************************/
	/* USEFUL SETTING METHOTS */
	/**************************/

	private SecurityBean setSecurityObject(ResultSet rs) {
		SecurityBean bean = new SecurityBean();		
		try {
			bean.setId(rs.getInt(1));
			bean.setDescription(rs.getString(2));
			bean.setUsername(rs.getString(3));
			bean.setPassword(rs.getString(4));
			bean.setStatus(rs.getString(5));
			bean.setGroup(rs.getString(6));
			bean.setGroupId(rs.getInt(7));
			bean.setAdministrator(rs.getBoolean(8));
			bean.setClassId(rs.getInt(9));
			bean.setClassName(rs.getString(10));
			bean.setMode(rs.getString(11));
		} catch (SQLException e) {
			e.printStackTrace();
		}		
		return bean;
	}

} // end of class
