package cmdbuild.presentation;

import cmdbuild.collection.AssetBean;
import cmdbuild.collection.AttributeBean;
import cmdbuild.collection.LookupBean;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;

public class BaseDisplay extends HTMLtemplate{
	
	private Vector assetVector;
	private Vector lookupVector;
	private Hashtable referenceHash;
	private String HTMLtext;

	public BaseDisplay() {
		super();
	}

	public BaseDisplay(Vector assetVector, Vector lookupVector, Hashtable referenceHash) {
		super();
		this.assetVector = assetVector;
		this.lookupVector = lookupVector;
		this.referenceHash = referenceHash;
	}

	// generate the code for BaseDSP table
	public String toForm(){
		String HTMLtext = "";
		if (assetVector==null){
			return HTMLtext;
		}
		HTMLtext+="<table class=\"show\" cellpadding=\"0\" cellspacing=\"0\">\n";
		Enumeration e = assetVector.elements();
		AssetBean obj = new AssetBean();
		Enumeration en = null;
		Vector vett = null;
		String desc = "";
		while (e.hasMoreElements()){
			obj = (AssetBean)e.nextElement();
			if (obj.getBaseDSP().equals("true")){ 
				//System.out.println(obj.getName()+" is type in asset="+obj.getType());
				if (obj.getType()==AttributeBean.LOOKUP){
					HTMLtext+="\t<tr><td class=\"td50\">"+obj.getDescription()+"</td>";
					HTMLtext+="<td>";
					en = lookupVector.elements();
					LookupBean lb = null;
					while ( (en!=null) && (en.hasMoreElements()) ){
						lb = (LookupBean)en.nextElement();
						if (obj.getValue()!=null){
							String id = ""+lb.getId(); 
							//System.out.println("obj is "+obj.getValue().getClass().getName());
							if (id.equals(obj.getValue())){
								desc = lb.getDescription();
								if (desc.length()==0){
									desc = "&nbsp;";
								}
								HTMLtext+=desc;
								break;
							}
						} else {
							HTMLtext+="&nbsp;";
						}
					}
					HTMLtext+="</td>";
					HTMLtext+="</tr>\n";
				} else if (obj.getType()==AttributeBean.REFERENCE){
					HTMLtext+="\t<tr><td class=\"td50\">"+obj.getDescription()+"</td>";
					HTMLtext+="<td>";
					if (referenceHash.containsKey(obj.getReference())){
						vett = (Vector) referenceHash.get(obj.getReference());
					} 
					if (vett!=null){
						en = vett.elements();
						LookupBean lb = null;
						while ( (en!=null) && (en.hasMoreElements()) ){
							lb = (LookupBean)en.nextElement();
							if (obj.getValue()!=null){
								String id = ""+lb.getId(); 
								//System.out.println("obj is "+obj.getValue().getClass().getName());
								if (id.equals(obj.getValue())){
									desc = lb.getDescription();
									if (desc.length()==0){
										desc = "&nbsp;";
									}
									HTMLtext+=desc;
									break;
								}
							} else {
								HTMLtext+="&nbsp;";
							}
						}
					} else {
						HTMLtext+="&nbsp;";
					}
					HTMLtext+="</td>";
					HTMLtext+="</tr>\n";
				} else if (obj.getValue()!=null && obj.getType()==AttributeBean.BOOLEAN){
					if (obj.getValue().equals("t") || obj.getValue().equals("true")){
						HTMLtext+="\t<tr><td class=\"td50\">"+obj.getDescription()+"</td><td>S</td></tr>\n";	
					} else { // f || false
						HTMLtext+="\t<tr><td class=\"td50\">"+obj.getDescription()+"</td><td>N</td></tr>\n";
					}
				} else {
					if (obj.getValue()==null || obj.getValue().equals("")){ 
						HTMLtext+="\t<tr><td class=\"td50\">"+obj.getDescription()+"</td><td>&nbsp;</td></tr>\n";					
					} else {
						HTMLtext+="\t<tr><td class=\"td50\">"+obj.getDescription()+"</td><td>"+obj.getValue()+"</td></tr>\n";					
					}
				}
			}
		}
		HTMLtext+="</table>\n";
		return HTMLtext;
	}

	public Vector getAssetVector() {
		return assetVector;
	}
	public void setAssetVector(Vector assetVector) {
		this.assetVector = assetVector;
	}
	public String getHTMLtext() {
		return HTMLtext;
	}
	public void setHTMLtext(String ltext) {
		HTMLtext = ltext;
	}
	public Vector getLookupVector() {
		return lookupVector;
	}
	public void setLookupVector(Vector lookupVector) {
		this.lookupVector = lookupVector;
	}
	public Hashtable getReferenceHash() {
		return referenceHash;
	}
	public void setReferenceHash(Hashtable referenceHash) {
		this.referenceHash = referenceHash;
	}

} // end of class
