package cmdbuild.presentation;

import cmdbuild.collection.AssetBean;
import cmdbuild.collection.AttributeBean;
import cmdbuild.collection.ClassBean;
import cmdbuild.collection.HistoryBean;
import cmdbuild.collection.InheritsBean;
import cmdbuild.collection.LookupBean;
import cmdbuild.collection.RelationBean;
import cmdbuild.collection.SearchRelationBean;
import cmdbuild.utils.GenerateTips;
import cmdbuild.utils.MultiLanguage;
import cmdbuild.utils.SecurityDescriptor;

import java.util.Collection;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Vector;

public class HTMLclass implements Presentation {
	
	protected MultiLanguage multilanguage;

	/* from class */
	protected Collection categoryCollection;
	protected boolean disabled = true; 
	protected InheritsBean superClass;
	protected Collection superCollection;
	protected String status;
	protected String manager; // used only in the forms of class.jsp
	protected String inherits; // used only in the forms of class.jsp
	protected boolean superClassOn;
	protected int categoryId;
	protected String mode; // used in classmodify
	protected Collection managersList;
	
	/* from card */
	protected String className = "";
	protected String masterDetail = "";
	protected Vector masterDetailMenu = new Vector();
	protected int referenceId; // used in CardCreateDetail
	protected int currentPage;
	protected int objId;
	protected String classDescription="";
	protected String category = "";
	protected Vector assetVector=new Vector();
	protected boolean toPaste;
	protected Collection classCollection;
	protected Vector lookupVector=new Vector();
	protected Hashtable referenceHash = new Hashtable();
	protected String notes="";
	protected String formName; // used for the calendar
	protected boolean deleted = false;
	protected SecurityDescriptor user;	
	protected Header header = new Header();
	
	/* from history */
	protected Vector historyVector; // contains a list of HistoryBean

	/* from relation */
	protected Vector relationVector; // contains a list of RelationBean
	protected int class1id;
	protected int obj1id;
	protected int subpage=0;
	protected int resultsForPage = 30; // if you change this, change in SearchForm too
	protected int totalPages=0;
	protected boolean hideLinks = false;

	/* from search */
	protected Vector searchRelationVector;
	protected Vector attributeVector;
	protected String inputName;
	protected Vector reportVector;
	protected Vector thVector;
	protected int pageToHighlight=0;
	protected Hashtable lookupHash;
	protected Hashtable referenceMap;
	protected boolean showAll=true;
	protected Vector tipsVector;
	
	protected boolean disableEditing = false; // used in PopupInfo
	
	public HTMLclass() {
		super();
	}

	public String toClassForm() {
		String HTMLtext = header.toForm();
		HTMLtext += "<table cellpadding=\"5\" cellspacing=\"0\">\n";
		HTMLtext += "\t<tr>";
		HTMLtext += "<td>"+multilanguage.getMessage("com.search")+"</td>";
		HTMLtext += "<td>";
		HTMLtext += "<select name=\"search\" onchange=\"method.value='search';submit()\">";
		// adding <option>scegli...</option>
		HTMLtext += "<option value=\"\">"+multilanguage.getMessage("com.choose")+"...</option>";
		Iterator it = classCollection.iterator();
		ClassBean cb = null;
		ClassBean thiscb = null;
		while (it.hasNext()){
			cb = (ClassBean)it.next();
			HTMLtext += "<option value=\""+cb.getName()+"\">"+cb.getDescription()+"</option>";
			if (cb.getName().equals(className)){
				thiscb = cb;
			}
		}
		// patch thiscb
		if (thiscb==null){
			thiscb = new ClassBean();
			thiscb.setSuperClass(false);
		}
		HTMLtext += "</select>";
		HTMLtext += "</td>";
		HTMLtext += "</tr>\n";
		HTMLtext += "\t<tr><td colspan=\"2\"><hr width=\"100%\" style=\"color: #0066CC;\"></td></tr>\n";
		HTMLtext += "\t<tr><td>"+multilanguage.getMessage("com.name")+"</td><td><input type=\"text\" name=\"name\" value=\""+className+"\" disabled/></td></tr>\n";
		HTMLtext += "\t<tr><td>"+multilanguage.getMessage("com.description")+"</td><td><input type=\"text\" name=\"description\" value=\""+classDescription+"\" disabled/></td></tr>\n";
		if (thiscb.isSuperClass()){
			HTMLtext += "\t<tr><td>"+multilanguage.getMessage("com.superclass")+"</td><td><input type=\"checkbox\" name=\"superClass\" checked disabled/></td></tr>\n";
		} else {
			HTMLtext += "\t<tr><td>"+multilanguage.getMessage("com.superclass")+"</td><td><input type=\"checkbox\" name=\"superClass\" disabled/></td></tr>\n";
		}
		if (!superClass.getParent().equals("Class")){
			HTMLtext += "\t<tr>";
			HTMLtext += "<td>"+multilanguage.getMessage("HTMLclass.inherits")+"</td>";
			HTMLtext += "<td>";
			HTMLtext += "<select name=\"inherits\" disabled>";
			HTMLtext += "<option value=\""+superClass.getParent()+"\">"+superClass.getParentDescription()+"</option>";
			HTMLtext += "</select>";
			HTMLtext += "</td>";
			HTMLtext += "</tr>\n";
		}
		if (manager!=null && manager.equals("class")){
			HTMLtext += "\t<tr><td>"+multilanguage.getMessage("HTMLclass.manager")+"</td><td><select name=\"manager\" disabled><option value=\""+manager+"\"></option></select></td></tr>\n";
		} else {
			HTMLtext += "\t<tr><td>"+multilanguage.getMessage("HTMLclass.manager")+"</td><td><select name=\"manager\" disabled><option value=\""+manager+"\">"+manager+"</option></select></td></tr>\n";
		}
		HTMLtext += "\t<tr>";
		HTMLtext += "<td>"+multilanguage.getMessage("com.status")+"</td>";
		HTMLtext += "<td><select name=\"status\" disabled>";
		if (status.equals("active")){
			HTMLtext += "<option value=\"active\">"+multilanguage.getMessage("com.active")+"</option><option value=\"noactive\">"+multilanguage.getMessage("com.noactive")+"</option>";
		} else {
			HTMLtext += "<option value=\"noactive\">"+multilanguage.getMessage("com.noactive")+"</option><option value=\"active\">"+multilanguage.getMessage("com.active")+"</option>";
		}
		HTMLtext += "</select></td>";
		HTMLtext += "</tr>\n";
		HTMLtext += "\t<tr style=\"font-size:1px\"><td>&nbsp;</td><td>&nbsp;</td></tr>\n";
		HTMLtext += "</table>\n";
		return HTMLtext;
	}
	public String toClassCreate() {
		String HTMLtext = header.toForm();
		HTMLtext += "<table cellpadding=\"5\" cellspacing=\"0\">\n";
		HTMLtext += "\t<tr>";
		HTMLtext += "<td>"+multilanguage.getMessage("com.search")+"</td>";
		HTMLtext += "<td>";
		HTMLtext += "<select name=\"search\" onchange=\"method.value='search';submit()\">";
		// adding <option>scegli...</option>
		HTMLtext += "<option value=\"\">"+multilanguage.getMessage("com.choose")+"...</option>";
		Iterator it = classCollection.iterator();
		ClassBean cb = null;
		while (it.hasNext()){
			cb = (ClassBean)it.next();
			HTMLtext += "<option value=\""+cb.getName()+"\">"+cb.getDescription()+"</option>";
		}
		HTMLtext += "</select>";
		HTMLtext += "</td>";
		HTMLtext += "</tr>\n";
		HTMLtext += "\t<tr><td colspan=\"2\"><hr width=\"100%\" style=\"color: #0066CC;\"></td></tr>\n";
		HTMLtext += "\t<tr><td>"+multilanguage.getMessage("com.name")+"</td><td><input type=\"text\" name=\"name\" value=\""+className+"\" /></td></tr>\n";
		HTMLtext += "\t<tr><td>"+multilanguage.getMessage("com.description")+"</td><td><input type=\"text\" name=\"description\" value=\""+classDescription+"\" /></td></tr>\n";
		if (superClassOn){
			HTMLtext += "\t<tr><td>"+multilanguage.getMessage("com.superclass")+"</td><td><input type=\"checkbox\" name=\"superClass\" checked/></td></tr>\n";	
		} else {
			HTMLtext += "\t<tr><td>"+multilanguage.getMessage("com.superclass")+"</td><td><input type=\"checkbox\" name=\"superClass\" /></td></tr>\n";
		}
		// inherits
		HTMLtext += "\t<tr>";
		HTMLtext += "<td>"+multilanguage.getMessage("HTMLclass.inherits")+"</td>";
		HTMLtext += "<td>";
		HTMLtext += "<select name=\"inherits\" onchange=\"method.value='loaddefman';submit()\">";
		cb = null;
		// if is empty then add "Class"
		if (superCollection.toArray()!=null && (superCollection.toArray()).length==0){
			cb = new ClassBean();
			cb.setName("Class");
			cb.setDescription("");
			cb.setManager("class");
			superCollection.add(cb);
		}
		//Hashtable noDuplicates = new Hashtable();
		it = superCollection.iterator();
		while (it.hasNext()){
			cb = (ClassBean)it.next();
			if (cb.getName().equals("Class")){
				cb.setDescription("");
			}
			if (!cb.getName().equals(inherits)){
				HTMLtext += "<option value=\""+cb.getName()+"\">"+cb.getDescription()+"</option>";
			} else {
				HTMLtext += "<option value=\""+cb.getName()+"\" selected>"+cb.getDescription()+"</option>";	
			}
		}
		HTMLtext += "</select>";
		HTMLtext += "</td>";
		HTMLtext += "</tr>\n";
		// manager
		HTMLtext += "\t<tr>";
		HTMLtext += "<td>"+multilanguage.getMessage("HTMLclass.manager")+"</td>";
		HTMLtext += "<td>";
		HTMLtext += "<select name=\"manager\" onchange=\"method.value='loadman';submit()\">";
		it = managersList.iterator();
		String mli = "";
		while (it.hasNext()){
			mli = (String)it.next();
			if (manager!=null && manager.equals(mli)){
				if (mli.equals("class")){
					HTMLtext += "<option value=\""+mli+"\" selected></option>";	
				} else {
					HTMLtext += "<option value=\""+mli+"\" selected>"+mli+"</option>";
				}
			} else {
				if (mli.equals("class")){
					HTMLtext += "<option value=\""+mli+"\"></option>";	
				} else {
					HTMLtext += "<option value=\""+mli+"\">"+mli+"</option>";
				}
			}
		}
		HTMLtext += "</select>";
		HTMLtext += "</td>";
		HTMLtext += "</tr>\n";
		HTMLtext += "\t<tr>";
		HTMLtext += "<td>"+multilanguage.getMessage("com.status")+"</td>";
		HTMLtext += "<td><select name=\"status\">";
		HTMLtext += "<option value=\"active\">"+multilanguage.getMessage("com.active")+"</option><option value=\"noactive\">"+multilanguage.getMessage("com.noactive")+"</option>";
		HTMLtext += "</select></td>";
		HTMLtext += "</tr>\n";
		HTMLtext += "\t<tr>";
		HTMLtext += "<td><input type=\"button\" onclick=\"validate.value='true';method.value='create';submit();\" value=\""+multilanguage.getMessage("com.confirm")+"\" class=\"button\"></td>";
		HTMLtext += "<td><input type=\"button\" name=\"button\" onclick=\"location.href='class.jsp'\" value=\""+multilanguage.getMessage("com.cancel")+"\" class=\"button\"></td>";
		HTMLtext += "</tr>\n";
		HTMLtext += "\t<tr style=\"font-size:1px\"><td>&nbsp;</td><td>&nbsp;</td></tr>\n";
		HTMLtext += "</table>";
		return HTMLtext;
	}
	public String toClassModify() {
		String HTMLtext = header.toForm();
		HTMLtext += "<table cellpadding=\"5\" cellspacing=\"0\">\n";
		HTMLtext += "\t<tr>";
		HTMLtext += "<td>"+multilanguage.getMessage("com.search")+"</td>";
		HTMLtext += "<td>";
		HTMLtext += "<select name=\"search\" onchange=\"method.value='search';submit()\">";
		// adding <option>scegli...</option>
		HTMLtext += "<option value=\"\">"+multilanguage.getMessage("com.choose")+"...</option>";
		Iterator it = classCollection.iterator();
		ClassBean cb = null;
		ClassBean thiscb = null;
		while (it.hasNext()){
			cb = (ClassBean)it.next();
			HTMLtext += "<option value=\""+cb.getName()+"\">"+cb.getDescription()+"</option>";
			if (cb.getName().equals(className)){
				thiscb = cb;
			}
		}
		HTMLtext += "</select>";
		HTMLtext += "</td>";
		HTMLtext += "</tr>\n";
		HTMLtext += "\t<tr><td colspan=\"2\"><hr width=\"100%\" style=\"color: #0066CC;\"></td></tr>\n";
		HTMLtext += "\t<tr><td>"+multilanguage.getMessage("com.name")+"</td><td><input type=\"text\" name=\"name\" value=\""+className+"\"/></td></tr>\n";
		HTMLtext += "\t<tr><td>"+multilanguage.getMessage("com.description")+"</td><td><input type=\"text\" name=\"description\" value=\""+classDescription+"\"/></td></tr>\n";
		if (thiscb.isSuperClass()){
			HTMLtext += "\t<tr><td>"+multilanguage.getMessage("com.superclass")+"</td><td><input type=\"checkbox\" name=\"superClass\" checked/></td></tr>\n";
		} else {
			HTMLtext += "\t<tr><td>"+multilanguage.getMessage("com.superclass")+"</td><td><input type=\"checkbox\" name=\"superClass\"/></td></tr>\n";
		}
		if (!superClass.getParent().equals("Class")){
			HTMLtext += "\t<tr>";
			HTMLtext += "<td>"+multilanguage.getMessage("HTMLclass.inherits")+"</td>";
			HTMLtext += "<td>";
			HTMLtext += "<select name=\"inherits\" disabled>";
			HTMLtext += "<option value=\""+superClass.getParent()+"\">"+superClass.getParentDescription()+"</option>";
			HTMLtext += "</select>";
			HTMLtext += "</td>";
			HTMLtext += "</tr>\n";
		}
		HTMLtext += "\t<tr>";
		HTMLtext += "<td>"+multilanguage.getMessage("com.manager")+"</td>";
		HTMLtext += "<td>";
		HTMLtext += "<select name=\"manager\">";
		it = managersList.iterator();
		String mli = "";
		while (it.hasNext()){
			mli = (String)it.next();
			if (manager!=null && manager.equals(mli)){
				if (mli.equals("class")){
					HTMLtext += "<option value=\""+mli+"\" selected></option>";	
				} else {
					HTMLtext += "<option value=\""+mli+"\" selected>"+mli+"</option>";
				}
			} else {
				if (mli.equals("class")){
					HTMLtext += "<option value=\""+mli+"\"></option>";	
				} else {
					HTMLtext += "<option value=\""+mli+"\">"+mli+"</option>";
				}
			}
			/*
			if (!mli.equals(manager)){
				HTMLtext += "<option value=\""+mli+"\">"+mli+"</option>";	
			} else {
				HTMLtext += "<option value=\""+mli+"\" selected>"+mli+"</option>";
			}
			*/
		}
		HTMLtext += "</select>";
		HTMLtext += "</td>";
		HTMLtext += "</tr>\n";
		HTMLtext += "\t<tr>";
		HTMLtext += "<td>"+multilanguage.getMessage("com.status")+"</td>";
		HTMLtext += "<td><select name=\"status\">";
		if (status.equals("active")){
			HTMLtext += "<option value=\"active\">"+multilanguage.getMessage("com.active")+"</option><option value=\"noactive\">"+multilanguage.getMessage("com.noactive")+"</option>";
		} else {
			HTMLtext += "<option value=\"noactive\">"+multilanguage.getMessage("com.noactive")+"</option><option value=\"active\">"+multilanguage.getMessage("com.active")+"</option>";
		}
		HTMLtext += "</select></td>";
		HTMLtext += "</tr>\n";
		HTMLtext += "\t<tr>";
		HTMLtext += "<td><input type=\"button\" onclick=\"validate.value='true';method.value='modify';submit()\" value=\""+multilanguage.getMessage("com.confirm")+"\" class=\"button\"></td>";
		HTMLtext += "<td><input type=\"button\" name=\"button\" onclick=\"location.href='class.jsp'\" value=\""+multilanguage.getMessage("com.cancel")+"\" class=\"button\"></td>";
		HTMLtext += "</tr>\n";
		HTMLtext += "\t<tr style=\"font-size:1px\"><td>&nbsp;</td><td>&nbsp;</td></tr>\n";
		HTMLtext += "</table>\n";
		return HTMLtext;
	}
	public String toCardForm() {
		String HTMLtext = header.toForm();
		if (deleted){
			HTMLtext+="<table class=\"cardDeleted\">\n";
	    } else {
	    	HTMLtext+="<table class=\"card\">\n";
	    }
		HTMLtext+="\t<tr><td class=\"tdr40\">classe</td><td>"+classDescription+"</td></tr>\n";
		/*
		if (category==null){
			category = "&nbsp;";
		}
		HTMLtext+="\t<tr><td class=\"tdr40\">categoria</td><td>"+category+"</td></tr>\n";
		*/
		HTMLtext+="\t<tr><td colspan=\"2\"><hr style=\"color: #0066CC;\" width=\"99%\"></td></tr>\n";
		Enumeration enu = assetVector.elements();
		AssetBean obj = new AssetBean();
		Vector vett = null;
		Enumeration en = null;
		while (enu.hasMoreElements()){
			obj = (AssetBean)enu.nextElement();
			if (!obj.getName().equals("Id") && !obj.getName().equals("IdCategory") && !obj.getName().equals("Notes") && !obj.getName().equals("Status")){ // don't show these
				//System.out.println(obj.getName()+" is type in asset="+obj.getType());
				// if is lookup, gettting lookup
				if (obj.getType()==AttributeBean.LOOKUP){
					HTMLtext+="\t<tr><td class=\"tdr40\">"+obj.getDescription()+"</td>";
					HTMLtext+="<td>";
					en = lookupVector.elements();
					LookupBean lb = null;
					while ( (en!=null) && (en.hasMoreElements()) ){
						lb = (LookupBean)en.nextElement();
						if (obj.getValue()!=null){
							String id = ""+lb.getId(); 
							if (id.equals(obj.getValue())){
								HTMLtext+=lb.getDescription();
								break;
							}
						} else {
							HTMLtext+="&nbsp;";
							break;
						}
					}
					HTMLtext+="</td>";
					HTMLtext+="</tr>\n";
				} else if (obj.getType()==AttributeBean.REFERENCE){
					HTMLtext+="\t<tr><td class=\"tdr40\">"+obj.getDescription()+"</td>";
					HTMLtext+="<td>";
					if (referenceHash.containsKey(obj.getReference())){
						vett = (Vector) referenceHash.get(obj.getReference());
					} 
					if (vett!=null){
						en = vett.elements();
						LookupBean lb = null;
						while ( (en!=null) && (en.hasMoreElements()) ){
							lb = (LookupBean)en.nextElement();
							if (obj.getValue()!=null){
								String id = ""+lb.getId(); 
								if (id.equals(obj.getValue())){
									HTMLtext+=lb.getDescription();
									break;
								}
							} else {
								HTMLtext+="&nbsp;";
								break;
							}
						}
					} else {
						HTMLtext+="&nbsp;";
					}
					HTMLtext+="</td>";
					HTMLtext+="</tr>\n";
				} else if (obj.getValue()!=null && obj.getType()==AttributeBean.BOOLEAN){
					if (obj.getValue().equals("t") || obj.getValue().equals("true")){
						HTMLtext+="\t<tr><td class=\"tdr40\">"+obj.getDescription()+"</td><td>"+multilanguage.getMessage("com.yes")+"</td></tr>\n";	
					} else { // f || false
						HTMLtext+="\t<tr><td class=\"tdr40\">"+obj.getDescription()+"</td><td>"+multilanguage.getMessage("com.no")+"</td></tr>\n";
					}
				} else {
					if (obj.getValue()==null || obj.getValue().equals("")){ 
						HTMLtext+="\t<tr><td class=\"tdr40\">"+obj.getDescription()+"</td><td>&nbsp;</td></tr>\n";					
					} else {
						HTMLtext+="\t<tr><td class=\"tdr40\">"+obj.getDescription()+"</td><td>"+obj.getValue()+"</td></tr>\n";					
					}
				}
			}
		}
		HTMLtext+="</table>\n";
		return HTMLtext;
	}
	public String toCardFormMaster() {
		// getting template from toCardForm
		String HTMLtext = toCardForm();
		if (masterDetailMenu.size()>0){
			AttributeBean ab = null;
			Enumeration en = masterDetailMenu.elements();
			HTMLtext+= "<div class=\"masterdetailmenu\">\n";
			HTMLtext+= "\t<div class=\"masterA\"><a href=\"card.jsp?class="+className+"&page="+currentPage+"\">Home</a></div>";
			while (en.hasMoreElements()){
				ab = (AttributeBean) en.nextElement();
				HTMLtext+= "\t<div class=\"detailI\"><a href=\"card.jsp?class="+className+"&page="+currentPage+"&masterdetail="+ab.getClassBean().getName()+"&objid="+objId+"\">"+ab.getClassBean().getDescription()+"</a></div>";
			}
			HTMLtext+= "</div>\n";
		}
		return HTMLtext;
	}
	public String toCardFormDetail() {
		// transform Vector in Hashtable
		// creating lookup hash
		lookupHash = new Hashtable();
		referenceMap = new Hashtable();
		LookupBean lb = null;
		Enumeration en = null;
		if (lookupVector!=null){
			en = lookupVector.elements();
			while (en.hasMoreElements()){
				lb = (LookupBean)en.nextElement();
				if (!lookupHash.containsKey(lb.getId()+"")){
					lookupHash.put(lb.getId()+"",lb.getDescription());
				}
			}
		}
		// generate reference mapping
		Vector vett = new Vector();
		en = referenceHash.elements();
		while (en.hasMoreElements()){
			vett.addAll( (Vector)en.nextElement() );
		}
		en = vett.elements();
		while (en.hasMoreElements()){
			lb = (LookupBean)en.nextElement();
			referenceMap.put(lb.getId()+"",lb.getDescription());
		}
		String HTMLtext = header.toForm();
		Vector assetVector = null;
		AssetBean as = null;
		if(reportVector==null){
			System.out.println("reportVector==null");
		}
    	if(reportVector!=null){
    		totalPages = reportVector.size();
			int tot = totalPages/resultsForPage;
			System.out.println(totalPages+"/"+resultsForPage+"tot="+tot);
			if (totalPages%resultsForPage!=0){
				tot++;
			}
			int first,prev,next,last;
			first = 1;
			if (subpage>1){
				prev=subpage-1;
			} else {
				prev = 1;
			}
			if (subpage<tot){
				next=subpage+1;
			} else {
				next = tot;
			}
			last = tot;
			if (tot==0){
				subpage=0;
			} else if (tot==1){
				subpage = 1;
			}
			// subpages arrows
			if (tot>1){
				HTMLtext+= "<table><tr><td colspan=\"5\">"+multilanguage.getMessage("HTMLclass.atpage")+" <input type=\"text\" size=\"3\" name=\"pagina\" maxlength=\"3\" value=\""+subpage+"\" onkeypress=\"goTo(event,"+first+","+last+")\"> di "+tot;
				HTMLtext+= "<a href=\"card.jsp?class="+className+"&mode=show&subpage="+first+"&masterdetail="+masterDetail+"&objid="+objId+"\"><img src=\"images/ico_first.gif\" alt=\"first\" title=\"first\"></a><a href=\"card.jsp?class="+className+"&mode=show&subpage="+prev+"&masterdetail="+masterDetail+"&objid="+objId+"\"><img src=\"images/ico_prev.gif\" alt=\"previous\" title=\"previous\"></a><a href=\"card.jsp?class="+className+"&mode=show&subpage="+next+"&masterdetail="+masterDetail+"&objid="+objId+"\"><img src=\"images/ico_next.gif\" alt=\"next\" title=\"next\"></a><a href=\"card.jsp?class="+className+"&mode=show&subpage="+last+"&masterdetail="+masterDetail+"&objid="+objId+"\"><img src=\"images/ico_last.gif\" alt=\"last\" title=\"last\"></a>";
				HTMLtext+= "</td></tr></table>";
			}
 	    	HTMLtext+="<table class=\"show\" cellpadding=\"0\" cellspacing=\"0\">\n";
 			// creating header of the table
 			en = thVector.elements();
 			HTMLtext+="<th>N.</th>\n";
 			AttributeBean ab = null;
 			while (en.hasMoreElements()){
				ab = (AttributeBean)en.nextElement();
				if (!ab.getName().equals("Id") && !ab.getName().equals("IdClass")){
					if (ab.getBaseDSP().equals("true")){
	 					HTMLtext+="<th>"+ab.getDescription()+"</th>";
					}
				}
 			}
 			HTMLtext+="<th>&nbsp;</th>\n";
 			// creating the table
 			String value="";
 			Enumeration enr = reportVector.elements();
 			int page=0;
 			if (subpage!=0){
 				page = (subpage-1)*resultsForPage;
 			}
 			int count = 0;
 			while (enr.hasMoreElements()){
 				page++;
 				count++;
				assetVector = (Vector)enr.nextElement();
 				as = (AssetBean)assetVector.elementAt(0); // id
 				int id = 0;
 				if (as!=null){
 	 				id = Integer.parseInt(as.getValue());
 				}
 				as = (AssetBean)assetVector.elementAt(1); // classid
 				int classid = 0;
 				if (as!=null){
 	 				classid = Integer.parseInt(as.getValue());
 				}
				HTMLtext+="<tr>";
				HTMLtext+="<td><a href=\"javascript:void(0);\" onclick=\"window.open('popupinfocard.jsp?class="+masterDetail+"&classid=&objid="+id+"','popupinfo','height=600,width=600,status=no,toolbar=no,menubar=no,scrollbars=yes,location=no,resizable');\">"+count+"</a></td>";
 				Enumeration eni = assetVector.elements();
 				while(eni.hasMoreElements()){
 					as = (AssetBean)eni.nextElement();
 					if (!as.getName().equals("Id") && !as.getName().equals("IdClass")){
 						if (as.getBaseDSP().equals("true")){
 							value = as.getValue();
 							if (value==null || value.equals("")){
 								value="&nbsp;";
 							} else if(as.getType()==AttributeBean.LOOKUP){
 								value = (String)lookupHash.get(value);
							} else if(as.getType()==AttributeBean.REFERENCE){
 								value = (String)referenceMap.get(value);
 							}
							HTMLtext+="<td>"+value+"</td>";
 						}
 					}
 				}
				HTMLtext+="<td class=\"fixed\">";
				if (user!=null && user.isAllowed(className,2)){
					HTMLtext+="<a href=\"javascript:void(0);\" onclick=\"window.open('cardpopup.jsp?mode=modify&masterclass="+className+"&masterobjid="+objId+"&detailclass="+masterDetail+"&detailobjid="+id+"&classid="+classid+"',null,'height=400,width=450,status=no,toolbar=no,scrollbars=yes,menubar=no,location=no,resizable');\"><img class=\"icon\" src=\"images/ico_edit.gif\" alt=\"edit\" title=\"edit\"></a>";
					HTMLtext+=" <a href=\"javascript:javascript:if (confirm('"+multilanguage.getMessage("com.areyousure")+"')){cardForm.targetClass.value='"+classid+"';cardForm.targetObjId.value='"+id+"';cardForm.method.value='deletedetail';cardForm.submit();}\"><img class=\"icon\" src=\"images/ico_del.gif\" alt=\"del\" title=\"del\"></a> ";
				} else {
					HTMLtext+="<a href=\"javascript:alert('"+multilanguage.getMessage("com.youhavenopermission")+"');\"><img class=\"icon\" src=\"images/ico_edit.gif\" alt=\"edit\" title=\"edit\"></a>";
					HTMLtext+=" <a href=\"javascript:alert('"+multilanguage.getMessage("com.youhavenopermission")+"');\"><img class=\"icon\" src=\"images/ico_del.gif\" alt=\"del\" title=\"del\"></a> ";
				}
				if (user!=null && user.isAllowed(className,1)){
					HTMLtext+=" <a href=\"javascript:cardForm.targetClass.value='"+classid+"';cardForm.targetObjId.value='"+id+"';cardForm.method.value='gotopage';cardForm.submit()\"><img class=\"icon\" src=\"images/ico_link.gif\" alt=\"go to\" title=\"go to\"></a> ";	
				} else {
					HTMLtext+=" <a href=\"javascript:alert('"+multilanguage.getMessage("com.youhavenopermission")+"');\"><img class=\"icon\" src=\"images/ico_link.gif\" alt=\"go to\" title=\"go to\"></a> ";
				}
				
				HTMLtext+="</td>";
				HTMLtext+="</tr>\n";
			}	
 			HTMLtext+="</table>\n";
    	}
		if (masterDetailMenu.size()>0){
			AttributeBean ab = null;
			en = masterDetailMenu.elements();
			HTMLtext+= "<div class=\"masterdetailmenu\">\n";
			HTMLtext+= "\t<div class=\"masterI\"><a href=\"card.jsp?class="+className+"&page="+currentPage+"\">Home</a></div>";
			while (en.hasMoreElements()){
				ab = (AttributeBean) en.nextElement();
				if (!masterDetail.equals(ab.getClassBean().getName())){
					HTMLtext+= "\t<div class=\"detailI\"><a href=\"card.jsp?class="+className+"&page="+currentPage+"&masterdetail="+ab.getClassBean().getName()+"&objid="+objId+"\">"+ab.getClassBean().getDescription()+"</a></div>";	
				} else {
					HTMLtext+= "\t<div class=\"detailA\"><a href=\"card.jsp?class="+className+"&page="+currentPage+"&masterdetail="+ab.getClassBean().getName()+"&objid="+objId+"\">"+ab.getClassBean().getDescription()+"</a></div>";
				}
			}
			HTMLtext+= "</div>\n";
		}
		return HTMLtext;
	}
	public String toCardCreate() {
		// removing lookups which state is not Active
		if (lookupVector!=null){
			int i = 0;
			LookupBean rlb = null;
			Enumeration eni = lookupVector.elements();
			while (eni.hasMoreElements()){
				rlb = (LookupBean)eni.nextElement();
				if (!rlb.getStatus().equals("A")){
					System.out.println("Asset, removing lookup "+rlb.getType()+" "+rlb.getDescription());
					lookupVector.remove(i);
				}
				i++;
			}
		}
		String HTMLtext = "";
		if (toPaste){ // use toCardModify instead
			String re = toCardModify();
			// replace buttons of toCardModify
			if (re.indexOf("onclick=\"method.value='modify';submit()\"")!=-1){
				System.out.println("toCardCreate found modify");
			}
			String old = "onclick=\"method.value='modify';submit()\"";
			String nuo = "onclick=\"method.value='create';submit()\"";
			StringBuffer ol = new StringBuffer(old);
			StringBuffer nu = new StringBuffer(nuo);
			re = re.replace(ol,nu);
			System.out.println("toCardCreate replacing");
			if (re.indexOf("onclick=\"method.value='modify';submit()\"")!=-1){
				System.out.println("toCardCreate found modify");
			}
			HTMLtext = re;
			return HTMLtext;
		}
		HTMLtext = header.toForm();
		HTMLtext+="<table class=\"card\">\n";
		HTMLtext+="\t<tr><td class=\"tdr50\">"+multilanguage.getMessage("com.class")+"</td>";
		if (classCollection!=null){
			HTMLtext+="<td><select name=\"search\" onchange=\"method.value='search';submit()\">";
			Iterator it = classCollection.iterator();
			while (it.hasNext()){
				ClassBean cb = (ClassBean)it.next();
				if (cb.getName().equals(className)){
					HTMLtext+="<option selected>"+cb.getName()+"</option>";
				} else {
					HTMLtext+="<option>"+cb.getName()+"</option>";
				}
			}
			HTMLtext+="</select>";
			HTMLtext+="</td></tr>\n";
		}
		HTMLtext+="\t<tr><td colspan=\"2\"><hr style=\"color: #0066CC;\" width=\"99%\"></td></tr>\n";
		// repeated buttons
		HTMLtext+="\t<tr>";
		HTMLtext+="<td class=\"tdr50\">&nbsp;</td>"; 
		if (user!=null && user.isAllowed(className,2)){
			HTMLtext+="<td><input type=\"button\" name=\"button\" value=\""+multilanguage.getMessage("com.confirm")+"\" onclick=\"method.value='create';submit()\" value=\""+multilanguage.getMessage("com.confirm")+"\" class=\"button\">&nbsp;<input type=\"button\" name=\"button\" value=\""+multilanguage.getMessage("com.cancel")+"\" onclick=\"javascript:location.href='card.jsp?mode=show';\" value=\""+multilanguage.getMessage("com.cancel")+"\" class=\"button\"></td>";
		} else {
			HTMLtext+="<td><input type=\"button\" name=\"button\" value=\""+multilanguage.getMessage("com.confirm")+"\" onclick=\"javascript:alert('"+multilanguage.getMessage("com.youhavenopermission")+"');\" value=\""+multilanguage.getMessage("com.confirm")+"\" class=\"button\">&nbsp;<input type=\"button\" name=\"button\" value=\""+multilanguage.getMessage("com.cancel")+"\" onclick=\"javascript:location.href='card.jsp?mode=show';\" value=\""+multilanguage.getMessage("com.cancel")+"\" class=\"button\"></td>";
		}
		HTMLtext+="</tr>\n";
		Enumeration e = assetVector.elements();
		AssetBean obj = new AssetBean();
		boolean manda = false;
		Vector vett = null;
		Enumeration en = null;
		String str = "";
		int target = 0;
		while (e.hasMoreElements()){
			obj = (AssetBean)e.nextElement();
			if (!obj.getName().equals("Id") && !obj.getName().equals("IdCategory") && !obj.getName().equals("Notes") && !obj.getName().equals("Status")){ // don't show these
				//System.out.println("obj type in asset="+obj.getType());
				manda = ( obj.getMandatory().equals("Y")?true:false );
				if (obj.getType()==AttributeBean.LOOKUP){
					if (!manda){
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+"</td>";	
					} else {
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+" *</td>";
					}
					HTMLtext+="<td><select name=\""+obj.getName()+"\">";
					// adding "" option
					HTMLtext+="<option></option>";
					en = lookupVector.elements();
					LookupBean lb = null;
					while ( (en!=null) && (en.hasMoreElements()) ){
						lb = (LookupBean)en.nextElement();
						if (lb.getType().equals(obj.getLookup())){
							if (lb.getType().equals(obj.getLookup())){
								str = obj.getDefaultValue();
								if (str!=null && str.length()>0){
									try {
										target = Integer.parseInt(str);
									} catch (NumberFormatException e1) {
										e1.printStackTrace();
										target = 0;
									}
									if (target==lb.getId()){
										HTMLtext+="<option value=\""+lb.getId()+"\" selected>"+lb.getDescription()+"</option>";
									} else {
										HTMLtext+="<option value=\""+lb.getId()+"\">"+lb.getDescription()+"</option>";
									}
								} else {
									HTMLtext+="<option value=\""+lb.getId()+"\">"+lb.getDescription()+"</option>";
								}
							}
						}
					}
					HTMLtext+="</select></td>";
					HTMLtext+="</tr>\n";
				} else if (obj.getType()==AttributeBean.REFERENCE){
					if (!manda){
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+"</td>";	
					} else {
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+" *</td>";
					}
					HTMLtext+="<td><select name=\""+obj.getName()+"\">";
					// adding "" option
					HTMLtext+="<option></option>";
					if (referenceHash.containsKey(obj.getReference())){
						vett = (Vector) referenceHash.get(obj.getReference());
					} 
					if (vett!=null){
						en = vett.elements();
						LookupBean lb = null;
						while ( (en!=null) && (en.hasMoreElements()) ){
							lb = (LookupBean)en.nextElement();
							if (lb.getType().equals(obj.getReference())){
								str = obj.getDefaultValue();
								if (str!=null && str.length()>0){
									try {
										target = Integer.parseInt(str);
									} catch (NumberFormatException e1) {
										e1.printStackTrace();
										target = 0;
									}
									if (target==lb.getId()){
										HTMLtext+="<option value=\""+lb.getId()+"\" selected>"+lb.getDescription()+"</option>";
									} else {
										HTMLtext+="<option value=\""+lb.getId()+"\">"+lb.getDescription()+"</option>";
									}
								} else {
									HTMLtext+="<option value=\""+lb.getId()+"\">"+lb.getDescription()+"</option>";
								}
							}
						}
					}
					HTMLtext+="</select></td>";
					HTMLtext+="</tr>\n";
				} else if( obj.getType()==AttributeBean.DATE ){
					if (!manda){
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+"</td>";	
					} else {
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+" *</td>";
					}
					HTMLtext+="<td><input type=\"text\" name=\""+obj.getName()+"\" readonly value=\""+obj.getDefaultValue()+"\">";
					HTMLtext+="<a href=\"javascript:showCalendarControl(document."+formName+"."+obj.getName()+");\"><img src=\"images/cal.gif\" alt=\"calendario\" title=\"calendario\" border=\"0\"></a>";
					if (obj.isDateExpire()){
						HTMLtext+=" "+multilanguage.getMessage("HTMLclass.dayswarning")+"<input type=\"text\" name=\""+obj.getName()+"datewarning\" size=\"4\" maxlength=\"4\">";
					}
					HTMLtext+="</td></tr>\n";
				} else if( obj.getType()==AttributeBean.TIMESTAMP ){
					if (!manda){
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+"</td>";
					} else {
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+" *</td>";
					}
					HTMLtext+="<td><input type=\"text\" name=\""+obj.getName()+"\" readonly value=\""+obj.getDefaultValue()+"\">";
					HTMLtext+="<a href=\"javascript:showCalendarControlT(document."+formName+"."+obj.getName()+");\"><img src=\"images/cal.gif\" alt=\"calendario\" title=\"calendario\" border=\"0\"></a></td></tr>\n";
				} else if(obj.getType()==AttributeBean.BOOLEAN){
					if (!manda){
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+"</td>";
					} else {
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+" *</td>";
					}
					HTMLtext+="<td><select name=\""+obj.getName()+"\"><option value=\"S\">"+multilanguage.getMessage("com.yes")+"</option><option value=\"N\">"+multilanguage.getMessage("com.no")+"</option></select></td></tr>\n";
				} else if( obj.getType()==AttributeBean.TEXT ){
					HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+"</td>";
					HTMLtext+="<td><textarea name=\""+obj.getName()+"\" cols=\"25\" rows=\"2\">"+obj.getDefaultValue()+"</textarea></td></tr>\n";
				} else if (obj.getType()==AttributeBean.STRING){
					if (!manda){
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+"</td>";
					} else {
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+" *</td>";
					}
					HTMLtext+="<td><input type=\"text\" name=\""+obj.getName()+"\" value=\""+obj.getDefaultValue()+"\" maxlength=\""+obj.getLength()+"\"></td></tr>\n";	
				} else {
					if (!manda){
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+"</td>";
					} else {
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+" *</td>";
					}
					HTMLtext+="<td><input type=\"text\" name=\""+obj.getName()+"\" value=\""+obj.getDefaultValue()+"\"></td></tr>\n";
				}
			}
		}	
		// repeated buttons
		HTMLtext+="\t<tr>";
		HTMLtext+="<td class=\"tdr50\">&nbsp;</td>"; 
		if (user!=null && user.isAllowed(className,2)){
			HTMLtext+="<td><input type=\"button\" name=\"button\" value=\""+multilanguage.getMessage("com.confirm")+"\" onclick=\"method.value='create';submit()\" value=\""+multilanguage.getMessage("com.confirm")+"\" class=\"button\">&nbsp;<input type=\"button\" name=\"button\" value=\""+multilanguage.getMessage("com.cancel")+"\" onclick=\"javascript:location.href='card.jsp?mode=show';\" value=\""+multilanguage.getMessage("com.cancel")+"\" class=\"button\"></td>";
		} else {
			HTMLtext+="<td><input type=\"button\" name=\"button\" value=\""+multilanguage.getMessage("com.confirm")+"\" onclick=\"javascript:alert('"+multilanguage.getMessage("com.youhavenopermission")+"');\" value=\""+multilanguage.getMessage("com.confirm")+"\" class=\"button\">&nbsp;<input type=\"button\" name=\"button\" value=\""+multilanguage.getMessage("com.cancel")+"\" onclick=\"javascript:location.href='card.jsp?mode=show';\" value=\""+multilanguage.getMessage("com.cancel")+"\" class=\"button\"></td>";
		}
		HTMLtext+="</tr>\n";
		HTMLtext+="</table>\n";
		return HTMLtext;
	}
	public String toCardCreateDetail() {
		// removing lookups which state is not Active
		if (lookupVector!=null){
			int i = 0;
			LookupBean rlb = null;
			Enumeration eni = lookupVector.elements();
			while (eni.hasMoreElements()){
				rlb = (LookupBean)eni.nextElement();
				if (!rlb.getStatus().equals("A")){
					System.out.println("Asset, removing lookup "+rlb.getType()+" "+rlb.getDescription());
					lookupVector.remove(i);
				}
				i++;
			}
		}
		String HTMLtext = "";
		HTMLtext = header.toForm();
		HTMLtext+="<table class=\"card\">\n";
		HTMLtext+="\t<tr><td class=\"tdr50\">"+multilanguage.getMessage("com.class")+"</td>";
		if (classCollection!=null){
			HTMLtext+="<td><select name=\"search\" onchange=\"method.value='search';submit()\">";
			Iterator it = classCollection.iterator();
			while (it.hasNext()){
				ClassBean cb = (ClassBean)it.next();
				if (cb.getName().equals(className)){
					HTMLtext+="<option selected>"+cb.getName()+"</option>";
				} else {
					HTMLtext+="<option>"+cb.getName()+"</option>";
				}
			}
			HTMLtext+="</select>";
			HTMLtext+="</td></tr>\n";
		} else {
			HTMLtext+="<td>"+classDescription+"</td></tr>\n";
		}
		HTMLtext+="\t<tr><td colspan=\"2\"><hr style=\"color: #0066CC;\" width=\"99%\"></td></tr>\n";
		// repeated buttons
		HTMLtext+="\t<tr>";
		HTMLtext+="<td class=\"tdr50\">&nbsp;</td>"; 
		if (user!=null && user.isAllowed(className,2)){
			HTMLtext+="<td><input type=\"button\" name=\"button\" value=\""+multilanguage.getMessage("com.confirm")+"\" onclick=\"method.value='create';submit()\" value=\""+multilanguage.getMessage("com.confirm")+"\" class=\"button\">&nbsp;<input type=\"button\" name=\"button\" value=\""+multilanguage.getMessage("com.close")+"\" onclick=\"javascript:window.close();\" class=\"button\"></td>";
		} else {
			HTMLtext+="<td><input type=\"button\" name=\"button\" value=\""+multilanguage.getMessage("com.confirm")+"\" onclick=\"javascript:alert('"+multilanguage.getMessage("com.youhavenopermission")+"');\" class=\"button\">&nbsp;<input type=\"button\" name=\"button\" value=\""+multilanguage.getMessage("com.close")+"\" onclick=\"javascript:window.close();\" class=\"button\"></td>";
		}
		HTMLtext+="</tr>\n";
		Enumeration e = assetVector.elements();
		AssetBean obj = new AssetBean();
		boolean manda = false;
		Vector vett = null;
		Enumeration en = null;
		String str = "";
		int target = 0;
		while (e.hasMoreElements()){
			obj = (AssetBean)e.nextElement();
			if (!obj.getName().equals("Id") && !obj.getName().equals("IdCategory") && !obj.getName().equals("Notes") && !obj.getName().equals("Status")){ // don't show these
				//System.out.println("obj type in asset="+obj.getType());
				manda = ( obj.getMandatory().equals("Y")?true:false );
				if (obj.getType()==AttributeBean.LOOKUP){
					if (!manda){
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+"</td>";	
					} else {
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+" *</td>";
					}
					HTMLtext+="<td><select name=\""+obj.getName()+"\">";
					// adding "" option
					HTMLtext+="<option></option>";
					en = lookupVector.elements();
					LookupBean lb = null;
					while ( (en!=null) && (en.hasMoreElements()) ){
						lb = (LookupBean)en.nextElement();
						if (lb.getType().equals(obj.getLookup())){
							if (lb.getType().equals(obj.getLookup())){
								str = obj.getDefaultValue();
								if (str!=null && str.length()>0){
									try {
										target = Integer.parseInt(str);
									} catch (NumberFormatException e1) {
										e1.printStackTrace();
										target = 0;
									}
									if (target==lb.getId()){
										HTMLtext+="<option value=\""+lb.getId()+"\" selected>"+lb.getDescription()+"</option>";
									} else {
										HTMLtext+="<option value=\""+lb.getId()+"\">"+lb.getDescription()+"</option>";
									}
								} else {
									HTMLtext+="<option value=\""+lb.getId()+"\">"+lb.getDescription()+"</option>";
								}
							}
						}
					}
					HTMLtext+="</select></td>";
					HTMLtext+="</tr>\n";
				} else if (obj.getType()==AttributeBean.REFERENCE){
					if (!manda){
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+"</td>";	
					} else {
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+" *</td>";
					}
					HTMLtext+="<td><select name=\""+obj.getName()+"\">";
					// adding "" option
					//HTMLtext+="<option></option>";
					if (referenceHash.containsKey(obj.getReference())){
						vett = (Vector) referenceHash.get(obj.getReference());
					} 
					if (vett!=null){
						en = vett.elements();
						LookupBean lb = null;
						while ( (en!=null) && (en.hasMoreElements()) ){
							lb = (LookupBean)en.nextElement();
							if (lb.getType().equals(obj.getReference())){
								str = obj.getDefaultValue();
								System.out.println("CCD val"+obj.getValue()+" defval="+obj.getDefaultValue()+" refId="+referenceId+" lbId="+lb.getId());
								if (referenceId==lb.getId()){
									HTMLtext+="<option value=\""+lb.getId()+"\" selected>"+lb.getDescription()+"</option>";
								} else {
									//HTMLtext+="<option value=\""+lb.getId()+"\">"+lb.getDescription()+"</option>";
								}
								/*
								if (str!=null && str.length()>0){
									try {
										target = Integer.parseInt(str);
									} catch (NumberFormatException e1) {
										e1.printStackTrace();
										target = 0;
									}
									if (referenceId==lb.getId()){
										HTMLtext+="<option value=\""+lb.getId()+"\" selected>"+lb.getDescription()+"</option>";
									} else {
										//HTMLtext+="<option value=\""+lb.getId()+"\">"+lb.getDescription()+"</option>";
									}
								} else {
									//HTMLtext+="<option value=\""+lb.getId()+"\">"+lb.getDescription()+"</option>";
								}
								*/
							}
						}
					}
					HTMLtext+="</select></td>";
					HTMLtext+="</tr>\n";
				} else if( obj.getType()==AttributeBean.DATE ){
					if (!manda){
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+"</td>";	
					} else {
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+" *</td>";
					}
					HTMLtext+="<td><input type=\"text\" name=\""+obj.getName()+"\" readonly value=\""+obj.getDefaultValue()+"\">";
					HTMLtext+="<a href=\"javascript:showCalendarControl(document."+formName+"."+obj.getName()+");\"><img src=\"images/cal.gif\" alt=\"calendario\" title=\"calendario\" border=\"0\"></a>";
					if (obj.isDateExpire()){
						HTMLtext+="<input type=\"text\" name=\""+obj.getName()+"datewarning\">";
					}
					HTMLtext+="</td></tr>\n";
				} else if( obj.getType()==AttributeBean.TIMESTAMP ){
					if (!manda){
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+"</td>";
					} else {
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+" *</td>";
					}
					HTMLtext+="<td><input type=\"text\" name=\""+obj.getName()+"\" readonly value=\""+obj.getDefaultValue()+"\">";
					HTMLtext+="<a href=\"javascript:showCalendarControlT(document."+formName+"."+obj.getName()+");\"><img src=\"images/cal.gif\" alt=\"calendario\" title=\"calendario\" border=\"0\"></a></td></tr>\n";
				} else if(obj.getType()==AttributeBean.BOOLEAN){
					if (!manda){
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+"</td>";
					} else {
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+" *</td>";
					}
					HTMLtext+="<td><select name=\""+obj.getName()+"\"><option value=\"S\">"+multilanguage.getMessage("com.yes")+"</option><option value=\"N\">"+multilanguage.getMessage("com.no")+"</option></select></td></tr>\n";
				} else if( obj.getType()==AttributeBean.TEXT ){
					HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+"</td>";
					HTMLtext+="<td><textarea name=\""+obj.getName()+"\" cols=\"25\" rows=\"2\">"+obj.getDefaultValue()+"</textarea></td></tr>\n";
				} else if (obj.getType()==AttributeBean.STRING){
					if (!manda){
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+"</td>";
					} else {
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+" *</td>";
					}
					HTMLtext+="<td><input type=\"text\" name=\""+obj.getName()+"\" value=\""+obj.getDefaultValue()+"\" maxlength=\""+obj.getLength()+"\"></td></tr>\n";	
				} else {
					if (!manda){
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+"</td>";
					} else {
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+" *</td>";
					}
					HTMLtext+="<td><input type=\"text\" name=\""+obj.getName()+"\" value=\""+obj.getDefaultValue()+"\"></td></tr>\n";
				}
			}
		}	
		// repeated buttons
		HTMLtext+="\t<tr>";
		HTMLtext+="<td class=\"tdr50\">&nbsp;</td>"; 
		if (user!=null && user.isAllowed(className,2)){
			HTMLtext+="<td><input type=\"button\" name=\"button\" value=\""+multilanguage.getMessage("com.confirm")+"\" onclick=\"method.value='create';submit()\" value=\""+multilanguage.getMessage("com.confirm")+"\" class=\"button\">&nbsp;<input type=\"button\" name=\"button\" value=\""+multilanguage.getMessage("com.close")+"\" onclick=\"javascript:window.close();\" class=\"button\"></td>";
		} else {
			HTMLtext+="<td><input type=\"button\" name=\"button\" value=\""+multilanguage.getMessage("com.confirm")+"\" onclick=\"javascript:alert('"+multilanguage.getMessage("com.youhavenopermission")+"');\" class=\"button\">&nbsp;<input type=\"button\" name=\"button\" value=\""+multilanguage.getMessage("com.close")+"\" onclick=\"javascript:window.close();\" class=\"button\"></td>";
		}
		HTMLtext+="</tr>\n";
		HTMLtext+="</table>\n";
		return HTMLtext;
	}
	public String toCardFilter() {
		// String HTMLtext = super.toForm(); // header
		String HTMLtext = "";
		HTMLtext+="<table class=\"card\">\n";
		HTMLtext+="\t<tr><td class=\"tdr30\">"+multilanguage.getMessage("com.class")+"</td>";
		HTMLtext+="<td><select name=\"f_className\"><option>"+multilanguage.getMessage("com.equal")+"</option></select></td>";
		HTMLtext+="<td><select name=\"search\" onchange=\"method.value='search';submit()\">";
		HTMLtext+="<option>"+className+"</option>";
		HTMLtext+="</select>";
		HTMLtext+="</td></tr>\n";
		HTMLtext+="\t<tr><td colspan=\"3\"><hr style=\"color: #0066CC;\" width=\"99%\"></td></tr>\n";
		// repeated buttons
		HTMLtext+="\t<tr>";
		HTMLtext+="<td class=\"tdr30\">&nbsp;</td>";
		HTMLtext+="<td>&nbsp;</td>";
		HTMLtext+="<td><input type=\"button\" name=\"button\" value=\"cerca\" onclick=\"method.value='filter';submit()\" value=\""+multilanguage.getMessage("com.confirm")+"\" class=\"button\">&nbsp;<input type=\"button\" name=\"button\" value=\""+multilanguage.getMessage("com.cancel")+"\" onclick=\"this.form.reset();\" value=\""+multilanguage.getMessage("com.cancel")+"\" class=\"button\"></td>";
		HTMLtext+="</tr>\n";
		Enumeration e = assetVector.elements();
		AssetBean obj = new AssetBean();
		Vector vett = null;
		Enumeration en = null;
		while (e.hasMoreElements()){
			obj = (AssetBean)e.nextElement();
			if (!obj.getName().equals("Id") && !obj.getName().equals("IdCategory") && !obj.getName().equals("Notes") && !obj.getName().equals("Status")){ // don't show these
				if (obj.getType()==AttributeBean.LOOKUP){
					HTMLtext+="\t<tr><td class=\"tdr30\">"+obj.getDescription()+"</td>";
					HTMLtext+="<td><select name=\"f_"+obj.getName()+"\"><option>"+multilanguage.getMessage("com.equal")+"</option></select></td>";
					HTMLtext+="<td><select name=\""+obj.getName()+"\">";
					// adding "" option
					HTMLtext+="<option></option>";
					en = lookupVector.elements();
					LookupBean lb = null;
					while ( (en!=null) && (en.hasMoreElements()) ){
						lb = (LookupBean)en.nextElement();
						//System.out.println("lb.getLtype="+lb.getLType()+" obj.getALookup()"+obj.getALookup());
						if (lb.getType().equals(obj.getLookup())){
							HTMLtext+="<option value=\""+lb.getId()+"\">"+lb.getDescription()+"</option>";
						}
					}
					HTMLtext+="</select></td>";
					HTMLtext+="</tr>\n";
				} else if (obj.getType()==AttributeBean.REFERENCE){
					HTMLtext+="\t<tr><td class=\"tdr30\">"+obj.getDescription()+"</td>";
					HTMLtext+="<td><select name=\"f_"+obj.getName()+"\"><option>"+multilanguage.getMessage("com.equal")+"</option></select></td>";
					HTMLtext+="<td><select name=\""+obj.getName()+"\">";
					// adding "" option
					HTMLtext+="<option></option>";
					if (referenceHash.containsKey(obj.getReference())){
						vett = (Vector) referenceHash.get(obj.getReference());
					} 
					if (vett!=null){
						en = vett.elements();
						LookupBean lb = null;
						while ( (en!=null) && (en.hasMoreElements()) ){
							lb = (LookupBean)en.nextElement();
							//System.out.println("lb.getLtype="+lb.getLType()+" obj.getALookup()"+obj.getALookup());
							if (lb.getType().equals(obj.getReference())){
								HTMLtext+="<option value=\""+lb.getId()+"\">"+lb.getDescription()+"</option>";
							}
						}
					}
					HTMLtext+="</select></td>";
					HTMLtext+="</tr>\n";
				} else if( obj.getType()==AttributeBean.STRING ){
					HTMLtext+="\t<tr><td class=\"tdr30\">"+obj.getDescription()+"</td>";
					HTMLtext+="<td><select name=\"f_"+obj.getName()+"\"><option>"+multilanguage.getMessage("com.equal")+"</option><option>"+multilanguage.getMessage("com.contains")+"</option><option>"+multilanguage.getMessage("com.startswith")+"</option></select></td>";
					HTMLtext+="<td><input type=\"text\" name=\""+obj.getName()+"\"></td></tr>\n";
				} else if( obj.getType()==AttributeBean.TEXT ){
					HTMLtext+="\t<tr><td class=\"tdr30\">"+obj.getDescription()+"</td>";
					HTMLtext+="<td><select name=\"f_"+obj.getName()+"\"><option>"+multilanguage.getMessage("com.equal")+"</option><option>"+multilanguage.getMessage("com.contains")+"</option><option>"+multilanguage.getMessage("com.startswith")+"</option></select></td>";
					HTMLtext+="<td><textarea name=\""+obj.getName()+"\" cols=\"25\" rows=\"2\"></textarea></td></tr>\n";
				} else if( obj.getType()==AttributeBean.DATE ){ 
					HTMLtext+="\t<tr><td class=\"tdr30\">"+obj.getDescription()+"</td>";
					HTMLtext+="<td><select name=\"f_"+obj.getName()+"\"><option value=\"=\">"+multilanguage.getMessage("com.equal")+"</option><option value=\">\">"+multilanguage.getMessage("com.greater")+"</option><option value=\"<\">"+multilanguage.getMessage("com.minor")+"</option></select></td>";
					HTMLtext+="<td><input type=\"text\" name=\""+obj.getName()+"\" readonly>";
					HTMLtext+="<a href=\"javascript:showCalendarControl(document."+formName+"."+obj.getName()+");\"><img src=\"images/cal.gif\" alt=\"calendario\" title=\"calendario\" border=\"0\"></a></td></tr>\n";
				} else if( obj.getType()==AttributeBean.TIMESTAMP ){ 
					HTMLtext+="\t<tr><td class=\"tdr30\">"+obj.getDescription()+"</td>";
					HTMLtext+="<td><select name=\"f_"+obj.getName()+"\"><option value=\"=\">"+multilanguage.getMessage("com.equal")+"</option><option value=\">\">"+multilanguage.getMessage("com.greater")+"</option><option value=\"<\">"+multilanguage.getMessage("com.minor")+"</option></select></td>";
					HTMLtext+="<td><input type=\"text\" name=\""+obj.getName()+"\" readonly>";
					HTMLtext+="<a href=\"javascript:showCalendarControlT(document."+formName+"."+obj.getName()+");\"><img src=\"images/cal.gif\" alt=\"calendario\" title=\"calendario\" border=\"0\"></a></td></tr>\n";
				} else if(obj.getType()==AttributeBean.BOOLEAN){ 
					HTMLtext+="\t<tr><td class=\"tdr30\">"+obj.getDescription()+"</td>";
					HTMLtext+="<td><select name=\"f_"+obj.getName()+"\"><option>"+multilanguage.getMessage("com.equal")+"</option></select></td>";
					HTMLtext+="<td><select name=\""+obj.getName()+"\"><option> </option><option value=\"S\">"+multilanguage.getMessage("com.yes")+"</option><option value=\"N\">"+multilanguage.getMessage("com.no")+"</option></select></td></tr>\n";
				} else { // float8,int4,numeric
					HTMLtext+="\t<tr><td class=\"tdr30\">"+obj.getDescription()+"</td>";
					HTMLtext+="<td><select name=\"f_"+obj.getName()+"\"><option value=\"=\">"+multilanguage.getMessage("com.equal")+"</option><option value=\">\">"+multilanguage.getMessage("com.greater")+"</option><option value=\"<\">"+multilanguage.getMessage("com.minor")+"</option></select></td>";
					HTMLtext+="<td><input type=\"text\" name=\""+obj.getName()+"\"></td></tr>\n";
				}
			}
		}	
		HTMLtext+="\t<tr>";
		HTMLtext+="<td class=\"tdr30\">&nbsp;</td>";
		HTMLtext+="<td>&nbsp;</td>";
		HTMLtext+="<td><input type=\"button\" name=\"button\" value=\"cerca\" onclick=\"method.value='filter';submit()\" value=\""+multilanguage.getMessage("com.confirm")+"\" class=\"button\">&nbsp;<input type=\"button\" name=\"button\" value=\""+multilanguage.getMessage("com.cancel")+"\" onclick=\"window.close();\" value=\""+multilanguage.getMessage("com.cancel")+"\" class=\"button\"></td>";
		HTMLtext+="</tr>\n";
		HTMLtext+="</table>\n";
		return HTMLtext;
	}
	public String toCardModify() {
		// removing lookups which state is not Active
		if (lookupVector!=null){
			int i = 0;
			LookupBean rlb = null;
			Enumeration eni = lookupVector.elements();
			while (eni.hasMoreElements()){
				rlb = (LookupBean)eni.nextElement();
				if (!rlb.getStatus().equals("A")){
					System.out.println("Asset, removing lookup "+rlb.getType()+" "+rlb.getDescription());
					lookupVector.remove(i);
				}
				i++;
			}
		}
		String HTMLtext = header.toForm();
		HTMLtext+="<table class=\"card\">\n";
		HTMLtext+="\t<tr><td class=\"tdr50\">classe</td>";
		HTMLtext+="<td><select name=\"search\">";
		HTMLtext+="<option>"+className+"</option>";
		HTMLtext+="</select>";
		HTMLtext+="</td></tr>\n";
		HTMLtext+="\t<tr><td colspan=\"2\"><hr style=\"color: #0066CC;\" width=\"99%\"></td></tr>\n";
		// repeated buttons
		HTMLtext+="\t<tr>";
		HTMLtext+="<td class=\"tdr50\">&nbsp;</td>";
		if (user!=null && user.isAllowed(className,2)){
			HTMLtext+="<td><input type=\"button\" name=\"button\" value=\""+multilanguage.getMessage("com.confirm")+"\" onclick=\"method.value='modify';submit()\" value=\""+multilanguage.getMessage("com.confirm")+"\" class=\"button\">&nbsp;<input type=\"button\" name=\"button\" value=\""+multilanguage.getMessage("com.cancel")+"\" onclick=\"javascript:location.href='card.jsp?mode=show';\" value=\""+multilanguage.getMessage("com.cancel")+"\" class=\"button\"></td>";
		} else {
			HTMLtext+="<td><input type=\"button\" name=\"button\" value=\""+multilanguage.getMessage("com.confirm")+"\" onclick=\"javascript:alert('"+multilanguage.getMessage("com.youhavenopermission")+"');\" value=\""+multilanguage.getMessage("com.confirm")+"\" class=\"button\">&nbsp;<input type=\"button\" name=\"button\" value=\""+multilanguage.getMessage("com.cancel")+"\" onclick=\"javascript:location.href='card.jsp?mode=show';\" value=\""+multilanguage.getMessage("com.cancel")+"\" class=\"button\"></td>";
		}
		HTMLtext+="</tr>\n";
		Enumeration e = assetVector.elements();
		AssetBean obj = new AssetBean();
		boolean manda = false;
		Vector vett = null;
		Enumeration en = null;
		String str = "";
		int target = 0;
		System.out.println("toCardModify assetV.size="+assetVector.size());
		while (e.hasMoreElements()){
			obj = (AssetBean)e.nextElement();
			if (!obj.getName().equals("Id") && !obj.getName().equals("IdCategory") && !obj.getName().equals("Notes") && !obj.getName().equals("Status")){ // don't show these
				manda = ( obj.getMandatory().equals("Y")?true:false);
				//System.out.println("obj type in asset="+obj.getType());
				if (obj.getType()==AttributeBean.LOOKUP){
					if (!manda){
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+"</td>";	
					} else {
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+" *</td>";
					}
					HTMLtext+="<td><select name=\""+obj.getName()+"\">";
					// adding "" option
					HTMLtext+="<option></option>";
					en = lookupVector.elements();
					LookupBean lb = null;
					while ( (en!=null) && (en.hasMoreElements()) ){
						lb = (LookupBean)en.nextElement();
						if (lb.getType().equals(obj.getLookup())){
							str = obj.getValue();
							if (str!=null && str.length()>0){
								try {
									target = Integer.parseInt(str);
								} catch (NumberFormatException e1) {
									e1.printStackTrace();
									target = 0;
								}
								if (target==lb.getId()){
									HTMLtext+="<option value=\""+lb.getId()+"\" selected>"+lb.getDescription()+"</option>";
								} else {
									HTMLtext+="<option value=\""+lb.getId()+"\">"+lb.getDescription()+"</option>";
								}
							} else {
								HTMLtext+="<option value=\""+lb.getId()+"\">"+lb.getDescription()+"</option>";
							}
						}
					}
					HTMLtext+="</select></td>";
					HTMLtext+="</tr>\n";
				} else if (obj.getType()==AttributeBean.REFERENCE){
					if (!manda){
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+"</td>";	
					} else {
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+" *</td>";
					}
					HTMLtext+="<td><select name=\""+obj.getName()+"\">";
					// adding "" option
					HTMLtext+="<option></option>";
					if (referenceHash.containsKey(obj.getReference())){
						vett = (Vector) referenceHash.get(obj.getReference());
					} 
					if (vett!=null){
						en = vett.elements();
						LookupBean lb = null;
						while ( (en!=null) && (en.hasMoreElements()) ){
							lb = (LookupBean)en.nextElement();
							if (lb.getType().equals(obj.getReference())){
								str = obj.getValue();
								if (str!=null && str.length()>0){
									try {
										target = Integer.parseInt(str);
									} catch (NumberFormatException e1) {
										e1.printStackTrace();
										target = 0;
									}
									if (target==lb.getId()){
										HTMLtext+="<option value=\""+lb.getId()+"\" selected>"+lb.getDescription()+"</option>";
									} else {
										HTMLtext+="<option value=\""+lb.getId()+"\">"+lb.getDescription()+"</option>";
									}
								} else {
									HTMLtext+="<option value=\""+lb.getId()+"\">"+lb.getDescription()+"</option>";
								}
							}
						}
					}
					HTMLtext+="</select></td>";
					HTMLtext+="</tr>\n";
				} else if( obj.getType()==AttributeBean.DATE ){
					String val="";
					if (obj.getValue()==null) {
						val = "";
					} else {
						val = obj.getValue(); 
					}
					if (!manda){
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+"</td>";
					} else {
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+" *</td>";
					}
					HTMLtext+="<td><input type=\"text\" name=\""+obj.getName()+"\" value=\""+val+"\" readonly>";
					HTMLtext+="<a href=\"javascript:showCalendarControl(document."+formName+"."+obj.getName()+");\"><img src=\"images/cal.gif\" alt=\"calendario\" title=\"calendario\" border=\"0\"></a>";
					if (obj.isDateExpire()){
						HTMLtext+=" "+multilanguage.getMessage("HTMLclass.dayswarning")+"<input type=\"text\" name=\""+obj.getName()+"datewarning\" size=\"4\" maxlength=\"4\">";
					}
					HTMLtext+="</td></tr>\n";
				} else if( obj.getType()==AttributeBean.TIMESTAMP ){
					String val="";
					if (obj.getValue()==null) {
						val = "";
					} else {
						val = obj.getValue(); 
					}
					if (!manda){
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+"</td>";
					} else {
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+" *</td>";
					}
					HTMLtext+="<td><input type=\"text\" name=\""+obj.getName()+"\" value=\""+val+"\" readonly>";
					HTMLtext+="<a href=\"javascript:showCalendarControlT(document."+formName+"."+obj.getName()+");\"><img src=\"images/cal.gif\" alt=\"calendario\" title=\"calendario\" border=\"0\"></a></td></tr>\n";
				} else if( obj.getType()==AttributeBean.TEXT ){
					String val="";
					if (obj.getValue()==null) {
						val = "";
					} else {
						val = obj.getValue(); 
					}
					if (!manda){
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+"</td>";
					} else {
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+" *</td>";
					}
					HTMLtext+="<td><textarea name=\""+obj.getName()+"\" cols=\"25\" rows=\"2\">"+val+"</textarea></td></tr>\n";
				} else if (obj.getType()==AttributeBean.BOOLEAN){
					if (obj.getValue()!= null && (obj.getValue().equals("t") || obj.getValue().equals("true"))){
						if (!manda){
							HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+"</td>";	
						} else {
							HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+" *</td>";
						}
						HTMLtext+="<td><select name=\""+obj.getName()+"\"><option value=\"S\">"+multilanguage.getMessage("com.yes")+"</option><option value=\"N\">"+multilanguage.getMessage("com.no")+"</option></select></td></tr>\n";
					} else { // f || false
						if (!manda){
							HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+"</td>";	
						} else {
							HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+" *</td>";
						}
						HTMLtext+="<td><select name=\""+obj.getName()+"\"><option>N</option><option>S</option></select></td></tr>\n";
					}
				} else if (obj.getType()==AttributeBean.STRING){
						if (!manda){
							HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+"</td>";
						} else {
							HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+" *</td>";
						}
						HTMLtext+="<td><input type=\"text\" name=\""+obj.getName()+"\" value=\""+obj.getValue()+"\" maxlength=\""+obj.getLength()+"\"></td></tr>\n";	
				} else {
					if (!manda){
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+"</td>";
					} else {
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+" *</td>";
					}
					HTMLtext+="<td><input type=\"text\" name=\""+obj.getName()+"\" value=\""+obj.getValue()+"\"></td></tr>\n";
				}
			}	
		}
		// repeated buttons
		HTMLtext+="\t<tr>";
		HTMLtext+="<td class=\"tdr50\">&nbsp;</td>";
		if (user!=null && user.isAllowed(className,2)){
			HTMLtext+="<td><input type=\"button\" name=\"button\" value=\""+multilanguage.getMessage("com.confirm")+"\" onclick=\"method.value='modify';submit()\" value=\""+multilanguage.getMessage("com.confirm")+"\" class=\"button\">&nbsp;<input type=\"button\" name=\"button\" value=\""+multilanguage.getMessage("com.cancel")+"\" onclick=\"javascript:location.href='card.jsp?mode=show';\" value=\""+multilanguage.getMessage("com.cancel")+"\" class=\"button\"></td>";
		} else {
			HTMLtext+="<td><input type=\"button\" name=\"button\" value=\""+multilanguage.getMessage("com.confirm")+"\" onclick=\"javascript:alert('"+multilanguage.getMessage("com.youhavenopermission")+"');\" value=\""+multilanguage.getMessage("com.confirm")+"\" class=\"button\">&nbsp;<input type=\"button\" name=\"button\" value=\""+multilanguage.getMessage("com.cancel")+"\" onclick=\"javascript:location.href='card.jsp?mode=show';\" value=\""+multilanguage.getMessage("com.cancel")+"\" class=\"button\"></td>";
		}
		HTMLtext+="</tr>\n";
		HTMLtext+="</table>\n";
		return HTMLtext;
	}
	public String toCardModifyDetail() {
		// removing lookups which state is not Active
		if (lookupVector!=null){
			int i = 0;
			LookupBean rlb = null;
			Enumeration eni = lookupVector.elements();
			while (eni.hasMoreElements()){
				rlb = (LookupBean)eni.nextElement();
				if (!rlb.getStatus().equals("A")){
					System.out.println("Asset, removing lookup "+rlb.getType()+" "+rlb.getDescription());
					lookupVector.remove(i);
				}
				i++;
			}
		}
		String HTMLtext = header.toForm();
		HTMLtext+="<table class=\"card\">\n";
		HTMLtext+="\t<tr><td class=\"tdr50\">classe</td>";
		HTMLtext+="<td><select name=\"search\">";
		HTMLtext+="<option>"+className+"</option>";
		HTMLtext+="</select>";
		HTMLtext+="</td></tr>\n";
		HTMLtext+="\t<tr><td colspan=\"2\"><hr style=\"color: #0066CC;\" width=\"99%\"></td></tr>\n";
		// repeated buttons
		HTMLtext+="\t<tr>";
		HTMLtext+="<td class=\"tdr50\">&nbsp;</td>";
		if (user!=null && user.isAllowed(className,2)){
			HTMLtext+="<td><input type=\"button\" name=\"button\" value=\""+multilanguage.getMessage("com.confirm")+"\" onclick=\"method.value='modify';submit()\" class=\"button\">&nbsp;<input type=\"button\" name=\"button\" value=\""+multilanguage.getMessage("com.close")+"\" onclick=\"javascript:window.close();;\" class=\"button\"></td>";
		} else {
			HTMLtext+="<td><input type=\"button\" name=\"button\" value=\""+multilanguage.getMessage("com.confirm")+"\" onclick=\"javascript:alert('"+multilanguage.getMessage("com.youhavenopermission")+"');\" class=\"button\">&nbsp;<input type=\"button\" name=\"button\" value=\""+multilanguage.getMessage("com.close")+"\" onclick=\"javascript:window.close();\" class=\"button\"></td>";
		}
		HTMLtext+="</tr>\n";
		Enumeration e = assetVector.elements();
		AssetBean obj = new AssetBean();
		boolean manda = false;
		Vector vett = null;
		Enumeration en = null;
		String str = "";
		int target = 0;
		System.out.println("toCardModify assetV.size="+assetVector.size());
		while (e.hasMoreElements()){
			obj = (AssetBean)e.nextElement();
			if (!obj.getName().equals("Id") && !obj.getName().equals("IdCategory") && !obj.getName().equals("Notes") && !obj.getName().equals("Status")){ // don't show these
				manda = ( obj.getMandatory().equals("Y")?true:false);
				if (obj.getType()==AttributeBean.LOOKUP){
					if (!manda){
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+"</td>";	
					} else {
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+" *</td>";
					}
					HTMLtext+="<td><select name=\""+obj.getName()+"\">";
					// adding "" option
					HTMLtext+="<option></option>";
					en = lookupVector.elements();
					LookupBean lb = null;
					while ( (en!=null) && (en.hasMoreElements()) ){
						lb = (LookupBean)en.nextElement();
						if (lb.getType().equals(obj.getLookup())){
							str = obj.getValue();
							if (str!=null && str.length()>0){
								try {
									target = Integer.parseInt(str);
								} catch (NumberFormatException e1) {
									e1.printStackTrace();
									target = 0;
								}
								if (target==lb.getId()){
									HTMLtext+="<option value=\""+lb.getId()+"\" selected>"+lb.getDescription()+"</option>";
								} else {
									HTMLtext+="<option value=\""+lb.getId()+"\">"+lb.getDescription()+"</option>";
								}
							} else {
								HTMLtext+="<option value=\""+lb.getId()+"\">"+lb.getDescription()+"</option>";
							}
						}
					}
					HTMLtext+="</select></td>";
					HTMLtext+="</tr>\n";
				} else if (obj.getType()==AttributeBean.REFERENCE){
					if (!manda){
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+"</td>";	
					} else {
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+" *</td>";
					}
					HTMLtext+="<td><select name=\""+obj.getName()+"\">";
					// adding "" option
					//HTMLtext+="<option></option>";
					if (referenceHash.containsKey(obj.getReference())){
						vett = (Vector) referenceHash.get(obj.getReference());
					} 
					if (vett!=null){
						en = vett.elements();
						LookupBean lb = null;
						while ( (en!=null) && (en.hasMoreElements()) ){
							lb = (LookupBean)en.nextElement();
							if (lb.getType().equals(obj.getReference())){
								str = obj.getValue();
								if (str!=null && str.length()>0){
									try {
										target = Integer.parseInt(str);
									} catch (NumberFormatException e1) {
										e1.printStackTrace();
										target = 0;
									}
									if (target==lb.getId()){
										HTMLtext+="<option value=\""+lb.getId()+"\" selected>"+lb.getDescription()+"</option>";
									} else {
										//HTMLtext+="<option value=\""+lb.getId()+"\">"+lb.getDescription()+"</option>";
									}
								} else {
									HTMLtext+="<option value=\""+lb.getId()+"\">"+lb.getDescription()+"</option>";
								}
							}
						}
					}
					HTMLtext+="</select></td>";
					HTMLtext+="</tr>\n";
				} else if( obj.getType()==AttributeBean.DATE ){
					String val="";
					if (obj.getValue()==null) {
						val = "";
					} else {
						val = obj.getValue(); 
					}
					if (!manda){
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+"</td>";
					} else {
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+" *</td>";
					}
					HTMLtext+="<td><input type=\"text\" name=\""+obj.getName()+"\" value=\""+val+"\" readonly>";
					HTMLtext+="<a href=\"javascript:showCalendarControl(document."+formName+"."+obj.getName()+");\"><img src=\"images/cal.gif\" alt=\"calendario\" title=\"calendario\" border=\"0\"></a>";
					if (obj.isDateExpire()){
						HTMLtext+="<input type=\"text\" name=\""+obj.getName()+"datewarning\">";
					}
					HTMLtext+="</td></tr>\n";
				} else if( obj.getType()==AttributeBean.TIMESTAMP ){
					String val="";
					if (obj.getValue()==null) {
						val = "";
					} else {
						val = obj.getValue(); 
					}
					if (!manda){
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+"</td>";
					} else {
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+" *</td>";
					}
					HTMLtext+="<td><input type=\"text\" name=\""+obj.getName()+"\" value=\""+val+"\" readonly>";
					HTMLtext+="<a href=\"javascript:showCalendarControlT(document."+formName+"."+obj.getName()+");\"><img src=\"images/cal.gif\" alt=\"calendario\" title=\"calendario\" border=\"0\"></a></td></tr>\n";
				} else if( obj.getType()==AttributeBean.TEXT ){
					String val="";
					if (obj.getValue()==null) {
						val = "";
					} else {
						val = obj.getValue(); 
					}
					if (!manda){
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+"</td>";
					} else {
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+" *</td>";
					}
					HTMLtext+="<td><textarea name=\""+obj.getName()+"\" cols=\"25\" rows=\"2\">"+val+"</textarea></td></tr>\n";
				} else if (obj.getType()==AttributeBean.BOOLEAN){
					if (obj.getValue()!= null && (obj.getValue().equals("t") || obj.getValue().equals("true"))){
						if (!manda){
							HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+"</td>";	
						} else {
							HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+" *</td>";
						}
						HTMLtext+="<td><select name=\""+obj.getName()+"\"><option value=\"S\">"+multilanguage.getMessage("com.yes")+"</option><option value=\"N\">"+multilanguage.getMessage("com.no")+"</option></select></td></tr>\n";
					} else { // f || false
						if (!manda){
							HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+"</td>";	
						} else {
							HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+" *</td>";
						}
						HTMLtext+="<td><select name=\""+obj.getName()+"\"><option>N</option><option>S</option></select></td></tr>\n";
					}
				} else if (obj.getType()==AttributeBean.STRING){
						if (!manda){
							HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+"</td>";
						} else {
							HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+" *</td>";
						}
						HTMLtext+="<td><input type=\"text\" name=\""+obj.getName()+"\" value=\""+obj.getValue()+"\" maxlength=\""+obj.getLength()+"\"></td></tr>\n";	
				} else {
					if (!manda){
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+"</td>";
					} else {
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+" *</td>";
					}
					HTMLtext+="<td><input type=\"text\" name=\""+obj.getName()+"\" value=\""+obj.getValue()+"\"></td></tr>\n";
				}
			}	
		}
		// repeated buttons
		HTMLtext+="\t<tr>";
		HTMLtext+="<td class=\"tdr50\">&nbsp;</td>";
		if (user!=null && user.isAllowed(className,2)){
			HTMLtext+="<td><input type=\"button\" name=\"button\" value=\""+multilanguage.getMessage("com.confirm")+"\" onclick=\"method.value='modify';submit()\" class=\"button\">&nbsp;<input type=\"button\" name=\"button\" value=\""+multilanguage.getMessage("com.close")+"\" onclick=\"javascript:window.close();\" class=\"button\"></td>";
		} else {
			HTMLtext+="<td><input type=\"button\" name=\"button\" value=\""+multilanguage.getMessage("com.confirm")+"\" onclick=\"javascript:alert('"+multilanguage.getMessage("com.youhavenopermission")+"');\" class=\"button\">&nbsp;<input type=\"button\" name=\"button\" value=\""+multilanguage.getMessage("com.close")+"\" onclick=\"javascript:windows.close();\" class=\"button\"></td>";
		}
		HTMLtext+="</tr>\n";
		HTMLtext+="</table>\n";
		return HTMLtext;
	}
	public String toNoteForm() {
		String HTMLtext = header.toForm();
		BaseDisplay base = new BaseDisplay(assetVector,lookupVector,referenceHash);
		HTMLtext += base.toForm(); // add the BaseDSP table
		if (notes==null){
			HTMLtext+="<table class=\"card\">\n";
			HTMLtext+="\t<tr><td>"+multilanguage.getMessage("HTMLclass.nonotes")+"</td></tr>\n";
			HTMLtext+="</table>\n";
		} else {
			HTMLtext+="<table class=\"card\">\n";
			HTMLtext+="\t<tr><td>note</td><td><textarea name=\"note\" cols=\"25\" rows=\"10\" disabled>"+notes+"</textarea></td></tr>\n";
			HTMLtext+="</table>\n";
		} 
		return HTMLtext;
	}
	public String toNoteModify() {
		String HTMLtext = header.toForm();
		BaseDisplay base = new BaseDisplay(assetVector,lookupVector,referenceHash);
		HTMLtext += base.toForm(); // add the BaseDSP table
		if (notes==null){
			HTMLtext+="<table class=\"card\">\n";
			HTMLtext+="\t<tr><td>"+multilanguage.getMessage("HTMLclass.nonotes")+"</td></tr>\n";
			HTMLtext+="</table>\n";
		} else if (user!=null && user.isAllowed(className,2)){
			HTMLtext+="<table class=\"card\">\n";
			HTMLtext+="\t<tr><td>note</td><td><textarea name=\"note\" cols=\"25\" rows=\"10\">"+notes+"</textarea></td></tr>\n";
			HTMLtext+="\t<tr><td>&nbsp;</td><td><input type=\"button\" name=\"button\" value=\""+multilanguage.getMessage("com.confirm")+"\" onclick=\"method.value='modify';submit()\" value=\""+multilanguage.getMessage("com.confirm")+"\" class=\"button\">&nbsp;<input type=\"button\" name=\"button\" value=\""+multilanguage.getMessage("com.cancel")+"\" onclick=\"javascript:location.href='card.jsp?mode=show';\" value=\""+multilanguage.getMessage("com.cancel")+"\" class=\"button\"></td></tr>\n";
			HTMLtext+="</table>\n";
		} else {
			HTMLtext+="<table class=\"card\">\n";
			HTMLtext+="\t<tr><td>note</td><td><textarea name=\"note\" cols=\"25\" rows=\"10\" disabled>"+notes+"</textarea></td></tr>\n";
			HTMLtext+="\t<tr><td>&nbsp;</td><td><input type=\"button\" name=\"button\" value=\""+multilanguage.getMessage("com.confirm")+"\" onclick=\"javascript:alert('Classe non modificabile');\" value=\""+multilanguage.getMessage("com.confirm")+"\" class=\"button\">&nbsp;<input type=\"button\" name=\"button\" value=\""+multilanguage.getMessage("com.cancel")+"\" onclick=\"javascript:location.href='card.jsp?mode=show';\" value=\""+multilanguage.getMessage("com.cancel")+"\" class=\"button\"></td></tr>\n";
			HTMLtext+="</table>\n";
		}
		return HTMLtext;
	}
	public String toHistoryPopup() {
		String HTMLtext = "";
		if (deleted){
			HTMLtext+="<table class=\"cardDeleted\">\n";
	    } else {
	    	HTMLtext+="<table class=\"card\">\n";
	    }
		HTMLtext+="\t<tr><td class=\"tdr50\">"+multilanguage.getMessage("com.class")+"</td><td>"+classDescription+"</td></tr>\n";
		/*
		if (category==null){
			category = "&nbsp;";
		}
		HTMLtext+="\t<tr><td class=\"tdr50\">"+multilanguage.getMessage("com.category")+"</td><td>"+category+"</td></tr>\n";
		*/
		HTMLtext+="\t<tr><td colspan=\"2\"><hr style=\"color: #0066CC;\" width=\"99%\"></td></tr>\n";
		Enumeration e = assetVector.elements();
		AssetBean obj = new AssetBean();
		Enumeration en = null;
		Vector vett = null;
		while (e.hasMoreElements()){
			obj = (AssetBean)e.nextElement();
			if (!obj.getName().equals("Id") && !obj.getName().equals("IdCategory") && !obj.getName().equals("Notes") && !obj.getName().equals("Status")){ // don't show these
				if (obj.getType()==AttributeBean.LOOKUP){
					HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+"</td>";
					HTMLtext+="<td>";
					en = lookupVector.elements();
					LookupBean lb = null;
					while ( (en!=null) && (en.hasMoreElements()) ){
						lb = (LookupBean)en.nextElement();
						if (obj.getValue()!=null){
							String id = ""+lb.getId(); 
							//System.out.println("obj is "+obj.getValue().getClass().getName());
							if (id.equals(obj.getValue())){
								HTMLtext+=lb.getDescription();
								break;
							}
						} else {
							HTMLtext+="";
						}
					}
					HTMLtext+="</td>";
					HTMLtext+="</tr>\n";
				} else if (obj.getType()==AttributeBean.REFERENCE){
					HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+"</td>";
					HTMLtext+="<td>";
					if (referenceHash.containsKey(obj.getReference())){
						vett = (Vector) referenceHash.get(obj.getReference());
					} 
					if (vett!=null){
						en = vett.elements();
						LookupBean lb = null;
						while ( (en!=null) && (en.hasMoreElements()) ){
							lb = (LookupBean)en.nextElement();
							if (obj.getValue()!=null){
								String id = ""+lb.getId(); 
								//System.out.println("obj is "+obj.getValue().getClass().getName());
								if (id.equals(obj.getValue())){
									HTMLtext+=lb.getDescription();
									break;
								}
							} else {
								HTMLtext+="";
							}
						}
					}
					HTMLtext+="</td>";
					HTMLtext+="</tr>\n";
				} else if (obj.getValue()!=null && obj.getType()==AttributeBean.BOOLEAN){
					if (obj.getValue().equals("t") || obj.getValue().equals("true")){
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+"</td><td>"+multilanguage.getMessage("com.yes")+"</td></tr>\n";	
					} else { // f || false
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+"</td><td>"+multilanguage.getMessage("com.no")+"</td></tr>\n";
					}
				} else {
					if (obj.getValue()==null || obj.getValue().equals("")){ 
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+"</td><td>&nbsp;</td></tr>\n";					
					} else {
						HTMLtext+="\t<tr><td class=\"tdr50\">"+obj.getDescription()+"</td><td>"+obj.getValue()+"</td></tr>\n";					
					}
				}
			}
		}
		HTMLtext+="</table>\n";
		return HTMLtext;
	}

	public String toHistoryTable() {
		HistoryBean obj = null;
		String HTMLtext = header.toForm();
		BaseDisplay base = new BaseDisplay(assetVector,lookupVector,referenceHash);
		HTMLtext += base.toForm(); // add the BasePSP table
		HTMLtext+="<table class=\"show\" cellpadding=\"0\" cellspacing=\"0\">\n";
		HTMLtext+="\t<th>data inizio</th><th>data fine</th><th>utente</th><th>attributi</th><th>Codice</th><th>"+multilanguage.getMessage("com.description")+"</th><th>relazioni</th>\n";
		//boolean direct = true;
		String relname = "";
		String bDate = "";
		String eDate = "";
		String rCode = "";
		String rDescription = "";
		if (historyVector!=null){
			Enumeration e = historyVector.elements();
			while (e.hasMoreElements()){
				obj = (HistoryBean)e.nextElement();
				//String otherClassName = "";
				if (obj.getRelationName()==null){
					relname = "";
				} else {
					relname = obj.getRelationName();
				}
				if (obj.getBeginDate()!=null){
					bDate = obj.getBeginDate().substring(0,10);	
				} else {
					bDate = "&nbsp;";
				}
				if (obj.getEndDate()!=null){
					eDate = obj.getEndDate().substring(0,10);
				} else {
					eDate = "";
				}
				HTMLtext+= "\t<tr>\n";
				HTMLtext+= "\t\t<td>"+bDate+"</td>";
				HTMLtext+= "\t\t<td>"+eDate+"</td>";
				HTMLtext+= "\t\t<td>"+obj.getUser()+"</td>";
				if (obj.isAttribute()){
					HTMLtext+= "\t\t<td><a href=\"javascript:void(0);\" onclick=\"window.open('historypopup.jsp?class="+className+"&classid="+obj.getClassId()+"&objid="+obj.getCurrentId()+"',null,'height=400,width=450,status=no,toolbar=no,menubar=no,scrollbars=yes,location=no,resizable');\"><img class=\"icon\" src=\"images/ico_show.gif\" alt=\"visualizza\" title=\"visualizza\"></a></td>";
					HTMLtext+= "\t\t<td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td>";
					
				} else { // is a relation
					if (obj.getRelatedObjectCode()!=null){
						rCode = obj.getRelatedObjectCode();	
					} else {
						rCode = "&nbsp;";
					}
					if (obj.getRelatedObjectDescription()!=null){
						rDescription = obj.getRelatedObjectDescription();	
					} else {
						rDescription = "&nbsp;";
					}
					HTMLtext+= "\t\t<td>&nbsp;</td>";
					HTMLtext+= "\t\t<td>"+rCode+"</td>";
					HTMLtext+= "\t\t<td>"+rDescription+"</td>";
					HTMLtext+= "\t\t<td>"+relname+" <a href=\"javascript:void(0);\" onclick=\"window.open('historypopup.jsp?classid="+obj.getClassId()+"&objid="+obj.getObjId()+"',null,'height=400,width=450,status=no,toolbar=no,menubar=no,scrollbars=yes,location=no,resizable');\"><img class=\"icon\" src=\"images/ico_show.gif\" alt=\"visualizza\" title=\"visualizza\"></a></td>";
				}
				HTMLtext+= "\t</tr>\n ";
			}
		} else {
			HTMLtext+="\t<tr>\n";
			HTMLtext+="\t<td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td>\n";
			HTMLtext+="\t</tr>\n";
		}
		HTMLtext+="</table>\n";
		return HTMLtext;
	}

	public String toRelationTable() {
		RelationBean obj = null;
		String HTMLtext = header.toForm();
		BaseDisplay base = new BaseDisplay(assetVector,lookupVector,referenceHash);
		HTMLtext += base.toForm(); // add the BasePSP table
		boolean direct = true;
		String dom = "";
		String nam = "";
		String ass = "";
		String des = "";
		String cdes = "";
		// if there are incorrect data in database...
		if(relationVector!=null){
			Enumeration rm = relationVector.elements();
			int remi = 0;
			while (rm.hasMoreElements()){
				obj = (RelationBean)rm.nextElement();
				if (obj.getClassName().equals("Asset")){
					relationVector.remove(remi);
					System.out.println("Data incorrect removing "+obj.getClassName());
				}
				remi++;
			}
		}
		if(relationVector!=null){
			int tot = totalPages/resultsForPage;
			System.out.println(totalPages+"/"+resultsForPage+"tot="+tot);
			if (totalPages%resultsForPage!=0){
				tot++;
			}
			if (tot>0 && subpage==0){ // patch
				subpage = 1;
			}
			int first,prev,next,last;
			first = 1;
			if (subpage>1){
				prev=subpage-1;
			} else {
				prev = 1;
			}
			if (subpage<tot){
				next=subpage+1;
			} else {
				next = tot;
			}
			last = tot;
			if (tot==0){
				subpage=0;
			}
			if (tot==1){
				subpage=1;
			}
			if (subpage>tot){
				subpage=tot;
			}
 			//System.out.println("start"+start+"end"+end);
			HTMLtext+= "<table><tr><td colspan=\"5\">"+multilanguage.getMessage("HTMLclass.atpage")+"<input type=\"text\" size=\"3\" name=\"pagina\" maxlength=\"3\" value=\""+subpage+"\" onkeypress=\"goTo(event,"+first+","+last+")\"> di "+tot;
			HTMLtext+= "<a href=\"relation.jsp?subpage="+first+"\"><img src=\"images/ico_first.gif\" alt=\"primo\" title=primo></a><a href=\"relation.jsp?subpage="+prev+"\"><img src=\"images/ico_prev.gif\" alt=\"precedente\" title=precedente></a><a href=\"relation.jsp?subpage="+next+"\"><img src=\"images/ico_next.gif\" alt=\"successivo\" title=successivo></a><a href=\"relation.jsp?subpage="+last+"\"><img src=\"images/ico_last.gif\" alt=\"ultimo\" title=ultimo></a>";
			HTMLtext+= "</td></tr></table>";
 			HTMLtext+="<table class=\"show\" cellpadding=\"0\" cellspacing=\"0\">\n";
 			HTMLtext+="\t<th>dominio</th><th>classe</th><th>SN oggetto</th><th>"+multilanguage.getMessage("com.description")+"</th><th>&nbsp;</th>\n";
 			// creating the table
 			Enumeration enr = relationVector.elements();
 			int page=0;
 			if (subpage!=0){
 				page = (subpage-1)*resultsForPage;
 			}
 			while (enr.hasMoreElements()){
 				page++;
				obj = (RelationBean)enr.nextElement();
				direct = obj.isDirect();
				dom = obj.getDomainDescription();
				if (dom==null || dom.equals("")){
					dom = "&nbsp;";
				}
				nam = obj.getClassName();
				if (nam==null || nam.equals("")){
					nam = "&nbsp;";
				}
				//System.out.println("Realtion.java getting classdescription "+obj.getClassDescription());
				cdes = obj.getClassDescription();
				if (cdes==null || cdes.equals("")){
					cdes = "&nbsp;";
				}
				ass = obj.getCode();
				if (ass==null || ass.equals("")){
					ass = "&nbsp;";
				}
				des = obj.getDescription();
				if (des==null || des.equals("")){
					des = "&nbsp;";
				}
				HTMLtext+="\t<tr>";
				HTMLtext+="<td>"+dom+"</td><td>"+cdes+"</td><td align=\"center\">"+ass+"</td>";
				if (!hideLinks){ // delete this "if" if you want always links
					HTMLtext+="<td><a href=\"javascript:void(0);\" onclick=\"window.open('popupinfocard.jsp?class="+nam+"&classid="+obj.getClassId()+"&objid="+obj.getObjId()+"','popupinfo','height=600,width=600,status=no,toolbar=no,menubar=no,scrollbars=yes,location=no,resizable');\">"+des+"</a></td>";
				} else {
					HTMLtext+="<td>"+des+"</td>";
				}
				HTMLtext+="<td class=\"fixed\">";
				if (!disableEditing){ 
					if (user!=null && user.isAllowed(className,3)){
						HTMLtext+="<a href=\"javascript:void(0);\" onclick=\"window.open('modifyrelation.jsp?class="+obj.getClassName()+"&class1id="+class1id+"&obj1id="+obj1id+"&class2id="+obj.getClassId()+"&obj2id="+obj.getObjId()+"&domain="+obj.getDomainRealName()+"&domainid="+obj.getDomainId()+"&direct="+direct+"',null,'height=400,width=450,status=no,toolbar=no,scrollbars=yes,menubar=no,location=no,resizable');\"><img class=\"icon\" src=\"images/ico_edit.gif\" alt=\"edit\" title=\"edit\"></a>";
						if (!obj.isDomainMasterDetail()){
							HTMLtext+=" <a href=\"javascript:javascript:if (confirm('"+multilanguage.getMessage("relation.areyousure")+"')){relationForm.targetClassId.value='"+obj.getClassId()+"';relationForm.targetObjId.value='"+obj.getObjId()+"';relationForm.direct.value='"+obj.isDirect()+"';relationForm.targetDomain.value='"+obj.getDomainRealName()+"';relationForm.targetDomainId.value='"+obj.getDomainId()+"';relationForm.method.value='delete';relationForm.submit();}\"><img class=\"icon\" src=\"images/ico_del.gif\" alt=\"del\" title=\"del\"></a> ";
						} // else don't show del button
					} else {
						HTMLtext+="<a href=\"javascript:alert('"+multilanguage.getMessage("com.youhavenopermission")+"');\"><img class=\"icon\" src=\"images/ico_edit.gif\" alt=\"edit\" title=\"edit\"></a>";
						HTMLtext+=" <a href=\"javascript:alert('"+multilanguage.getMessage("com.youhavenopermission")+"');\"><img class=\"icon\" src=\"images/ico_del.gif\" alt=\"del\" title=\"del\"></a> ";
					}
					HTMLtext+=" <a href=\"javascript:relationForm.targetClass.value='"+obj.getClassName()+"';relationForm.targetObjId.value='"+obj.getObjId()+"';relationForm.method.value='gotopage';relationForm.submit()\"><img class=\"icon\" src=\"images/ico_link.gif\" alt=\"go to\" title=\"go to\"></a> ";
				} else { // disableEditing in PopupInfo
					HTMLtext+="<img class=\"icon\" src=\"images/ico_blank.gif\">";
				}
				HTMLtext+="</td>";
				HTMLtext+="</tr>\n";
			}
			HTMLtext+="</table>\n";
		} else { // empty table
			HTMLtext+="<table class=\"show\" cellpadding=\"0\" cellspacing=\"0\">\n";
			HTMLtext+="\t<th>dominio</th><th>classe</th><th>SN oggetto</th><th>"+multilanguage.getMessage("com.description")+"</th><th>&nbsp;</th>\n";
			HTMLtext+="\t<tr>\n";
			HTMLtext+="\t<td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td>\n";
			HTMLtext+="\t</tr>\n";
			HTMLtext+="</table>\n";
		}
		return HTMLtext;
	}

	public String toSearchFilter() {
		String HTMLtext = header.toForm();
		HTMLtext+="<table class=\"card\">\n";
		HTMLtext+="\t<tr><td class=\"tdr30\">classe</td>";
		HTMLtext+="<td><select name=\"f_className\"><option>"+multilanguage.getMessage("com.equal")+"</option></select></td>";
		HTMLtext+="<td><select name=\"search\" onchange=\"method.value='search';submit()\">";
		Iterator it = classCollection.iterator();
		while (it.hasNext()){
			ClassBean cb = (ClassBean)it.next();
			if (cb.getName().equals(className)){
				HTMLtext+="<option selected>"+cb.getName()+"</option>";
			} else {
				HTMLtext+="<option>"+cb.getName()+"</option>";
			}
		}
		HTMLtext+="</select>";
		HTMLtext+="</td></tr>\n";
		HTMLtext+="\t<tr><td colspan=\"3\"><hr style=\"color: #0066CC;\" width=\"99%\"></td></tr>\n";
		// repeated buttons
		HTMLtext+="\t<tr>";
		HTMLtext+="<td class=\"tdr30\">&nbsp;</td>";
		HTMLtext+="<td>&nbsp;</td>";
		HTMLtext+="<td><input type=\"button\" name=\"button\" value=\"cerca\" onclick=\"method.value='filter';submit()\" value=\""+multilanguage.getMessage("com.confirm")+"\" class=\"button\">&nbsp;<input type=\"button\" name=\"button\" value=\""+multilanguage.getMessage("com.cancel")+"\" onclick=\"javascript:location.href='management.jsp';\" value=\""+multilanguage.getMessage("com.cancel")+"\" class=\"button\"></td>";
		HTMLtext+="</tr>\n";
		// showing only baseDSPs, removing the others
		AssetBean toer = null;
		if (!showAll && assetVector!=null && assetVector.size()>0){
			for (int i=assetVector.size()-1;i>=0;i--){
				toer = (AssetBean)assetVector.elementAt(i);
				if (!toer.getBaseDSP().equals("true")){
					assetVector.remove(i);
				}
			}
		}
		Enumeration e = assetVector.elements();
		AssetBean obj = new AssetBean();
		Enumeration en = null;
		Vector vett = null;
		while (e.hasMoreElements()){
			obj = (AssetBean)e.nextElement();
			if (!obj.getName().equals("Id") && !obj.getName().equals("IdCategory") && !obj.getName().equals("Notes") && !obj.getName().equals("Status")){ // don't show these
				if (obj.getType()==AttributeBean.LOOKUP){
					HTMLtext+="\t<tr><td class=\"tdr30\">"+obj.getDescription()+"</td>";
					HTMLtext+="<td><select name=\"f_"+obj.getName()+"\"><option>"+multilanguage.getMessage("com.equal")+"</option></select></td>";
					HTMLtext+="<td><select name=\""+obj.getName()+"\">";
					// adding "" option
					HTMLtext+="<option></option>";
					en = lookupVector.elements();
					LookupBean lb = null;
					while ( (en!=null) && (en.hasMoreElements()) ){
						lb = (LookupBean)en.nextElement();
						//System.out.println("lb.getLtype="+lb.getLType()+" obj.getALookup()"+obj.getALookup());
						if (lb.getType().equals(obj.getLookup())){
							HTMLtext+="<option value=\""+lb.getId()+"\">"+lb.getDescription()+"</option>";
						}
					}
					HTMLtext+="</select></td>";
					HTMLtext+="</tr>\n";
				} else if (obj.getType()==AttributeBean.REFERENCE){
					HTMLtext+="\t<tr><td class=\"tdr30\">"+obj.getDescription()+"</td>";
					HTMLtext+="<td><select name=\"f_"+obj.getName()+"\"><option>"+multilanguage.getMessage("com.equal")+"</option></select></td>";
					HTMLtext+="<td><select name=\""+obj.getName()+"\">";
					// adding "" option
					HTMLtext+="<option></option>";
					if (referenceHash.containsKey(obj.getReference())){
						vett = (Vector) referenceHash.get(obj.getReference());
					} 
					if (vett!=null){
						en = vett.elements();
						LookupBean lb = null;
						while ( (en!=null) && (en.hasMoreElements()) ){
							lb = (LookupBean)en.nextElement();
							//System.out.println("lb.getLtype="+lb.getLType()+" obj.getALookup()"+obj.getALookup());
							if (lb.getType().equals(obj.getReference())){
								HTMLtext+="<option value=\""+lb.getId()+"\">"+lb.getDescription()+"</option>";
							}
						}
					}
					HTMLtext+="</select></td>";
					HTMLtext+="</tr>\n";
				} else if( obj.getType()==AttributeBean.STRING ){
					HTMLtext+="\t<tr><td class=\"tdr30\">"+obj.getDescription()+"</td>";
					HTMLtext+="<td><select name=\"f_"+obj.getName()+"\"><option>"+multilanguage.getMessage("com.equal")+"</option><option>"+multilanguage.getMessage("com.contains")+"</option><option>"+multilanguage.getMessage("com.startswith")+"</option></select></td>";
					HTMLtext+="<td><input type=\"text\" name=\""+obj.getName()+"\" onkeypress=\"doSearch(event)\"></td></tr>\n";
				} else if( obj.getType()==AttributeBean.TEXT ){
					HTMLtext+="\t<tr><td class=\"tdr30\">"+obj.getDescription()+"</td>";
					HTMLtext+="<td><select name=\"f_"+obj.getName()+"\"><option>"+multilanguage.getMessage("com.equal")+"</option><option>"+multilanguage.getMessage("com.contains")+"</option><option>"+multilanguage.getMessage("com.startswith")+"</option></select></td>";
					HTMLtext+="<td><textarea name=\""+obj.getName()+"\" cols=\"25\" rows=\"2\" onkeypress=\"doSearch(event)\"></textarea></td></tr>\n";
				} else if( obj.getType()==AttributeBean.DATE ){ 
					HTMLtext+="\t<tr><td class=\"tdr30\">"+obj.getDescription()+"</td>";
					HTMLtext+="<td><select name=\"f_"+obj.getName()+"\"><option value=\"=\">"+multilanguage.getMessage("com.equal")+"</option><option value=\">\">"+multilanguage.getMessage("com.greater")+"</option><option value=\"<\">"+multilanguage.getMessage("com.minor")+"</option></select></td>";
					HTMLtext+="<td><input type=\"text\" name=\""+obj.getName()+"\" readonly>";
					HTMLtext+="<a href=\"javascript:showCalendarControl(document."+formName+"."+obj.getName()+");\"><img src=\"images/cal.gif\" alt=\"calendario\" title=\"calendario\" border=\"0\"></a></td></tr>\n";
				} else if( obj.getType()==AttributeBean.TIMESTAMP ){ 
					HTMLtext+="\t<tr><td class=\"tdr30\">"+obj.getDescription()+"</td>";
					HTMLtext+="<td><select name=\"f_"+obj.getName()+"\"><option value=\"=\">"+multilanguage.getMessage("com.equal")+"</option><option value=\">\">"+multilanguage.getMessage("com.greater")+"</option><option value=\"<\">"+multilanguage.getMessage("com.minor")+"</option></select></td>";
					HTMLtext+="<td><input type=\"text\" name=\""+obj.getName()+"\" readonly>";
					HTMLtext+="<a href=\"javascript:showCalendarControlT(document."+formName+"."+obj.getName()+");\"><img src=\"images/cal.gif\" alt=\"calendario\" title=\"calendario\" border=\"0\"></a></td></tr>\n";
				} else if(obj.getType()==AttributeBean.BOOLEAN){ 
					HTMLtext+="\t<tr><td class=\"tdr30\">"+obj.getDescription()+"</td>";
					HTMLtext+="<td><select name=\"f_"+obj.getName()+"\"><option>"+multilanguage.getMessage("com.equal")+"</option></select></td>";
					HTMLtext+="<td><select name=\""+obj.getName()+"\"><option> </option><option value=\"S\">"+multilanguage.getMessage("com.yes")+"</option><option value=\"N\">"+multilanguage.getMessage("com.no")+"</option></select></td></tr>\n";
				} else { // float8,int4,numeric
					HTMLtext+="\t<tr><td class=\"tdr30\">"+obj.getDescription()+"</td>";
					HTMLtext+="<td><select name=\"f_"+obj.getName()+"\"><option value=\"=\">"+multilanguage.getMessage("com.equal")+"</option><option value=\">\">"+multilanguage.getMessage("com.greater")+"</option><option value=\"<\">"+multilanguage.getMessage("com.minor")+"</option></select></td>";
					HTMLtext+="<td><input type=\"text\" name=\""+obj.getName()+"\"></td></tr>\n";
				}
			}
		}	
		HTMLtext+="\t<tr><td colspan=\"3\"><hr style=\"color: #0066CC;\" width=\"99%\"></td></tr>\n";
		en = searchRelationVector.elements();
		SearchRelationBean sr = null;
		while (en.hasMoreElements()){
			sr = (SearchRelationBean)en.nextElement();
			HTMLtext+="\t<tr><td align=\"right\">"+sr.getDomain()+"</td><td colspan=\"2\"><textarea name=\""+sr.getInputName()+"\" cols=\"30\" rows=\"1\" wrap=\"physical\" readonly></textarea>";
			HTMLtext+="<a href=\"javascript:void(0);\" onclick=\"window.open('searchpopup.jsp?searchname="+sr.getNameToSearch()+"&inputname="+sr.getInputName()+"',null,'height=400,width=600,status=no,toolbar=no,scrollbars=yes,menubar=no,location=no,resizable');\"><img class=\"icon\" src=\"images/ico_cut.gif\" alt=\"filtro\" title=\"filtro\"></a>";
			//HTMLtext+="<a href=\"javascript:window.open('searchpopup.jsp?class="+sr.getNameToSearch()+"',null,'height=400,width=450,status=no,toolbar=no,scrollbars=yes,menubar=no,location=no,resizable');\"><img class=\"icon\" src=\"images/ico_cut.gif\" alt=\"filtro\" title=\"filtro\"></a>";
			HTMLtext+="<a href=\"javascript:void(0);\" onclick=\"javascript:document.searchForm."+sr.getInputName()+".value='';\"><img class=\"icon\" src=\"images/ico_cut_x.gif\" alt=\"rimuovi filtro\" title=\"rimuovi filtro\"></a></td></tr>\n";
		}
		HTMLtext+="\t<tr>";
		HTMLtext+="<td class=\"tdr30\">&nbsp;</td>";
		HTMLtext+="<td>&nbsp;</td>";
		HTMLtext+="<td><input type=\"button\" name=\"button\" value=\"cerca\" onclick=\"method.value='filter';submit()\" value=\""+multilanguage.getMessage("com.confirm")+"\" class=\"button\">&nbsp;<input type=\"button\" name=\"button\" value=\""+multilanguage.getMessage("com.cancel")+"\" onclick=\"javascript:location.href='management.jsp';\" value=\""+multilanguage.getMessage("com.cancel")+"\" class=\"button\"></td>";
		HTMLtext+="</tr>\n";
		HTMLtext+="</table>\n";
		return HTMLtext;
	}

	public String toSearchPopup() {
		//String HTMLtext = super.toForm();
		String HTMLtext = "";
		HTMLtext+="<table class=\"card\">\n";
		HTMLtext+="\t<tr><td class=\"tdr30\">classe</td><td colspan=\"2\">"+classDescription+"</td></tr>\n";
		HTMLtext+="\t<tr><td colspan=\"3\"><hr style=\"color: #0066CC;\" width=\"99%\"></td></tr>\n";
		// repeated buttons
		HTMLtext+="\t<tr>";
		HTMLtext+="<td class=\"tdr30\">&nbsp;</td>";
		HTMLtext+="<td colspan=\"2\"><input type=\"button\" name=\"button\" value=\"cerca\" onclick=\"fetchAll()\" value=\""+multilanguage.getMessage("com.confirm")+"\" class=\"button\">&nbsp;<input type=\"button\" name=\"button\" value=\""+multilanguage.getMessage("com.cancel")+"\" onclick=\"window.close();\" value=\""+multilanguage.getMessage("com.cancel")+"\" class=\"button\"></td>";
		HTMLtext+="</tr>\n";
		Enumeration e = attributeVector.elements();
		AttributeBean obj = null;
		Enumeration en = null;
		Vector vett = null;
		while (e.hasMoreElements()){
			obj = (AttributeBean)e.nextElement();
			if (!obj.getName().equals("Id") && !obj.getName().equals("IdCategory") && !obj.getName().equals("Notes") && !obj.getName().equals("Status")){ // don't show these
				if (obj.getType()==AttributeBean.LOOKUP){
					HTMLtext+="\t<tr><td class=\"tdr30\">"+obj.getDescription()+"</td>";
					HTMLtext+="<td><select name=\"f_"+obj.getName()+"\"><option>"+multilanguage.getMessage("com.equal")+"</option></select></td>";
					HTMLtext+="<td><select name=\""+obj.getName()+"\">";
					// adding "" option
					HTMLtext+="<option></option>";
					en = lookupVector.elements();
					LookupBean lb = null;
					while ( (en!=null) && (en.hasMoreElements()) ){
						lb = (LookupBean)en.nextElement();
						//System.out.println("lb.getLtype="+lb.getLType()+" obj.getALookup()"+obj.getALookup());
						if (lb.getType().equals(obj.getLookup())){
							HTMLtext+="<option value=\""+lb.getId()+"\">"+lb.getDescription()+"</option>";
						}
					}
					HTMLtext+="</select></td>";
					HTMLtext+="</tr>\n";
				} else if (obj.getType()==AttributeBean.REFERENCE){
					HTMLtext+="\t<tr><td class=\"tdr30\">"+obj.getDescription()+"</td>";
					HTMLtext+="<td><select name=\"f_"+obj.getName()+"\"><option>"+multilanguage.getMessage("com.equal")+"</option></select></td>";
					HTMLtext+="<td><select name=\""+obj.getName()+"\">";
					// adding "" option
					HTMLtext+="<option></option>";
					if (referenceHash.containsKey(obj.getReference())){
						vett = (Vector) referenceHash.get(obj.getReference());
					} 
					if (vett!=null){
						en = vett.elements();
						LookupBean lb = null;
						while ( (en!=null) && (en.hasMoreElements()) ){
							lb = (LookupBean)en.nextElement();
							//System.out.println("lb.getLtype="+lb.getLType()+" obj.getALookup()"+obj.getALookup());
							if (lb.getType().equals(obj.getReference())){
								HTMLtext+="<option value=\""+lb.getId()+"\">"+lb.getDescription()+"</option>";
							}
						}
					}
					HTMLtext+="</select></td>";
					HTMLtext+="</tr>\n";
				} else if( obj.getType()==AttributeBean.STRING ){
					HTMLtext+="\t<tr><td class=\"tdr30\">"+obj.getDescription()+"</td>";
					HTMLtext+="<td><select name=\"f_"+obj.getName()+"\"><option>"+multilanguage.getMessage("com.equal")+"</option><option>"+multilanguage.getMessage("com.contains")+"</option><option>"+multilanguage.getMessage("com.startswith")+"</option></select></td>";
					HTMLtext+="<td><input type=\"text\" name=\""+obj.getName()+"\"></td></tr>\n";
				} else if( obj.getType()==AttributeBean.TEXT ){
					HTMLtext+="\t<tr><td class=\"tdr30\">"+obj.getDescription()+"</td>";
					HTMLtext+="<td><select name=\"f_"+obj.getName()+"\"><option>"+multilanguage.getMessage("com.equal")+"</option><option>"+multilanguage.getMessage("com.contains")+"</option><option>"+multilanguage.getMessage("com.startswith")+"</option></select></td>";
					HTMLtext+="<td><textarea name=\""+obj.getName()+"\" cols=\"25\" rows=\"2\"></textarea></td></tr>\n";
				} else if( obj.getType()==AttributeBean.DATE ){ 
					HTMLtext+="\t<tr><td class=\"tdr30\">"+obj.getDescription()+"</td>";
					HTMLtext+="<td><select name=\"f_"+obj.getName()+"\"><option value=\"=\">"+multilanguage.getMessage("com.equal")+"</option><option value=\">\">"+multilanguage.getMessage("com.greater")+"</option><option value=\"<\">"+multilanguage.getMessage("com.minor")+"</option></select></td>";
					HTMLtext+="<td><input type=\"text\" name=\""+obj.getName()+"\" readonly>";
					HTMLtext+="<a href=\"javascript:showCalendarControl(document."+formName+"."+obj.getName()+");\"><img src=\"images/cal.gif\" alt=\"calendario\" title=\"calendario\" border=\"0\"></a></td></tr>\n";
				} else if( obj.getType()==AttributeBean.TIMESTAMP ){ 
					HTMLtext+="\t<tr><td class=\"tdr30\">"+obj.getDescription()+"</td>";
					HTMLtext+="<td><select name=\"f_"+obj.getName()+"\"><option value=\"=\">"+multilanguage.getMessage("com.equal")+"</option><option value=\">\">"+multilanguage.getMessage("com.greater")+"</option><option value=\"<\">"+multilanguage.getMessage("com.minor")+"</option></select></td>";
					HTMLtext+="<td><input type=\"text\" name=\""+obj.getName()+"\" readonly>";
					HTMLtext+="<a href=\"javascript:showCalendarControlT(document."+formName+"."+obj.getName()+");\"><img src=\"images/cal.gif\" alt=\"calendario\" title=\"calendario\" border=\"0\"></a></td></tr>\n";
				} else if(obj.getType()==AttributeBean.BOOLEAN){ 
					HTMLtext+="\t<tr><td class=\"tdr30\">"+obj.getDescription()+"</td>";
					HTMLtext+="<td><select name=\"f_"+obj.getName()+"\"><option>"+multilanguage.getMessage("com.equal")+"</option></select></td>";
					HTMLtext+="<td><select name=\""+obj.getName()+"\"><option> </option><option value=\"S\">"+multilanguage.getMessage("com.yes")+"</option><option value=\"N\">"+multilanguage.getMessage("com.no")+"</option></select></td></tr>\n";
				} else { // float8,int4,numeric
					HTMLtext+="\t<tr><td class=\"tdr30\">"+obj.getDescription()+"</td>";
					HTMLtext+="<td><select name=\"f_"+obj.getName()+"\"><option value=\"=\">"+multilanguage.getMessage("com.equal")+"</option><option value=\">\">"+multilanguage.getMessage("com.greater")+"</option><option value=\"<\">"+multilanguage.getMessage("com.minor")+"</option></select></td>";
					HTMLtext+="<td><input type=\"text\" name=\""+obj.getName()+"\"></td></tr>\n";
				}
			}
		}	
		HTMLtext+="\t<tr>";
		HTMLtext+="<td class=\"tdr30\">&nbsp;</td>";
		HTMLtext+="<td colspan=\"2\"><input type=\"button\" name=\"button\" value=\"cerca\" onclick=\"fetchAll()\" value=\""+multilanguage.getMessage("com.confirm")+"\" class=\"button\">&nbsp;<input type=\"button\" name=\"button\" value=\""+multilanguage.getMessage("com.cancel")+"\" onclick=\"window.close();\" value=\""+multilanguage.getMessage("com.cancel")+"\" class=\"button\"></td>";
		HTMLtext+="</tr>\n";
		HTMLtext+="</table>\n";
		// creating an array of names for the javascript function fetchAll()
		HTMLtext+= "<script language=\"javascript\">";
		HTMLtext+="var elenco = new Array("+attributeVector.size()+");";
		en = attributeVector.elements();
		int i=0;
		while (en.hasMoreElements()){
			obj = (AttributeBean)en.nextElement();
			if (!obj.getName().equals("Id") && !obj.getName().equals("IdCategory") && !obj.getName().equals("Notes") && !obj.getName().equals("Status")){ // don't show these
				HTMLtext+="elenco["+i+"]=\""+obj.getDescription()+"\";";
				i++;
			}	
		}
		//HTMLtext+="var target=opener.document.searchForm."+inputName+"; ";
		HTMLtext+="var target=opener.document.forms[0]."+inputName+"; ";
		HTMLtext+="</script>";
		return HTMLtext;
	}

	public String toSearchTable() {
		// transform Vector in Hashtable
		GenerateTips gentips = new GenerateTips(tipsVector);
		Hashtable tips = gentips.getTips();
		// creating lookup hash
		lookupHash = new Hashtable();
		referenceMap = new Hashtable();
		LookupBean lb = null;
		Enumeration en = null;
		if (lookupVector!=null){
			en = lookupVector.elements();
			while (en.hasMoreElements()){
				lb = (LookupBean)en.nextElement();
				if (!lookupHash.containsKey(lb.getId()+"")){
					lookupHash.put(lb.getId()+"",lb.getDescription());
				}
			}
		}
		// generate reference mapping
		Vector vett = new Vector();
		en = referenceHash.elements();
		while (en.hasMoreElements()){
			vett.addAll( (Vector)en.nextElement() );
		}
		en = vett.elements();
		while (en.hasMoreElements()){
			lb = (LookupBean)en.nextElement();
			referenceMap.put(lb.getId()+"",lb.getDescription());
		}
		String HTMLtext = header.toForm();
		Vector assetVector = null;
		AssetBean as = null;
		if(reportVector==null){
			System.out.println("reportVector==null");
		}
    	if(reportVector!=null){
			int tot = totalPages/resultsForPage;
			System.out.println(totalPages+"/"+resultsForPage+"tot="+tot);
			if (totalPages%resultsForPage!=0){
				tot++;
			}
			int first,prev,next,last;
			first = 1;
			if (subpage>1){
				prev=subpage-1;
			} else {
				prev = 1;
			}
			if (subpage<tot){
				next=subpage+1;
			} else {
				next = tot;
			}
			last = tot;
			if (tot==0){
				subpage=0;
			}
 			//System.out.println("start"+start+"end"+end);
			HTMLtext+= "<table><tr><td colspan=\"5\">"+multilanguage.getMessage("HTMLclass.atpage")+" <input type=\"text\" size=\"3\" name=\"pagina\" maxlength=\"3\" value=\""+subpage+"\" onkeypress=\"goTo(event,"+first+","+last+")\"> di "+tot;
			HTMLtext+= "<a href=\"search.jsp?mode=show&subpage="+first+"\"><img src=\"images/ico_first.gif\" alt=\"first\" title=\"first\"></a><a href=\"search.jsp?mode=show&subpage="+prev+"\"><img src=\"images/ico_prev.gif\" alt=\"previous\" title=\"previous\"></a><a href=\"search.jsp?mode=show&subpage="+next+"\"><img src=\"images/ico_next.gif\" alt=\"next\" title=\"next\"></a><a href=\"search.jsp?mode=show&subpage="+last+"\"><img src=\"images/ico_last.gif\" alt=\"last\" title=\"last\"></a>";
			HTMLtext+= "</td></tr></table>";
 	    	HTMLtext+="<table class=\"show\" cellpadding=\"0\" cellspacing=\"0\">\n";
 			// creating header of the table
 			en = thVector.elements();
 			AttributeBean ab = null;
 			// adding classDescription as first column
 			HTMLtext+="<th>Classe</th>";
 			while (en.hasMoreElements()){
				ab = (AttributeBean)en.nextElement();
				if (!ab.getName().equals("Id") && !ab.getName().equals("IdClass")){
					if (ab.getBaseDSP().equals("true")){
	 					HTMLtext+="<th>"+ab.getDescription()+"</th>";
					}
				}
 			}
 			
 			HTMLtext+="<th>&nbsp;</th>\n";
 			// creating the table
 			String value="";
 			String link = "";
 			String tip = "";
 			Enumeration enr = reportVector.elements();
 			int page=0;
 			if (subpage!=0){
 				page = (subpage-1)*resultsForPage;
 			}
 			while (enr.hasMoreElements()){
 				page++;
				assetVector = (Vector)enr.nextElement();
 				Enumeration eni = assetVector.elements();
 				as = (AssetBean)assetVector.elementAt(0); // id
 				int objid = 0;
 				if (as!=null){
 	 				tip = (String)tips.get(as.getClassBean().getId()+"-"+as.getValue());
 	 				objid = Integer.parseInt(as.getValue());
 	 				if (tip==null){ tip=""; }
 				}
				if (pageToHighlight!=page){
					HTMLtext+="<tr>";
				} else {
					HTMLtext+="<tr style=\"color: red;\">";
				}
 	 			// adding classDescription as first column
 	 			HTMLtext+="<td class=\"arrow\" onmouseover=\"tooltip(this,'"+tip+"');\" onmouseout=\"exit();\">"+as.getClassBean().getDescription()+"</td>";
 				while(eni.hasMoreElements()){
 					as = (AssetBean)eni.nextElement();
 					if (!as.getName().equals("Id") && !as.getName().equals("IdClass")){
 						if (as.getBaseDSP().equals("true")){
 							value = as.getValue();
 							if (value==null || value.equals("")){
 								value="&nbsp;";
 							} else if(as.getType()==AttributeBean.LOOKUP){
 								value = (String)lookupHash.get(value);
							} else if(as.getType()==AttributeBean.REFERENCE){
 								value = (String)referenceMap.get(value);
 							}
 			 				if (user!=null && user.isAllowed(className,1)){
 			 	 				link ="<a href=\"card.jsp?class="+as.getClassBean().getName()+"&classid="+as.getClassBean().getId()+"&objid="+objid+"&mode=show\">"+value+"</a>";
 			 				} else {
 			 	 				link ="<a href=\"javascript:alert('"+multilanguage.getMessage("com.youhavenopermission")+"');\">"+value+"</a>";
 			 				}
 	 						if (pageToHighlight!=page){
 								HTMLtext+="<td>"+link+"</td>";
 	 						} else {
 								HTMLtext+="<td style=\"color: red;\">"+link+"</td>";
 							}
 						}
 					}
 				}
 				HTMLtext+="<td>";
 				// don't show button goto
 				/*
 				if (user!=null && user.isAllowed(className,1)){
 	 				HTMLtext+="<a href=\"card.jsp?class="+as.getClassBean().getName()+"&classid="+as.getClassBean().getId()+"&objid="+objid+"&mode=show\"><img class=\"icon\" src=\"images/ico_link.gif\" alt=\"go to\" title=\"go to\"></a>";
 				} else {
 	 				HTMLtext+="<a href=\"javascript:alert('"+multilanguage.getMessage("com.youhavenopermission")+"');\"><img class=\"icon\" src=\"images/ico_link.gif\" alt=\"go to\" title=\"go to\"></a>";
 				}
 				*/
 				if (user!=null && user.isAllowed(className,3)){
 	 				HTMLtext+="<a href=\"relation.jsp?class="+as.getClassBean().getName()+"&classid="+as.getClassBean().getId()+"&objid="+objid+"&mode=show\"><img class=\"icon\" src=\"images/ico_add.gif\" alt=\"add relation\" title=\"add relation\"></a>";

 				} else {
 	 				HTMLtext+="<a href=\"javascript:alert('"+multilanguage.getMessage("com.youhavenopermission")+"');\"><img class=\"icon\" src=\"images/ico_add.gif\" alt=\"add\" title=\"add\"></a>";
 				}
 				HTMLtext+="</td>\n";
 				HTMLtext+="</tr>\n";
			}	
 			HTMLtext+="</table>\n";
    	}
		return HTMLtext;
	}

	public String toWarning() {
		String HTMLtext = "";
		HTMLtext+="<table class=\"card\">\n";
		HTMLtext+="\t<tr><td>"+multilanguage.getMessage("com.warning")+"</td></tr>\n";
		HTMLtext+="</table>\n";
		return HTMLtext;
	}

	/***********************/
	/* GETTERS AND SETTERS */
	/***********************/
	
	public void setAssetVector(Vector assetVector) {
		this.assetVector = assetVector;
	}
	public void setAttributeVector(Vector attributeVector) {
		this.attributeVector = attributeVector;
	}
	public void setCategory(String category) {
		this.category = category;
	}
	public void setCategoryCollection(Collection categoryCollection) {
		this.categoryCollection = categoryCollection;
	}
	public void setCategoryId(int categoryId) {
		this.categoryId = categoryId;
	}
	public void setClass1id(int class1id) {
		this.class1id = class1id;
	}
	public void setClassCollection(Collection classCollection) {
		this.classCollection = classCollection;
	}
	public void setClassDescription(String classDescription) {
		this.classDescription = classDescription;
	}
	public void setClassName(String className) {
		this.className = className;
	}
	public void setCurrentPage(int currentPage) {
		this.currentPage = currentPage;
	}
	public void setDeleted(boolean deleted) {
		this.deleted = deleted;
	}
	public void setDisabled(boolean disabled) {
		this.disabled = disabled;
	}
	public void setDisableEditing(boolean disableEditing) {
		this.disableEditing = disableEditing;
	}
	public void setFormName(String formName) {
		this.formName = formName;
	}
	public void setHeader(Header header) {
		this.header = header;
	}
	public void setHideLinks(boolean hideLinks) {
		this.hideLinks = hideLinks;
	}
	public void setHistoryVector(Vector historyVector) {
		this.historyVector = historyVector;
	}
	public void setInputName(String inputName) {
		this.inputName = inputName;
	}
	public void setLookupHash(Hashtable lookupHash) {
		this.lookupHash = lookupHash;
	}
	public void setLookupVector(Vector lookupVector) {
		this.lookupVector = lookupVector;
	}
	public void setManager(String manager) {
		this.manager = manager;
	}
	public void setManagersList(Collection managersList) {
		this.managersList = managersList;
	}
	public void setMasterDetail(String masterDetail) {
		this.masterDetail = masterDetail;
	}
	public void setMasterDetailMenu(Vector masterDetailMenu) {
		this.masterDetailMenu = masterDetailMenu;
	}
	public void setMode(String mode) {
		this.mode = mode;
	}
	public void setMultilanguage(MultiLanguage multilanguage) {
		this.multilanguage = multilanguage;
	}
	public void setNotes(String notes) {
		this.notes = notes;
	}
	public void setObj1id(int obj1id) {
		this.obj1id = obj1id;
	}
	public void setObjId(int objId) {
		this.objId = objId;
	}
	public void setPageToHighlight(int pageToHighlight) {
		this.pageToHighlight = pageToHighlight;
	}
	public void setReferenceHash(Hashtable referenceHash) {
		this.referenceHash = referenceHash;
	}
	public void setReferenceMap(Hashtable referenceMap) {
		this.referenceMap = referenceMap;
	}
	public void setRelationVector(Vector relationVector) {
		this.relationVector = relationVector;
	}
	public void setReportVector(Vector reportVector) {
		this.reportVector = reportVector;
	}
	public void setResultsForPage(int resultsForPage) {
		this.resultsForPage = resultsForPage;
	}
	public int getResultsForPage() {
		return resultsForPage;
	}
	public void setSearchRelationVector(Vector searchRelationVector) {
		this.searchRelationVector = searchRelationVector;
	}
	public void setShowAll(boolean showAll) {
		this.showAll = showAll;
	}
	public void setStatus(String status) {
		this.status = status;
	}
	public void setSubpage(int subpage) {
		this.subpage = subpage;
	}
	public void setSuperClass(InheritsBean superClass) {
		this.superClass = superClass;
	}
	public void setSuperCollection(Collection superCollection) {
		this.superCollection = superCollection;
	}
	public void setThVector(Vector thVector) {
		this.thVector = thVector;
	}
	public void setTipsVector(Vector tipsVector) {
		this.tipsVector = tipsVector;
	}
	public void setToPaste(boolean toPaste) {
		this.toPaste = toPaste;
	}
	public void setTotalPages(int totalPages) {
		this.totalPages = totalPages;
	}
	public void setUser(SecurityDescriptor user) {
		this.user = user;
	}
	public Header getHeader() {
		return header;
	}
	public void setReferenceId(int referenceId) {
		this.referenceId = referenceId;
	}
	public String getInherits() {
		return inherits;
	}
	public void setInherits(String inherits) {
		this.inherits = inherits;
	}
	public boolean isSuperClassOn() {
		return superClassOn;
	}
	public void setSuperClassOn(boolean superClassOn) {
		this.superClassOn = superClassOn;
	}
	
} // end of class
