package cmdbuild.utils;

import cmdbuild.collection.ClassBean;
import cmdbuild.collection.InheritsBean;

import java.util.Enumeration;
import java.util.HashSet;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Vector;

public class ClassFamily {

	private HashSet family;
	private String lastChild;
	private Hashtable parentHash;
	private Vector treeVector;
	private HashSet superSet;
	
	public ClassFamily(String lastChild, Vector treeVector) {
		super();
		// TODO Auto-generated constructor stub
		this.lastChild = lastChild;
		parentHash = new Hashtable();
		superSet = new HashSet();  // strings
		this.treeVector = treeVector;
		Enumeration en = treeVector.elements();
		InheritsBean inh = null;
		while (en.hasMoreElements()){
			inh = (InheritsBean) en.nextElement();
			if (!parentHash.containsKey(inh.getChild())){
				parentHash.put(inh.getChild(),inh.getParent());
			}
			if (!superSet.contains(inh.getParent())){
				superSet.add(inh.getParent());
			}
		}
		doFamily();
	}
	
	public void doFamily(){
		// creating treeFamily
		family = new HashSet(); // family of this class
		String targ = lastChild;
		while (targ!=null && !targ.equals("Class")){
			family.add(targ);
			//System.out.println("adding to family "+targ);
			targ = (String) parentHash.get(targ);
		}
	}
	public Vector childrenOf(String name){
		Vector vett = new Vector();
		Enumeration en = treeVector.elements();
		InheritsBean inh = null;
		ClassBean cb = null;
		while (en.hasMoreElements()){
			inh = (InheritsBean) en.nextElement();
			if (inh.getParent().equals(name)){
				cb = new ClassBean();
				cb.setName(inh.getChild());
				cb.setDescription(inh.getChildDescription());
				if (superSet.contains(cb.getName())){
					//System.out.println(cb.getName()+" is a superclass");
					cb.setSuperClass(true);
				}
				vett.add(cb);
			}
		}
		return vett;
	}
	// internal function
	private boolean superClassFind(Vector test){
		Enumeration en = test.elements();
		ClassBean cb = null;
		while (en.hasMoreElements()){
			cb = (ClassBean) en.nextElement();
			if (cb.isSuperClass()){
				return true;
			}
		}
		return false;
	}
	
	public Vector descendantsOf(String name){
		Enumeration en = treeVector.elements();
		Vector vett = new Vector();
		ClassBean cb = null;
		if (superSet.contains(name)){
			vett = childrenOf(name);
			//System.out.println(name+" is a superclass");
		}
		en = null;
		while (superClassFind(vett)){
			en = vett.elements();
			while (en.hasMoreElements()){
				cb = (ClassBean) en.nextElement();
				if (cb.isSuperClass()){
					cb.setSuperClass(false);
					//System.out.println(cb.getName()+" is now false, adding "+childrenOf(cb.getName()).size()+" childs");
					vett.addAll(childrenOf(cb.getName()));
				}
			}
		}
		return vett;
	}
	
	public Vector getHTMLoptions(Hashtable classHash){
		Vector vett = new Vector();
		String str = "";
		Iterator it = family.iterator();
		String tmp = "";
		while (it.hasNext()){
			tmp = (String) it.next();
			str = "<option value=\""+tmp+"\">"+( (ClassBean)classHash.get(tmp) ).getDescription()+"</option>";
			vett.add(str);
		}
		return vett;
	}
	
	public HashSet getFamily() {
		return family;
	}
	public void setFamily(HashSet family) {
		this.family = family;
	}
	public String getLastChild() {
		return lastChild;
	}
	public void setLastChild(String lastChild) {
		this.lastChild = lastChild;
	}
	public Hashtable getParentHash() {
		return parentHash;
	}
	public void setParentHash(Hashtable parentHash) {
		this.parentHash = parentHash;
	}
	public Vector getTreeVector() {
		return treeVector;
	}
	public void setTreeVector(Vector treeVector) {
		this.treeVector = treeVector;
	}
	

	
} // end of class
