package cmdbuild.utils;

import java.io.File;
import java.util.Collection;
import java.util.LinkedList;
import java.util.Locale;

import javax.xml.parsers.*;

import org.apache.struts.util.MessageResources;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

import cmdbuild.collection.ClassBean;


public class Settings {

	private Collection managersList;
	private String cmdbRealPath;
	private String language ="";
	private boolean languagePrompt;
	private String startingClass="";
	private Collection languageCollection;
	
	public Settings() {
		super();
		// TODO Auto-generated constructor stub
	}

	public Settings(String url) {
		super();
		// TODO Auto-generated constructor stub
		managersList = new LinkedList();
		try {
			System.out.println("** CMDB SETTINGS **");
			this.cmdbRealPath = url;
			String path = url+File.separator+"WEB-INF"+File.separator+"cmdbuild-config.xml";
			System.out.println("Loading cmdbuild-config......"+path);
			File file = new File(path);
			 //Declare variables
			Document document;
			DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
			DocumentBuilder builder = factory.newDocumentBuilder();
			document = builder.parse(file);
			//	Generate the NodeList;
			NodeList nodeList = document.getElementsByTagName("manager");
			Element curElm = null;
			for (int i=0; i<nodeList.getLength(); i++){
				//Node curNode = nodeList.item(i);
				//	Get name:
				curElm = (Element)nodeList.item(i);
				String cur = curElm.getAttribute("name");
				//System.out.println("ManagerList cur="+cur);
				managersList.add(cur);
			}//end for
			
			// language collection
	        File dir = new File(cmdbRealPath+File.separator+"WEB-INF"+File.separator+"classes"+File.separator+"resources");
	        String[] children = dir.list();
	        String filenameext = "";
	        String resourcename = "";
	        String str = "";
	        ClassBean cb = null;
	        MessageResources mess = null;
	        languageCollection = new LinkedList();
	        if (children == null) {
	            // Either dir does not exist or is not a directory
	        } else {
	            for (int i=0; i<children.length; i++) {
	                // Get filename of file or directory
	                filenameext = children[i];
	                resourcename = filenameext.substring(0,filenameext.indexOf("."));
	                resourcename = "resources."+resourcename;
		        	cb = new ClassBean();
		        	if (filenameext.indexOf(".")!=-1 && filenameext.indexOf("_")!=-1){
		        		str = filenameext.substring(filenameext.indexOf("_")+1,filenameext.indexOf("."));
			        	cb.setName(str);
				        Locale local = new Locale(str); 
				        mess = MessageResources.getMessageResources(resourcename);
				        MultiLanguage multilanguage = new MultiLanguage(local,mess);
				        cb.setDescription(multilanguage.getMessage("language"));
			        	languageCollection.add(cb);
		        	} else if (filenameext.indexOf(".")!=-1){
		        		// don't add default label, else remove comment to the next section
		        		/*
		        		str = "";
			        	cb.setName(str);
				        Locale local = new Locale(str); 
				        mess = MessageResources.getMessageResources(resourcename);
				        MultiLanguage multilanguage = new MultiLanguage(local,mess);
				        cb.setDescription(multilanguage.getMessage("language"));
			        	languageCollection.add(cb);
			        	*/
		        	}
	                //System.out.println("file="+filenameext+" filename="+resourcename+" str="+str);
	            }
	        }
			nodeList = document.getElementsByTagName("language");
			curElm = (Element)nodeList.item(0);
			language = curElm.getAttribute("default");
			String lp = curElm.getAttribute("prompt");
			if (lp.length()>0 && lp.indexOf("n")!=-1){
				languagePrompt = false;
			} else {
				languagePrompt = true;
			}
			nodeList = document.getElementsByTagName("startingclass");
			curElm = (Element)nodeList.item(0);
			startingClass = curElm.getAttribute("default");
			if (startingClass==null){
				startingClass = "";
			}
		} catch (Exception e){
			e.printStackTrace();
		}		
	}

	public String getLanguage() {
		return language;
	}
	public void setLanguage(String language) {
		this.language = language;
	}
	public boolean isLanguagePrompt() {
		return languagePrompt;
	}
	public void setLanguagePrompt(boolean languagePrompt) {
		this.languagePrompt = languagePrompt;
	}
	public Collection getManagersList() {
		return managersList;
	}
	public void setManagersList(Collection managersList) {
		this.managersList = managersList;
	}
	public String getStartingClass() {
		return startingClass;
	}
	public void setStartingClass(String startingClass) {
		this.startingClass = startingClass;
	}
	public String getCmdbRealPath() {
		return cmdbRealPath;
	}
	public void setCmdbRealPath(String cmdbRealPath) {
		this.cmdbRealPath = cmdbRealPath;
	}
	public Collection getLanguageCollection() {
		return languageCollection;
	}
	public void setLanguageCollection(Collection languageCollection) {
		this.languageCollection = languageCollection;
	}

} // end of class
