package cmdbuild.wizards;


import javax.servlet.http.HttpServletRequest;

import cmdbuild.db.DBService;
import cmdbuild.utils.MultiLanguage;

public class WizardManager {

	private String wizardName;
	private DBService db;
	private MultiLanguage multilanguage;
	
	private WizardTemplate wiz;
	
	public WizardManager() {
		super();
		// TODO Auto-generated constructor stub
		//wiz = load(wizardName);
	}
	
	public WizardManager(String name, DBService db, MultiLanguage multilanguage) {
		super();
		// TODO Auto-generated constructor stub
		this.wizardName = name;
		this.db = db;
		this.multilanguage = multilanguage;
		wiz = load(wizardName);
	}

	// usually used as internal call
	public WizardTemplate load(String name){
		String path = "cmdbuild.wizards.Wizard";
		//System.out.println("Loader: found Wizard");
		WizardTemplate obj = null;
		try {
			obj = (WizardTemplate)(Class.forName(path+name.toUpperCase()).newInstance());
			obj.setDb(db);
			obj.setMultilanguage(multilanguage);
			System.out.println("loading "+path+name.toUpperCase());
		} catch (InstantiationException e) {
			// TODO Auto-generated catch block
			System.out.println("InstantiationException");
			//e.printStackTrace();
		} catch (IllegalAccessException e) {
			// TODO Auto-generated catch block
			System.out.println("IllegalAccessException");
			//e.printStackTrace();
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
	       System.out.println("ClassNotFoundException");
			//e.printStackTrace();
		}
		return obj;
	} 
	
	public String toForm(int page){
		String HTMLtext = "";
		switch (page) {
           	case 1:  HTMLtext = toPage1(); break;
           	default: HTMLtext = wiz.toForm(page); break;
		}
		if (HTMLtext.equals("")){
			HTMLtext = toLastPage();
		}
		return HTMLtext;
	}

	public void getDataForPage(HttpServletRequest request, int page){
		switch (page) {
           	case 1:  getPage1(); break;
           	default: wiz.getDataForPage(request,page); break;
		}
	}

	public void actionForPage( HttpServletRequest request,int page){
		switch (page) {
           	case 1:  actionPage1(request); break;
           	default: wiz.actionForPage(request,page); break;
		}
	}
	
	// page 1
	public void getPage1(){
	}
	public String toPage1(){
		String HTMLtext = "";
		HTMLtext += "<div id=\"icons\"><table id=\"icotable\"><tr><td class=\"td50\">";
		HTMLtext +=	multilanguage.getMessage("com.page")+" 1</td><td class=\"td50\">&nbsp;</td></tr></table></div>\n";
		HTMLtext += "<table cellpadding=\"5\" cellspacing=\"0\">\n";
		HTMLtext += "\t<tr><td>"+multilanguage.getMessage("wizard.hello")+"</td></tr>";
		HTMLtext += "\t<tr><td>"+multilanguage.getMessage("wizard.select")+"</td></tr>";
		HTMLtext += "\t<tr><td><select name=\"wizardselect\">";
		HTMLtext += "<option value=\"\">"+multilanguage.getMessage("wizard.modifyrelation")+"</option>";
		HTMLtext += "</select>";
		HTMLtext += "</td>";
		HTMLtext += "</tr>\n";
		HTMLtext += "\t<tr>";
		HTMLtext += "<td><input type=\"button\" disabled value=\""+multilanguage.getMessage("wizard.back")+"\" class=\"button\" onclick=\"wizardForm.method.value='back';submit();\">";
		HTMLtext += "<input type=\"button\" value=\""+multilanguage.getMessage("wizard.next")+"\" class=\"button\" onclick=\"wizardForm.method.value='next';submit();\"></td>";
		HTMLtext += "</tr>\n";
		HTMLtext += "</table>\n";
		return HTMLtext;
	}
	public void actionPage1(HttpServletRequest request){
		String ch = request.getParameter("wizardselect");
		wiz.choice.put("page1",ch);
	}

	public String toLastPage(){
		String HTMLtext = "";
		HTMLtext += "<div id=\"icons\"><table id=\"icotable\"><tr><td class=\"td50\">";
		HTMLtext +=	multilanguage.getMessage("wizard.result")+"</td><td class=\"td50\">&nbsp;</td></tr></table></div>\n";
		HTMLtext += "<table cellpadding=\"5\" cellspacing=\"0\">\n";
		HTMLtext += "\t<tr><td>"+multilanguage.getMessage("wizard.final")+"</td></tr>";
		HTMLtext += "</table>\n";
		return HTMLtext;
	}
	
	public DBService getDb() {
		return db;
	}
	public void setDb(DBService db) {
		this.db = db;
	}
	public MultiLanguage getMultilanguage() {
		return multilanguage;
	}
	public void setMultilanguage(MultiLanguage multilanguage) {
		this.multilanguage = multilanguage;
	}
	public WizardTemplate getWiz() {
		return wiz;
	}
	public void setWiz(WizardTemplate wiz) {
		this.wiz = wiz;
	}
	public String getWizardName() {
		return wizardName;
	}
	public void setWizardName(String wizardName) {
		this.wizardName = wizardName;
	}
	
	
} // end of class
