package cmdbuild.wizards;

import java.sql.SQLException;
import java.util.Collection;
import java.util.Enumeration;
import java.util.HashSet;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Vector;

import javax.servlet.http.HttpServletRequest;

import net.sf.jasperreports.engine.JRException;

import cmdbuild.collection.LookupBean;
import cmdbuild.collection.AttributeBean;
import cmdbuild.collection.ClassBean;
import cmdbuild.collection.ErrorBean;
import cmdbuild.collection.InheritsBean;
import cmdbuild.collection.ReportBean;
import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBclass;
import cmdbuild.elements.CMDBlookup;
import cmdbuild.elements.CMDBmap;
import cmdbuild.elements.CMDBreport;
import cmdbuild.utils.MultiLanguage;
import cmdbuild.utils.SecurityDescriptor;
import cmdbuild.wizards.reportutils.ReportFactory;
import cmdbuild.wizards.reportutils.ReportFilter;
import cmdbuild.wizards.reportutils.ReportMenu;
import cmdbuild.wizards.reportutils.ReportQueryFactory;
import cmdbuild.wizards.reportutils.WizardReportSerializable;
import cmdbuild.wizards.reportutils.ReportTextFormats;

public class WizardReport extends WizardTemplate {
	
	private String JSPpage; // can be createReport.jsp or modifyReport.jsp
	private int targetId; // db target row used in REPORT.modifyReport(targetId,rb);
	private CMDBclass CMDB;
	private Collection classCollection;
	private Vector treeVector;
	private Vector domainVector;
	private Vector lookupVector;
	private Hashtable referenceHash;
	private ReportMenu menu;
	private ReportQueryFactory queryFactory;
	private Hashtable parentHash;  // key (child)/value(parent)
	private Hashtable classHash; // class informations
	private int subPage;	// used in page 3
	private Hashtable attributesHash; // contains vectors of AttributeBean
	private int nSubPages;
	private ReportTextFormats rtf; // not need to serialize 
	
	public WizardReport(DBService db, MultiLanguage multilanguage, String JSPpage) {
		super();
		this.db = db;
		this.multilanguage = multilanguage;
		this.JSPpage = JSPpage;
		this.queryFactory = new ReportQueryFactory();
		this.targetId = 0;
	}
	
	public String toForm(int page){
		String HTMLtext = "";
		switch (page) {
           	case 1:  HTMLtext = toPage1(); break;
           	case 2:  HTMLtext = toPage2(); break;
           	case 3:  HTMLtext = toPage3(); break;
           	case 4:  HTMLtext = toPage4(); break;
		}
		if (HTMLtext.equals("")){
			HTMLtext = toLastPage();
		}
		return HTMLtext;
	}
	
	public void getDataForPage(HttpServletRequest request, int page){
		switch (page) {
           	case 1:  getPage1(request); break;
           	case 2:  getPage2(request); break;
           	case 3:  getPage3(request); break;
           	case 4:  getPage4(request); break;
		}
	}
	
	public void actionForPage(HttpServletRequest request, int page){
		switch (page) {
           	case 1:  actionPage1(request); break;
           	case 2:  actionPage2(request); break;
           	case 3:  actionPage3(request); break;
           	case 4:  actionPage4(request); break;
		}
	}

	// page 1
	public void getPage1(HttpServletRequest request){
		CMDB = new CMDBclass(db);
		if (classCollection==null){
			try {
				classCollection = CMDB.selectAllClass();
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		// retrieving data from DB
		if (domainVector==null){
			CMDBmap MAP = new CMDBmap(this.db);
			try {
				domainVector = MAP.selectAllDomain();
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		if (treeVector==null){
			CMDBclass CMDB = new CMDBclass(this.db);
			try {
				treeVector = CMDB.selectClassTree();
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		// creating treeHash and classHash
		if (parentHash==null || classHash==null){
			parentHash = new Hashtable();
			classHash = new Hashtable(); 
			Enumeration en = treeVector.elements();
			InheritsBean inh = null;
			ClassBean cb = null;
			while (en.hasMoreElements()){
				inh = (InheritsBean) en.nextElement();
				if (!parentHash.containsKey(inh.getChild())){
					parentHash.put(inh.getChild(),inh.getParent());
				}
			}
			Iterator it = classCollection.iterator();
			while (it.hasNext()){
				cb = (ClassBean)it.next();
				if (!classHash.containsKey(cb.getName())){
					classHash.put(cb.getName(),cb);
				}
			}
		}
	}
	public String toPage1(){
		String HTMLtext = "";
		ReportBean rb = new ReportBean("","","","","");
		if (choice.get("page1")!=null){
			rb = (ReportBean) choice.get("page1");
		}
		HTMLtext += "<div id=\"icons\"><table id=\"icotable\"><tr><td class=\"td50\">";
		HTMLtext +=	multilanguage.getMessage("com.page")+" 1</td><td class=\"td50\">&nbsp;</td></tr></table></div>\n";
		HTMLtext += "<table>\n";
		HTMLtext += "\t<tr><td>"+multilanguage.getMessage("report.title")+"</td><td><input type=\"text\" name=\"title\" value=\""+rb.getName()+"\"></td></tr>\n";
		HTMLtext += "\t<tr><td>"+multilanguage.getMessage("report.description")+"</td><td><textarea name=\"description\">"+rb.getDescription()+"</textarea></td></tr>\n";
		HTMLtext += "\t<tr><td>"+multilanguage.getMessage("report.startclass")+"</td>";
		HTMLtext += "<td><select name=\"startclass\">";
		Iterator it = classCollection.iterator();
		ClassBean cb = null;
		while (it.hasNext()){
			cb = (ClassBean) it.next();
			if (!cb.getName().equals(rb.getStartClass())){
				HTMLtext += "<option value=\""+cb.getName()+"\">"+cb.getDescription()+"</option>";	
			} else {
				HTMLtext += "<option value=\""+cb.getName()+"\" selected>"+cb.getDescription()+"</option>";
			}
		}
		HTMLtext += "</select>";
		HTMLtext += "</td></tr>\n";
		HTMLtext += "\t<tr><td>"+multilanguage.getMessage("report.type")+"</td>";
		// tipo, non ancora stabilito
		HTMLtext += "<td><select name=\"type\"><option value=\"normal\">tipo normale</option></td>";
		HTMLtext += "</tr>\n";
		HTMLtext += "\t<tr style=\"visibility:hidden;display:none;\">";
		HTMLtext += "<td>"+multilanguage.getMessage("report.atdate")+"</td>";
		HTMLtext += "<td><input type=\"text\" name=\"atdate\" readonly value=\""+rb.getAtDate()+"\">";
		HTMLtext += "<a href=\"javascript:showCalendarControl(document."+JSPpage+"Form.atdate);\"><img src=\"images/cal.gif\" alt=\"calendar\" title=\"calendar\" border=\"0\"></a></td></tr>\n";
		HTMLtext += "\t<tr>";
		HTMLtext += "<td>&nbsp;</td>";
		HTMLtext += "<td><input type=\"button\" value=\""+multilanguage.getMessage("wizard.cancel")+"\" class=\"button\" onclick=\"location.href='report.jsp'\"></td>";
		HTMLtext += "<td><input type=\"button\" value=\""+multilanguage.getMessage("wizard.next")+"\" class=\"button\" onclick=\""+JSPpage+"Form.method.value='next';submit();\"></td>";
		HTMLtext += "</tr>\n";
		HTMLtext += "</table>\n";
		HTMLtext += "</table>\n";
		return HTMLtext;
	}
	public void actionPage1(HttpServletRequest request){
		String title = request.getParameter("title");
		String desc = request.getParameter("description");
		String startclass = request.getParameter("startclass");
		String type = request.getParameter("type");
		String atdate = request.getParameter("atdate");
		ReportBean rb = new ReportBean(title,desc,startclass,type,atdate);
		if (choice.get("page1")!=null){
			ReportBean rb2 = (ReportBean) choice.get("page1");
			//System.out.println("new rb="+rb.getStartClass()+" old rb="+rb2.getStartClass());
			if (!rb2.getStartClass().equals(rb.getStartClass())){
				System.out.println("found old value, clearing queryFactory");
				queryFactory = null;
				request.getSession().setAttribute("rm",null);
			}
		}
		choice.put("page1",rb);
		if (queryFactory==null){
			System.out.println("ac1 creating queryFactory");
			queryFactory = new ReportQueryFactory();
		}
		queryFactory.setStartClass(rb.getStartClass());
	}
	
	// page 2
	public void getPage2(HttpServletRequest request){
		String path ="";
		if (request.getParameter("rm")!=null){
			path = request.getParameter("rm");
			request.getSession().setAttribute("rm",path);	
		} else if (request.getSession().getAttribute("rm")!=null){
			path = (String)request.getSession().getAttribute("rm");		
		}
		ReportBean rb = (ReportBean) choice.get("page1");
		menu = new ReportMenu(rb.getStartClass(),path,classHash,treeVector,domainVector);
		// title for base path
		ClassBean cb = (ClassBean)classHash.get(rb.getStartClass());
		if (queryFactory==null){
			queryFactory = new ReportQueryFactory();
			System.out.println("gp2 creating queryFactory");
		}
		queryFactory.setTitle(cb.getDescription(),0);
	}
	public String toPage2(){
		String HTMLtext = "";
		HTMLtext += "<div id=\"icons\"><table id=\"icotable\"><tr><td class=\"td50\">";
		HTMLtext +=	multilanguage.getMessage("com.page")+" 2</td><td class=\"td50\">&nbsp;</td></tr></table></div>\n";
		// center
		HTMLtext += "<div align=\"center\">";
		// menu
		//HTMLtext += "<div class=\"elastic\">";
		HTMLtext += "<div align=\"left\">";
		HTMLtext += "<table class=\"title\"><th>"+multilanguage.getMessage("com.menutitle")+"</th></table>\n";
		HTMLtext += menu.toForm();
		HTMLtext += "</div>";
		// saved paths
		//HTMLtext += "<div class=\"elastic\">";
		HTMLtext += "<div align=\"left\">";
		HTMLtext += "<table class=\"title\"><th>"+multilanguage.getMessage("report.selectedpaths")+" ";
		String str = (String) choice.get("andOr");
		if (str==null || str.endsWith("AND")){
			HTMLtext +=	"AND<input type=\"radio\" name=\"andor\" value=\"AND\" checked=\"checked\"/>OR<input type=\"radio\" name=\"andor\" value=\"OR\"/></th></table>\n";
		} else {
			HTMLtext +=	"AND<input type=\"radio\" name=\"andor\" value=\"AND\"/>OR<input type=\"radio\" name=\"andor\" value=\"OR\" checked=\"checked\"/></th></table>\n";
		}
		HTMLtext += "<table>\n";
		for (int i=0;i<queryFactory.getPathVector().size();i++){
			str = (String) queryFactory.getTitle(i+1);
			str += "<a href=\"javascript:"+JSPpage+"Form.mpath.value='"+i+"';"+JSPpage+"Form.method.value='remove';"+JSPpage+"Form.submit();\"><img class=\"icon\" src=\"images/ico_del.gif\" alt=\"del\" title=\"del\" class=\"icon\"></a>";
			HTMLtext += "\t<tr><td>"+str+"</td></tr>\n";
		}
		HTMLtext += "</table>\n";
		HTMLtext += "</div>"; // elastic
		HTMLtext += "</div> <!-- enf of div center --> ";
		HTMLtext += "<table>\n";
		HTMLtext += "\t<tr>";
		HTMLtext += "<td><input type=\"button\" value=\""+multilanguage.getMessage("wizard.back")+"\" class=\"button\" onclick=\""+JSPpage+"Form.method.value='back';submit();\"></td>";
		HTMLtext += "<td><input type=\"button\" value=\""+multilanguage.getMessage("wizard.cancel")+"\" class=\"button\" onclick=\"location.href='report.jsp'\"></td>";
		HTMLtext += "<td><input type=\"button\" value=\""+multilanguage.getMessage("wizard.next")+"\" class=\"button\" onclick=\""+JSPpage+"Form.method.value='next';submit();\"></td>";
		HTMLtext += "</tr>\n";
		HTMLtext += "</table>\n";
		return HTMLtext;
	}
	public void actionPage2(HttpServletRequest request){
		//System.out.println("**actionPage2**");
		String andor = request.getParameter("andor");
		if (andor!=null){
			queryFactory.setAndOr(andor);
			choice.put("andOr",andor);
		}
		nSubPages = queryFactory.countPaths();
		//System.out.println("n paths="+nSubPages);
		if (subPage>nSubPages){
			subPage = 0;	// base path
		}
		String name = ((ReportBean)choice.get("page1")).getStartClass();
		Vector vett = null;
		Enumeration en = null;
		queryFactory.updateInvolvedClasses(name);
		// creating aliases
		name = ((ReportBean)choice.get("page1")).getStartClass();
		for (int i=0;i<=nSubPages;i++){
			vett = (Vector) queryFactory.getInvolvedClassesForPage(i);
			en = vett.elements();
			// don't show the first element (startClass) except in the base path
			if (i!=0 && en.hasMoreElements()){
				en.nextElement();
			}
			queryFactory.removeSelectForPage(i);
			while (en.hasMoreElements()){
				name = (String) en.nextElement();
				queryFactory.addSelectForPage(name,i);
			}
		}
		if (attributesHash==null){
			attributesHash = new Hashtable();
		}
		en = queryFactory.getInvolvedClasses().elements();
		Enumeration eni = null;
		AttributeBean ab = null;
		Vector targetlookups = new Vector();
		//System.out.println("creating target lookups");
		//System.out.println("queryFactory.getInvolvedClasses().size="+queryFactory.getInvolvedClasses().size());
		Vector options = null;
		CMDBlookup LOOKUP = new CMDBlookup(db);
		referenceHash = new Hashtable();
		HashSet hash = new HashSet();
		while (en.hasMoreElements()){
			name = (String) en.nextElement();
			//System.out.println("involved class "+name);
			//System.out.println("attributesHash.containsKey(name)?"+attributesHash.containsKey(name));
			try {
				vett = CMDB.selectAllAttribute(name,"rw");
				attributesHash.put(name,vett);
				eni = vett.elements();
				while (eni.hasMoreElements()){
					ab = (AttributeBean) eni.nextElement();
					if (ab.getType()==AttributeBean.LOOKUP){
						hash.add(ab.getLookup());
					}
					if (ab.getType()==AttributeBean.REFERENCE){
						try {
							if (!referenceHash.containsKey(ab.getReference()) && ab.getReference().length()>0){ // don't get duplicates
								options = LOOKUP.selectAllReference(ab.getReference());
								referenceHash.put(ab.getReference(),options);
							}
						} catch (SQLException e) {
							e.printStackTrace();
						}
					}
				}
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		targetlookups.addAll(hash);
		if (targetlookups.size()>0){
			try {
				lookupVector = LOOKUP.selectLookupByTypes(targetlookups);
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		} else {
			lookupVector = new Vector();
		}
	}
	
	// page 3
	public void getPage3(HttpServletRequest request){
	}
	public String toPage3(){
		String HTMLtext = "";
		HTMLtext += "<div id=\"icons\"><table id=\"icotable\"><tr><td class=\"td50\">";
		HTMLtext +=	multilanguage.getMessage("com.page")+" 3</td><td class=\"td50\">&nbsp;</td></tr></table></div>\n";
		// center
		HTMLtext += "<div align=\"center\">\n";
		// reportfilters
		HTMLtext += "<div class=\"elastic\">\n";
		if (subPage==0){
			HTMLtext += "<table class=\"title\"><th colspan=\"8\">"+multilanguage.getMessage("report.basepath")+": "+queryFactory.getTitle(subPage)+" ";
			HTMLtext += "<a href=\"javascript:"+JSPpage+"Form.method.value='addfilter';"+JSPpage+"Form.submit();\"><img class=\"icon\" src=\"images/ico_add.gif\" alt=\"add\" title=\"add\" class=\"icon\"></th>\n";
				
		} else {
			HTMLtext += "<table class=\"title\"><th colspan=\"8\">"+multilanguage.getMessage("report.path")+" "+subPage+": "+queryFactory.getTitle(subPage)+" ";
			HTMLtext += "<a href=\"javascript:"+JSPpage+"Form.method.value='addfilter';"+JSPpage+"Form.submit();\"><img class=\"icon\" src=\"images/ico_add.gif\" alt=\"add\" title=\"add\" class=\"icon\"></th>\n";
		}
		Enumeration en = queryFactory.getFiltersForPage(subPage).elements();
		ReportFilter rf = null;
		while (en.hasMoreElements()){
			rf = (ReportFilter) en.nextElement();
			HTMLtext += rf.toForm();
			//rf.showValues();
		}
		HTMLtext += "</table>\n";
		HTMLtext += "</div>\n";  // end of elastic
		// attributes to print
		Vector vett = (Vector) queryFactory.getSelectForPage(subPage);
		//HTMLtext += "<div class=\"elastic\">\n";
		HTMLtext += "<div align=\"left\">";
		HTMLtext += "<table class=\"title\"><th>"+multilanguage.getMessage("report.attprint")+"</th></table>\n";
		en = vett.elements();
		AttributeBean ab = null;
		Enumeration eni = null;
		HTMLtext += "<table>";
		ClassBean cb = null;
		while (en.hasMoreElements()){
			cb = (ClassBean)en.nextElement();
			vett = (Vector) attributesHash.get(cb.getName());
			cb.setDescription( ( (AttributeBean)vett.elementAt(0) ).getClassBean().getDescription() );
			eni = vett.elements();
			HTMLtext += "\t<tr>";
			HTMLtext +=	"<td>"+cb.getDescription()+":</td>";
			HTMLtext +=	"<td><select name=\""+cb.getComment()+"\" multiple size=\"4\">";
			while (eni.hasMoreElements()){
				ab = (AttributeBean) eni.nextElement();
				if (queryFactory.isAttributesToPrint(cb.getComment(),ab)){
					HTMLtext +=	"<option value=\""+ab.getName()+"\" selected>"+ab.getDescription()+"</option>";	
				} else {
					HTMLtext +=	"<option value=\""+ab.getName()+"\">"+ab.getDescription()+"</option>";
				}
				
			}
			HTMLtext +=	"</select></td></tr>\n";
		}
		HTMLtext += "</table>\n";
		HTMLtext += "</div>\n";
		HTMLtext += "</div> <!-- center -->\n";
		// buttons
		HTMLtext += "<table>\n";
		HTMLtext += "\t<tr>";
		HTMLtext += "<td><input type=\"button\" value=\""+multilanguage.getMessage("wizard.back")+"\" class=\"button\" onclick=\""+JSPpage+"Form.method.value='back';submit();\"></td>";
		HTMLtext += "<td><input type=\"button\" value=\""+multilanguage.getMessage("wizard.cancel")+"\" class=\"button\" onclick=\"location.href='report.jsp'\"></td>";
		HTMLtext += "<td><input type=\"button\" value=\""+multilanguage.getMessage("wizard.next")+"\" class=\"button\" onclick=\""+JSPpage+"Form.method.value='next';submit();\"></td>";
		HTMLtext += "</tr>\n";
		HTMLtext += "</table>\n";
		// adding data for filters
		HTMLtext += "<!-- follow data -->\n";
		HTMLtext += "<script language=\"javascript\">\n";
		// attributes
		int cnum = 1;
		int anum = 1;
		String tmps = "";
		HTMLtext += "ab = new AttributeBean('','"+multilanguage.getMessage("com.choose")+"','','');";
		vett = (Vector) queryFactory.getInvolvedClassesForPage(subPage);
		en = vett.elements();
		// skip first class if subPage!=0
		if (subPage!=0 && en.hasMoreElements()){
			en.nextElement();
			//System.out.println("skipping first element of vett data for filters");
		}
		String name = "";
		while (en.hasMoreElements()){
			name = (String) en.nextElement();
			HTMLtext += "class"+cnum+"=new Array();";
			HTMLtext += "class"+cnum+"[0] = ab;";
			eni = ((Vector) attributesHash.get(name)).elements();
			anum = 1;
			while (eni.hasMoreElements()){
				ab = (AttributeBean) eni.nextElement();
				tmps = ab.getDescription();
				name = tmps.replace('\'', ' ');
				name = name.replace('"', ' ');
				HTMLtext += "ab"+anum+" = new AttributeBean('"+ab.getName()+"','"+name+"','"+ab.getType()+"','"+ab.getLookup()+"');";
				HTMLtext += "class"+cnum+"["+anum+"] = ab"+anum+";";
				anum++;
			}
			cnum++;
		}
		// adding lookups
		HTMLtext += "lookup = new Array();\n";
		en = lookupVector.elements();
		LookupBean lb = null;
		cnum = 0;
		while (en.hasMoreElements()){
			lb = (LookupBean)en.nextElement();
			tmps = lb.getDescription();
			name = tmps.replace('\'', ' ');
			name = name.replace('"', ' ');
			HTMLtext += "ll = new Lookup('"+lb.getType()+"','"+name+"','"+lb.getId()+"');";
			HTMLtext += "lookup["+cnum+"] = ll;";
			cnum++;
		}
		// adding references
		HTMLtext += "reference = new Array();\n";
		Vector ref = new Vector();
		vett = null;
		en = referenceHash.elements();
		while (en.hasMoreElements()){
			vett = (Vector) en.nextElement();
			ref.addAll(vett);
		}
		cnum = 0;
		en = ref.elements();
		while (en.hasMoreElements()){
			lb = (LookupBean)en.nextElement();
			tmps = lb.getDescription();
			name = tmps.replace('\'', ' ');
			name = name.replace('"', ' ');
			HTMLtext += "ll = new Reference('"+lb.getType()+"','"+name+"','"+lb.getId()+"');";
			HTMLtext += "reference["+cnum+"] = ll;";
			cnum++;
		}
		HTMLtext += "</script>\n";
		return HTMLtext;
	}
	// repeated until page=3
	public void actionPage3(HttpServletRequest request){
		Enumeration en = queryFactory.getSelectForPage(subPage).elements();
		
		//System.out.println("getting alias for subpage="+subPage+" selects are "+queryFactory.getSelectForPage(subPage).size());
		nSubPages = queryFactory.countPaths();
		Enumeration eni = null;
		String[] alres;
		ClassBean cb = null;
		
		AttributeBean ab = null;
		AttributeBean ab2 = null;
		String tip = "";
		Vector vett = null;
		Vector vett2 = null;
		// no action when going to page 4
		
		// saving select values
		//System.out.println("saving select values, selects are "+queryFactory.getSelectForPage(subPage).size());
		while (en.hasMoreElements() && subPage<=nSubPages){
			cb = (ClassBean) en.nextElement();
			tip = (String) queryFactory.getTitle(subPage);
			alres = (String[]) request.getParameterValues(cb.getComment());
			//System.out.println("get parameters for "+cb.getComment());
			for (int i=0;i<alres.length;i++){
				//System.out.println("alres"+i+"="+alres[i]);
			}
			if (alres!=null){
				vett = new Vector();
				for (int i =0;i<alres.length;i++){
					//System.out.println("alres for cbcomment "+cb.getComment()+" ="+alres[i]);
					vett.add(alres[i]);
				}
				HashSet hs = new HashSet(vett);
				//System.out.println("hs.size= "+hs.size()+"== vett.size="+vett.size());
				Vector va = (Vector) attributesHash.get(cb.getName());
				//System.out.println("attributes of "+cb.getName()+" are="+va.size());
				eni = va.elements();
				vett2 = new Vector();
				while (eni.hasMoreElements()){
					ab = (AttributeBean) eni.nextElement();
					ab2 = AttributeBean.getCopyOf(ab);
					if (hs.contains(ab.getName())){
						ab2.setComment(tip); 
						// saving alias1, alias2 etc....
						//System.out.println("setting comment="+cb.getComment());
						ab2.getClassBean().setComment(cb.getComment());
						//System.out.println("adding "+ab2.getName()+" for "+ab2.getClassBean().getName());
						vett2.add(ab2);
					}
				}
				queryFactory.setAttributesToPrint(cb.getComment(),vett2,subPage);
				//queryFactory.addOrder(vett2,subPage);
			}
		}
		
		// getting/setting filters
		vett = queryFactory.getFiltersForPage(subPage);
		en = vett.elements();
		ReportFilter rf = null;
		int i = 0;
		String val = "";
		while (en.hasMoreElements()){
			rf = (ReportFilter) en.nextElement();
			eni = rf.getRequestParam().elements();
			i = 0;
			while(eni.hasMoreElements()){
				tip = (String) eni.nextElement();
				val = request.getParameter(tip);
				if (val!=null){
					rf.setValueAt(val,i);
				}
				//System.out.println("row="+rn+" column="+cn+" value="+val);
				i++;
			}
			rf.validate();
			rf.mapAlias(queryFactory.getSelectForPage(subPage));
			//System.out.println("rf alias="+rf.getAlias()+" halfValid?"+rf.isHalfValid()+" fullValid? "+rf.isFullValid());
			if (rf.isHalfValid()){
				// setting attribute info
				//System.out.println("rf class="+rf.getRequestClass());
				vett = (Vector) attributesHash.get(rf.getRequestClass());
				rf.setAttributeVector(vett);
				rf.setLookupVector(lookupVector);
				rf.setReferenceHash(referenceHash);
				eni = vett.elements();
				while (eni.hasMoreElements()){
					ab = (AttributeBean) eni.nextElement();
					//System.out.println("rf attribute="+rf.getRequestAttribute()+"=?"+ab.getName()+"?");
					if (ab.getName().equals(rf.getRequestAttribute())){
						rf.setAttributeBean(ab);
						//System.out.println("rf attribute="+rf.getRequestAttribute()+"=?"+ab.getName()+" setted");
						break;
					}
				}		
			}
		}
		queryFactory.createOrders();
		queryFactory.initializeCouters();
	}

	// page 4
	public void getPage4(HttpServletRequest request){
		String url = (String) request.getSession().getAttribute("cmdbRealPath");
		if (rtf==null){
			rtf = new ReportTextFormats(url);	
		}
	}
	public String toPage4(){
		String HTMLtext = "";
		HTMLtext += "<div id=\"icons\"><table id=\"icotable\"><tr><td class=\"td50\">";
		HTMLtext +=	multilanguage.getMessage("com.page")+" 4</td><td class=\"td50\">&nbsp;</td></tr></table></div>\n";
		HTMLtext += "<div align=\"center\">\n";  
		// attributes to print
		Vector vett = (Vector) queryFactory.getOrders();
		//HTMLtext += "<div class=\"elastic\">\n";
		HTMLtext += "<div align=\"left\">";
		HTMLtext += "<table class=\"title\"><th>"+multilanguage.getMessage("report.order")+"</th></table>\n";
		AttributeBean ab = null;
		HTMLtext += "<table class=\"report\">\n";
		HTMLtext += "\t<th colspan=\"2\"></th><th>"+multilanguage.getMessage("report.header")+"</th><th>"+multilanguage.getMessage("report.alignment")+"</th><th>"+multilanguage.getMessage("report.ordering")+"</th>\n";
		int i = 0;
		Vector vett2 = null;
		HashSet aligns = rtf.getAligns(); 
		Iterator it = null;
		Enumeration eni = null;
		String str = "";
		Enumeration en = vett.elements();
		while (en.hasMoreElements()){
			ab = (AttributeBean) en.nextElement();
			HTMLtext += "\t<tr>";
			HTMLtext +=	"<td class=\"arrow\" onmouseover=\"tooltip(this,'"+ab.getComment()+"');\" onmouseout=\"exit();\">"+ab.getClassBean().getDescription()+"</td>";
			HTMLtext +=	"<td>"+ab.getDescription()+"</td>";
			// this is the columnHeader
			HTMLtext +=	"<td><input type=\"text\" name=\""+ab.getClassBean().getComment()+ab.getName()+"CH"+"\" value=\""+ab.getDefaultValue()+"\"></td>";
			
			// the next td contains alignments, formats etc..
			HTMLtext += "<td>";
			// text alignment
			HTMLtext += "<select name=\""+ab.getClassBean().getComment()+ab.getName()+"TA"+"\">";
			it = aligns.iterator();
			ClassBean cb = null;
			while (it.hasNext()){
				str = (String) it.next();
				//System.out.println("ab.baseDSP="+ab.getBaseDSP()+" str="+str);
				if (ab.getBaseDSP().length()>0){
					//System.out.println("ab.getBaseDSP().length()>0");
					if (!str.equals(ab.getBaseDSP())){
						HTMLtext += "<option value=\""+str+"\">"+str+"</option>";	
					} else {
						HTMLtext += "<option value=\""+str+"\" selected>"+str+"</option>";
					}
				} else {
					//System.out.println("ab.getBaseDSP().length()==0");
					if (!str.equals("left")){
						HTMLtext += "<option value=\""+str+"\">"+str+"</option>";	
					} else {
						HTMLtext += "<option value=\""+str+"\" selected>"+str+"</option>";
					}
				}
			}
			HTMLtext += "</select>";
			// text format
			vett = rtf.getOptionVector(ab.getType());
			//System.out.println("ab.mode="+ab.getMode());
			vett2 = new Vector();
			if (vett.size()>0){
				// adding a blank value
				cb = new ClassBean();
				cb.setName("");
				cb.setDescription("");
				vett2.add(cb);
				vett2.addAll(vett);
			}
			if (vett2.size()>0){
				HTMLtext += "<select name=\""+ab.getClassBean().getComment()+ab.getName()+"TF"+"\">";
				eni = vett2.elements();
				while (eni.hasMoreElements()){
					cb = (ClassBean) eni.nextElement();
					if (!ab.getMode().equals(cb.getName())){
						HTMLtext += "<option value=\""+cb.getName()+"\">"+cb.getDescription()+"</option>";	
					} else {
						HTMLtext += "<option value=\""+cb.getName()+"\" selected>"+cb.getDescription()+"</option>";
					}
				}
				HTMLtext += "</select>";	
			} else {
				HTMLtext += "&nbsp;";
			}
			HTMLtext += "</td>";
			
			// arrows
			HTMLtext +=	"<td><a href=\"javascript:"+JSPpage+"Form.mpath.value='"+i+"';"+JSPpage+"Form.method.value='down';"+JSPpage+"Form.submit();\"><img class=\"icon\" src=\"images/ico_down.gif\" alt=\"down\" title=\"down\" class=\"icon\"></a>";
			HTMLtext +=	"<a href=\"javascript:"+JSPpage+"Form.mpath.value='"+i+"';"+JSPpage+"Form.method.value='up';"+JSPpage+"Form.submit();\"><img class=\"icon\" src=\"images/ico_up.gif\" alt=\"up\" title=\"up\" class=\"icon\"></a>";
			HTMLtext +=	"<a href=\"javascript:"+JSPpage+"Form.mpath.value='"+i+"';"+JSPpage+"Form.method.value='lower';"+JSPpage+"Form.submit();\"><img class=\"icon\" src=\"images/ico_lower.gif\" alt=\"lower\" title=\"lower\" class=\"icon\"></a>";
			HTMLtext +=	"<a href=\"javascript:"+JSPpage+"Form.mpath.value='"+i+"';"+JSPpage+"Form.method.value='upper';"+JSPpage+"Form.submit();\"><img class=\"icon\" src=\"images/ico_upper.gif\" alt=\"upper\" title=\"upper\" class=\"icon\"></a>";
			HTMLtext +=	"</td></tr>\n";
			i++;
		}
		HTMLtext += "</table>\n";
		HTMLtext += "</div>\n";
		HTMLtext += "</div>\n <!-- center -->";
		HTMLtext += "<table>\n";
		// added
		HTMLtext += "\t<tr>";
		HTMLtext += "<td>"+multilanguage.getMessage("report.printorder")+"</td>";
		HTMLtext += "<td><input type=\"radio\" name=\"print\" value=\"O\" checked>"+multilanguage.getMessage("report.horizontal")+"</td>";
		HTMLtext += "<td><input type=\"radio\" name=\"print\" value=\"V\">"+multilanguage.getMessage("report.vertical")+"</td>";
		HTMLtext += "</tr>\n";
		// compilation notes
		HTMLtext += "\t<tr>";
		HTMLtext += "<td colspan=\"3\" id=\"scroll\">"+multilanguage.getMessage("report.savenotes")+"</td>";
		HTMLtext += "</tr>\n";
		// navigation buttons
		HTMLtext += "\t<tr>";
		HTMLtext += "<td><input type=\"button\" value=\""+multilanguage.getMessage("wizard.back")+"\" class=\"button\" onclick=\""+JSPpage+"Form.method.value='back';submit();\"></td>";
		HTMLtext += "<td><input type=\"button\" value=\""+multilanguage.getMessage("wizard.cancel")+"\" class=\"button\" onclick=\"location.href='report.jsp'\"></td>";
		if (queryFactory.getOrders().size()>0){
			HTMLtext += "<td><input type=\"button\" value=\""+multilanguage.getMessage("wizard.save")+"\" class=\"button\" onclick=\"scrollMessage();"+JSPpage+"Form.method.value='next';submit();\"></td>";
		} else {
			// HTMLtext += "<td><input type=\"button\" value=\""+multilanguage.getMessage("wizard.save")+"\" class=\"button\" onclick=\"createReportForm.method.value='next';submit();\"></td>";
		}
		HTMLtext += "</tr>\n";
		HTMLtext += "</table>\n";
		// setting waiting message 
		HTMLtext += "<script language=\"javaScript\">";
		HTMLtext += "basemsg = \""+multilanguage.getMessage("report.wait")+"\";";
		HTMLtext += "</script>";
		return HTMLtext;
	}
	public void actionPage4(HttpServletRequest request){
		// getting preferences for orders
		// CH TA TF
		Vector vett = queryFactory.getOrders();
		AttributeBean ab = null;
		Enumeration en = vett.elements();
		String value = "";
		while (en.hasMoreElements()){
			ab = (AttributeBean) en.nextElement();
			// columnHeader
			value = request.getParameter(ab.getClassBean().getComment()+ab.getName()+"CH");
			if (value!=null){
				ab.setDefaultValue(value);
				//System.out.println("setting CH="+value);
			}
			// Text alignment
			value = request.getParameter(ab.getClassBean().getComment()+ab.getName()+"TA");
			if (value!=null){
				ab.setBaseDSP(value);
				//System.out.println("setting TA="+value);
			}
			// Text format
			value = request.getParameter(ab.getClassBean().getComment()+ab.getName()+"TF");
			if (value!=null){
				ab.setMode(value);
				//System.out.println("setting TF="+value);
			}
		}
		// getting user from session
		SecurityDescriptor user = null;
		if (request.getSession().getAttribute("user")!=null){
			user = (SecurityDescriptor)request.getSession().getAttribute("user");
		}
		String prin = request.getParameter("print");
		if (prin.equals("O")){
			queryFactory.setHorizontalPrint(true);
		} else {
			queryFactory.setHorizontalPrint(false);
		}
		Vector querys = new Vector();
		if (queryFactory.getPathVector().size()>0){
			for (int i=0;i<queryFactory.getPathVector().size();i++){
				prin = queryFactory.makeQueryForPath(i);
				querys.add(prin);
				System.out.println("Query for path"+i+":");
				System.out.println(prin);
			}
		} else {
			prin = queryFactory.makeQueryForPath(0);
			querys.add(prin);
		}
		System.out.println("==================================");
		prin = queryFactory.makeQueryAndOr(querys);
		System.out.println("FINAL QUERY:");
		System.out.println(prin);
		
		// debug
		queryFactory.setAndOr("AND");
		queryFactory.makeQueryAndOr(querys);
		queryFactory.setAndOr("OR");
		queryFactory.makeQueryAndOr(querys);
		
		queryFactory.showStatistics();
		
		ReportBean rb = (ReportBean) choice.get("page1");
		rb.setUser(user.getUserName());
		rb.setQuery(prin);
		rb.setPrintOrder("");
		//System.out.println("rb.getQuery="+rb.getQuery());
		String cmdbRealPath = (String) request.getSession().getAttribute("cmdbRealPath");
		ReportFactory rfS = new ReportFactory(rb,cmdbRealPath,db,queryFactory.getOrders());
		ReportFactory rfR = new ReportFactory(rb,cmdbRealPath,db,queryFactory.getOrders());
		rfS.setReportType(ReportFactory.CSV);
		rfS.createReport();
		rfR.setReportType(ReportFactory.PDF);
		rfR.createReport();
		ErrorBean err = null;
		try {
			rfS.compile();
			rfR.compile();
		} catch (JRException e) {
			err = new ErrorBean(JSPpage.toLowerCase()+".jsp",e);
			e.printStackTrace();
		}
		rb.setSimpleReport(rfS.getReport());
		rb.setRichReport(rfR.getReport());
		// saving wizard data for modifyreport.jsp
		String rm = (String) request.getSession().getAttribute("rm");
		WizardReportSerializable wrs = new WizardReportSerializable(choice,classCollection,treeVector,domainVector,lookupVector,referenceHash,queryFactory,parentHash,classHash,subPage,attributesHash,nSubPages,rm);
		rb.setWizard(wrs);
		CMDBreport REPORT = new CMDBreport(db);
		try {
			if (JSPpage.equals("createReport")){
				REPORT.createReport(rb);	
			} else {
				REPORT.modifyReport(targetId,rb);	
			}
		} catch (SQLException e) {
			err = new ErrorBean(JSPpage+".jsp",e);
			e.printStackTrace();
		}
		request.getSession().setAttribute("error",err);
		
		// clean data
		choice.clear();
		classCollection = null;
		treeVector = null;
		domainVector = null;
		lookupVector = null;
		referenceHash = null;
		request.getSession().setAttribute("rm",null);
		queryFactory = null;
		parentHash = null;
		classHash = null;
		subPage = 0;
		attributesHash = null;
		nSubPages = 0;
	}

	public String toLastPage(){
		String HTMLtext = "";
		HTMLtext += "<div id=\"icons\"><table id=\"icotable\"><tr><td class=\"td50\">";
		HTMLtext +=	multilanguage.getMessage("wizard.result")+"</td><td class=\"td50\">&nbsp;</td></tr></table></div>\n";
		HTMLtext += "<table cellpadding=\"5\" cellspacing=\"0\">\n";
		HTMLtext += "\t<tr><td>"+multilanguage.getMessage("wizard.final")+"</td></tr>";
		HTMLtext += "</table>\n";
		return HTMLtext;
	}

	public ReportMenu getMenu() {
		return menu;
	}
	public void setMenu(ReportMenu menu) {
		this.menu = menu;
	}
	public ReportQueryFactory getQueryFactory() {
		return queryFactory;
	}
	public void setQueryFactory(ReportQueryFactory queryFactory) {
		this.queryFactory = queryFactory;
	}
	public Hashtable getClassHash() {
		return classHash;
	}
	public void setClassHash(Hashtable classHash) {
		this.classHash = classHash;
	}
	public int getSubPage() {
		return subPage;
	}
	public void setSubPage(int subPage) {
		this.subPage = subPage;
	}
	public int getNSubPages() {
		return nSubPages;
	}
	public void setNSubPages(int subPages) {
		nSubPages = subPages;
	}
	public Hashtable getAttributesHash() {
		return attributesHash;
	}
	public Vector getLookupVector() {
		return lookupVector;
	}
	public Collection getClassCollection() {
		return classCollection;
	}
	public void setClassCollection(Collection classCollection) {
		this.classCollection = classCollection;
	}
	public Vector getDomainVector() {
		return domainVector;
	}
	public void setDomainVector(Vector domainVector) {
		this.domainVector = domainVector;
	}
	public Hashtable getParentHash() {
		return parentHash;
	}
	public void setParentHash(Hashtable parentHash) {
		this.parentHash = parentHash;
	}
	public Vector getTreeVector() {
		return treeVector;
	}
	public void setTreeVector(Vector treeVector) {
		this.treeVector = treeVector;
	}
	public void setAttributesHash(Hashtable attributesHash) {
		this.attributesHash = attributesHash;
	}
	public void setLookupVector(Vector lookupVector) {
		this.lookupVector = lookupVector;
	}
	public void setTargetId(int targetId) {
		this.targetId = targetId;
	}
	
	
} // end of class
