package cmdbuild.wizards.importutils;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.StringTokenizer;
import java.util.Vector;

import cmdbuild.collection.AssetBean;

public class CSVReader {
	
	private Vector header;
	private Vector tableVector;
	private static char comma=',';
	private static char quote='"';
	private char separator;
	
	public CSVReader() {
		super();
		// TODO Auto-generated constructor stub
	}
	
	public CSVReader(InputStream is) {
		super();
		String line = "";
		InputStreamReader isr = new InputStreamReader(is);
		java.io.BufferedReader br = new java.io.BufferedReader(isr);
		System.out.println("Reading stream");
		tableVector = new Vector();
		separator = comma;
		try {
			line = (String) br.readLine();
			header = CSVline(line,String.valueOf(separator));
			System.out.println("header="+line);
			while (br.readLine()!=null){
				line = (String) br.readLine();
				System.out.println(line);
				tableVector.add(CSVline(line,String.valueOf(separator)));
			}
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public CSVReader(InputStream is, char separator) {
		super();
		this.separator = separator;
		String line = "";
		InputStreamReader isr = new InputStreamReader(is);
		java.io.BufferedReader br = new java.io.BufferedReader(isr);
		System.out.println("Reading stream");
		tableVector = new Vector();
		//separator = comma;
		try {
			line = (String) br.readLine();
			header = CSVline(line,String.valueOf(separator));
			do{
				line = (String) br.readLine();
				//System.out.println(line);
				if (line!=null && line.trim().length()>0){
					tableVector.add(CSVline(line,String.valueOf(separator)));	
					//System.out.println("adding line to tableVector size="+tableVector.size());
				}
			} while (line!=null);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public Vector CSVline(String line,String separator){
		//System.out.println("CVline line="+line+" separator="+separator);
		Vector vett = new Vector();
		if (line!=null){
			StringTokenizer st = new StringTokenizer(line,separator);
			String str;
			Vector svett = new Vector();
			AssetBean as = null;
			AssetBean asn = null;
			while (st.hasMoreTokens()){
				str = st.nextToken();
				//System.out.println("CSVline str="+str+"  str="+str.length()+" new str="+str.trim().length());
				str = str.trim();
				if (str.length()>0){
					as = new AssetBean();
					as.setValue(str);
					as.setToDelete(false);
					svett.add(as);
				}
			}
			for (int i=0;i<svett.size();i++){
				as = (AssetBean)svett.elementAt(i);
				if (as.getValue().charAt(0)==quote && as.getValue().charAt(as.getValue().length()-1)!=quote){ // if this start with "....
					//System.out.println("as start with quote="+as.getValue());
					if (i+1<svett.size()){
						asn = (AssetBean)svett.elementAt(i+1); 
						if (asn.getValue().charAt(asn.getValue().length()-1)==quote){ // ...and next finish with "
							as.setValue(as.getValue()+asn.getValue());
							((AssetBean)svett.elementAt(i+1)).setToDelete(true);
							//System.out.println("asn finish with quote="+asn.getValue());
							//System.out.println("as="+as.getValue());
						}
					}
				}
				if (as.getValue().charAt(0)==quote && as.getValue().charAt(as.getValue().length()-1)==quote){
					str = as.getValue();
					//System.out.println("str="+str);
					str = str.substring(1,str.length());
					str = str.substring(0,str.length()-1);
					as.setValue(str);
					//System.out.println("cutting str now is="+as.getValue());
					
				}
				//System.out.println("str="+str);
				vett.add(as);
			}
			for (int i=svett.size()-1;i>=0;i--){
				as = (AssetBean)svett.elementAt(i);
				if (as.isToDelete()){
					svett.removeElementAt(i);
					//System.out.println("removing element at "+i+""+as.getValue());
				}
			}
		}
		return vett;
	}

	public Vector getHeader() {
		return header;
	}
	public void setHeader(Vector header) {
		this.header = header;
	}
	public Vector getTableVector() {
		return tableVector;
	}
	public void setTableVector(Vector tableVector) {
		this.tableVector = tableVector;
	}

} // end of class
