package cmdbuild.wizards.importutils;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;

import cmdbuild.collection.AssetBean;
import cmdbuild.collection.AttributeBean;

public class ImportLine {
	
	private boolean toDelete; // refers to the entire line (in Red)
	private Vector headerVector;
	private Hashtable lookupHash;
	private Hashtable referenceMap;
	private Vector lineVector; // output
	private boolean importOk; // merges all the boolean values

	public ImportLine() {
		super();
		// TODO Auto-generated constructor stub
	}

	public ImportLine(Vector headerVector, Hashtable lookupHash, Hashtable referenceMap, Vector temp) {
		super();
		// TODO Auto-generated constructor stub
		this.headerVector = headerVector;
		this.lookupHash = lookupHash;
		this.referenceMap = referenceMap;
		doMatch(temp);
	}

	private void doMatch(Vector temp){
		importOk = true;
		Vector result = new Vector();
		lineVector = new Vector();
		AssetBean as = null;
		AssetBean ash = null;
		// casting to headerVector.size
		result.addAll(temp);
		//System.out.println("temp.size="+temp.size()+" result.size="+result.size()+" header.size="+headerVector.size());
		if (temp.size()>headerVector.size()){
			// adding extra fields to the last field
			String val = "";
			for (int i=headerVector.size()-1;i<temp.size();i++){
				as = (AssetBean) temp.elementAt(i);
				val += as.getValue();
				//System.out.println("val="+val);
			}
			as = (AssetBean) result.elementAt(headerVector.size()-1);
			as.setValue(val);
			for (int i=result.size()-1;i>=headerVector.size();i--){
				result.removeElementAt(i);
				//System.out.println("removing an element at "+i);
			}
		}
		Hashtable typel = null;
		//System.out.println("result.size="+result.size());
		for (int i=0;i<headerVector.size();i++){
			ash = (AssetBean) headerVector.elementAt(i);
			as = new AssetBean();
			as.setName(ash.getName());
			as.setType(ash.getType());
			as.setLength(ash.getLength());
			as.setLookup(ash.getLookup());
			as.setMandatory(ash.getMandatory());
			if (i<result.size()){ // adding a field if there are too few fields
				as.setValue( ( (AssetBean)result.elementAt(i) ).getValue() );
			} else {  
				as.setValue("");
			}
			if (as.getType()==AttributeBean.VOID){
				as.setToDelete(true);
				importOk = false;
			} else if (as.getType()==AttributeBean.INTEGER){
				try {
					Integer.parseInt(as.getValue());
				} catch (NumberFormatException e){
					as.setToDelete(true);
					importOk = false;
				}
			} else if (as.getType()==AttributeBean.DOUBLE){
				try {
					Double.parseDouble(as.getValue());
				} catch (NumberFormatException e){
					as.setToDelete(true);
					importOk = false;
				}
			} else if (as.getType()==AttributeBean.DECIMAL){
				try {
					Double.parseDouble(as.getValue());
				} catch (NumberFormatException e){
					as.setToDelete(true);
					importOk = false;
				}
			} else if (as.getType()==AttributeBean.BOOLEAN){
				if (as.getValue()!=null && ( as.getValue().equals("true") || as.getValue().equals("false") ) ){
				} else {
					as.setToDelete(true);
					importOk = false;
				}
			} else if (as.getType()==AttributeBean.STRING){
				//System.out.println("varchar val="+as.getValue()+""+as.getLength()+"");
				if (as.getValue()!=null && as.getValue().length()>as.getLength()){
					as.setToDelete(true);
					importOk = false;
				}
			} else if (as.getType()==AttributeBean.LOOKUP){
				if (as.getValue()==null || !lookupHash.containsKey(as.getLookup())){
					System.out.println("ImportLine lookup type="+as.getLookup()+" val="+as.getValue()+" NOT TYPE OR NULL");
					as.setToDelete(true);
					importOk = false;
				} else {
					typel = (Hashtable) lookupHash.get(as.getLookup());
					if (!typel.containsKey(as.getValue())){
						System.out.println("ImportLine lookup type="+as.getLookup()+" val="+as.getValue()+" "+as.getValue().length()+" NOT FOUND DESCRIPTION");
						as.setToDelete(true);
						importOk = false;
						System.out.println("Importline lookup.size="+lookupHash.size());
						// debug
						String str = "";
						Enumeration en = typel.keys();
						while (en.hasMoreElements()){
							str = (String) en.nextElement();
							System.out.println("Description="+str+" "+str.length());
						}
					}
				}
			} else if (as.getType()==AttributeBean.REFERENCE){
				if (as.getValue()==null || !referenceMap.containsKey(as.getReference())){
					System.out.println("ImportLine reference type="+as.getReference()+" val="+as.getValue()+" NOT TYPE OR NULL");
					as.setToDelete(true);
					importOk = false;
				} else {
					typel = (Hashtable) referenceMap.get(as.getReference());
					if (!typel.containsKey(as.getValue())){
						//System.out.println("ImportLine reference type="+as.getReference()+" val="+as.getValue()+" "+as.getValue().length()+" NOT FOUND DESCRIPTION");
						as.setToDelete(true);
						importOk = false;
						//System.out.println("ImportLine reference.size="+referenceMap.size());
						/*
						// debug
						String str = "";
						Enumeration en = typel.keys();
						while (en.hasMoreElements()){
							str = (String) en.nextElement();
							System.out.println("Description="+str+" "+str.length());
						}
						*/
					}
				}
			} else if (as.getType()==AttributeBean.DATE || as.getType()==AttributeBean.TIMESTAMP){
				try {
					java.sql.Date.valueOf(as.getValue());
				} catch (IllegalArgumentException e){
					//System.out.println("ImportLine="+as.getValue()+" date error:"+e);
					as.setToDelete(true);
					importOk = false;
				}
				if (as.getValue()!=null && !as.isToDelete()){
					//System.out.println(as.getValue().charAt(4)+" "+as.getValue().charAt(7));
					if (as.getValue().charAt(4)!='-' && as.getValue().charAt(7)!='-'){
						as.setToDelete(true);
						importOk = false;
					}
				}
			} // end varchar
			// saving this bean
			lineVector.add(as);
		}
		//System.out.println("linevector.size="+this.lineVector.size());
	}
	
	public void doCheck(){
		importOk = true;
		AssetBean as = null;
		for (int i=0;i<lineVector.size();i++){
			as = (AssetBean) lineVector.elementAt(i);
			if (as.getType()==AttributeBean.VOID){
				as.setToDelete(true);
				// permit null value
				if (as.getMandatory().equals("Y")){
					importOk = false;	
				}
			} else if (as.getType()==AttributeBean.INTEGER){
				try {
					Integer.parseInt(as.getValue());
				} catch (NumberFormatException e){
					as.setToDelete(true);
					if (as.getMandatory().equals("Y")){
						importOk = false;	
					}
				}
			} else if (as.getType()==AttributeBean.DOUBLE){
				try {
					Double.parseDouble(as.getValue());
				} catch (NumberFormatException e){
					as.setToDelete(true);
					if (as.getMandatory().equals("Y")){
						importOk = false;	
					}
				}
			} else if (as.getType()==AttributeBean.DECIMAL){
				try {
					Double.parseDouble(as.getValue());
				} catch (NumberFormatException e){
					as.setToDelete(true);
					if (as.getMandatory().equals("Y")){
						importOk = false;	
					}
				}
			} else if (as.getType()==AttributeBean.BOOLEAN){
				if (as.getValue()!=null && !as.getValue().equals("") && ( as.getValue().equals("true") || as.getValue().equals("false") ) ){
				} else {
					as.setToDelete(true);
					if (as.getMandatory().equals("Y")){
						importOk = false;	
					}
				}
			} else if (as.getType()==AttributeBean.STRING){
				//System.out.println("varchar val="+as.getValue()+""+as.getLength()+"");
				if (as.getValue()!=null && as.getValue().length()>as.getLength()){
					as.setToDelete(true);
					if (as.getMandatory().equals("Y")){
						importOk = false;	
					}
				}
			} else if (as.getType()==AttributeBean.LOOKUP){
				if (as.getValue()==null || !lookupHash.containsKey(as.getValue())){
					as.setToDelete(true);
					if (as.getMandatory().equals("Y")){
						importOk = false;	
					}
				} 
			} else if (as.getType()==AttributeBean.REFERENCE){
				if (as.getValue()==null || !referenceMap.containsKey(as.getValue())){
					as.setToDelete(true);
					if (as.getMandatory().equals("Y")){
						importOk = false;	
					}
				} 
			} else if (as.getType()==AttributeBean.DATE || as.getType()==AttributeBean.TIMESTAMP){
				try {
					java.sql.Date.valueOf(as.getValue());
				} catch (IllegalArgumentException e){
					//System.out.println("ImportLine="+as.getValue()+" date error:"+e);
					as.setToDelete(true);
					if (as.getMandatory().equals("Y")){
						importOk = false;	
					}
				}
				if (as.getValue()!=null && !as.isToDelete()){
					System.out.println(as.getValue().charAt(4)+" "+as.getValue().charAt(7));
					if (as.getValue().charAt(4)!='-' && as.getValue().charAt(7)!='-'){
						as.setToDelete(true);
						if (as.getMandatory().equals("Y")){
							importOk = false;	
						}
					}
				}
			} // end varchar
			//System.out.println("as name="+as.getName()+" type="+as.getType()+" val="+as.getValue()+" ok?="+importOk+" toDelete?="+as.isToDelete());
		}	
	}	
	
	public Vector getLineVector() {
		return lineVector;
	}
	public void setLineVector(Vector lineVector) {
		this.lineVector = lineVector;
	}
	public Hashtable getLookupHash() {
		return lookupHash;
	}
	public void setLookupHash(Hashtable lookupHash) {
		this.lookupHash = lookupHash;
	}
	public boolean isToDelete() {
		return toDelete;
	}
	public void setToDelete(boolean toDelete) {
		this.toDelete = toDelete;
	}
	public Vector getHeaderVector() {
		return headerVector;
	}
	public void setHeaderVector(Vector headerVector) {
		this.headerVector = headerVector;
	}
	public boolean isImportOk() {
		return importOk;
	}
	public void setImportOk(boolean importOk) {
		this.importOk = importOk;
	}
	public Hashtable getReferenceMap() {
		return referenceMap;
	}
	public void setReferenceMap(Hashtable referenceMap) {
		this.referenceMap = referenceMap;
	}
	
} // end of class
