package cmdbuild.wizards.reportutils;

import java.util.Hashtable;
import java.util.Vector;
import java.util.Enumeration;

import cmdbuild.utils.QueryTokenizer;

public class OptimizeQuery {

	String query;
	String fastQuery;
	
	// put WHERE conditions (if possible) near JOIN conditions
	public OptimizeQuery(String query) {
		super();
		// TODO Auto-generated constructor stub
		this.query = query;
		//System.out.println("=====================");
		//System.out.println("==**OptimizeQuery**==");
		//System.out.println("=====================");
		System.out.println("try to Optimize query="+query);
		System.out.println("can optimize???? "+canOptimize());
		if (canOptimize()){
			String selectfrom = "";
			if (query.indexOf("LEFT")!=-1){
				selectfrom = query.substring(0,query.indexOf("LEFT"));
			} else {
				if (query.indexOf("WHERE")!=-1){
					selectfrom = query.substring(0,query.indexOf("WHERE"));					
				} else {
					selectfrom = query.substring(0,query.indexOf("ORDER"));
				}
			}
			//System.out.println("selectfrom="+selectfrom+"*");	
			String where = "";
			if (query.indexOf("WHERE")!=-1){
				where = query.substring(query.indexOf("WHERE")+6,query.indexOf("ORDER"));
			} else {
				where = "";
			}
			//System.out.println("where="+where+"*");	
			String orderby = query.substring(query.indexOf("ORDER"),query.length());
			//System.out.println("orderby="+orderby+"*");
			String join = "";
			if (query.indexOf("WHERE")!=-1){
				join = query.substring(query.indexOf("LEFT"),query.indexOf("WHERE"));	
			} else {
				join = query.substring(query.indexOf("LEFT"),query.indexOf("ORDER"));
			}
			//System.out.println("join="+join+"*");
			QueryTokenizer qt = new QueryTokenizer(where,"AND",false);
			Vector whereV = qt.getTokens();
			qt = new QueryTokenizer(join,"LEFT",true);
			Vector joinV = qt.getTokens();
			Hashtable aliasMapping = new Hashtable(); // of string vectors
			Enumeration en = whereV.elements();
			String str = "";
			String line = "";
			String alias = "";
			StringBuffer buf = new StringBuffer();
			Vector vett = null;
			while (en.hasMoreElements()){
				line = (String) en.nextElement();
				// find alias used in this line
				//System.out.println("%% line="+line+"*");
				str = line.substring(line.indexOf("select"),line.indexOf("select")+10);
				buf = new StringBuffer();
				for (int i=0;i<str.length();i++){
					if (str.charAt(i)!=' ' && str.charAt(i)!='.'){
						buf.append(str.charAt(i));
					} else {
						break;
					}
				}
				alias = buf.toString();
				//System.out.println("alias found is "+alias);
				if (aliasMapping.containsKey("alias")){
					//System.out.println("found vett");
					vett = (Vector) aliasMapping.get(alias);
					//System.out.println("vett size="+vett.size());
					vett.add(line);
					vett = (Vector) aliasMapping.get(alias);
					//System.out.println("now vett size="+vett.size());
					//System.out.println("add "+line+" for alias");
				} else {
					//System.out.println("create vett");
					vett = new Vector();
					vett.add(line);
					aliasMapping.put(alias,vett);
					//System.out.println("add "+line+" for alias");
				}
			}
			en = joinV.elements();
			int n = 0;
			line = "";
			Enumeration eni = null;
			while (en.hasMoreElements()){
				line = (String) en.nextElement();
				// find alias used in this line
				str = line.substring(line.indexOf("select"),line.indexOf("select")+10);
				buf = new StringBuffer();
				for (int i=0;i<str.length();i++){
					if (str.charAt(i)!=' ' && str.charAt(i)!='.'){
						buf.append(str.charAt(i));
					} else {
						break;
					}
				}
				alias = buf.toString();
				//System.out.println("LEFT JOIN alias found is "+alias);
				if (!alias.equals("select0")){
					vett = (Vector) aliasMapping.get(alias);
					if (vett!=null){
						eni = vett.elements();
						while (eni.hasMoreElements()){
							if (!alias.equals("select0")){
								line += " AND "+eni.nextElement();
							} 
						}
					}
				} 
				//System.out.println("setting line="+line+" at pos"+n);
				joinV.setElementAt(line,n);
				n++;
			}
			en = joinV.elements();
			join = "";
			while (en.hasMoreElements()){
				if (join.length()>0){
					join += " "+en.nextElement();
				} else {
					join = (String)en.nextElement();
				}
			}
			vett = (Vector) aliasMapping.get("select0");
			if (vett==null){
				vett = new Vector();
			}
			en = vett.elements();
			where = "";
			while (en.hasMoreElements()){
				if (where.length()>0){
					where += " AND "+en.nextElement();
				} else {
					where = "WHERE "+en.nextElement();
				}
			}
			fastQuery = selectfrom+" "+join+" "+where+" "+orderby;
		} else {
			this.fastQuery = query;
		}
	}
	
	private boolean canOptimize(){
		boolean result = false;
		String where = "";
		if (query.indexOf("WHERE")!=-1){
			where = query.substring(query.indexOf("WHERE")+6,query.indexOf("ORDER")); 
		}
		//System.out.println("canOptimize???"+where);
		// if there are others conditions != select0
		Hashtable noRepeat = new Hashtable(); // of string vectors
		QueryTokenizer qt = new QueryTokenizer(where,"AND",false);
		Vector whereV = qt.getTokens();
		Enumeration en = whereV.elements();
		String str = "";
		String line = "";
		String alias = "";
		StringBuffer buf = new StringBuffer();
		while (en.hasMoreElements()){
			line = (String) en.nextElement();
			//System.out.println("line="+line);
			if (line.indexOf("select")!=-1){
				// find alias used in this line
				str = line.substring(line.indexOf("select"),line.indexOf("select")+10);
				buf = new StringBuffer();
				for (int i=0;i<str.length();i++){
					if (str.charAt(i)!=' ' && str.charAt(i)!='.'){
						buf.append(str.charAt(i));
					} else {
						break;
					}
				}
				alias = buf.toString();
				if (!noRepeat.containsKey("alias")){
					noRepeat.put(alias,alias);
				}
			}
		}
		en = noRepeat.elements();
		while (en.hasMoreElements()){
			alias = (String) en.nextElement();
			if (!alias.equals("select0")){
				result = true;
				break;
			}
		}
		return result;
	}

	public String getFastQuery() {
		return fastQuery;
	}
	
} // end of class
