package cmdbuild.wizards.reportutils;

import cmdbuild.utils.ClassFamily;
import cmdbuild.collection.ClassBean;
import cmdbuild.collection.DomainBean;
import cmdbuild.collection.ReportMenuBean;

import java.util.*;

public class ReportMenu {
	
	//
	// ok dal 28-06-2006
	//
	
	private String path;
	private Vector levels; 
	private Vector level;
	private Vector HTMLlevels;
	private Vector HTMLlevel;
	private Vector palevVector;
	private Vector domainVector;
	private Vector treeVector;
	private Hashtable classHash; // class informations
	
	public ReportMenu(String startclass, String path,  Hashtable classHash, Vector treeVector, Vector domainVector) {
		super();
		this.path = path;
		this.levels = new Vector();
		this.classHash = classHash;
		this.treeVector = treeVector;
		this.domainVector = domainVector;
		
		if (path==null || path.equals("")){
			path = "0A";
		}
		String mtok="";
		int mlevel=0;
		ReportMenuBean menu = null;
		// creating the menu
		if (path==null || path.equals("")){ // base level
			ReportMenuBean basermb = new ReportMenuBean(startclass,((ClassBean)classHash.get(startclass)).getDescription(),startclass,((ClassBean)classHash.get(startclass)).getDescription(),"","");
			basermb.setText( ((ClassBean)classHash.get(startclass)).getDescription() );
			Vector level = new Vector();
			level.add(basermb);
			levels.insertElementAt(level,0);
		} else { // more levels
			ReportMenuBean basermb = new ReportMenuBean(startclass,((ClassBean)classHash.get(startclass)).getDescription(),startclass,((ClassBean)classHash.get(startclass)).getDescription(),"","");
			basermb.setText( ((ClassBean)classHash.get(startclass)).getDescription() );
			level = new Vector();
			level.add(basermb);
			levels.insertElementAt(level,0);
			mlevel = 1;
			StringTokenizer tok = new StringTokenizer(path,"A",false);
			while (tok.hasMoreTokens()){
				mtok = tok.nextToken();
				int mtokn = Integer.parseInt(mtok);
				level = (Vector)levels.elementAt(mlevel-1);
				//System.out.println("level.size="+level.size()+"mtok="+mtok+" mtokn="+mtokn);
				menu = (ReportMenuBean)level.elementAt(mtokn);
				if (menu.isDirect()){
					level = selectMenu(menu.getClass2());	
				} else {
					level = selectMenu(menu.getClass1());
				}
				Enumeration enim = level.elements();
				ReportMenuBean rmb = null;
				while (enim.hasMoreElements()){
					rmb = (ReportMenuBean)enim.nextElement();
					//System.out.println(rmb.getClass1()+" "+rmb.getDescription1()+" "+rmb.getClass2()+" "+rmb.getDescription2()+" "+rmb.getRelation()+" "+rmb.getDomain());
					if (rmb.isDirect()){
						rmb.setText(rmb.getRelation()+" "+rmb.getDescription2());
					} else {
						rmb.setText(rmb.getRelation()+" "+rmb.getDescription1());
					}
				}
				levels.insertElementAt(level,mlevel);
				mlevel++;
			}
		}
		//stampa(levels);
		// linking path
		StringTokenizer tok = new StringTokenizer(path,"A",false);
		palevVector = new Vector();
		palevVector.add(""); // first level (0)
		//palevVector.add("0A");  // adding first static level level (1)
		String newpal;
		int i = 1;
		while (tok.hasMoreTokens()){
			mtok = tok.nextToken();
			newpal = palevVector.elementAt(i-1)+mtok+"A";
			palevVector.add(newpal); // added in position i
			i++;
		}
		doMenuLinks();
		//stampa(levels);
		//stampaHTML(HTMLlevels);
	}
	public Vector selectMenu(String name){
		//System.out.println("**Selectmenu "+name+"**");
		ClassFamily tf = new ClassFamily(name,treeVector);
		// finding for domains associated with this family
		Enumeration en = domainVector.elements();
		DomainBean dm = null;
		//Vector targetDomains = new Vector();
		Hashtable targetDomains = new Hashtable();
		while(en.hasMoreElements()){
			dm = (DomainBean) en.nextElement();
			if (tf.getFamily().contains(dm.getStartClass()) && !targetDomains.containsKey(dm.getStartClass())){
				if (!targetDomains.containsKey(dm.getName())){
					targetDomains.put(dm.getName(),dm);	
				}
				//System.out.println("adding domain="+dm.getName());
			}
			if (tf.getFamily().contains(dm.getEndClass()) && !targetDomains.containsKey(dm.getEndClass())){
				if (!targetDomains.containsKey(dm.getName())){
					targetDomains.put(dm.getName(),dm);	
				}
				//System.out.println("adding domain="+dm.getName());
			}
		}
		ReportMenuBean rmb = null;
		Vector navigationVector = new Vector();
		en = targetDomains.elements();
		while (en.hasMoreElements()){
			dm = (DomainBean) en.nextElement();
			//System.out.println("name="+name+" sc="+dm.getStartClass()+" ec="+dm.getEndClass());
			if (tf.getFamily().contains(dm.getStartClass())){
				rmb = new ReportMenuBean(dm.getStartClass(),((ClassBean)classHash.get(dm.getStartClass())).getDescription(),dm.getEndClass(),((ClassBean)classHash.get(dm.getEndClass())).getDescription(),dm.getDirectDescription(),dm.getName());
				rmb.setDirect(true);
				//System.out.println("direct adding rmb "+rmb.getClass1()+" "+rmb.getDescription1()+" "+rmb.getClass2()+" "+rmb.getDescription2()+" "+rmb.getRelation()+" "+rmb.getDomain());
				navigationVector.add(rmb);
			}
			if (tf.getFamily().contains(dm.getEndClass())){
				rmb = new ReportMenuBean(dm.getStartClass(),((ClassBean)classHash.get(dm.getStartClass())).getDescription(),dm.getEndClass(),((ClassBean)classHash.get(dm.getEndClass())).getDescription(),dm.getInverseDescription(),dm.getName());
				rmb.setDirect(false);
				//System.out.println("notdirect adding rmb "+rmb.getClass1()+" "+rmb.getDescription1()+" "+rmb.getClass2()+" "+rmb.getDescription2()+" "+rmb.getRelation()+" "+rmb.getDomain());
				navigationVector.add(rmb);
			}
		}
		return navigationVector;
	}

	public void doMenuLinks() {
		ReportMenuBean item;
		String itemLink;
		String cl = "";
		String des = "";
		String plv = "";
		HTMLlevels = new Vector();
		ClassFamily ft = null;
		for (int i=0; i<levels.size();i++){
			level = (Vector)levels.elementAt(i);
			HTMLlevel = new Vector();
			Enumeration enu = level.elements();
			int step = 0;
			while (enu.hasMoreElements()){
				item = (ReportMenuBean)enu.nextElement();
				if (item.isDirect()){
					cl = item.getClass2();
					des = item.getDescription2();
				} else {
					cl = item.getClass1();
					des = item.getDescription1();
				}
				//System.out.println("i="+i+"<"+levels.size()+"?");
				plv = (String) palevVector.elementAt(i);
				ft = new ClassFamily(cl,treeVector); 
				Vector childVett = ft.descendantsOf(cl);
				String options = "<option value=\""+cl+"\">Tutti</option>";
				itemLink = "&nbsp;<a href=\"createreport.jsp?page=2&class="+cl+"&rm="+plv+step+"A\" class=\"menu\" alt=\""+des+"\" title=\""+des+"\"><img src=\"images/punto_chiuso.gif\" hspace=\"3\">"+item.getText()+"</a>\n";
				if (childVett.size()>1){
					ClassBean cb = null;
					Enumeration en = childVett.elements();
					while (en.hasMoreElements()){
						cb =  (ClassBean) en.nextElement();
						options += "<option value=\""+cb.getName()+"\">"+cb.getDescription()+"</option>";
					}
					itemLink += "<select name=\""+plv+step+"A\">"+options+"</select>";
				}
				String str = plv+step+"A";
				// don't add button for firts level
				if (!str.equals("0A")){
					itemLink +="<a href=\"javascript:createReportForm.mpath.value='"+plv+step+"A';createReportForm.method.value='add';createReportForm.submit();\"><img class=\"icon\" src=\"images/ico_add.gif\" alt=\"add\" title=\"add\" class=\"icon\"></a><br/>\n";
				}
				//System.out.println("adding item");
				HTMLlevel.add(itemLink);
				step++;
			}
			//System.out.println("adding level");
			HTMLlevels.add(HTMLlevel);
			//System.out.println("HTMLlevels.size="+HTMLlevels.size());
		} // end for
	} // end method

	public String toForm(){
		String HTMLtext = "";
		String head = "<div class=\"indent\">";
		String foot = "</div>";
		String change;
		Vector HTMLvector= new Vector();
		Vector v1;
		Vector v2;
		String step = "";
		int pos;
		if (path==null){
			path = "0A";
		}
		// creating a unique vector
		if (path == null || path.equals("")){
			HTMLvector = (Vector)HTMLlevels.elementAt(0);
		} else {
			StringTokenizer tok = new StringTokenizer(path,"A",false);
			int numlevel = 0 ;
			int totalLevels = 1;
			Hashtable ht = new Hashtable();
			while (tok.hasMoreTokens()){
				step = tok.nextToken();
				ht.put(numlevel+"",step); // level / point to insert vector
				//System.out.println("numlevel="+numlevel+" step="+step);
				numlevel++;
				totalLevels++;
			}
			//System.out.println("totalLevels="+totalLevels);
			int lev = totalLevels-1;
			while (lev>0){
				v1 = (Vector)HTMLlevels.elementAt(lev-1); // before last
				v2 = (Vector)HTMLlevels.elementAt(lev); // before last
				//System.out.println( " v1 point at "+(lev-1)+" v2 point at "+lev);
				v2.add(foot); // </div>
				pos = Integer.parseInt( (String)ht.get((lev-1)+"") ) ;
				//System.out.println( "prev lev="+ ((String)ht.get((lev-1)+""))+" where="+pos );
				// changing icon
				change = (String)v1.elementAt(pos);
				v1.remove(pos); // punto_chiuso.gif
				change = change.replaceFirst("punto_chiuso.gif","punto_aperto.gif");
				v1.insertElementAt(change,pos);
				v1.insertElementAt(head,pos+1); // <div class="indent">
				v1.addAll(pos+2,v2);
				HTMLlevels.remove(lev);
				HTMLlevels.setElementAt(v1,lev-1);
				lev--;
			}
			HTMLvector = (Vector)HTMLlevels.elementAt(0);
		}
		// creating HTML
		Enumeration enu = HTMLvector.elements();
		String str;
		while (enu.hasMoreElements()){
			str = (String)enu.nextElement();
			HTMLtext += str+"\n";
		}
		return HTMLtext;
	}

	// used for debugging
	public void stampa(Vector vett){ // vett is a vector of vectors (of beans)
		System.out.println("--- Vector levels ---");
		System.out.println("--- NOT really tested ---");
		Enumeration en = vett.elements();
		Vector lev = null;
		ReportMenuBean item;
 		while (en.hasMoreElements()){
			lev = (Vector)en.nextElement();
			Enumeration enu = lev.elements();
			while(enu.hasMoreElements()){
				item = (ReportMenuBean)enu.nextElement();
				if (item.isDirect()){
					System.out.println(item.getClass1());	
				} else {
					System.out.println(item.getClass2());
				}
			}
			System.out.println("---");
		}
	}

	// used for debugging
	public void stampaHTML(Vector vett){ // vett is a vector of vectors (of strings)
		System.out.println("--- Vector levels ---");
		Enumeration en = vett.elements();
		Vector lev = null;
		String item;
 		while (en.hasMoreElements()){
			lev = (Vector)en.nextElement();
			Enumeration enu = lev.elements();
			while(enu.hasMoreElements()){
				item = (String)enu.nextElement();
				System.out.println(item);
			}
			System.out.println("---");
		}
	}
	public Vector getLevels() {
		return levels;
	}
	public void setLevels(Vector levels) {
		this.levels = levels;
	}
	public Hashtable getClassHash() {
		return classHash;
	}
	public void setClassHash(Hashtable classHash) {
		this.classHash = classHash;
	}
	public Vector getDomainVector() {
		return domainVector;
	}
	public void setDomainVector(Vector domainVector) {
		this.domainVector = domainVector;
	}
	public Vector getTreeVector() {
		return treeVector;
	}
	public void setTreeVector(Vector treeVector) {
		this.treeVector = treeVector;
	}

} // end of class	
	
