package cmdbuild.wizards.reportutils;

import java.io.File;
import java.util.Enumeration;
import java.util.HashSet;
import java.util.Hashtable;
import java.util.StringTokenizer;
import java.util.Vector;

import javax.xml.parsers.*;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

import cmdbuild.collection.ClassBean;


public class ReportTextFormats {

	private Hashtable types;
	private Hashtable formats;
	private HashSet aligns;
	
	public ReportTextFormats(String url) {
		super();
		// TODO Auto-generated constructor stub
		types = new Hashtable();
		formats = new Hashtable();
		aligns = new HashSet();
		try {
			//System.out.println("** CMDB ReportTextFormats **");
			String path = url+File.separator+"WEB-INF"+File.separator+"cmdbuild-report-formats.xml";
			System.out.println("Loading cmdbuild-report-formats......"+path);
			File file = new File(path);
			 //Declare variables
			Document document;
			DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
			DocumentBuilder builder = factory.newDocumentBuilder();
			document = builder.parse(file);
			// iter between <type>
			NodeList nodeList = document.getElementsByTagName("type");
			Element curElm = null;
			String key = "";
			String value = "";
			Vector vett = null;
			//System.out.println("types="+nodeList.getLength());
			for (int i=0; i<nodeList.getLength(); i++){
				curElm = (Element)nodeList.item(i);
				key = curElm.getAttribute("name");
				value = curElm.getAttribute("value");
				//System.out.println("key="+key+" value="+value);
				if (value!=null && value.length()>0){
					StringTokenizer tok = new StringTokenizer(value,",",false);
					vett = new Vector();
					while (tok.hasMoreTokens()){
						value = tok.nextToken();
						vett.add(value);
					}
				} else {
					vett = new Vector();
				}
				types.put(key,vett);
			}
			// iter between <format>
			nodeList = document.getElementsByTagName("format");
			curElm = null;
			key = "";
			value = "";
			//System.out.println("formats="+nodeList.getLength());
			for (int i=0; i<nodeList.getLength(); i++){
				curElm = (Element)nodeList.item(i);
				key = curElm.getAttribute("name");
				value = curElm.getAttribute("value");
				//System.out.println("key="+key+" value="+value);
				if (value!=null && value.length()>0){
					formats.put(key,value);
				} else {
					formats.put(key,"");
				}
			}
			// iter between <align>
			nodeList = document.getElementsByTagName("align");
			curElm = null;
			key = "";
			value = "";
			//System.out.println("aligns="+nodeList.getLength());
			for (int i=0; i<nodeList.getLength(); i++){
				curElm = (Element)nodeList.item(i);
				value = curElm.getAttribute("value");
				//System.out.println("value="+value);
				if (value!=null && value.length()>0){
					aligns.add(value);
				} 
			}
		} catch (Exception e){
			e.printStackTrace();
		}		
	}
	/*
	ClassBean examples
	name=i0		description=###0
	name=d2		description=###0.00
	name=date	description=dd/MM/yyyy
	name=time	description=HH:mm.ss
	 */
	public Vector getOptionVector(int attributeType){
		Vector result = new Vector();
		Vector vett = null;
		String str = "";
		ClassBean cb = null;
		Enumeration en = null;
		//System.out.println("getOptionVector(attributeType="+attributeType+")");
		if (types.containsKey(attributeType+"")){
			//System.out.println("types contains it");
			vett = (Vector) types.get(attributeType+"");
			//System.out.println("types are="+vett.size());
			en = vett.elements();
			while (en.hasMoreElements()){
				str = (String) en.nextElement();
				//System.out.println("str="+str);
				if (formats.containsKey(str)){
					//System.out.println("format contains str");
					cb = new ClassBean();
					cb.setName(str);
					cb.setDescription((String) formats.get(str));
					result.add(cb);
					//System.out.println("atttype="+attributeType+" adding cb name="+cb.getName()+" description="+cb.getDescription());
				}
			}
		}
		return result;
	}
	public HashSet getAligns() {
		return aligns;
	}

} // end of class
