package cmdbuild.wizards.reportutils;

import java.io.Serializable;
import java.util.Collection;
import java.util.Hashtable;
import java.util.Vector;


public class WizardReportSerializable implements Serializable{
	
	static final long serialVersionUID = 1L;
	private Hashtable choice;
	private Collection classCollection;
	private Vector treeVector;
	private Vector domainVector;
	private Vector lookupVector;
	private Hashtable referenceHash;
	private ReportQueryFactory queryFactory;
	private Hashtable parentHash;  // key (child)/value(parent)
	private Hashtable classHash; // class informations
	private int subPage;	// used in page 3
	private Hashtable attributesHash; // contains vectors of AttributeBean
	private int nSubPages;
	private String rm; // session attribute rm wich rapresents the menu opened
	
	public WizardReportSerializable(Hashtable choice, Collection classCollection, Vector treeVector, Vector domainVector, Vector lookupVector, Hashtable referenceHash, ReportQueryFactory queryFactory, Hashtable parentHash, Hashtable classHash, int subPage, Hashtable attributesHash, int subPages, String rm) {
		super();
		// TODO Auto-generated constructor stub
		this.choice = choice;
		this.classCollection = classCollection;
		this.treeVector = treeVector;
		this.domainVector = domainVector;
		this.lookupVector = lookupVector;
		this.referenceHash = referenceHash;
		this.queryFactory = queryFactory;
		this.parentHash = parentHash;
		this.classHash = classHash;
		this.subPage = subPage;
		this.attributesHash = attributesHash;
		nSubPages = subPages;
		this.rm = rm;
	}

	public Hashtable getAttributesHash() {
		return attributesHash;
	}
	public void setAttributesHash(Hashtable attributesHash) {
		this.attributesHash = attributesHash;
	}
	public Collection getClassCollection() {
		return classCollection;
	}
	public void setClassCollection(Collection classCollection) {
		this.classCollection = classCollection;
	}
	public Hashtable getClassHash() {
		return classHash;
	}
	public void setClassHash(Hashtable classHash) {
		this.classHash = classHash;
	}
	public Vector getDomainVector() {
		return domainVector;
	}
	public void setDomainVector(Vector domainVector) {
		this.domainVector = domainVector;
	}
	public Vector getLookupVector() {
		return lookupVector;
	}
	public void setLookupVector(Vector lookupVector) {
		this.lookupVector = lookupVector;
	}
	public int getNSubPages() {
		return nSubPages;
	}
	public void setNSubPages(int subPages) {
		nSubPages = subPages;
	}
	public Hashtable getParentHash() {
		return parentHash;
	}
	public void setParentHash(Hashtable parentHash) {
		this.parentHash = parentHash;
	}
	public ReportQueryFactory getQueryFactory() {
		return queryFactory;
	}
	public void setQueryFactory(ReportQueryFactory queryFactory) {
		this.queryFactory = queryFactory;
	}
	public int getSubPage() {
		return subPage;
	}
	public void setSubPage(int subPage) {
		this.subPage = subPage;
	}
	public Vector getTreeVector() {
		return treeVector;
	}
	public void setTreeVector(Vector treeVector) {
		this.treeVector = treeVector;
	}
	public String getRm() {
		return rm;
	}
	public void setRm(String rm) {
		this.rm = rm;
	}
	public Hashtable getChoice() {
		return choice;
	}
	public void setChoice(Hashtable choice) {
		this.choice = choice;
	}
	public Hashtable getReferenceHash() {
		return referenceHash;
	}
	public void setReferenceHash(Hashtable referenceHash) {
		this.referenceHash = referenceHash;
	}
	
} // end of class
